
Pages_Sauvees DB 0  ;1 => pages EMS deja sauvegardes...

Dernier_Handle_EMS DW 0
Handle_EMS         DW 0
Handle_Sauvegarde  DW 0
Nb_Pages_EMS       DB 0

;Ŀ
;                     Gestion de l'EMS                      
;

Sauver_EMS Proc Near
        CMP Pages_Sauvees,1
        JE  Ne_Pas_Sauver_EMS
        MOV Pages_Sauvees,1

        MOV Dernier_Handle_EMS,-1    ; Pour viter d'accder 2 fois de suite
        MOV DX,Handle_EMS            ; au mme handle.
        MOV Handle_Sauvegarde,DX
        MOV AH,47h
        INT 67h                      ; Appel IRQ 67h

Ne_Pas_Sauver_EMS:
        RET
Sauver_EMS Endp

Recuperer_EMS Proc Near
        CMP Pages_Sauvees,0
        JE  Ne_Pas_Recuperer_EMS
        MOV Pages_Sauvees,0
        MOV DX,Handle_Sauvegarde
        MOV AH,48h
        INT 67h                      ; Appel IRQ 67h
Ne_Pas_Recuperer_EMS:
        RET
Recuperer_EMS EndP

;Ŀ
;  Placer_Pages_EMS: Accder  un handle EMS                
;                                                           
;  Entre: Handle_EMS et Nb_Pages_EMS                       
;                                                           
;

Placer_Pages_EMS Proc Near

        CMP Handle_EMS,-1
        JE Handle_EMS_Incorrect      ; Le bloc mmoire n'est pas en EMS...
        CALL Sauver_EMS              ; Sauver le mapping EMS (si jamais sauv)
        MOV DX,Handle_EMS
        CMP DX,Dernier_Handle_EMS
        JE  Handle_EMS_Incorrect     ; Handle dj utilis !
        MOV Dernier_Handle_EMS,DX

        PUSH BX CX

        XOR CX,CX
        MOV CL,Nb_Pages_EMS
Boucle_Placer_Pages1:                ; Boucle pour les pages EMS
        MOV BX,CX                    ; BX, N Page Logique
        DEC BX
        MOV AX,CX                    ; AL, N Page Physique
        DEC AX
        MOV AH,44h                   ; Fonction 44h
        INT 67h                      ; Appel IRQ 67h
        DEC CX
        JNZ Boucle_Placer_Pages1

        POP CX BX
Handle_EMS_Incorrect:
        RET
Placer_Pages_EMS Endp

Init_EMS Proc Near
        MOV  Pages_Sauvees,0
        RET
Init_EMS Endp
