; module pour TP
; Programme rsident qui affiche une horloge en coordonnes (75,24)
; et un calendrier en coordonnes (43,24)
; noir/vert dans la RAM vido couleur (raffichage deux fois par seconde)

CODE SEGMENT
     ASSUME CS:CODE

; donnes rsidentes

EXTRN Mois: Byte                ; tableau des mois: Janvier=1, ..., Dcembre=12

Jour     DB 8,"Dimanche",5,"Lundi   ",5,"Mardi   ",8,"Mercredi"
         DB 5,"Jeudi   ",8,"Vendredi",6,"Samedi  "

listemois30   DB 4,6,9,11       ; mois de 30 jours: Avril, Juin, Sept., Nov.

DSTP     DW 0                   ; DATA SEGMENT de TP

ancint   DD 0                   ; ancienne adresse de INT 1Ch
compteur DB 0                   ; compteur incrment de 5  chaque appel 
                                ; de INT 1Ch tous les 18.2me de seconde
                                ; une seconde s'est coule s'il vaut 91
heures   DB 0
minutes  DB 0
secondes DB 0
jour_    DB 0                   ; Dimanche=0, ...,  Samedi=6
date     DB 0
mois_    DB 0                   ; Janvier=1, ..., Dcembre=12
annee    DW 0
clignote DB 1                   ; tmoin pour le clignotement de ":"

; programme

NOUVINT PROC FAR

        PUSH AX                 ; sauvegarde les registres modifis
        PUSH CX
        PUSH DS
        PUSH ES
        PUSH SI
        PUSH DI

        CLD                     ; sens croissant pour tout le reste

        ADD [compteur],5        ; incrmente le compteur de 5
        CMP [compteur],91       ; compteur<91?
        JB verssuite            ; oui, pas de correction  faire
        SUB [compteur],91       ; corrige le compteur
        INC [secondes]          ; incrmente les secondes
        CMP [secondes],60       ; secondes<60?
        JB verssuite            ; oui, pas de correction  faire
        MOV [secondes],0        ; rinitialise les secondes  0
        INC [minutes]           ; incrmente les minutes
        CMP [minutes],60        ; minutes<60?
        JB verssuite            ; oui, pas de correction  faire
        MOV [minutes],0         ; rinitialise les minutes  0
        INC [heures]            ; incrmente les heures
        CMP [heures],24         ; heures<24?
        JB verssuite            ; oui, pas de correction  faire
        MOV [heures],0          ; il est minuit
        INC [jour_]             ; incrmente le jour
        CMP [jour_],6           ; jour<=6?
        JBE testdate            ; oui
        MOV [jour_],0           ; on est Lundi
testdate:
        INC [date]              ; incrmente la date
        CMP [mois_],2           ; est-on en Fvrier?
        JE fevrier              ; oui
        PUSH CS
        POP ES                  ; ES=CODE SEGMENT
        MOV DI,OFFSET listemois30
        MOV CX,4                ; 4 mois  scanner
        MOV AL,[mois_]
        REPNE SCASB             ; est-ce un mois de 30 jours?
        JE mois30               ; oui
        JMP mois31              ; sinon, c'est un mois de 31 jours
verssuite:
        JMP suite               ;  cause des sauts conditionnels (-127, +128)
mois31:
        CMP [date],31           ; date<=31?
        JMP testmois
mois30:
        CMP [date],30           ; date<=30?
testmois:
        JBE suite               ; oui, pas de correction  faire
        MOV [date],1            ; 1er du mois
        INC [mois_]             ; mois suivant
        CMP [mois_],12          ; mois<=12?
        JBE suite               ; oui, pas de correction  faire
        MOV [mois_],1           ; on est en Janvier
        INC [annee]             ; anne suivante
        JMP suite               ; on continue
fevrier:
        PUSH [annee]            ; sauvegarde anne
        AND [annee],3           ; est-ce une anne divisible par 4?
        POP [annee]             ; restaure anne
        JZ bissextile           ; oui, c'est une anne bissextile
        CMP [date],28           ; date<=28?
        JMP testmois
bissextile:
        CMP [date],29           ; date<=29?
        JMP testmois
suite:
        CMP [compteur],4        ; compteur<=4? (premire demi-seconde)
        JBE affichehorloge      ; oui, il faut rafficher l'horloge
        CMP [compteur],44       ; compteur>=44? (deuxime demi-seconde)
        JAE suite_              ; oui, on continue les tests
        JMP quitte              ; sinon, il ne faut pas rafficher l'horloge
suite_:
        CMP [compteur],48       ; compteur<=48? (deuxime demi-seconde)
        JBE affichehorloge      ; oui, il faut rafficher l'horloge
        JMP quitte              ; sinon, on quitte
affichehorloge:
        MOV AX,0B800h
        MOV ES,AX               ; ES=B800: segment RAM vido couleur
        MOV DI,2*74+160*23      ; affichage de l'horloge en (75,24)
                                           
        MOV AL,[heures]
        CALL divise             ; spare dizaines et units d'heures
        OR AL,AL                ; dizaines d'heures=0?
        JNZ suite1              ; non, on continue
        MOV AL,240              ; il faut afficher un espace au lieu de "0"
                                ; astuce: 240+48=32 sur un octet
suite1:
        CALL affichenombre      ; affiche les heures
        XOR [clignote],1        ; inverse le tmoin de clignotement
        MOV AL,":"              ; par dfaut, il faut afficher ":"
        JZ suite2               ; si clignote=0, il faut afficher ":"
        MOV AL," "              ; sinon, il faut afficher un espace
suite2:
        STOSW                   ; affiche ":" ou espace (clignotement)

        MOV AL,[minutes]
        CALL divise             ; spare dizaines et units de minutes
        CALL affichenombre      ; affiche les minutes

        MOV DI,2*42+160*23      ; affichage du calendrier en (43,24)
        PUSH CS
        POP DS                  ; DS=CODE SEGMENT
        MOV AL,[jour_]          ; AX=jour
        MOV CX,9
        MOV SI,OFFSET Jour
        CALL affichecalendrier  ; affiche le jour

        MOV AL,[date]
        CALL divise             ; spare dizaines et units de date
        OR AL,AL                ; dizaines de date=0?
        JZ suite3               ; oui, on ne l'affiche pas
        ADD AL,48               ; convertit dcimal en ASCII
        STOSW                   ; affiche les dizaines de date
suite3:
        MOV AL,CH               ; restaure les units de date
        ADD AL,48               ; convertit dcimal en ASCII
        STOSW                   ; affiche les units de date

        CMP [date],1            ; est-on le 1er du mois?
        JNE suite4              ; non, on continue
        MOV AL,"e"
        STOSW
        MOV AL,"r"
        STOSW                   ; affiche "er" derrire le 1
suite4:
        MOV AL," "
        STOSW                   ; affiche un espace

        MOV DS,[DSTP]           ; DS=DS de TP
        MOV AL,[mois_]
        DEC AL                  ; AX=mois-1
        MOV CX,10
        MOV SI,OFFSET Mois
        CALL affichecalendrier  ; affiche le mois

        MOV AX,[annee]
        MOV CL,100
        DIV CL                  ; AL=19, AH=XX, pour l'anne 19XX (par ex.)
        PUSH AX                 ; sauvegarde 19 et XX
        CALL divise             ; spare dizaines et units de 19
        CALL affichenombre      ; affiche 19
        POP AX                  ; restaure 19 et XX
        MOV AL,AH               ; AL=XX
        CALL divise             ; spare dizaines et units de XX
        CALL affichenombre      ; affiche XX

        MOV AX,256*32+" "       ; attribut noir/vert, espace

effacefinzonedate:
        STOSW                   ; affiche un espace
        CMP DI,2*71+160*23      ; fin de zone date atteinte? (72,24)
        JNE effacefinzonedate   ; non, on recommence

quitte:
        POP DI                  ; restaure les registres
        POP SI
        POP ES
        POP DS
        POP CX
        POP AX

        JMP [ancint]            ; excute l'ancien gestionnaire INT 1Ch

divise:
        XOR AH,AH               ; AX=nombre  diviser par 10
        MOV CL,10
        DIV CL                  ; AL=dizaines, AH=units
        MOV CH,AH               ; sauvegarde les units
        MOV AH,32               ; attribut noir/vert
        RETN                    ; retour NEAR

affichenombre:
        ADD AL,48               ; convertit dcimal en ASCII
        STOSW                   ; affiche les dizaines
        MOV AL,CH               ; restaure les units
        ADD AL,48               ; convertit dcimal en ASCII
        STOSW                   ; affiche les units
        RETN                    ; retour NEAR

affichecalendrier:
        XOR AH,AH               ; AX=jour ou mois-1
        MUL CL                  ; AX=9*jour ou 10*(mois-1)
        ADD SI,AX               ; SI=offset du nombre de lettres
        MOV CL,[SI]             ; CX=nombre de lettres
        INC SI                  ; SI=offset de la premire lettre
        MOV AH,32               ; attribut noir/vert
    affiche:
        LODSB                   ; AL=code ASCII lettre
        STOSW                   ; affiche lettre
        LOOP affiche            ; lettre suivante
        MOV AL," "
        STOSW                   ; affiche un espace
        RETN                    ; retour NEAR

NOUVINT ENDP


InstalleHorloge PROC NEAR
PUBLIC InstalleHorloge

        PUSH DS                 ; sauvegarde DS de TP

        MOV AX,351Ch
        INT 21h                 ; lit le vecteur INT 1Ch
        MOV WORD PTR [ancint],BX
        MOV WORD PTR [ancint+2],ES      ; mmorise l'adresse de INT 1Ch

        MOV [DSTP],DS           ; sauvegarde DS de TP

        MOV AH,2Ch
        INT 21h                 ; lit l'heure
        MOV [heures],CH
        MOV [minutes],CL
        MOV [secondes],DH
        MOV AH,2Ah
        INT 21h                 ; lit la date
        MOV [jour_],AL
        MOV [date],DL
        MOV [mois_],DH
        MOV [annee],CX

        PUSH CS
        POP DS                  ; DS=CODE SEGMENT

        MOV AX,251Ch
        MOV DX,OFFSET NOUVINT
        INT 21h                 ; installe nouvelle INT 1Ch

        POP DS                  ; restaure DS de TP
        RET                     ; retour

InstalleHorloge ENDP


DesinstalleHorloge PROC NEAR
PUBLIC DesinstalleHorloge

        PUSH DS                 ; sauvegarde DS de TP

        LDS DX,[ancint]
        MOV AX,251Ch
        INT 21h                 ; restaure ancienne INT 1Ch

        POP DS                  ; restaure DS de TP
        RET                     ; retour

DesinstalleHorloge ENDP

CODE ENDS
     END

