; MICROSOFT KILLER
; Programme trs con qui remplace le texte "Microsoft" par "coin-coin"  l'cran
; - premier appel : installation
; - deuxime appel: dsinstallation

ASSUME CS:CODE

CODE SEGMENT
     ORG 100h                   ; programme COM

debut:        jmp PROG          ; point d'entre

ancINT08      DD 0              ; ancienne adresse de int 08h (timer)

delai         EQU 9             ; dlai d'activation
compteur      DB delai          ; compteur d'activation

microsoft     DB "microsoft",0  ; chane de caractres  chercher
coin_coin     DB "coin-coin",0  ; chane de caractres  afficher

ident         DB "$"           ; chane d'identification du programme


B EQU BYTE PTR
W EQU WORD PTR


.386

INT08 PROC FAR

        pushf
        call ancINT08

        dec compteur
        jnz fin_08              ; si compteur<>0, on quitte
        call Cherche
        mov compteur,delai      ; rinitialise le compteur d'activation
fin_08:
        iret

INT08 ENDP



Cherche PROC NEAR

        pusha
        push DS

        push 0040h
        pop DS
        cmp B DS:[0049h],03h    ; mode vido courant=mode texte couleur?
        jne fin_cherche         ; non, on ne fait rien

        push 0B800h
        pop DS

        xor BX,BX               ; index de caractre  trouver
        xor SI,SI               ; index de caractre  l'cran

        cld
        mov CX,80*50
cherche_chaine:
        mov DX,W CS:microsoft[BX] ; DL=caractre  trouver, DH=caractre suivant
        lodsw                   ; AL=caractre  l'cran
        cmp AL,'Z'
        ja  minuscule
        add AL,'a'-'A'          ; convertit en minuscule
  minuscule:
        cmp AL,DL               ; compare les caractres
        jne raz_index           ; diffrents

        inc BL                  ; incrmente l'index
        or  DH,DH               ; fin de chane?
        jnz suivant             ; non

        mov DI,SI
        xor BP,BP
  affiche:
        mov AL,CS:coin_coin[BP]
        or  AL,AL
        jz  raz_index
        mov B [DI-2*9],AL
        inc DI
        inc DI
        inc BP
        jmp short affiche       ; affiche la chane

  raz_index:
        xor BL,BL               ; rinitialise l'index

  suivant:
        loop cherche_chaine

fin_cherche:
        pop DS
        popa
        ret

Cherche ENDP



LitINT MACRO numero
        mov AX,3500h+numero
        int 21h
ENDM

EcritINT MACRO numero,routine
        mov AX,2500h+numero
        lea DX,routine
        int 21h
ENDM

TesteINT MACRO numero
        LitINT numero
        cmp W ES:ident,"$"
ENDM

SauveINT MACRO numero,ancINT
        LitINT numero
        mov W [ancINT],BX
        mov W [ancINT+2],ES
ENDM

RestaureINT MACRO numero,ancINT
        lds DX,ES:ancINT
        mov AX,2500h+numero
        int 21h
ENDM

EchangeINT MACRO numero,ancINT,routine
        SauveINT numero,ancINT
        EcritINT numero,routine
ENDM



PROG PROC NEAR

        TesteINT 08h
        je desinstalle          ; ES=segment du TSR !! (code+donnes)

installe:
        EchangeINT 08h,ancINT08,INT08

        lea DX,ok_inst_msg
        mov AH,09h
        int 21h                 ; affiche un message

        lea DX,PROG
        add DX,15               ; taille du module rsident
        shr DX,4                ; taille en paragraphes
        mov AX,3100h
        int 21h                 ; termine en laissant rsident

desinstalle:
        RestaureINT 08h,ancINT08

        push CS
        pop DS

        push ES                 ; sauvegarde le segment TSR
        mov ES,ES:[002Ch]       ; segment de l'environnement PSP
        mov AH,49h
        int 21h                 ; libre la mmoire
        pop ES                  ; restaure le segment TSR
        jc  erreur_desinstalle

        mov AH,49h
        int 21h                 ; libre la mmoire (segment TSR)
        lea DX,ok_desinst_msg   ; tout va bien
        jnc ok

erreur_desinstalle:
        lea DX,err_desinst_msg  ; erreur  la dsallocation mmoire
ok:
        mov AH,09h
        int 21h                 ; affiche un message
        mov AX,4C00h
        int 21h                 ; fin

PROG ENDP


CRLF EQU 13,10
ok_inst_msg     DB "soft killer is alive.",CRLF,"$"
ok_desinst_msg  DB "I'll be back!",CRLF,"$"
err_desinst_msg DB "Shit",7,CRLF,"$"


CODE ENDS
END debut
