.MODEL SMALL,PASCAL
.386

.DATA
EXTRN Cosinus,Sinus,Cosinus2,Sinus2: WORD

.CODE
dxc DW 0        ; composante x du vecteur 'colonne' (ratio 1:1)
dyc DW 0        ; composante y du vecteur 'colonne' (ratio 1:1)
dxl DW 0        ; composante x du vecteur 'ligne' (ratio 1:1.2)
dyl DW 0        ; composante y du vecteur 'ligne' (ratio 1:1.2)

;procedure AfficheRotations(segment_image,x: word; y: byte; distance: word; angle: byte);
;Affiche les images contiges tournes de 'angle', vues depuis 'distance'
;Le centre de l'cran est le point (x,y) de l'image originelle

W EQU WORD PTR
MOVW EQU mov W CS:

PUBLIC AfficheRotations
AfficheRotations PROC NEAR segment_image: WORD, x: WORD, y: BYTE, distance: WORD, angle: BYTE

   push DS
   cld

   xor BH,BH
   mov BL,angle
   shl BX,1                     ; BX=2*angle

   mov CX,distance

   mov AX,W DS:Cosinus[BX]      ; AX=Cosinus[angle]
   imul CX                      ; [DX,AX]=Cosinus[angle]*distance
   mov AL,AH
   mov AH,DL
   mov dxc,AX                   ; dxc=(Cosinus[angle]*distance)/256

   i=0
   REPT 4
    MOVW boucle_colonne+1+14*i,AX
    i=i+1
   ENDM

   mov AX,W DS:Sinus[BX]        ; AX=Sinus[angle]
   imul CX                      ; [DX,AX]=Sinus[angle]*distance
   mov AL,AH
   mov AH,DL
   mov dyc,AX                   ; dyc=(Sinus[angle]*distance)/256

   i=0
   REPT 4
    MOVW boucle_colonne+5+14*i,AX
    i=i+1
   ENDM

   mov AX,DS:W Cosinus2[BX]     ; AX=Cosinus2[angle]
   imul CX                      ; [DX,AX]=Cosinus2[angle]*distance
   mov AL,AH
   mov AH,DL
   mov dxl,AX                   ; dxl=(Cosinus2[angle]*distance)/256

   MOVW incr_dxl-2,AX

   mov AX,W DS:Sinus2[BX]       ; AX=Sinus2[angle]
   imul CX                      ; [DX,AX]=Sinus2[angle]*distance
   mov AL,AH
   mov AH,DL
   mov dyl,AX                   ; dyl=(Sinus2[angle]*distance)/256

   MOVW incr_dyl-2,AX

   mov BX,x
   mov BH,BL
   xor BL,BL                    ; BX=x*256
   imul AX,dxc,160              ; AX=dxc*160
   sub BX,AX
   imul AX,dxl,100              ; AX=dxl*100
   sub BX,AX
   mov FS,BX                    ; FS=x*256-dxc*160-dxl*100
                                ; (coordonne x dans l'image)
   xor BL,BL
   mov BH,y                     ; BX=y*256
   imul AX,dyc,160              ; AX=dyc*160
   sub BX,AX
   imul AX,dyl,100              ; AX=dyl*100
   sub BX,AX
   mov GS,BX                    ; GS=y*256-dyc*160-dyl*100
                                ; (coordonne y dans l'image)
   mov DS,segment_image
   push 0A000h
   pop ES
   xor DI,DI                    ; ES:DI -> A000:0000

   mov CH,200                   ; 200 lignes
boucle_ligne:
   mov AX,FS                    ; AX=coordonne x dans l'image
   mov BX,GS                    ; BX=coordonne y dans l'image

   mov CL,320/4                 ; 320 colonnes
  boucle_colonne:
    REPT 4
     add AX,1234h               ; AH=Int(x), AL=Frac(x)
     add BX,1234h               ; BH=Int(y), BL=Frac(y)
     mov DL,AH
     mov DH,BH
     mov SI,DX                  ; SI=256*Int(y)+Int(x): offset du point
     movsb                      ; charge le point et l'affiche
    ENDM
    dec CL
    jnz boucle_colonne

   mov AX,FS
   add AX,1234h
  incr_dxl:
   mov FS,AX                    ; incrmente de dxl la coordonne x dans l'image

   mov AX,GS
   add AX,1234h
  incr_dyl:
   mov GS,AX                    ; incrmente de dyl la coordonne y dans l'image

   dec CH
   jnz boucle_ligne

   pop DS
   ret

AfficheRotations ENDP

END
