{$A+,G+,Q-,R-,S-}

USES Crt,Graph256,GraphX;

CONST ResX=320; ResY=400;
      ResX2=ResX div 2; ResY2=ResY div 2;

      quitte: boolean=FALSE;

VAR x,y: word;


procedure CalculePalette;
var i: byte;
    comp: RVB;
    dR,dV,dB: shortint;
begin
 with comp do   begin R:=1+Random(63); V:=1+Random(63); B:=1+Random(63) end;
 dR:=+1;
 dV:=+1;
 dB:=+1;
 for i:=1 to 255 do with comp do begin
  FixeDAC(i,comp);
  if (Random(100)=0) or (R in [0,63]) then dR:=-dR;
  if (Random(100)=0) or (V in [0,63]) then dV:=-dV;
  if (Random(100)=0) or (B in [0,63]) then dB:=-dB;
  inc(R,dR);
  inc(V,dV);
  inc(B,dB);
 end;
end;


procedure CyclePalette;
var p: Palette256;
    couleur: RVB;
begin
 p.Charge(0,256);
 couleur:=p.palette[255];
 Move(p.palette[1],p.palette[2],3*254);
 p.palette[1]:=couleur;
 p.Fixe(0,256);
end;


procedure Point2(grille: byte; x,y: word; couleur: byte);
begin
 PointX(Segment_actif_x,2*x+grille,2*y+grille,couleur);
end;



BEGIN
 InitModeX(_320x400);
 Randomize;

 for y:=0 to ResY2-1 do
  for x:=0 to ResX2-1 do
   Point2(0,x,y,1+((ResX2-1-x)*y div 40) mod 128);

 for y:=0 to ResY2-1 do
  for x:=0 to ResX2-1 do
   Point2(1,x,y,(x*(ResY2-1-y) div 60) mod 128+128);

 PermuterPages;

 CalculePalette;
 repeat
  CyclePalette;
  if Keypressed then if ReadKey=#27 then quitte:=TRUE else CalculePalette
 until quitte;

 TextMode(LastMode);
END.
