{$A+,G+,Q-,R-,S-}

USES Crt,Util,Graph256,BMP256;

CONST dt=0.1;  {intervalle de temps}
      K=0.9;   {coefficient de rebond}

      epsilon=0.1;

      XMAX=319;
      YMAX=199;

      BORDURE=25/2;
      XG=BORDURE;
      XD=XMAX-BORDURE;
      YH=YMAX-BORDURE;
      YB=BORDURE;

VAR x,y,dx,dy,anc_x,anc_y,vx,vy: real;

    image: BMP;
    erreur: word;

BEGIN
 image.Charge('C:\PROJETS\TESTS\BOULE.BMP',erreur);
 if erreur<>0 then begin writeln('Erreur BMP: ',erreur); halt; end;

 Init320x200;
 image.FixePalette;

 randomize;

 y:=YB;

 repeat
  if (y=YB) and (abs(vx)<epsilon) then begin
   EffaceZone($A000,0,0,XMAX,YMAX,0);

   x:=XG;
   y:=YB+(YH-YB)/4+(1+random)/2*(YH-YB)/2;

   vx:=5+random(60);
   vy:=random(50);
  end;

  anc_x:=x;
  anc_y:=y;

  vy:=vy-9.81*dt;

  dx:=vx*dt;
  dy:=vy*dt;

  x:=x+dx;
  y:=y+dy;

  if x<XG then begin
   y:=y+(XG-x)*dy/dx;
   x:=XG;
   vx:=-vx;
  end;

  if x>XD then begin
   y:=y+(XD-x)*dy/dx;
   x:=XD;
   vx:=-vx;
  end;

  if y<YB then begin
   x:=x+(YB-y)*dx/dy;
   y:=YB;
   if abs(x-anc_x)<epsilon then begin x:=x+dx/2; vx:=K*vx; end;
   vy:=-K*vy;
  end;

  if y>YH then begin
   x:=x+(YH-y)*dx/dy;
   y:=YH;
   vy:=-K*vy;
  end;

  AttendVBL2;
  EffaceZone($A000,round(anc_x-image.ResX/2),round(YMAX-anc_y-image.ResY/2),
                   round(anc_x+image.ResX/2),round(YMAX-anc_y+image.ResY/2),0);
  image.Affiche($A000,round(x-image.ResX/2),round(YMAX-y-image.ResY/2));

  if keypressed then case ReadKey of
   #27: break;
   ' ',#13: begin y:=YB; vx:=0; end;
  end;
 until FALSE;

 textmode(LASTMODE);
END.
