{$A+,G+,Q-,R-,S-}

USES Crt,Graph256,Evirtuel,BMP256,Souris,SourisG,Util;

CONST nbr_loupes=2;
      largeur=96; { changer selon le fichier .inc dans LOUPE.asm !!}

TYPE t_tampon=array[1..largeur,1..largeur] of byte;

VAR image: BMP;
    i,erreur: word;
    x: array[1..nbr_loupes] of word;
    y: array[1..nbr_loupes] of byte;
    dx,dy: array[1..nbr_loupes] of shortint;
    ancx,ancy: word;
    tampon_loupe: array[1..nbr_loupes] of ^t_tampon;

CONST x0=165-(largeur shr 1);
      y0=110-(largeur shr 1);
      nbr_points=100;

VAR x1: array[1..3*nbr_points] of word;
    y1: array[1..3*nbr_points] of byte;
    K: real;
    tampon_loupe1: ^t_tampon;


procedure AfficheLoupe(segment,x: word; y: byte); external;
{$L Loupe}


BEGIN
 image.Charge('C:\Projets\tests\sq4_poil.bmp',erreur);
 if erreur<>0 then begin WriteLn('erreur BMP: ',erreur); halt(1) end;

 Init320x200;
 palette_noire.Fixe(0,256);
 image.Affiche($A000,(320-image.ResX) div 2,0);
 ZoneSouris(5,10,315-largeur,200-largeur);
 image.palette.Fondu(0,256,+2);

 for i:=1 to nbr_loupes do New(tampon_loupe[i]);
 Cree_ev;
 Copie_ev;
 Randomize;
 for i:=1 to nbr_loupes do begin
  x[i]:=10+Random(300-largeur); y[i]:=10+Random(180-largeur);
  dx[i]:=1-2*Random(2); dy[i]:=1-2*Random(2);
 end;
 BougeCursSourisXY(x[nbr_loupes],y[nbr_loupes]);

 repeat
  for i:=1 to nbr_loupes do
   TransfereZone(Segment_ev,tampon_loupe[i]^,et,x[i],y[i],x[i]+largeur-1,y[i]+largeur-1);
  AttendVBL;
  for i:=1 to nbr_loupes do
   AfficheLoupe(Segment_ev,x[i],y[i]);
  if (x[nbr_loupes]<>ancx) or (y[nbr_loupes]<>ancy) then begin
   Affiche_ev;
   ancx:=x[nbr_loupes];
   ancy:=y[nbr_loupes];
  end
  else
   for i:=1 to nbr_loupes do
    TransfereZone_ev(vr,x[i]-1,y[i]-1,(x[i]+largeur-1)+1,(y[i]+largeur-1)+1);
  for i:=1 to nbr_loupes do
   TransfereZone(Segment_ev,tampon_loupe[i]^,te,x[i],y[i],x[i]+largeur-1,y[i]+largeur-1);
  for i:=1 to nbr_loupes-1 do begin
   if (x[i]=1) or (x[i]=319-largeur) then dx[i]:=-dx[i];
   if y[i] in [10,199-largeur] then dy[i]:=-dy[i];
   inc(x[i],dx[i]);
   inc(y[i],dy[i]);
  end;
  if SourisBouge then begin x[nbr_loupes]:=Xsouris; y[nbr_loupes]:=Ysouris end;
 until BoutonSouris<>aucun;

 for i:=1 to nbr_loupes do Dispose(tampon_loupe[i]);

 repeat until BoutonSouris=aucun;
 image.Affiche($A000,(320-image.ResX) div 2,0);

 New(tampon_loupe1);

 for i:=1 to 3*nbr_points do begin
  K:=2*Pi*(i-1)/nbr_points;
  x1[i]:=x0+Round(50*Cos(K)*Sin(K/3));
  y1[i]:=y0+Round(40*Sin(K)*Sin(K/8));
 end;
 i:=1;
 repeat
  TransfereZone(Segment_ev,tampon_loupe1^,et,x1[i],y1[i],x1[i]+largeur-1,y1[i]+largeur-1);
  AttendVBL;
  AfficheLoupe(Segment_ev,x1[i],y1[i]);
  TransfereZone_ev(vr,x1[i]-3,y1[i]-3,(x1[i]+largeur-1)+3,(y1[i]+largeur-1)+3);
  TransfereZone(Segment_ev,tampon_loupe1^,te,x1[i],y1[i],x1[i]+largeur-1,y1[i]+largeur-1);
  inc(i); if i>3*nbr_points then i:=1
 until BoutonSouris<>aucun;

 Dispose(tampon_loupe1);

 Supprime_ev;
 image.Supprime;
 TextMode(LastMode);
END.