PROGRAM Dump; {affiche le contenu de la mmoire sur tout l'cran}
{$A+,G+,Q-,R-,S-}

{$M 2048,0,2048}

USES Clavier,Texte,Util,UtilT;

CONST long_max=60;
      segment: word=0;
      trouve: boolean=FALSE;

      car_hexa: string[3]='$HX';

VAR anc_segment,offset_,mult: word;
    chaine: string[long_max];
    str_segment: string[5];
    abandon,appui: boolean;
    ancINT08,ancINT09: pointer;
    anc_nbr_lignes,i,base: byte;


procedure INT08; interrupt;
begin
 asm
  pushf
  call ancINT08
 end;

 AffChXY(0,25,1,EntierHexa(segment,4)+':'+EntierHexa(offset_,4),30);
end;


procedure INT09; interrupt;
begin
 appui:=(Port[$60]<$80);

 asm
  pushf
  call ancINT09
 end;
end;


BEGIN
 anc_nbr_lignes:=NombreLignes+1;
 if CarteVGA then InitTexte(50) else InitTexte(25);
 Curseur(off);

 repeat
  AttendVBL;
  asm
   push DS
   cld

   mov AL,80/4
   mul hauteur_ecran_txt
   mov CX,AX
   mov DS,segment
   mov AX,0B800h
   mov ES,AX
   xor SI,SI
   xor DI,DI
   mov AH,7

  @affiche:
   lodsb
   stosw
   lodsb
   stosw
   lodsb
   stosw
   lodsb
   stosw
   dec CX
   jnz @affiche

   pop DS
  end;

  if trouve then begin
   AffChXY(0,1+(offset_ mod 80),1+(offset_ div 80),chaine,14);
   if segment<>anc_segment then trouve:=FALSE;
  end;

  anc_segment:=segment;

  if KeyPressed then
   case ReadKey of
    Up   : dec(segment,5);
    Down : inc(segment,5);
    PgUp : dec(segment,5*hauteur_ecran_txt);
    PgDn : inc(segment,5*hauteur_ecran_txt);

    Enter: begin
            AffChXY2(0,1,1,'Segment: ^'+EntierTexte2(segment,5)+'^ (^'+EntierHexa(segment,4)+
                          '^)  Nouveau segment?'+RepeteCar(' ',80-40+1),30,31);

            str_segment:=LitChaine('',40+1,1,5+1,5,FALSE,chiffres+['A'..'F','$','H','X'],TRUE,16*1+11,16*1+15,abandon);

            if not(abandon) and (str_segment<>'') then begin
             base:=10;
             for i:=1 to Length(car_hexa) do
              while Pos(car_hexa[i],str_segment)<>0 do begin
               Delete(str_segment,Pos(car_hexa[i],str_segment),1); base:=16;
              end;

             for i:=1 to Length(str_segment) do
              if str_segment[i] in ['A'..'F'] then base:=16;

             segment:=0;
             mult:=1;
             for i:=Length(str_segment) downto 1 do begin
              case str_segment[i] of
               '0'..'9': inc(segment,mult*(BYTE(str_segment[i])-BYTE('0')));
               'A'..'F': inc(segment,mult*(BYTE(str_segment[i])-BYTE('A')+10));
              end;
              mult:=mult*base;
             end;
            end;
           end;

    Space: begin
            AffChXY(0,1,1,'Recherche:'+RepeteCar(' ',80-10),30);
            chaine:=LitChaine(chaine,10+2,1,long_max,long_max,FALSE,[' '..#255],FALSE,27,31,abandon);

            if not(abandon) then begin
             AffChXY(0,1,1,'Recherche en cours...'+RepeteCar(' ',80-21),31);
             appui:=FALSE;
             trouve:=FALSE;
             SwapIntVec($08,ancINT08,@INT08);
             SwapIntVec($09,ancINT09,@INT09);

             asm
              mov SI,OFFSET chaine
              mov CL,[SI]
              inc SI
              xor BX,BX
             @debut_segment:
              mov ES,segment
              xor DI,DI
             @cherche:
              mov offset_,DI
              mov AL,ES:[DI]
              cmp AL,[SI+BX]
              je @caractere_trouve
              xor BL,BL
              jmp @suite
             @caractere_trouve:
              inc BL
              cmp BL,CL
              jb @suite
              mov trouve,TRUE
              sub DI,BX
              inc DI
              jmp @fin
             @suite:
              inc DI
              cmp DI,120*16+long_max
              jbe @test_appui
              add segment,120
              jmp @debut_segment
             @test_appui:
              cmp appui,TRUE
              jne @cherche
             @fin:
              mov offset_,DI
             end;

             SwapIntVec($08,ancINT08,ancINT08);
             SwapIntVec($09,ancINT09,ancINT09);

             if appui then begin
              AffChXY(0,50,1,'Abandon...',31);
              Pause(9);
              VideBufferClavier;
             end;

             anc_segment:=segment;
            end;
           end;

    Esc  : break;
   end;
 until FALSE;

 InitTexte(anc_nbr_lignes);
END.
