{$A+,G+,Q-,R-,S-}

USES Crt,Graph256,BMP256,Evirtuel,Util,Souris;

CONST L=192-154+1; H=70-30+1;
      xg: word=154; yh: byte=30; xd: word=192; yb: byte=70;
      {xg=154; yh=30; xd=192; yb=70;}
      {xg=118; yh=24; xd=208; yb=90;}
      {xg=112; yh=24; xd=208; yb=190;}
      {xg=35; yh=0; xd=295; yb=10;}

      coeff_11=01; coeff_12=01; coeff_13=01;
      coeff_21=01; coeff_22=08; coeff_23=02;
      coeff_31=01; coeff_32=02; coeff_33=04;

      somme=coeff_11+coeff_12+coeff_13+
            coeff_21+coeff_22+coeff_23+
            coeff_31+coeff_32+coeff_33;

      tolerance=4;

      max_coul=32;

      quitte: boolean=FALSE;


VAR image: BMP;
    erreur: word;
    palette_grise: palette256;

    histo_R,histo_V,histo_B: array[0..63] of
                              record
                               nombre: byte;
                               couleur: array[1..max_coul] of byte;
                              end;


procedure CalculeHisto;
var palette: palette256;
    c,i: byte;
begin
 FillChar(histo_R,sizeof(histo_R),0);
 FillChar(histo_V,sizeof(histo_V),0);
 FillChar(histo_B,sizeof(histo_B),0);
 palette.Charge(0,256);
 for c:=0 to 255 do with palette.palette[c] do begin
  with histo_R[R] do if nombre<max_coul then begin inc(nombre); couleur[nombre]:=c end;
  with histo_V[V] do if nombre<max_coul then begin inc(nombre); couleur[nombre]:=c end;
  with histo_B[B] do if nombre<max_coul then begin inc(nombre); couleur[nombre]:=c end;
 end;

 {corrige les histogrammes en liminant les 0}
 for i:=0 to 63 do with histo_R[i] do
  if nombre=0 then begin nombre:=1; couleur[nombre]:=c end
              else c:=couleur[nombre];
 for i:=0 to 63 do with histo_V[i] do
  if nombre=0 then begin nombre:=1; couleur[nombre]:=c end
              else c:=couleur[nombre];
 for i:=0 to 63 do with histo_B[i] do
  if nombre=0 then begin nombre:=1; couleur[nombre]:=c end
              else c:=couleur[nombre];
end; {CalculeHisto}


procedure AfficheHisto;
var i,c: byte;

procedure Pause;
begin
 Writeln;
 if WhereY>Mem[$40:$84] then begin repeat until Readkey=' '; ClrScr end;
end;

begin
 Pause;
 for i:=0 to 63 do with histo_R[i] do begin
  Write('R',i:2,':',nombre:2,' = ');
  for c:=1 to nombre do Write(couleur[c],',');
  Pause;
 end;

 Pause;
 for i:=0 to 63 do with histo_V[i] do begin
  Write('V',i:2,':',nombre:2,' = ');
  for c:=1 to nombre do Write(couleur[c],',');
  Pause;
 end;

 Pause;
 for i:=0 to 63 do with histo_B[i] do begin
  Write('B',i:2,':',nombre:2,' = ');
  for c:=1 to nombre do Write(couleur[c],',');
  Pause;
 end;
end; {AfficheHisto}


procedure Filtre;
var Rs,Vs,Bs: word;
    palette: palette256;
    ptr_palette: pointer;
begin
 Copie_ev;

 palette.Charge(0,256);
 ptr_palette:=@palette;

{ EffaceZone($A000,xg-10,yh,xg-5,yh+5,255);}

 asm
  push DS
  cld

  mov DX,Segment_ev
  mov WORD ptr CS:[@Seg_ev-2],DX

  mov AX,0A000h
  mov ES,AX
  mov AH,yh
  inc AH
  mov DI,AX
  shr AX,2
  add DI,AX
  add DI,xg
  inc DI             {ES:DI->A000:(xg+1)+320*(yh+1)}

  mov CX,xd
  sub CX,xg
  sub CX,2
  mov WORD ptr CS:[@nbr_boucles_x-2],CX

  mov AX,320
  sub AX,CX          {incrment DI: AX=320-[(xd-1)-(xg+1)]}
  mov WORD ptr CS:[@incr_DI-2],AX

  xor CH,CH
  mov CL,yb
  sub CL,yh
  sub CL,2           {CX=(yb-1)-(yh+1)}

  jmp @ici
 @ici:

 @boucle_y:
  push CX
  mov CX,1234h
  @nbr_boucles_x:

  @boucle_x:
   push CX

   lds SI,ptr_palette

   mov Rs,0
   mov Vs,0
   mov Bs,0

   {cumul des 9 composantes pondres}

   xor BH,BH
   mov BL,ES:[DI-321]
   mov AX,BX
   shl BX,1
   add BX,AX          {BX=3*couleur(-1,-1)}
   mov CL,coeff_11
   mov AL,[SI][BX]
   mul CL
   add Rs,AX
   mov AL,[SI][BX+1]
   mul CL
   add Vs,AX
   mov AL,[SI][BX+2]
   mul CL
   add Bs,AX

   xor BH,BH
   mov BL,ES:[DI-320]
   mov AX,BX
   shl BX,1
   add BX,AX          {BX=3*couleur( 0,-1)}
   mov CL,coeff_12
   mov AL,[SI][BX]
   mul CL
   add Rs,AX
   mov AL,[SI][BX+1]
   mul CL
   add Vs,AX
   mov AL,[SI][BX+2]
   mul CL
   add Bs,AX

   xor BH,BH
   mov BL,ES:[DI-319]
   mov AX,BX
   shl BX,1
   add BX,AX          {BX=3*couleur(+1,-1)}
   mov CL,coeff_13
   mov AL,[SI][BX]
   mul CL
   add Rs,AX
   mov AL,[SI][BX+1]
   mul CL
   add Vs,AX
   mov AL,[SI][BX+2]
   mul CL
   add Bs,AX

   xor BH,BH
   mov BL,ES:[DI-  1]
   mov AX,BX
   shl BX,1
   add BX,AX          {BX=3*couleur(-1, 0)}
   mov CL,coeff_21
   mov AL,[SI][BX]
   mul CL
   add Rs,AX
   mov AL,[SI][BX+1]
   mul CL
   add Vs,AX
   mov AL,[SI][BX+2]
   mul CL
   add Bs,AX

   xor BH,BH
   mov BL,ES:[DI-  0]
   mov AX,BX
   shl BX,1
   add BX,AX          {BX=3*couleur( 0, 0)}
   mov CL,coeff_22
   mov AL,[SI][BX]
   mul CL
   add Rs,AX
   mov AL,[SI][BX+1]
   mul CL
   add Vs,AX
   mov AL,[SI][BX+2]
   mul CL
   add Bs,AX

   xor BH,BH
   mov BL,ES:[DI+  1]
   mov AX,BX
   shl BX,1
   add BX,AX          {BX=3*couleur(+1, 0)}
   mov CL,coeff_23
   mov AL,[SI][BX]
   mul CL
   add Rs,AX
   mov AL,[SI][BX+1]
   mul CL
   add Vs,AX
   mov AL,[SI][BX+2]
   mul CL
   add Bs,AX

   xor BH,BH
   mov BL,ES:[DI+319]
   mov AX,BX
   shl BX,1
   add BX,AX          {BX=3*couleur(-1,+1)}
   mov CL,coeff_31
   mov AL,[SI][BX]
   mul CL
   add Rs,AX
   mov AL,[SI][BX+1]
   mul CL
   add Vs,AX
   mov AL,[SI][BX+2]
   mul CL
   add Bs,AX

   xor BH,BH
   mov BL,ES:[DI+320]
   mov AX,BX
   shl BX,1
   add BX,AX          {BX=3*couleur( 0,+1)}
   mov CL,coeff_32
   mov AL,[SI][BX]
   mul CL
   add Rs,AX
   mov AL,[SI][BX+1]
   mul CL
   add Vs,AX
   mov AL,[SI][BX+2]
   mul CL
   add Bs,AX

   xor BH,BH
   mov BL,ES:[DI+321]
   mov AX,BX
   shl BX,1
   add BX,AX          {BX=3*couleur(+1,+1)}
   mov CL,coeff_33
   mov AL,[SI][BX]
   mul CL
   add Rs,AX
   mov AL,[SI][BX+1]
   mul CL
   add Vs,AX
   mov AL,[SI][BX+2]
   mul CL
   add Bs,AX

   {moyennage}

   mov BH,somme
   mov AX,Rs
   div BH
   mov BL,AL          {BL=Rs/somme: moyenne de Rouge}
   mov AX,Vs
   div BH
   mov DH,AL          {DH=Vs/somme: moyenne de Vert}
   mov AX,Bs
   div BH
   mov DL,AL          {DL=Bs/somme: moyenne de Bleu}

   {recherche de la couleur la plus proche de la moyenne}

   mov BH,3*64        {valeur de dpart pour min()}
   xor CL,CL
  @cherche_couleur:
   lodsb
   sub AL,BL
   jns @fin_R
   neg AL
   @fin_R:
   mov AH,AL          {AH=R-(Rs/somme)=R}
   lodsb
   sub AL,DH
   jns @fin_V
   neg AL
   @fin_V:
   add AH,AL          {AH=AH+V-(Vs/somme)=AH+V}
   lodsb
   sub AL,DL
   jns @fin_B
   neg AL
   @fin_B:
   add AH,AL          {AH=AH+B-(Bs/somme)=AH+B}
   cmp AH,BH
   jae @suite
   mov BH,AH          {BH=min()}
   mov CH,CL          {CH=n couleur la plus proche}
   cmp BH,tolerance
   jbe @ecrit_point   {min()<=tolrance -> accepte cette couleur }
   @suite:
   inc CL
   jnz @cherche_couleur

   {criture du point}

  @ecrit_point:
   mov DX,1234h
   @Seg_ev:
   mov ES,DX
   mov ES:[DI],CH
   inc DI

   pop CX
   dec CX
   jnz @boucle_x

  add DI,1234h
  @incr_DI:

  pop CX
  dec CX
  jnz @boucle_y

  pop DS
 end;

 Affiche_ev;
end; {Filtre}


procedure NiveauxGris(var palette: palette256); assembler;
const coef_R=77; coef_V=128; coef_B=256-coef_R-coef_V;
asm
 cld
 les DI,palette
 xor CL,CL
@calcule_couleur:
 mov AL,coef_R
 mul BYTE ptr ES:[DI]
 mov BX,AX
 mov AL,coef_V
 mul BYTE ptr ES:[DI+1]
 add BX,AX
 mov AL,coef_B
 mul BYTE ptr ES:[DI+2]
 add AX,BX
 mov AL,AH
 stosw
 stosb
 dec CL
 jnz @calcule_couleur
end; {NiveauxGris}


BEGIN
 with image do begin
  Charge('C:\Projets\tests\sq4.bmp',erreur);
  if erreur=0 then begin
   Init320x200;

   Cree_ev;

   palette_noire.Fixe(0,256);
   Affiche($A000,0,0);
   palette.Fondu(0,256,16);

   CalculeHisto;

   ZoneSouris(0,0,319-L,199-H);

   repeat
    repeat until Keypressed or SourisBouge;
    if Keypressed then
     case UpCase(ReadKey) of
      'F': Filtre;
      'G': with palette_grise do begin
            Charge(0,256);
            NiveauxGris(palette_grise);
            Fixe(0,256);
            CalculeHisto;
           end;
      #27: quitte:=TRUE;
     end
    else begin
     xg:=Xsouris; yh:=Ysouris;
     xd:=xg+L-1; yb:=yh+H-1;
     Filtre;
    end;
   until quitte;

   palette_noire.Fondu(0,256,auto);
   Supprime;

   Supprime_ev;

   TextMode(CO80+Font8x8);

   AfficheHisto;
  end
  else WriteLn('Erreur BMP ',erreur);
 end;
END.
