{Programme de dmo pour la disquette de L'INFO DES SAVANES n2 - mai 1995}

{$A+,G+,Q-,R-,S-}

USES Crt,Clavier,Util,LZ,Fichiers,Fich_Grp,Graph256,Evirtuel,BMP256_G;

CONST largeur=96; { changer selon le fichier .inc dans LOUPE.asm !!}

TYPE t_tampon=array[1..largeur,1..largeur] of byte;

VAR image: BMP;
    i,erreur: word;

CONST x0=165-(largeur shr 1);
      y0=110-(largeur shr 1);
      nbr_points=100;

      loupe_dat: array[1..9] of char='LOUPE.DAT';
      loupe_tmp: array[1..9] of char='LOUPE.TMP';

      nom_image: array[1..2] of string[10]=('WOILD3.BMP','SQ4.BMP');
      numero_image: byte=1;

VAR x1: array[1..3*nbr_points] of word;
    y1: array[1..3*nbr_points] of byte;
    K: real;
    tampon_loupe1: ^t_tampon;


procedure AfficheLoupe(segment,x: word; y: byte); external;
{$L Loupe}


BEGIN
 if not(CarteVGA) then
  begin WriteLn('Ce programme ncessite une carte VGA !'); halt(1) end;

 if Processeur<_386 then
  begin WriteLn('Ce programme ncessite un 386 minimum !'); halt(2) end;

 if ParamCount>=1 then
  if Maj(ParamStr(1))=CopyL(nom_image[2],3) then numero_image:=2;

 DecompLZf(loupe_dat,loupe_tmp,erreur);
 if erreur<>0 then begin WriteLn('erreur LZ: ',erreur); halt(4) end;

 DefinitFichierGroupe(loupe_tmp);
 if f_erreur>f_ok then begin WriteLn('erreur Groupe: ',f_erreur); halt(5) end;

 image.Charge(nom_image[numero_image],erreur);
 if erreur<>0 then begin WriteLn('erreur BMP: ',erreur); halt(6) end;

 Init320x200;
 palette_noire.Fixe(0,256);
 image.Affiche($A000,0,0);
 image.palette.Fondu(0,256,auto);

 Cree_ev;
 Copie_ev;
 Randomize;

 New(tampon_loupe1);

 for i:=1 to 3*nbr_points do begin
  K:=2*Pi*(i-1)/nbr_points;
  x1[i]:=x0+Round(50*Cos(K)*Sin(K/3));
  y1[i]:=y0+Round(40*Sin(K)*Sin(K/8));
 end;

 i:=1;
 repeat
  TransfereZone(Segment_ev,tampon_loupe1^,et,x1[i],y1[i],x1[i]+largeur-1,y1[i]+largeur-1);
  AfficheLoupe(Segment_ev,x1[i],y1[i]);
  TransfereZone_ev(vr,x1[i]-3,y1[i]-3,(x1[i]+largeur-1)+3,(y1[i]+largeur-1)+3);
  TransfereZone(Segment_ev,tampon_loupe1^,te,x1[i],y1[i],x1[i]+largeur-1,y1[i]+largeur-1);
  inc(i); if i>3*nbr_points then i:=1;
 until KeyPressed;

 palette_noire.Fondu(0,256,auto);

 VideBufferClavier;

 Dispose(tampon_loupe1);
 Supprime_ev;
 image.Supprime;
 FermeFichierGroupe;

 EcraseFichier(loupe_tmp);

 TextMode(LastMode);
END.