{$A+,G+,N+,Q-,R-,S-}

USES Crt,Graph256,Evirtuel;

CONST hauteur=20;
      largeur=20;
      Forme: array[1..hauteur,1..largeur] of byte
              =((5,4,3,3,2,2,1,1,0,0,0,0,1,1,2,2,3,3,4,5),
                (4,5,4,3,3,2,2,2,1,1,1,1,2,2,2,3,3,4,5,4),
                (3,4,5,4,3,3,2,2,2,2,2,2,2,2,3,3,4,5,4,3),
                (3,3,4,5,4,4,3,3,2,2,2,2,3,3,4,4,5,4,3,3),
                (2,3,3,4,5,4,4,4,3,3,3,3,4,4,4,5,4,3,3,2),
                (2,2,3,4,4,5,5,4,4,4,4,4,4,5,5,4,4,3,2,2),
                (1,2,2,3,4,5,5,5,4,4,4,4,5,5,5,4,3,2,2,1),
                (1,2,2,3,4,4,5,5,5,5,5,5,5,5,4,4,3,2,2,1),
                (0,1,2,2,3,4,4,5,5,5,5,5,5,4,4,3,2,2,1,0),
                (0,1,2,2,3,4,4,5,5,6,6,5,5,4,4,3,2,2,1,0),
                (0,1,2,2,3,4,4,5,5,6,6,5,5,4,4,3,2,2,1,0),
                (0,1,2,2,3,4,4,5,5,5,5,5,5,4,4,3,2,2,1,0),
                (1,2,2,3,4,4,5,5,5,5,5,5,5,5,4,4,3,2,2,1),
                (1,2,2,3,4,5,5,5,4,4,4,4,5,5,5,4,3,2,2,1),
                (2,2,3,4,4,5,5,4,4,4,4,4,4,5,5,4,4,3,2,2),
                (2,3,3,4,5,4,4,4,3,3,3,3,4,4,4,5,4,3,3,2),
                (3,3,4,5,4,4,3,3,2,2,2,2,3,3,4,4,5,4,3,3),
                (3,4,5,4,3,3,2,2,2,2,2,2,2,2,3,3,4,5,4,3),
                (4,5,4,3,3,2,2,2,1,1,1,1,2,2,2,3,3,4,5,4),
                (5,4,3,3,2,2,1,1,0,0,0,0,1,1,2,2,3,3,4,5));

      coef_couleur=150;
      coef_deplacement=20;

      x0=160-(largeur shr 1);
      y0=100-(hauteur shr 1);

      dt=2*Pi/50;

      {modes de dplacement}
      aucun=0;
      lineaire=1;
      circulaire=2;
      combine=3;

      matrice_filtre: array[1..3,1..3] of byte
                      =((04,01,02),
                        (01,06,01),
                        (02,01,03));

      fin: boolean=FALSE;
      plasma: boolean=FALSE;
      deplacement: byte=combine;

VAR x,y: integer;
    dx,dy,dr: ShortInt;
    r,t: real;
    anc_depl: byte;
    nouveau: boolean;


procedure CalculePalette;
var i: byte;
    comp: RVB;
    dR,dV,dB: shortint;
begin
 with comp do begin R:=1+Random(63); V:=1+Random(63); B:=1+Random(63) end;
 dR:=+1;
 dV:=+1;
 dB:=+1;
 for i:=0 to 255 do with comp do begin
  FixeDAC(i,comp);
  if (Random(coef_couleur)=0) or (R in [0,63]) then dR:=-dR;
  if (Random(coef_couleur)=0) or (V in [0,63]) then dV:=-dV;
  if (Random(coef_couleur)=0) or (B in [0,63]) then dB:=-dB;
  inc(R,dR);
  inc(V,dV);
  inc(B,dB);
 end;
end;


procedure CyclePalette;
var p: Palette256;
    couleur: RVB;
begin
 p.Charge(0,256);
 couleur:=p.palette[255];
 Move(p.palette[0],p.palette[1],3*255);
 p.palette[0]:=couleur;
 p.Fixe(0,256);
end;


procedure AfficheForme(x,y: integer);
begin
 AfficheFormeLimite(Forme,$A000,x,y,largeur,hauteur,TRUE,FALSE,ADD_,0,0,319,199);
end;


procedure Change_x_y;
begin
 if (Random(coef_deplacement)=0) or (x=0) or (x=319-largeur) then dx:=-dx;
 if (Random(coef_deplacement)=0) or (y=0) or (y=199-hauteur) then dy:=-dy;
 inc(x,dx);
 inc(y,dy);
end;


procedure Change_r;
begin
 if (Random(coef_deplacement)=0) or (r<=0) or (r>=320) then dr:=-dr;
 r:=r+dr;
 t:=t+dt;
end;


procedure FiltreRapide; assembler;
asm
 push DS
 cld
 mov AX,0A000h
 mov DS,AX
 mov ES,AX
 mov DI,1+320*1
 xor BH,BH
 mov CX,(320-2)*(200-2)
@calcule_filtre:
 xor AX,AX
 add AL,[DI-321]
 adc AH,BH
 add AL,[DI-320]
 adc AH,BH
 add AL,[DI-319]
 adc AH,BH
 add AL,[DI-  1]
 adc AH,BH
 add AL,[DI+  1]
 adc AH,BH
 add AL,[DI+319]
 adc AH,BH
 add AL,[DI+320]
 adc AH,BH
 add AL,[DI+321]
 adc AH,BH
 xor DH,DH
 mov DL,[DI]
 shl DX,3
 add AX,DX
 shr AX,4
 stosb
 dec CX
 jnz @calcule_filtre
 pop DS
end; {FiltreRapide}



procedure Filtre; assembler;
asm
 push 0
 call Efface_ev

 mov BX,3*3
 xor AL,AL
@calcule_diviseur:
 add AL,BYTE(matrice_filtre[BX-1])
 dec BL
 jnz @calcule_diviseur
 mov DL,AL

 cld
 mov DI,1+320*1
 mov CX,(320-2)*(200-2)
@calcule_filtre:
 mov AX,0A000h
 mov ES,AX
 xor BX,BX
 xor AH,AH
 mov AL,ES:[DI-321]
 mul BYTE(matrice_filtre[1])
 add BX,AX
 xor AH,AH
 mov AL,ES:[DI-320]
 mul BYTE(matrice_filtre[2])
 add BX,AX
 xor AH,AH
 mov AL,ES:[DI-319]
 mul BYTE(matrice_filtre[3])
 add BX,AX
 xor AH,AH
 mov AL,ES:[DI-  1]
 mul BYTE(matrice_filtre[4])
 add BX,AX
 xor AH,AH
 mov AL,ES:[DI    ]
 mul BYTE(matrice_filtre[5])
 add BX,AX
 xor AH,AH
 mov AL,ES:[DI+  1]
 mul BYTE(matrice_filtre[6])
 add BX,AX
 xor AH,AH
 mov AL,ES:[DI+319]
 mul BYTE(matrice_filtre[7])
 add BX,AX
 xor AH,AH
 mov AL,ES:[DI+320]
 mul BYTE(matrice_filtre[8])
 add BX,AX
 xor AH,AH
 mov AL,ES:[DI+321]
 mul BYTE(matrice_filtre[9])
 add BX,AX
 mov AX,BX
 div DL
 mov ES,Segment_ev
 stosb
 dec CX
 jnz @calcule_filtre

 call Affiche_ev
end; {Filtre}


BEGIN
 Init320x200;
 Randomize;

 Cree_ev;

 for y:=1 to hauteur do
  for x:=1 to largeur do Forme[y,x]:=Round(Forme[y,x]*0.5);

 repeat
  nouveau:=FALSE;
  CalculePalette;
  EffaceZone($A000,0,0,319,199,0);
  x:=x0; y:=y0;
  dx:=+1; dy:=+1;
  r:=10; t:=0;
  dr:=+1;
  repeat
   repeat
    case deplacement of
     lineaire: begin
                AfficheForme(x,y);
                Change_x_y;
               end;
     circulaire: begin
                  AfficheForme(x0+Round(r*Cos(t)),y0+Round(r*Sin(t)));
                  Change_r;
                 end;
     combine: begin
               AfficheForme(x+Round(r*Cos(t)),y+Round(r*Sin(t)));
               Change_x_y; Change_r;
              end;
    end;
    if plasma then CyclePalette;
   until KeyPressed;

   case UpCase(ReadKey) of
    #27: fin:=TRUE;
    'P': plasma:=not(plasma);
    'D': if deplacement<>aucun then
          deplacement:=1+(deplacement mod 3);
    'F': Filtre;
    'R': FiltreRapide;
    ' ': if deplacement<>aucun then begin
          anc_depl:=deplacement; deplacement:=aucun;
         end
         else deplacement:=anc_depl;
    #13: begin
          nouveau:=TRUE;
          if deplacement=aucun then deplacement:=anc_depl;
         end;
   end;
  until fin or nouveau;
 until fin;

 Supprime_ev;

 TextMode(LastMode);
END.
