{$A+,G+,N-,Q-,R-,S-}

USES Crt,Dos,Util,BMP256;

CONST CRLF=#13#10;

VAR info: SearchRec;
    rep: DirStr;
    nom: NameStr;
    ext: ExtStr;

    nom_fichier: string[12];

    image: BMP;
    erreur: word;

    n_couleurs,nc_ini,nc: word;


Procedure Syntaxe;
begin
  Writeln('syntaxe: ReduBMP nom_image[.BMP] n_couleurs',CRLF,
          '         2  n_couleurs  256',CRLF);
end; {Syntaxe}


BEGIN
  Writeln(CRLF,
          'ReduBMP v1.0 - (c) 1999 Fabrice Couteau',CRLF,
          'Rducteur de couleurs pour images BitMap RGB 8 bits',CRLF);

  if ParamCount<>2 then begin Syntaxe; halt(1); end;

  Val(ParamStr(2),n_couleurs,erreur);
  if (n_couleurs<2) or (n_couleurs>256) or (erreur<>0) then begin Syntaxe; halt(1); end;

  FSplit(ParamStr(1),rep,nom,ext);
  if ext='' then ext:='.BMP';

  FindFirst(rep+nom+ext,Archive,info);
  while DosError=0 do begin
    nom_fichier:=info.Name;
    Write(nom_fichier+' ':15);

    with image do begin
      Charge(rep+nom_fichier,erreur);
      if erreur=0 then begin
        nc_ini:=NombreCouleurs;
        ReduitPalette(n_couleurs);
        nc:=NombreCouleurs;

        Sauve(rep+nom_fichier,erreur);
        if erreur=0 then begin
          Write(nc_ini:3,' -> ',nc:3,' ');
          if nc=n_couleurs then Write(integer(nc)-nc_ini:3) else Write('*');
          Writeln;
        end
        else Writeln('Erreur d''criture (',erreur,')');

        Supprime;
      end
      else case erreur of
          1: Writeln('Format non support');
          2: Writeln('Fichier introuvable');
          3: Writeln('Chemin introuvable');
          6: Writeln('Mmoire insuffisante');
        else Writeln('Erreur de lecture (',erreur,')');
      end;
    end;

    FindNext(info);
  end;
END.
