PROGRAM Reussite;
{$A+,G+,Q-,R-,S-}

USES Crt,Clavier,Texte,Util,UtilT,Souris,SourisT;

{$UNDEF Mouchard}

TYPE hiscore=record
              nom: string[15];
              score: longint;
             end;

CONST Trefle =#5;
      Carreau=#4;
      Coeur  =#3;
      Pique  =#6;
      Couleurs: array[1..4] of char=(Trefle,Carreau,Coeur,Pique);
                                    {   1      2      3     4  }
      As=1; Roi=13;

      nom_fichier='REUSSITE.SCO';

      nbr_scores=15;
      best: array[1..nbr_scores] of hiscore
             =((nom:'';score:0),
               (nom:'';score:0),
               (nom:'';score:0),
               (nom:'';score:0),
               (nom:'';score:0),
               (nom:'';score:0),
               (nom:'';score:0),
               (nom:'';score:0),
               (nom:'';score:0),
               (nom:'';score:0),
               (nom:'';score:0),
               (nom:'';score:0),
               (nom:'';score:0),
               (nom:'';score:0),
               (nom:'';score:0));

{$IFDEF Mouchard}
      mouchard: boolean=TRUE;
{$ENDIF}
      son: boolean=TRUE;
      modification: boolean=FALSE;


TYPE T_Carte=record Valeur,Couleur: byte end;
             { 1Valeur13, 1Couleur4 }


VAR Talon: array[1..2] of
            record
             Nombre: byte;
             Carte: array[1..52] of T_Carte;
            end;

    Jeu: array[1..7] of
          record
           NombreCache,Nombre: byte;
           {nombre de cartes visibles=Nombre-NombreCache}
           Carte: array[1..7+13] of T_Carte;
           {pire des cas: 7 cartes retournes (tas de droite) + 13 cartes
            par-dessus (du Roi  l'As) -> 20 max !}
          end;

    Pile: array[1..4] of
           record
            Nombre: byte;
            Carte: array[As..Roi] of T_Carte;
           end;

    Prise: record
            Tas,Nombre: byte;
            Carte: array[1..13] of T_Carte;
           end;

    ZoneCarte: record
                x1,y1,x2,y2,xi,yi: shortint;
               end;

    autorise_clique,carte_prise,zone_maxi,
    timer_actif,recommence,quitte: boolean;
    anc_x,anc_y: byte;
    compteur,pts,score: longint;
    zone1,zone2: Zone;
    ancINT1C: pointer;

{--------------------------------------------------------------------}

procedure AfficheScoreTemps;
var duree_sec: longint;
begin
 duree_sec:=Round(compteur/18.2);
 if duree_sec<>0 then score:=Round(pts/(duree_sec/60));
 CacheCursSouris;
 AffChXY(0,4,24,EntierTexte2(pts,5),49);
 AffChXY(0,20,24,EntierTexte2(duree_sec div 60,2+et_zeros)+':'+
                 EntierTexte2(duree_sec mod 60,2+et_zeros),49);
 AffChXY(0,36,24,EntierTexte2(score,5),49);
 AffCursSouris;
end; {AfficheScoreTemps}

{--------------------------------------------------------------------}

procedure INT1C; interrupt; {appele 18.2 fois/sec.}
begin
 if not(timer_actif) then exit;

 inc(compteur);
 if ((compteur mod 18)=0) and son then
  begin
   Sound(50);
   asm
    mov CX,200
   @boucle:
    loop @boucle
   end;
   NoSound;
  end;
 if (compteur mod 9)=0 then AfficheScoreTemps;
end; {INT1C}

{--------------------------------------------------------------------}

procedure Bip(frequence: word);
begin
 if son then begin Sound(frequence); Delay(2); NoSound end;
end; {Bip}

{--------------------------------------------------------------------}

procedure AfficheFondEcran;
var y: byte;
begin
 for y:=1 to 25 do AffChXY(0,1,y,RepeteCar('',79)+' ',2);
 AffChXY(0,3,24,
  '     0 Points    00:00    Score:     0   S:Son  :Recommence  Esc:Quitte ',49);
end; {AfficheFondEcran}

{--------------------------------------------------------------------}

procedure DessineCarte(x,y: byte; carte: T_Carte);
const Nom: array[As..Roi] of string[2]
            =('1','2','3','4','5','6','7','8','9','10','V','D','R');
      Masque: array[As..Roi,1..5] of string[5]
               =(('     ','     ','  *  ','     ','     '),
                 ('  *  ','     ','     ','     ','  *  '),
                 ('  *  ','     ','  *  ','     ','  *  '),
                 ('*   *','     ','     ','     ','*   *'),
                 ('*   *','     ','  *  ','     ','*   *'),
                 ('*   *','     ','*   *','     ','*   *'),
                 ('*   *','  *  ','*   *','     ','*   *'),
                 ('*   *','*   *','     ','*   *','*   *'),
                 ('*   *','*   *','  *  ','*   *','*   *'),
                 ('*   *','* * *','     ','* * *','*   *'),
                 ('     ','     ','Valet','     ','     '),
                 ('     ','     ','Dame ','     ','     '),
                 ('     ','     ',' Roi ','     ','     '));
      coul: array[1..4] of byte=(112,116,116,112);

var i,j: byte;
    ligne: string[5];
    car: char;
begin
 AffChXY(0,x,y-6,' Ŀ',113);
 for i:=1 to 5 do AffChXY(0,x,y+i-6,'       ',113);
 AffChXY(0,x,y,' ',113);
 with carte do begin
  AffChXY(0,x,y-6,Nom[Valeur]+Couleurs[Couleur],coul[Couleur]);
  AffChXY(0,x+8-Length(Nom[Valeur]),y,Nom[Valeur]+Couleurs[Couleur],coul[Couleur]);
 end;
 for i:=1 to 5 do begin
  ligne:='';
  for j:=1 to 5 do begin
   car:=Masque[carte.Valeur,i][j];
   if car='*' then ligne:=ligne+Couleurs[carte.Couleur] else ligne:=ligne+car;
  end;
  AffChXY(0,x+2,y+i-6,ligne,coul[carte.Couleur]);
 end;
end; {DessineCarte}

{--------------------------------------------------------------------}

procedure DessineDos(x,y: byte);
var i: byte;
begin
 for i:=1 to 7 do AffChXY(0,x,y+i-7,RepeteCar('',9),113);
end; {DessineDos}

{--------------------------------------------------------------------}

procedure DessineVide(x,y: byte);
var i: byte;
begin
 for i:=1 to 7 do AffChXY(0,x,y+i-7,RepeteCar(' ',9),79);
end; {DessineVide}

{--------------------------------------------------------------------}

procedure AfficheTalon(tas: byte); {1tas2}
begin
 with Talon[tas] do begin
  if Nombre=0 then DessineVide(11*tas-8,8)
  else
   if tas=1 then DessineDos(11*tas-8,8)
            else DessineCarte(11*tas-8,8,Carte[Nombre]);
 end;
end; {AfficheTalon}

{--------------------------------------------------------------------}

procedure AfficheJeu(tas: byte); {1tas7}
const fond: array[1..9] of char='';
begin
 with Jeu[tas] do begin
  if NombreCache=0 then begin
   DessineVide(11*tas-8,19);
   AffChXY(0,11*tas-8,11,fond,2);
   AffChXY(0,11*tas-8,12,fond,2)
  end
  else DessineDos(11*tas-8,17);

  if Nombre-NombreCache>0 then begin
   DessineCarte(11*tas-8,19,Carte[NombreCache+1]);
   if Jeu[tas].Nombre-NombreCache>1 then
    DessineCarte(11*tas-8,21,Carte[NombreCache+Nombre-NombreCache]);
  end;

  if (Nombre-NombreCache=0) and (NombreCache>0) then begin
   AffChXY(0,11*tas-8,18,fond,2);
   AffChXY(0,11*tas-8,19,fond,2);
  end;
  if Nombre-NombreCache<=1 then begin
   AffChXY(0,11*tas-8,20,fond,2);
   AffChXY(0,11*tas-8,21,fond,2);
  end;
 end;
end; {AfficheJeu}

{--------------------------------------------------------------------}

procedure AffichePile(tas: byte); {1tas4}
begin
 with Pile[tas] do begin
  if Nombre=0 then begin
   DessineVide(25+11*tas,8);
   AffCarXY(0,29+11*tas,5,Couleurs[tas],79);
  end
  else DessineCarte(25+11*tas,8,Carte[Nombre]);
 end;
end; {AffichePile}

{--------------------------------------------------------------------}

function Points: word;
var i,valeur: byte;
    pts: word;
begin
 pts:=0;
 for i:=1 to Prise.Nombre do begin
  valeur:=Prise.Carte[i].Valeur;
  if valeur<=10 then inc(pts,10*valeur) else inc(pts,100);
 end;
 Points:=pts;
end; {Points}

{--------------------------------------------------------------------}

function OkRougeNoir(carte_destination: T_Carte): boolean;
{renvoie TRUE si l'une est noire (1:trfle,4:pique) et l'autre est rouge (2:carreau,3:coeur)
 et si la valeur de la premire carte prise est juste infrieure  celle de la carte destination.
 (associations possibles: 1+2,1+3,4+2,4+3)}
begin
 with Prise.Carte[1] do
  OkRougeNoir:=(Valeur+1=carte_destination.Valeur) and
               (Couleur<>carte_destination.Couleur) and
               (Couleur+carte_destination.Couleur<>5);
end; {OkRougeNoir}

{--------------------------------------------------------------------}

function TasDetecte(x,y: byte): byte;
var i: byte;
{ ĿĿ    ĿĿĿĿ
   1 2     3 4 5 6
                  
      

  
  ĿĿĿĿĿĿĿ
   7 8 910111213
                
  
   }
begin
 TasDetecte:=0;
 if y in [2..8] then
  case x of
    3..11: TasDetecte:=1;
   14..22: TasDetecte:=2;
   36..44: TasDetecte:=3;
   47..55: TasDetecte:=4;
   58..66: TasDetecte:=5;
   69..77: TasDetecte:=6;
  end
 else
  for i:=0 to 6 do
   if (x in [11*i+3..11*i+11]) and (y in [11..21]) then
    begin TasDetecte:=7+i; break end;
end; {TasDetecte}

{--------------------------------------------------------------------}

procedure EnleveCarte(tas_source,nombre_cartes: byte);
var i: byte;
begin
 Prise.Tas:=tas_source;
 Prise.Nombre:=nombre_cartes;

 case tas_source of
  1,2: with Talon[tas_source] do  {on ne peut enlever qu'une carte}
      begin
       Prise.Carte[1]:=Carte[Nombre];
       dec(Nombre);
       AfficheTalon(tas_source);
      end;
  7..13: with Jeu[tas_source-6] do begin
          for i:=1 to nombre_cartes do
           Prise.Carte[i]:=Carte[Nombre+i-nombre_cartes];
          dec(Nombre,nombre_cartes);
          AfficheJeu(tas_source-6);
         end;
 end;
end; {EnleveCarte}

{--------------------------------------------------------------------}

procedure AjouteCarte(tas_destination: byte);
var i: byte;
begin
 case tas_destination of
  2: with Talon[2] do begin
      for i:=1 to Prise.Nombre do Carte[Nombre+i]:=Prise.Carte[i];
      inc(Nombre,Prise.Nombre);
      AfficheTalon(2);
     end;
  3,4,5,6: with Pile[tas_destination-2] do begin  {on ne peut ajouter qu'une carte}
            Carte[Nombre+1]:=Prise.Carte[1];
            inc(Nombre);
            AffichePile(tas_destination-2);
           end;
  7..13: with Jeu[tas_destination-6] do begin
          for i:=1 to Prise.Nombre do Carte[Nombre+i]:=Prise.Carte[i];
          inc(Nombre,Prise.Nombre);
          AfficheJeu(tas_destination-6);
         end;
 end;
end; {AjouteCarte}

{--------------------------------------------------------------------}

procedure TireCarte;

procedure RetourneTalon;
var i: byte;
begin
 for i:=1 to Talon[2].Nombre do
  Talon[1].Carte[Talon[2].Nombre-i+1]:=Talon[2].Carte[i];
 Talon[1].Nombre:=Talon[2].Nombre;
 Talon[2].Nombre:=0;
end;

begin
 if Talon[1].Nombre>0 then
  begin EnleveCarte(1,1); AjouteCarte(2) end
 else
  if Talon[2].Nombre>0 then
   begin RetourneTalon; TireCarte end;
 Bip(2000);
end; {TireCarte}

{--------------------------------------------------------------------}

procedure PrendCarte(tas,nombre: byte);
var xs,ys,x,y: byte;
begin
 with ZoneCarte do begin
  {recherche les coordonnes de la carte clique}
  xs:=Xsouris; ys:=Ysouris; x:=xs; y:=ys;
  while CodeXY(0,xs,y)<>176 do inc(y);
  y2:=y-1; y1:=y-7;
  while CodeXY(0,x,ys)<>176 do inc(x);
  x2:=x-1; x1:=x-9;
  if nombre>1 then dec(y1,2);
  xi:=xs; yi:=ys;

  zone2.Sauve(0,x1,y1,x2,y2);
  ZoneSouris(1+(xi-x1),1+(yi-y1),79-(x2-xi),23-(y2-yi));
  zone_maxi:=FALSE;
  EnleveCarte(tas,nombre);
  zone1.Sauve(0,x1,y1,x2,y2);
 end;
 zone2.Restaure(0,0,0,0);
 Bip(2000);
 carte_prise:=TRUE;
end; {PrendCarte}

{--------------------------------------------------------------------}

procedure EffaceZoneCarte(ok_bip: boolean);
begin
 zone1.Restaure(0,0,0,0);
 zone1.Supprime; zone2.Supprime;
 if ok_bip then Bip(1000);
 carte_prise:=FALSE;
end; {EffaceZoneCarte}

{--------------------------------------------------------------------}

procedure ReposeCarte;
begin
 EffaceZoneCarte(FALSE);
 AjouteCarte(Prise.Tas);
end; {ReposeCarte}

{--------------------------------------------------------------------}

procedure GestionClavierSouris;
var i,tas,x,y: byte;
    incr_points: integer;
    trouve: boolean;

{$IFDEF Mouchard}
procedure AfficheNomCarte(carte: T_Carte);
const Nom: array[As..Roi] of string[2]
           =('1','2','3','4','5','6','7','8','9','10','V','D','R');
begin
 with carte do begin
  if Couleur in [1,4] then TextColor(0) else TextColor(4);
  Write(Nom[Valeur]+Couleurs[Couleur],' ');
 end;
end;
{$ENDIF}

begin
 x:=Xsouris; y:=Ysouris;

{$IFDEF Mouchard}
 GotoXY(1,23); TextBackGround(7);
 if mouchard then begin
  tas:=TasDetecte(x,y);
  case tas of
   0: if CodeXY(0,1,23)<>176 then
       begin TextAttr:=2; Write(RepeteCar('',79)) end;
   1,2: with Talon[tas] do for i:=1 to Nombre do AfficheNomCarte(Carte[i]);
   3..6: with Pile[tas-2] do for i:=1 to Nombre do AfficheNomCarte(Carte[i]);
   7..13: with Jeu[tas-6] do begin
           for i:=1 to NombreCache do AfficheNomCarte(Carte[i]);
           TextColor(0); Write('');
           for i:=NombreCache+1 to Nombre do AfficheNomCarte(Carte[i]);
          end;
  end;
  if tas<>0 then begin TextAttr:=2; while WhereX<80 do Write('') end;
 end
 else if CodeXY(0,1,23)<>176 then AffChXY(0,1,23,RepeteCar('',80),2);
{$ENDIF}

 {dplacement des cartes prises}
 if (BoutonSouris=gauche) and carte_prise and ((x<>anc_x) or (y<>anc_y)) then begin
  CacheCursSouris;
  AttendVBL;
  with zone1 do begin Restaure(0,0,0,0); Supprime end;
  with ZoneCarte do begin
   zone1.Sauve(0,x-(xi-x1),y-(yi-y1),x+(x2-xi),y+(y2-yi));
   zone2.Restaure(0,x-xi,y-yi,0);
  end;
  anc_x:=x; anc_y:=y;
  AffCursSouris;
 end;

 {tat repos}
 if BoutonSouris=aucun then begin
  autorise_clique:=TRUE;
  if not(zone_maxi) then begin ZoneSouris(1,1,79,25); zone_maxi:=TRUE end;
 end;

 {prise de cartes}
 if (BoutonSouris=gauche) and autorise_clique then begin
  autorise_clique:=FALSE;
  anc_x:=Xsouris; anc_y:=Ysouris;
  CacheCursSouris;
  tas:=TasDetecte(anc_x,anc_y);
  case tas of
   1: TireCarte;
   2: if Talon[2].Nombre>0 then PrendCarte(2,1);

   7..13: with Jeu[tas-6] do
           case Nombre-NombreCache of  {nombre de cartes visibles}
            0: if (anc_y in [11..17]) and (NombreCache>0) then begin  {retourne une carte}
                Bip(2000);
                dec(NombreCache);
                AfficheJeu(tas-6);
               end;
            1: if anc_y in [13..19] then PrendCarte(tas,1); {prend la seule carte visible}
            else
             case anc_y of
              13..14: PrendCarte(tas,Nombre-NombreCache); {prend toutes les cartes visibles}
              15..21: PrendCarte(tas,1); {prend la carte du dessus}
             end;
           end;
  end;
  AffCursSouris;
 end;

 {placement des cartes prises}
 if (BoutonSouris=aucun) and carte_prise then begin
  CacheCursSouris;
  incr_points:=0;
  tas:=TasDetecte(x,y);
  case tas of
   0,1: ReposeCarte;

   2: with Talon[2] do if OkRougeNoir(Carte[Nombre]) then begin
       AjouteCarte(2);
       EffaceZoneCarte(TRUE);
       AfficheTalon(2);
       incr_points:=-2*Points;
      end
      else ReposeCarte;

   3..6: if (Prise.Nombre=1) and (Prise.Carte[1].Couleur=tas-2) then
          with Pile[tas-2] do begin
           if (Nombre=0) and (Prise.Carte[1].Valeur=As) then begin  {place l'As sur une case vide}
            AjouteCarte(tas);
            EffaceZoneCarte(TRUE);
            AffichePile(tas-2);
            incr_points:=500;
           end
           else
            if Carte[Nombre].Valeur+1=Prise.Carte[1].Valeur then begin
             AjouteCarte(tas);
             EffaceZoneCarte(TRUE);
             AffichePile(tas-2);
             incr_points:=5*Prise.Carte[1].Valeur;
            end
            else ReposeCarte;
          end
         else ReposeCarte;

   7..13: with Jeu[tas-6] do
           case Nombre-NombreCache of  {nombre de cartes visibles}
            0: if (y in [13..19]) and (Nombre=0) and
                  (Prise.Carte[1].Valeur=Roi) then begin  {place le Roi sur une case vide}
                AjouteCarte(tas);
                EffaceZoneCarte(TRUE);
                AfficheJeu(tas-6);
                incr_points:=1000+Points;
               end
               else ReposeCarte;

            1: if (y in [13..19]) and OkRougeNoir(Carte[Nombre]) then begin
                AjouteCarte(tas);
                EffaceZoneCarte(TRUE);
                AfficheJeu(tas-6);
                incr_points:=Points;
               end
               else ReposeCarte;
            else
             if (y in [15..21]) and OkRougeNoir(Carte[Nombre]) then begin
              AjouteCarte(tas);
              EffaceZoneCarte(TRUE);
              AfficheJeu(tas-6);
              incr_points:=Points;
             end
             else ReposeCarte;
           end;
  end;

  {cas o il ne faut pas compter de points}
  if tas=Prise.Tas then incr_points:=0;  {mme tas de dpart et d'arrive}
  if (Prise.Carte[1].Valeur=Roi) and (Prise.Tas in [7..13]) then
   if Jeu[Prise.Tas-6].Nombre=0 then incr_points:=0; {Roi (ou +) dplac d'un tas JEU  l'autre}

  inc(pts,incr_points);
  AffCursSouris;
 end;

 {placement automatique des cartes cliques}
 if (BoutonSouris=droite) and not(carte_prise) then begin
  CacheCursSouris;
  trouve:=FALSE;
  tas:=TasDetecte(x,y);
  case tas of
   2: if Talon[2].Nombre>0 then begin
       EnleveCarte(2,1);
       case Prise.Carte[1].Valeur of
        As: begin  {place l'As sur une case vide}
             trouve:=TRUE;
             i:=Prise.Carte[1].Couleur;
             AjouteCarte(2+i);
             inc(pts,500);
            end;

        2..12: begin
                for i:=1 to 7 do  {recherche en priorit sur les 7 tas JEU}
                 with Jeu[i] do
                  if (Nombre-NombreCache>=1) and
                     OkRougeNoir(Carte[Nombre]) then begin  {au moins une carte visible}
                   trouve:=TRUE;
                   AjouteCarte(6+i);
                   inc(pts,Points);
                   break;
                  end;
                if not(trouve) then begin  {si rien, recherche sur le tas PILE}
                 i:=Prise.Carte[1].Couleur;
                 with Pile[i] do
                  if Nombre>=1 then
                   if Carte[Nombre].Valeur+1=Prise.Carte[1].Valeur then begin
                    trouve:=TRUE;
                    AjouteCarte(2+i);
                    inc(pts,5*Prise.Carte[1].Valeur);
                   end;
                end;
               end;

        Roi: for i:=7 downto 1 do  {recherche une case vide pour le Roi}
              with Jeu[i] do
               if Nombre=0 then begin
                trouve:=TRUE;
                AjouteCarte(6+i);
                inc(pts,1000+Points);
                break;
               end;
       end;
       if not(trouve) then AjouteCarte(2);
      end;

   7..13: begin
           Prise.Nombre:=0;

           with Jeu[tas-6] do
            case Nombre-NombreCache of  {nombre de cartes visibles}
             0:; {rien}
             1: if y in [13..19] then EnleveCarte(tas,1);
             else
              case y of
               13..14: EnleveCarte(tas,Nombre-NombreCache);
               15..21: EnleveCarte(tas,1);
              end;
            end;

           if Prise.Nombre>0 then begin
            if Prise.Nombre=1 then begin  {recherche en priorit sur le tas PILE}
             i:=Prise.Carte[1].Couleur;
             with Pile[i] do
              case Nombre of
               0: if Prise.Carte[1].Valeur=As then begin  {place l'As sur une case vide}
                   trouve:=TRUE;
                   AjouteCarte(2+i);
                   inc(pts,500);
                  end;
               1..12: if Carte[Nombre].Valeur+1=Prise.Carte[1].Valeur then begin
                       trouve:=TRUE;
                       AjouteCarte(2+i);
                       inc(pts,5*Prise.Carte[1].Valeur);
                      end;
              end;
            end;

            if not(trouve) then  {si rien, recherche sur les 6 autres tas JEU}
             for i:=7 downto 1 do if i<>tas-6 then
              with Jeu[i] do
               if (Nombre=0) and (Prise.Carte[1].Valeur=Roi) then begin  {place le Roi (ou +) sur une case vide}
                trouve:=TRUE;
                AjouteCarte(6+i);
                if Jeu[tas-6].Nombre>0 then inc(pts,1000+Points);
                break;
               end
               else
                if (Nombre-NombreCache>=1) and OkRougeNoir(Carte[Nombre]) then begin
                 trouve:=TRUE;
                 AjouteCarte(6+i);
                 inc(pts,Points);
                 break;
                end;

            if not(trouve) then AjouteCarte(tas);
           end;
          end;
  end;
  AffCursSouris;
  repeat until BoutonSouris=aucun;
 end;

 if KeyPressed then
  case UpCase(ReadKey) of
   Enter: recommence:=TRUE;
   Esc: quitte:=TRUE;
{$IFDEF Mouchard}
   Key('M'): mouchard:=not(mouchard);
{$ENDIF}
   Key('S'): son:=not(son);
  end;
end; {GestionClavierSouris}

{--------------------------------------------------------------------}

procedure InitialisationJeu;
var i,j,hasard: byte;
    JeuCarte: array[1..52] of boolean;
begin
 Talon[1].Nombre:=0;
 Talon[2].Nombre:=0;
 for i:=1 to 4 do Pile[i].Nombre:=0;
 for i:=1 to 7 do
  with Jeu[i] do begin NombreCache:=0; Nombre:=0 end;

 FillChar(JeuCarte,52,FALSE);

 Randomize;
 with Talon[1] do
  repeat
   hasard:=1+Random(52);
   if not(JeuCarte[hasard]) then begin
    JeuCarte[hasard]:=TRUE;
    inc(Nombre);
    with Carte[Nombre] do begin
     Valeur :=1+((hasard-1) mod 13);
     Couleur:=1+((hasard-1) div 13);
    end;
   end;
  until Nombre=52;

 for i:=1 to 7 do
  for j:=1 to i do begin
   with Talon[1] do Jeu[i].Carte[j]:=Carte[Nombre];
   inc(Jeu[i].NombreCache);
   inc(Jeu[i].Nombre);
   dec(Talon[1].Nombre);
  end;

 AfficheFondEcran;
 for i:=1 to 2 do AfficheTalon(i);
 for i:=1 to 7 do AfficheJeu(i);
 for i:=1 to 4 do AffichePile(i);

 ZoneSouris(1,1,79,25);
 autorise_clique:=TRUE;
 carte_prise:=FALSE;
 zone_maxi:=TRUE;
 recommence:=FALSE;
 quitte:=FALSE;
 pts:=0; score:=0;
 compteur:=0;
end; {InitialisationJeu}

{--------------------------------------------------------------------}

function Gagne: boolean;
begin
 Gagne:=Pile[1].Nombre+Pile[2].Nombre+Pile[3].Nombre+Pile[4].Nombre=52;
end; {Gagne}

{--------------------------------------------------------------------}

procedure Bravo;
var touche: Key;
    rang,i: byte;
    abandon: boolean;
begin
 inc(pts,2500);
 AfficheScoreTemps;
 EffaceZone(0,24,10,56,14,49);
 AffChXY(0,31,12,'B  R  A  V  O   ! !',49);
 Cadre(0,1,25,10,55,14,49,'',49,'');

 if son then begin
  Sound(523); Delay(50);
  Sound(659); Delay(50);
  Sound(784); Delay(50);
  Sound(1046); Delay(150); NoSound;
 end;
 Delay(1500);
 EffaceZone(0,20,4,60,22,16);
 Cadre(0,1,21,4,59,22,31,' les '+EntierTexte2(nbr_scores,2)+' MEILLEURS SCORES ',31,'');
 rang:=0;

 for i:=nbr_scores downto 1 do if score>best[i].score then rang:=i;
 if rang>0 then begin
  for i:=nbr_scores downto rang+1 do begin
   best[i].nom:=best[i-1].nom;
   best[i].score:=best[i-1].score;
  end;
  best[rang].nom:='';
  best[rang].score:=score;
  modification:=TRUE;
 end;

 for i:=1 to nbr_scores do begin
  AffChXY(0,26,i+5,EntierTexte2(i,2)+'.',30);
  with best[i] do
   AffChXY(0,32,i+5,XString(nom,' ',15)+'   '+EntierTexte2(score,5),23);
 end;

 VideBufferClavier;
 if rang>0 then begin
  AffChXY(0,26,rang+5,EntierTexte2(rang,2)+'.',30+128);
  with best[rang] do begin
   AffChXY(0,50,rang+5,EntierTexte2(score,5),27+128);
   nom:=LitChaine('',32,rang+5,16,15,FALSE,alpha+espace,FALSE,27,27,abandon);
   AffChXY(0,32,rang+5,XString(nom,' ',15),27+128);
  end;
 end;

 repeat
  touche:=ReadKey;
  case touche of
   Enter: recommence:=TRUE;
   Esc  : quitte:=TRUE
  end;
 until touche in [Enter,Esc];
end; {Bravo}

{--------------------------------------------------------------------}

procedure LitFichier;
var i: byte;
    fichier: File of hiscore;
begin
 Assign(fichier,nom_fichier);
 {$I-}
 Reset(fichier);
 {$I+}
 if IOResult=0 then begin
  for i:=1 to nbr_scores do Read(fichier,best[i]);
  Close(fichier);
 end;
end; {LitFichier}

{--------------------------------------------------------------------}

procedure EcritFichier;
var i: byte;
    fichier: File of hiscore;
begin
 Assign(fichier,nom_fichier);
 {$I-}
 Rewrite(fichier);
 {$I+}
 if IOResult=0 then begin
  for i:=1 to nbr_scores do Write(fichier,best[i]);
  Close(fichier);
 end;
end; {EcritFichier}

{--------------------------------------------------------------------}

procedure Initialisation;
const blanc: RVB=(R:48; V:48; B:54);
      Special: array[1..8] of Binaire16=(
       ($00,$00,$00,$00,$66,$FF,$FF,$FF,$FF,$7E,$3C,$18,$00,$00,$00,$00),  {coeur}
       ($00,$00,$00,$00,$18,$3C,$7E,$FF,$FF,$7E,$3C,$18,$00,$00,$00,$00),  {carreau}
       ($00,$00,$00,$18,$3C,$3C,$DB,$FF,$FF,$DB,$18,$3C,$00,$00,$00,$00),  {trfle}
       ($00,$00,$00,$18,$3C,$7E,$FF,$FF,$FF,$DB,$18,$3C,$00,$00,$00,$00),  {pique}
       ($00,$00,$00,$00,$00,$00,$00,$E0,$30,$18,$18,$18,$18,$18,$18,$18),  {}
       ($18,$18,$18,$18,$18,$18,$0C,$07,$00,$00,$00,$00,$00,$00,$00,$00),  {}
       ($18,$18,$18,$18,$18,$18,$30,$E0,$00,$00,$00,$00,$00,$00,$00,$00),  {}
       ($00,$00,$00,$00,$00,$00,$00,$07,$0C,$18,$18,$18,$18,$18,$18,$18)   {}
      );
begin
 CheckBreak:=FALSE;
 NoSound;
 LitFichier;
 InitTexte(25);
 Curseur(off);
 BougeCursSourisXY(40,14);

 if CarteVGA then begin
  LargeurCar(8);
  FixeDAC(7,blanc);
  RedefCar(0,Coeur,4,Special[1],binaire); {redfinit coeur,carreau,trfle,pique}
  RedefCar(0,'',2,Special[5],binaire); {redfinit  et }
  RedefCar(0,'',2,Special[7],binaire); {redfinit  et }
  InitSourisFleche(#255,FALSE);
 end;
end; {Initialisation}

{====================================================================}

VAR anc_nbr_lignes: byte;

BEGIN
 if not(InitSouris) then
  begin WriteLn('Ce programme ncessite une souris !'); halt(1) end;

 anc_nbr_lignes:=NombreLignes+1;

 Initialisation;

 SwapIntVec($1C,ancINT1C,@INT1C);

 repeat
  InitialisationJeu;
  AffCursSouris;
  timer_actif:=TRUE;
  repeat GestionClavierSouris until Gagne or recommence or quitte;
  timer_actif:=FALSE;
  CacheCursSouris;
  if Gagne then Bravo;
 until quitte;

 SwapIntVec($1C,ancINT1C,ancINT1C);

 if modification then EcritFichier;
 InitTexte(anc_nbr_lignes);
END.
