{$A+,G+,Q-,R-,S-}

USES Crt,Fichiers,Util;

CONST taille_tampon=16*1024;

VAR f_in,f_out0,f_out1: Fichier;

    nom_f: String80;
    ext: String3;

    tampon: array[0..taille_tampon-1] of byte;
    tampon0,tampon1: array[0..(taille_tampon div 2)-1] of byte;
    taille_fichier,taille_a_lire,taille_lue: longint;
    i: word;

BEGIN
 Writeln('SplitFile v1.0 - (c) 1998 Fabrice Couteau');
 Writeln('Sparateur de fichier par parit (extension 0:pair, 1:impair)');
 if ParamCount=0 then begin Writeln('usage: SPLITF <nom_fichier>'); halt(1) end;

 nom_f:=ParamStr(1);
 f_in.Ouvre(lecture,nom_f);
 if f_erreur<>f_ok then begin Writeln(nom_f,': erreur ouverture (',f_erreur,')'); halt(2) end;

 taille_fichier:=f_in.Taille;
 if taille_fichier=0 then begin Writeln(nom_f,': taille nulle'); halt(2) end;

 ext:=ExtensionSeule(nom_f);
 case Length(ext) of
  0: ext:='.';
  3: begin dec(nom_f[0]); dec(ext[0]) end;
 end;

 f_out0.Cree(ecrase,nom_f+'0');
 if f_erreur<>f_ok then begin Writeln(nom_f+'0',': erreur cration (',f_erreur,')'); halt(2) end;
 f_out1.Cree(ecrase,nom_f+'1');
 if f_erreur<>f_ok then begin Writeln(nom_f+'1',': erreur cration (',f_erreur,')'); halt(2) end;

 taille_a_lire:=taille_tampon;
 taille_lue:=0;
 repeat
  GotoXY(1,WhereY); Write(Round(100*taille_lue/taille_fichier):3,'%');

  if taille_lue+taille_a_lire>taille_fichier then taille_a_lire:=taille_fichier-taille_lue;
  f_in.Lit(tampon,taille_a_lire);
  inc(taille_lue,taille_a_lire);

  for i:=0 to (taille_a_lire div 2) do begin
   tampon0[i]:=tampon[2*i];
   tampon1[i]:=tampon[2*i+1];
  end;

  f_out0.Ecrit(tampon0,taille_a_lire div 2);
  f_out1.Ecrit(tampon1,taille_a_lire div 2);
 until taille_lue>=taille_fichier;

 GotoXY(1,WhereY); Write('OK. ');

 f_out1.Ferme;
 f_out0.Ferme;
 f_in.Ferme;
END.
