{$A+,G+,Q-,R-,S-}

USES Crt,Dos,Fichiers,Clavier,Texte,Util,UtilT,Souris,SourisT,Archives;


function SelectionneFichier(titre: String25; extension: String3; hauteur_fenetre: byte): String80; FAR;
{hauteur_fenetre=nombre de fichiers affichs (doit tre > 5 !)}
{valeur standard: hauteur_ecran_txt-11}

type type_coul=(normal,inverse);

const dx_asc=+5; y_asc=6;  {coordonnes de la flche vers le haut}

var z: Zone;
    x,y,x_milieu,msg_err,explore_arch: byte;
    i,premier,nbr_fich,choix_fich,erreur_arch: word;

    touche: Key;
    lecteur_physique,lecteur_logique: char;
    fich: SearchRec;
    Dir: array[1..512] of string[14];
    liste_lecteurs: String26;

    change_rep,sortie_archive,
    defile_fenetre,bouge_ascenseur,choix_clique,
    ok,sortie: boolean;

    boutonOK,boutonAnnuler: Bouton;

    repert_reel,sous_repert_parent_reel: String80;
    nom_archive: String12;

    info: T_InfoArch;


label relit_lecteur,fin;


procedure ChangeLecteur(lettre: char);
begin
 nom_archive:='';
 explore_arch:=aucun;
 sortie_archive:=FALSE;
 lecteur_physique:=lettre; lecteur_logique:=lecteur_physique;
 repert:=CheminAcces(lecteur_logique);
 sous_repert_parent:=''; change_rep:=TRUE;
end; {ChangeLecteur}


function Repertoire(index: word): boolean;
begin
 Repertoire:=(Dir[index][1]='\');
end; {Repertoire}


procedure AfficheChoix(ch: word; coul: type_coul);
const Couleur: array[boolean,type_coul] of byte=((48+1,16+15),(48+14,16+14));
begin
 if nbr_fich>0 then
  AffChXY(0,x_milieu+dx_asc-15,ch-premier+y_asc,' '+XString(Dir[ch],' ',14),Couleur[Repertoire(ch),coul]);
end; {AfficheChoix}


function IndexChoix(nom: String20): word;
var i: word;
begin
 for i:=1 to nbr_fich do
  if Dir[i]=nom then begin IndexChoix:=i; exit end;
 IndexChoix:=0;
end; {IndexChoix}


procedure TestChoix;
var type_arch: byte;
begin
 if nbr_fich>0 then

  if Repertoire(choix_fich) then begin
   if Dir[choix_fich]='\..' then begin
    sous_repert_parent:=SousRepertoire(repert);
    repert:=CopyL(repert,Length(repert)-Length(sous_repert_parent)-1);
    if repert='' then
     begin
      sortie_archive:=TRUE;
      explore_arch:=aucun;
      repert:=repert_reel;
      sous_repert_parent:=sous_repert_parent_reel;
     end;
   end
   else begin
    sous_repert_parent:='';
    dec(repert[0]);
    repert:=repert+Dir[choix_fich]+'\';
   end;
   change_rep:=TRUE;
  end
  else begin
   type_arch:=TypeArchive(Dir[choix_fich]);
   if type_arch=aucun then ok:=TRUE
   else
    if explore_arch=aucun then begin
     explore_arch:=type_arch;
     nom_archive:=Dir[choix_fich];
     repert_reel:=repert; repert:='';
     sous_repert_parent_reel:=sous_repert_parent; sous_repert_parent:='';
     change_rep:=TRUE;
    end;
  end;
end; {TestChoix}


procedure ExploreArchive;

var f: Fichier;
    header: T_Mix_Header;
    first,valide: boolean;
    type_arch,i: byte;
    nf: String80;
    taille_fichier,taille_cumulee: longint;

begin
 with f do begin
  Ouvre(lecture,repert_reel+nom_archive);
  if f_erreur<>f_ok then exit;

  inc(nbr_fich); Dir[nbr_fich]:='\..';

  type_arch:=TypeArchive(nom_archive);
  first:=TRUE;

  taille_cumulee:=0;
  taille_fichier:=Taille;

  repeat
   valide:=FALSE;

   case type_arch of
    ARJ: with header.ARJ do begin
          Lit(header,sizeof(ARJ_Header));
          if (HeadID<>ARJ_ID) or (HdrSize=0) then break;

          i:=HdrSize-HeadSize-2;
          Lit(nf[1],i); nf[0]:=CHAR(i);
          valide:=not(first) and (OrigSize<>0);
          if not(valide) then PackSize:=0;

          DeplacePointeur(4+4+PackSize);
          inc(taille_cumulee,(HdrSize-HeadSize-2)+4+4+PackSize);
         end;

    LZH: with header.LZH do begin
          Lit(header,sizeof(LZH_Header));
          if (Copy(HeadID,1,sizeof(LZH_ID))<>LZH_ID) or (HeadSize=0) then break;

          Lit(nf,HeadSize-sizeof(LZH_Header));
          valide:=(OrigSize<>0);

          DeplacePointeur(2+PackSize);
          inc(taille_cumulee,(HeadSize-sizeof(LZH_Header))+2+PackSize);
         end;

    RAR: with header.RAR do begin
          Lit(header,Sizeof_RAR_BeginBlk);
          inc(taille_cumulee,Sizeof_RAR_BeginBlk);

          case HeadType of
           HT_MarkerBlk : if LongPtr(@header)^<>LONGINT(RAR_ID) then break;
           HT_ArchiveHdr,
           HT_CommentHdr,
           HT_ExtraHdr  : begin
                           DeplacePointeur(HeadSize-Sizeof_RAR_BeginBlk);
                           inc(taille_cumulee,HeadSize-Sizeof_RAR_BeginBlk);
                          end;
           HT_FileHdr   : with HeadData.FileHdr do begin
                           Lit(HeadData,sizeof(T_FileHdr));
                           i:=FileNameLen;
                           Lit(nf[1],i); nf[0]:=CHAR(i);
                           valide:=(OrigSize<>0);

                           DeplacePointeur(HeadSize-Sizeof_RAR_BeginBlk-sizeof(T_FileHdr)-FileNameLen+PackSize);
                           inc(taille_cumulee,HeadSize-Sizeof_RAR_BeginBlk+PackSize);
                          end;

           else with HeadData.UnknownHdr do begin
                 Lit(HeadData,sizeof(T_UnknownHdr));
                 DeplacePointeur(HeadSize-Sizeof_RAR_BeginBlk-sizeof(T_UnknownHdr)+BlockSize);
                 inc(taille_cumulee,HeadSize-Sizeof_RAR_BeginBlk+BlockSize);
                end;
          end;
         end;

    ZIP: with header.ZIP do begin
          Lit(header,sizeof(ZIP_Header));
          if HeadID<>ZIP_ID then break;

          i:=FileNameLen;
          Lit(nf[1],i); nf[0]:=CHAR(i);
          valide:=(OrigSize<>0);

          DeplacePointeur(PackSize+ExtraField);
          inc(taille_cumulee,FileNameLen+PackSize+ExtraField);
         end;
   end;

   if valide then begin
    nf:=NomFichierDOS(nf);
    if Pos('\',nf)<>0 then nf:='\'+nf;
    i:=Pos(repert,nf);
    if (i<>0) or (repert='\') then begin
     if i<>0 then begin
      Delete(nf,i,Length(repert));
      if nf[1]='\' then Delete(nf,1,1);
     end;
     i:=Pos('\',nf);
     if i=0 then begin inc(nbr_fich); Dir[nbr_fich]:=nf end
     else begin
      nf:='\'+CopyL(nf,i-1);
      if IndexChoix(nf)=0 then begin inc(nbr_fich); Dir[nbr_fich]:=nf end;
     end;
    end;
   end;

   first:=FALSE;
  until taille_cumulee>=taille_fichier;

  Ferme;
 end;
end; {ExploreArchive}


procedure CorrigePremier;
begin
 if choix_fich<premier then premier:=choix_fich;
 if choix_fich>premier+hauteur_fenetre-1 then premier:=choix_fich-hauteur_fenetre+1;
end; {CorrigePremier}


procedure CorrigeChoix;
begin
 if choix_fich<premier then choix_fich:=premier;
 if choix_fich>premier+hauteur_fenetre-1 then choix_fich:=premier+hauteur_fenetre-1;
end; {CorrigeChoix}


procedure DefileHaut;
begin
 if choix_fich>1 then dec(choix_fich);
 CorrigePremier;
end; {DefileHaut}


procedure DefileBas;
begin
 if choix_fich<nbr_fich then inc(choix_fich);
 CorrigePremier;
end; {DefileBas}


procedure DefilePageHaut;
begin
 if choix_fich>hauteur_fenetre then begin
  dec(choix_fich,hauteur_fenetre);
  if premier>hauteur_fenetre then dec(premier,hauteur_fenetre) else premier:=1
 end
 else begin choix_fich:=1; premier:=1 end;
end; {DefilePageHaut}


procedure DefilePageBas;
begin
 inc(choix_fich,hauteur_fenetre); inc(premier,hauteur_fenetre);
 if choix_fich>nbr_fich then choix_fich:=nbr_fich;
 if nbr_fich>=hauteur_fenetre then
  if premier>nbr_fich-hauteur_fenetre+1 then premier:=nbr_fich-hauteur_fenetre+1;
 if nbr_fich<hauteur_fenetre then premier:=1;
end; {DefilePageBas}


procedure QuickSort(debut,fin: word);
var i,j: word;
    aux: string[14];
begin
 i:=debut; j:=fin; aux:=Dir[(debut+fin) shr 1];
 repeat
  {$IFDEF Smooth}
  AnimeCursSouris;
  {$ENDIF}
  while Dir[i]<aux do inc(i);
  while aux<Dir[j] do dec(j);
  if i<=j then begin
   SwapVar(Dir[i],Dir[j],sizeof(Dir[1]));
   inc(i); if j>0 then dec(j);
  end;
 until i>j;
 if debut<j then QuickSort(debut,j);
 if i<fin   then QuickSort(i,fin);
end; {QuickSort}


procedure ChercheInitiale(initiale: char);
var i,j,nbr: word;
begin
 nbr:=0;
 for i:=1 to nbr_fich do
  if Dir[i][1]=initiale then begin inc(nbr); j:=i end;
 if nbr>0 then begin
  if (choix_fich>=j-nbr+1) and (choix_fich<j) then inc(choix_fich) else choix_fich:=j-nbr+1;
  CorrigePremier;
 end;
end; {ChercheInitiale}


procedure AfficheLettresLecteurs;
const couleur: array[boolean] of byte=(112+1,15);
var i: byte;
    lettre: char;
begin
 for i:=1 to MinEntier(Length(liste_lecteurs),(hauteur_fenetre div 2)+1) do begin
  lettre:=liste_lecteurs[i];
  AffChXY(0,x_milieu+dx_asc+2,y_asc-1+2*(i-1),' '+lettre+': ',couleur[lettre=lecteur_logique]);
 end;
end; {AfficheLettresLecteurs}



begin {SelectionneFichier}
 Curseur(off);
 CacheCursSouris;

 x_milieu:=largeur_ecran_txt div 2;

 liste_lecteurs:=ListeLecteurs; lecteur_logique:=repert[1];

 z.Ombre(0,x_milieu+dx_asc-20,y_asc-3,x_milieu+dx_asc+8,y_asc+hauteur_fenetre+3,48);
 Cadre(0,1,x_milieu+dx_asc-19,y_asc-3,x_milieu+dx_asc+7,y_asc+hauteur_fenetre+3,48+1,' '+titre+' ',112,'');
 AfficheBoutonsOKAnnuler(x_milieu+dx_asc-15,y_asc+hauteur_fenetre+1,boutonOK,boutonAnnuler);

 nom_archive:='';
 explore_arch:=aucun;
 sortie_archive:=FALSE;
 sortie:=FALSE; ok:=FALSE;

 repeat
 relit_lecteur:

  CacheCursSouris;

  if repert[Length(repert)]<>'\' then repert:=repert+'\';

  if explore_arch=aucun then begin
   lecteur_physique:=repert[1];
   AfficheLettresLecteurs;
   AffChXY(0,x_milieu+dx_asc-18,y_asc-2,
           XString(LimiteNomFichier(repert,25),' ',25),48);
  end
  else
   AffChXY(0,x_milieu+dx_asc-18,y_asc-2,
           nom_archive+''+
           XString(LimiteNomFichier(repert,25-Length(nom_archive)-1),' ',25-Length(nom_archive)-1),48);

  EffaceZone(0,x_milieu+dx_asc-15,y_asc,x_milieu+dx_asc-1,y_asc+hauteur_fenetre-1,48);
  Cadre(0,1,x_milieu+dx_asc-16,y_asc-1,x_milieu+dx_asc,y_asc+hauteur_fenetre,48+1,' *.'+extension+' ',48+1,'');

  AffCursSouris;
  {$IFDEF Smooth}
  DefCursSouris(sablier);
  {$ENDIF}

  nbr_fich:=0;

  if explore_arch=aucun then begin
   repeat
    FindFirst(repert+'*.*',Directory or Archive or ReadOnly or Hidden,fich);
    if DosError in [0,18] then break;
    msg_err:=MessageErreur(DosError+msg_donnee,repert);
    case msg_err of
     alt_repete,
     alt_continue:;
     alt_annule  : goto fin;
     BYTE('A')..BYTE('Z'): begin ChangeLecteur(CHAR(msg_err)); goto relit_lecteur end;
    end;
   until FALSE;

   while DosError=0 do begin
    {$IFDEF Smooth}
    AnimeCursSouris;
    {$ENDIF}
    if fich.Name<>'.' then
     if (extension='*') or (Pos('.'+extension,fich.Name)>0)
        or (fich.Attr=Directory) then begin
      inc(nbr_fich);
      Dir[nbr_fich]:=fich.Name;
      if fich.Attr=Directory then Dir[nbr_fich]:='\'+Dir[nbr_fich];
     end;
    repeat
     FindNext(fich);
     if DosError in [0,18] then break;
     msg_err:=MessageErreur(DosError+msg_donnee,repert);
     case msg_err of
      alt_repete,
      alt_continue:;
      alt_annule  : goto fin;
      BYTE('A')..BYTE('Z'): begin ChangeLecteur(CHAR(msg_err)); goto relit_lecteur end;
     end;
    until FALSE;
   end;
  end
  else ExploreArchive;

  choix_fich:=1; premier:=1;
  if nbr_fich>0 then begin
   for i:=1 to nbr_fich do if Repertoire(i) then Insert(#0,Dir[i],1);
   QuickSort(1,nbr_fich);
   for i:=1 to nbr_fich do if Dir[i][1]=#0 then Delete(Dir[i],1,1);
  end;

  if sortie_archive then begin
   choix_fich:=MaxEntier(IndexChoix(nom_archive),1);
   CorrigePremier;
   sortie_archive:=FALSE;
   nom_archive:='';
  end
  else
   if sous_repert_parent<>'' then begin
    choix_fich:=MaxEntier(IndexChoix('\'+sous_repert_parent),1);
    CorrigePremier;
   end;

  change_rep:=FALSE; defile_fenetre:=FALSE;
  bouge_ascenseur:=FALSE; choix_clique:=FALSE;

  {$IFDEF Smooth}
  DefCursSouris(fleche);
  {$ENDIF}

  repeat
   {$IFNDEF Smooth}
   if (BoutonSouris=aucun) or not(defile_fenetre) then
   {$ENDIF}
   CacheCursSouris;

   if nbr_fich>hauteur_fenetre then
    AfficheAscenseur(x_milieu+dx_asc,y_asc,hauteur_fenetre,nbr_fich,premier,11);

   for i:=premier to premier+hauteur_fenetre-1 do
    if (i<=nbr_fich) and (i<>choix_fich) then AfficheChoix(i,normal);
   AfficheChoix(choix_fich,inverse);

   if BoutonSouris=aucun then begin
    {$IFNDEF Smooth}
    DefCursSouris(standard,0,0,#0);
    {$ENDIF}
    if choix_clique and not(defile_fenetre) then TestChoix;
    defile_fenetre:=FALSE; bouge_ascenseur:=FALSE; choix_clique:=FALSE;
   end;

   if choix_clique then ZoneSouris(x_milieu+dx_asc-15,y_asc-1,x_milieu+dx_asc-1,y_asc+hauteur_fenetre)
   else
    if defile_fenetre or bouge_ascenseur then ZoneSouris(x_milieu+dx_asc,y_asc,x_milieu+dx_asc,y_asc+hauteur_fenetre-1)
                                         else ZoneSouris(1,1,largeur_ecran_txt,hauteur_ecran_txt);

{------------------------------------------}
   EffaceZone(0,1,1,largeur_ecran_txt,1,7);
   if (explore_arch=aucun) and (TypeArchive(Dir[choix_fich])<>0) then begin
    erreur_arch:=InfoArchive(repert+Dir[choix_fich],info);
    if erreur_arch=0 then with info do
     AffChXY(0,1,1,'Archive: init='+EntierTexte(TailleInit,8)+
                           ' comp='+EntierTexte(TailleComp,8)+
                               ' ('+EntierTexte2(Ratio,3)+'%)  '+
                                    EntierTexte2(Nombre,3)+' fichier(s)',7)
    else AffChXY(0,1,1,'Erreur Archive: '+EntierTexte2(erreur_arch,3),12);
   end;
{------------------------------------------}

   AttendClavierSouris(not(defile_fenetre or bouge_ascenseur or choix_clique),change_rep or ok,x,y);

   {$IFDEF Smooth}
   SourisBouge:=FALSE;
   {$ENDIF}
   if bouge_ascenseur or (choix_clique and not(defile_fenetre)) then
    repeat until KeyPressed or SourisBouge or (BoutonSouris=aucun);

   if KeyPressed then begin
    touche:=UpCase(ReadKey);
    if (EtatClavier and (ShiftG or ShiftD))=0 then {aucune touche Shift appuye}
     case touche of
      Key('A')..Key('Z'): if Pos(CHAR(touche),liste_lecteurs)>0 then ChangeLecteur(CHAR(touche));
      Up  : DefileHaut;
      Down: DefileBas;
      PgUp: DefilePageHaut;
      PgDn: DefilePageBas;
      Home: begin choix_fich:=1; premier:=1 end;
      End_: begin
             choix_fich:=nbr_fich;
             if nbr_fich>hauteur_fenetre then premier:=nbr_fich-hauteur_fenetre+1;
            end;
      CtrlPgUp: if premier>1 then begin dec(premier); CorrigeChoix end
                else DefileHaut;
      CtrlPgDn: if nbr_fich>hauteur_fenetre then
                 if premier<nbr_fich-hauteur_fenetre+1 then
                  begin inc(premier); CorrigeChoix end
                 else DefileBas
                else DefileBas;
      Enter: TestChoix;
      Esc  : sortie:=TRUE;
     end
    else  {au moins une touche Shift est appuye}
     if (touche>=Key('A')) and (touche<=Key('Z')) then ChercheInitiale(CHAR(touche));
   end

   else begin  {souris}

    if (x in [x_milieu+dx_asc-15..x_milieu+dx_asc-1]) and (y in [y_asc..y_asc+hauteur_fenetre-1]) then
     if (premier+y-y_asc<=nbr_fich) and (BoutonSouris=gauche) then
      begin choix_clique:=TRUE; choix_fich:=premier+y-y_asc end;
     if (x=x_milieu+dx_asc) and (nbr_fich>hauteur_fenetre) then
      if y=y_asc then begin
       {$IFNDEF Smooth}
       DefCursSouris(standard,0,0,#0);
       {$ENDIF}
       defile_fenetre:=TRUE; DefileHaut; DelaiBoutonSouris(10);
      end
      else
       if y=y_asc+hauteur_fenetre-1 then begin
        {$IFNDEF Smooth}
        DefCursSouris(standard,0,0,#0);
        {$ENDIF}
        defile_fenetre:=TRUE; DefileBas; DelaiBoutonSouris(10);
       end
       else
        if (y in [y_asc+1..y_asc+hauteur_fenetre-2]) then begin
         {$IFNDEF Smooth}
         DefCursSouris(change_tout,4,11,'');
         {$ENDIF}
         premier:=1+Round((y-y_asc-1)*(nbr_fich-hauteur_fenetre)/(hauteur_fenetre-3));
         CorrigeChoix; bouge_ascenseur:=TRUE;
        end;
     if (x in [x_milieu+dx_asc+2..x_milieu+dx_asc+5]) then begin
      for i:=1 to MinEntier(Length(liste_lecteurs),(hauteur_fenetre div 2)+1) do
       if y=y_asc-1+2*(i-1) then begin
        {$IFNDEF Smooth}
        DefCursSouris(inverse_attribut,0,0,'');
        {$ENDIF}
        ChangeLecteur(liste_lecteurs[i]);
       end;
      repeat until BoutonSouris=aucun;
      {$IFNDEF Smooth}
      DefCursSouris(standard,0,0,#0);
      {$ENDIF}
     end;
     if choix_clique then
      if y=y_asc-1 then begin
       {$IFNDEF Smooth}
       DefCursSouris(garde_fond,0,15,'');
       {$ENDIF}
       defile_fenetre:=TRUE; DefileHaut; Delay(15);
      end
      else
       if y=y_asc+hauteur_fenetre then begin
        {$IFNDEF Smooth}
        DefCursSouris(garde_fond,0,15,'');
        {$ENDIF}
        defile_fenetre:=TRUE; DefileBas; Delay(15);
       end
       else begin
        {$IFNDEF Smooth}
        DefCursSouris(inverse_attribut,0,0,'');
        {$ENDIF}
        defile_fenetre:=FALSE;
       end;
    if boutonOK.Clique then TestChoix;
    sortie:=boutonAnnuler.Clique;
   end;
  until change_rep or sortie or ok;
 until sortie or ok;

fin:
 RestaureZoneSuppr(0,z);
 if ok then SelectionneFichier:=repert+Dir[choix_fich]
       else SelectionneFichier:='';
end; {SelectionneFichier}


VAR nom_fichier: string;

BEGIN
 InitTexte(50);
 TextMode(CO80+Font8x8);
 AffCursSouris;
 InitRepert;
 nom_fichier:=SelectionneFichier('','*',hauteur_ecran_txt-11);
END.
