USES Crt,Texte,Souris,SourisSm;

CONST repert='C:\Musique\MODM\design\';

      nbr_boutons=6;
      bt: array[1..nbr_boutons] of
           record
            x,y: byte;
            titre: string[15];
            attr_rel,attr_app,attr_l: byte;
           end
          =((x:10;y: 5;titre:'bouton 1';attr_rel:113;attr_app:121;attr_l:0),
            (x:40;y:10;titre:'bouton 2';attr_rel:114;attr_app:122;attr_l:0),
            (x:30;y:20;titre:'bouton 3';attr_rel:115;attr_app:123;attr_l:0),
            (x:30;y: 5;titre:'^b^outon 4';attr_rel:113;attr_app:121;attr_l:122),
            (x:10;y:10;titre:'b^o^uton 5';attr_rel:114;attr_app:122;attr_l:123),
            (x:50;y:20;titre:'bo^u^ton 6';attr_rel:115;attr_app:123;attr_l:124));

CONST nbr_cases=4;
      cs: array[1..nbr_cases] of record x,y: byte end
           =((x: 2;y: 2),
             (x:60;y:12),
             (x:22;y:18),
             (x:42;y:22));

CONST nbr_boutons_3D=3;
      bt_3D: array[1..nbr_boutons_3D] of
              record
               x,y: byte;
               titre: string[15];
               att_rel: boolean;
               base_delai: byte;
              end
             =((x:60;y: 5;titre:'bouton_3D 1'  ;att_rel:TRUE ;base_delai: 0),
               (x:50;y:15;titre:'bou^t^on_3D 2';att_rel:FALSE;base_delai:20),
               (x:10;y:20;titre:'bout^o^n_3D 3';att_rel:TRUE ;base_delai: 0));

CONST nbr_objclics=2;
      oc: array[1..nbr_objclics] of
           record
            x,y: byte;
            titre: string[15];
           end
          =((x:50;y: 1;titre:'hello'),
            (x:25;y:12;titre:'cliquez ^ici^!'));

VAR boutons   : array[1..nbr_boutons] of bouton;
    cases     : array[1..nbr_cases] of caseopt;
    boutons_3D: array[1..nbr_boutons_3D] of bouton3D;
    objclics  : array[1..nbr_objclics] of objclic;

    fonte: Fonte8;
    erreur: word;
    palette: Palette16;

    i: byte;
    touche: char;

BEGIN
 fonte.Charge_(repert+'modm8.fnt',erreur);
 if erreur<>0 then begin Writeln('Erreur FNT: ',erreur); halt(1) end;

 palette.Charge_(repert+'pal_modm.pal',erreur);
 if erreur<>0 then begin Writeln('Erreur PAL: ',erreur); halt(1) end;

 InitTexte(50);
 Clignotement(FALSE);
 EffacePage(0,16*4);

 fonte.Redef(0);
 LargeurCar(8);
 palette.Fixe;

 InitSourisSmooth(#252,#253,#254,#255);

 for i:=1 to nbr_boutons do with bt[i] do begin
  boutons[i].Definit(0,x,y,' '+titre+' ',attr_rel,attr_app,attr_l,16*3+8);
  if i in [2,5] then boutons[i].Active(FALSE);
  boutons[i].Affiche;
 end;

 for i:=1 to nbr_cases do with cs[i] do begin
  cases[i].Definit(0,x,y,#20,#21,#22,16*4+13,16*4+8);
  if i=2 then cases[i].Active(FALSE);
  if i=3 then cases[i].coche(TRUE);
  cases[i].Affiche;
 end;

 for i:=1 to nbr_boutons_3D do with bt_3D[i] do begin
  boutons_3D[i].Definit(0,x,y,' '+titre+' ',att_rel,base_delai,16*5,16*5+15,16*5+14,6,3,5,#3);
  if i=2 then boutons_3D[i].Active(FALSE);
  boutons_3D[i].Affiche;
 end;

 for i:=1 to nbr_objclics do with oc[i] do begin
  objclics[i].Definit(0,x,y,titre,FALSE,20,16*1,16*1+15);
  objclics[i].Affiche;
 end;

 AffCursSouris;

 repeat
  for i:=0 to 24 do inc(MemW[$B800:160*i]);
  for i:=1 to nbr_boutons    do if boutons[i].Clique then break;
  for i:=1 to nbr_cases      do if cases[i].Cliquee then break;
  for i:=1 to nbr_boutons_3D do if boutons_3D[i].Clique then break;
  for i:=1 to nbr_objclics   do if objclics[i].Clique then break;
  if objclics[1].Clique then begin
   with boutons_3D[2] do begin Active(FALSE); Affiche end;
   with cases[3] do begin Active(TRUE); Affiche end;
  end;
  if objclics[2].Clique then begin
   with boutons_3D[2] do begin Active(TRUE); Affiche end;
   with cases[3] do begin Active(FALSE); Affiche end;
  end;

  if Keypressed then begin
   touche:=Readkey;
   for i:=1 to nbr_boutons do if boutons[i].Appuye(touche) then break;
   for i:=1 to nbr_boutons_3D do if boutons_3D[i].Appuye(touche) then break;
  end;
 until BoutonSouris=droite;

 FinSourisSmooth;

 repeat until BoutonSouris=aucun;
 InitTexte(25);
END.
