{$A+,G+,Q-,R-,S-}

USES Crt,Util,EMS;

VAR nbr_pages,nbr_mapping,handle,i,j: word;
    ok: boolean;

    table: EMSTable;


procedure Pause;
begin
 Write('<Espace>...');
 repeat until ReadKey=' ';
 Writeln;
end;


BEGIN
 ClrScr;
 if not(EMSInit) then begin WriteLn('Pas d''EMS !'); halt end;

 Writeln('Gestionnaire EMM version ',EMMVersion div 10,'.',EMMVersion mod 10,' dtect');
 Writeln('Segment des pages physiques=',EntierHexa(EMSPageFrameSeg,4)+'h');
 Writeln(EMSPageAvail,' pages en tout (',16*EMSPageAvail,' ko)');
 Writeln(EMSPagesFree,' pages libres (',16*EMSPagesFree,' ko)');
 Writeln;

 nbr_pages:=EMSPagesFree and not 3;
 nbr_mapping:=nbr_pages div 4;

 i:=EMSGetAllHandles(table);
 Writeln(i,' handles occups en tout:');
 for j:=1 to i do with table[j] do Writeln(handle,': ',pages,' pages alloues (',16*pages,' ko)');
 Writeln;

 Writeln('Allocation de ',nbr_pages,' pages EMS (',16*nbr_pages,' ko)...');

 Pause;

 EMSGet(handle,nbr_pages);
 EMSTestError;

 Writeln('ok! (handle=',handle,', ',EMSGetLogPages(handle),' pages alloues)');
 Writeln(EMSPagesFree,' pages libres');

 Pause;

 for i:=1 to nbr_mapping do begin
  Write('Pages ',(i-1)*4,'  ',(i-1)*4+3,': ');
  Write('mapping...');
  EMSMap4(handle,(i-1)*4);
  EMSTestError;
  Write('criture...');
  for j:=0 to 16384*4-1 do Mem[EMSPageFrameSeg:j]:=BYTE(i+j+72);
  Pause;
 end;

 Writeln('Relecture et vrification...');

 Pause;

 for i:=1 to nbr_mapping do begin
  Write('Pages ',(i-1)*4,'  ',(i-1)*4+3,': ');
  Write('mapping...');
  EMSMap4(handle,(i-1)*4);
  EMSTestError;
  Write('vrification...');
  ok:=TRUE;
  for j:=0 to 16384*4-1 do if Mem[EMSPageFrameSeg:j]<>BYTE(i+j+72) then
    begin Write('ERREUR (',j,') '); ok:=FALSE; break end;
  if ok then Write('ok! ');
  Pause;
 end;

 Writeln('Libration de ',nbr_pages,' pages EMS...');
 EMSFree(handle);
 EMSTestError;

 Writeln(EMSPagesFree,' pages libres');

 Pause;
END.
