{$A+,G+,Q-,R-,S-}

USES Clavier,Texte,Util,Timers;

procedure Test1; far; begin inc(MemW[$B800:2*((1-1)+80*(5+0-1))]) end;
procedure Test2; far; begin inc(MemW[$B800:2*((1-1)+80*(5+1-1))]) end;
procedure Test3; far; begin inc(MemW[$B800:2*((1-1)+80*(5+2-1))]) end;
procedure Test4; far; begin inc(MemW[$B800:2*((1-1)+80*(5+3-1))]) end;
procedure Test5; far; begin inc(MemW[$B800:2*((1-1)+80*(5+4-1))]) end;
procedure Test6; far; begin inc(MemW[$B800:2*((1-1)+80*(5+5-1))]) end;
procedure Test7; far; begin inc(MemW[$B800:2*((1-1)+80*(5+6-1))]) end;
procedure Test8; far; begin inc(MemW[$B800:2*((1-1)+80*(5+7-1))]) end;
procedure Test9; far; begin inc(MemW[$B800:2*((1-1)+80*(5+8-1))]) end;
procedure Test10;far; begin inc(MemW[$B800:2*((1-1)+80*(5+9-1))]) end;

CONST nbr_timers=10;

      Test: array[1..nbr_timers] of
             record frequence: real; routine: procedure end
           =((frequence:  50; routine:Test1),
             (frequence: 0.5; routine:Test2),
             (frequence: 400; routine:Test3),
             (frequence:2560; routine:Test4),
             (frequence:   4; routine:Test5),
             (frequence:  10; routine:Test6),
             (frequence:   8; routine:Test7),
             (frequence:   2; routine:Test8),
             (frequence:  16; routine:Test9),
             (frequence:1000; routine:Test10));

      etat_txt: array[empty..busy] of string[6]
                 =('      ','paused','      ','run   ','busy  ');

      quitte: boolean=FALSE;

VAR TimerTest: array[1..nbr_timers] of Timer;

    Timer_1Hz: Timer;

    touche: Key;
    t: byte;


procedure Chrono; far;
var minutes,secondes: byte;
begin
 with Timer_1Hz do begin
  minutes :=Ticks div 60;
  secondes:=Ticks mod 60;
 end;
 AffChXY(0,1,20,EntierTexte(minutes,2)+':'+EntierTexte(secondes,2),14);
end;


BEGIN
 InitTexte(25);

 AffChXY(0,1,1,'Ctrl+<F1..F10> : set/remove timer',8);
 AffChXY(0,1,2,'     <F1..F10> : stop/restart timer',8);

 for t:=1 to nbr_timers do with Test[t] do
  AffChXY(0,3,5+t-1,'Test'+EntierTexte(t,2)+':'+ReelTexte(frequence,8,2)+' Hz',7);

 with Timer_1Hz do begin Set_(1,Chrono); Start(TRUE) end;

 repeat
  if Keypressed then begin
   touche:=Readkey;

   case touche of
    Esc: quitte:=TRUE;

    CtrlF1..CtrlF10: begin
                      t:=touche-CtrlF1+1;
                      AffCarXY(0,1,5+t-1,' ',7);
                      with TimerTest[t] do
                       if (Status and used)=used then Remove else begin
                        with Test[t] do Set_(frequence,routine);
                        Start(TRUE);
                       end;
                     end;

    F1..F10: with TimerTest[touche-F1+1] do
              if (Status and run)=run then Stop else Start(FALSE);
   end;
 end;

  for t:=1 to nbr_timers do with TimerTest[t] do begin
   AffChXY(0,22,5+t-1,'('+EntierTexte(Ticks,6)+')',7);
   AffChXY(0,32,5+t-1,etat_txt[Status],15);
  end;
 until quitte;

 Timer_1Hz.Remove;
END.
