{$A+,G+,Q-,R-,S-}

USES Crt,MemLin,Util;
{$M 16384,0,1000}

CONST max=40000;

VAR a,t: longint;
    buffer: array[0..max-1] of byte;


procedure Pause;
begin
 if WhereX>1 then WriteLn;
 Write('  <Espace>');
 repeat until ReadKey=' ';
 WriteLn;
end;


procedure AffTemps;
begin
 t:=Timer-t;
 if WhereX>1 then WriteLn;
 WriteLn('Temps machine  ',(t/18.2):4:2,' sec.');
 Pause;
end;


procedure AffBuffer;
var a: longint;
begin
 for a:=0 to max-1 do
  if buffer[a]>=32 then Write(Chr(buffer[a])) else Write('.');
 Pause;
end;


BEGIN
 ClrScr;

 WriteLn('Mmoire DOS libre = ',MemDOSLibre,' octets');
 WriteLn('Nombre de pages disponibles = ',NbrPagesDisp,' (',16384*LONGINT(NbrPagesDisp),' octets)');
 Pause;

 WriteLn('Test LitOctet et EcritOctet...');
 Pause;
 t:=Timer;
 for a:=0 to max-1 do buffer[a]:=LitOctet(a);
 AffTemps;
 AffBuffer;
 t:=Timer;
 for a:=0 to max-1 do EcritOctet(5*a,a);
 AffTemps;
 t:=Timer;
 for a:=0 to max-1 do buffer[a]:=LitOctet(5*a);
 AffTemps;
 AffBuffer;

 {^ ok! ^}


 WriteLn('Test LitBloc et EcritBloc...');
 Pause;
 t:=Timer;
 LitBloc(0,max,buffer);
 AffTemps;
 AffBuffer;
 for a:=0 to max-1 do buffer[a]:=a;
 t:=Timer;
 EcritBloc(0,max,buffer);
 AffTemps;
 t:=Timer;
 LitBloc(0,max,buffer);
 AffTemps;
 AffBuffer;

 {^ ok! ^}


 WriteLn('Test RemplitBloc...');
 Pause;
 t:=Timer;
 RemplitBloc(0,20000,Ord('\'));
 RemplitBloc(20000,20000,Ord('/'));
 for a:=0 to 28 do
  RemplitBloc(8000*a,8000,65+a);
 AffTemps;
 LitBloc(8000*26,max,buffer);
 AffBuffer;

 {^ ok! ^}


 WriteLn('Test CopieBloc...');
 Pause;
 for a:=0 to max-1 do buffer[a]:=32+(a mod 100);
 AffBuffer;
 EcritBloc(0,max,buffer);
 t:=Timer;
 CopieBloc(0,max,max);
 AffTemps;
 LitBloc(max,max,buffer);
 AffBuffer;

 {^ ok! ^}

END.
