PROGRAM TestMMD;
{$A+,G+,Q-,R-,S-}

USES CRT,Clavier,Texte,Util,VGA,FFT_U,
     ModmVar,ModmDemo,ModmCmd,
     ChMOD,ChSTM,ChS3M,ChDTM,ChMTM,Ch669,ChFAR,ChPTM,ChULT;

{$M 16384,0,56000}

{***$DEFINE COL132}

CONST Freq=22100;   { Frquence de sortie      }
      Vol=5*60;     { Volume de sortie   0-500 }
      LectCont=TRUE;
      Stereo=TRUE;
      Nb_Oct_Mod=6;

      repert_mod='C:\MUSIQUE\';

      {paramtres FFT}
      mode_FFT: Word=FFT_directe+FFT_trapeze+FFT_module;
      log2_taille_tampon_FFT=log2_nbr_points_max;
      taille_tampon_FFT=1 SHL log2_taille_tampon_FFT;
      ampl_FFT: Byte=4;


TYPE T_Oscillo=Array[0..639] of Shortint;


VAR erreur: Word;
    Nb_Voies_Aff: Byte;
    TailleDMAMin,TailleDMAMax: Word;
    PositionDMAMin,PositionDMAMax: Word;
    TPMin,TPMax: Word;
    TailleDMA,PositionDMA: Word;

    Type_Affichage: Byte;
    Afficher: Boolean;

    oscillo   : Record gauche,droite: T_Oscillo End;
    tampon_FFT: Record gauche,droite: T_FFT End;
    top_FFT,cpt_FFT: Longint;
    min_FFT,max_FFT: Byte;
    x_FFT: Word;


FUNCTION Lire_Taille_DMA(DMA:Byte):word; assembler;
ASM
    XOR  AL,AL
    OUT  0Ch,AL           { Clear flipflop }
    MOV  DL,DMA
    XOR  DH,DH
    SHL  DX,1
    INC  DX               { DX = channel * 2 + 1 = base counter }
    IN   AL,DX            { AL = lower byte }
    MOV  BL,AL
    IN   AL,DX            { AL = higher byte }
    MOV  BH,AL
    MOV  AX,BX            { AX = high and low part together ;) - return that }
                          { bytes left to send = ax + 1 }
END;


FUNCTION Lire_Position_DMA(DMA:Byte):word; ASSEMBLER;
ASM
    XOR  AL,AL
    OUT  0Ch,AL           { clear flipflop }
    MOV  DL,DMA
    XOR  DH,DH
    SHL  DX,1
                          { dx = channel * 2 = Offset }
    IN   AL,DX            { al = lower byte           }
    MOV  BL,AL
    IN   AL,DX            { al = higher byte          }
    MOV  BH,AL
    MOV  AX,BX            { AX = high and low part together ;) - return that }
                          { bytes left to send = ax + 1                      }
END;


PROCEDURE Afficher_Infos;
BEGIN
 If Afficher Then
  Begin
   Afficher:=False;
   InitTexte(25);

   AffChXY(0,2,1,'Frquence: '+EntierTexte(Freq,4),2);
   AffChXY(0,2,3,'Note :',2);
   AffChXY(0,2,4,'Sequence :',2);
   AffChXY(0,2,5,'Pattern  :',2);

   AffChXY(0,18,3,'Volume: ',2);

   AffChXY(0,2,7,'Tampon_Actif:',2);
   AffChXY(0,2,8,'Nouveau_Pointeur_Tampon:',2);

   AffChXY(0,2,10,'Tempo:',2);
   AffChXY(0,2,11,'BPM  :',2);

   AffChXY(0,2,13,'Segment Tampons: '+EntierTexte(Variables^.Seg_Table_Volume,4),2);
   AffChXY(0,2,14,'Offset Tampon1 : '+EntierTexte(Variables^.Offset_Tampon1,4),2);
   AffChXY(0,2,15,'Offset Tampon2 : '+EntierTexte(Variables^.Offset_Tampon2,4),2);
   AffChXY(0,2,16,'Taille Tampon DMA: '+EntierTexte(Info^.Taille_Tampon,4),2);

   AffChXY(0,40,2,'Taille DMA:',2);
   AffChXY(0,40,3,'Taille DMA Mesuree:',2);
   AffChXY(0,40,4,'Position DMA:',2);
   AffChXY(0,40,5,'Position Min DMA:',2);
   AffChXY(0,40,6,'Position Max DMA:',2);
   AffChXY(0,40,7,'Diff Adresses:',2);
   AffChXY(0,40,8,'Taille Sortie DMA: '+EntierTexte(Info^.Taille_Sortie_DMA,3),2);
  End;

 AffChXY(0,70,2,EntierTexte(Chrono_min,2),1);
 AffChXY(0,73,2,EntierTexte(Chrono_sec,2),1);
 AffChXY(0,76,2,EntierTexte(Chrono_50,2),1);

 AffChXY(0,60,2,EntierTexte(TailleDMA,2)+'  ',7);
 AffChXY(0,60,3,EntierTexte(TailleDMAMax,3)+'  ',7);

 AffChXY(0,60,5,EntierTexte(PositionDMA,4)+'  ',7);
 AffChXY(0,60,6,EntierTexte(PositionDMAMin,5)+' '+EntierTexte(TPMin,4),7);
 AffChXY(0,60,7,EntierTexte(PositionDMAMax,5)+' '+EntierTexte(TPMax,4),7);
 AffChXY(0,60,8,EntierTexte(PositionDMAMax-PositionDMAMin,5)+' ',7);

 AffChXY(0,8,3,EntierTexte(Info^.Pos_Note,3),7);
 AffChXY(0,12,4,EntierTexte(Info^.Pos_Sequence,3),7);
 AffChXY(0,12,5,EntierTexte(Info^.Num_Pattern,3),7);
 AffChXY(0,25,3,EntierTexte(Info^.Volume_General,3),7);

 AffChXY(0,16,7,EntierTexte(Info^.Tampon_Actif,1),3);
 AffChXY(0,27,8,EntierTexte(Info^.Pointeur_Tampon_Joue,4),3);

 AffChXY(0,10,10,EntierTexte(Info^.Tempo,4)+' '+EntierTexte(Info^.Cmpt_tempo,4),3);
 AffChXY(0,10,11,EntierTexte(Info^.BPM,4)+' '+EntierTexte(Info^.Cmpt_BPM,4),3);
End;


Procedure Afficher_Voies;
Var i: Byte;
Begin
 If Afficher Then
  Begin
   Afficher:=False;
   InitTexte(25);

   AffChXY(0,4,8,'Per  Vol Smp Fine  C-2  Posit   Ent Dec  Pann VContr',5);
   AffChXY(0,2,1,'Frquence: '+EntierTexte(Freq,4),2);
   AffChXY(0,2,3,'Note :',2);
   AffChXY(0,2,4,'Sequence :',2);
   AffChXY(0,2,5,'Pattern  :',2);
  End;

 AffChXY(0, 8,3,EntierTexte(Info^.Pos_Note,3),7);
 AffChXY(0,12,4,EntierTexte(Info^.Pos_Sequence,3),7);
 AffChXY(0,12,5,EntierTexte(Info^.Num_Pattern,3),7);
 AffChXY(0,70,2,EntierTexte(Chrono_min,2),1);
 AffChXY(0,73,2,EntierTexte(Chrono_sec,2),1);
 AffChXY(0,76,2,EntierTexte(Chrono_50,2),1);

 For i:=1 to Nb_Voies_Aff do
  Begin
   AffChXY(0,12,9+i,EntierTexte(Info^.VSample[i],4),3);
   AffChXY(0, 2,9+i,EntierTexte(Info^.VPeriode_re[i],5),3);
   AffChXY(0, 7,9+i,EntierTexte(Info^.VVolume[i],4),3);
   AffChXY(0,16,9+i,EntierTexte(Info^.FineTune[i],4),3);
   AffChXY(0,22,9+i,EntierTexte(Info^.VDadj[i],5),3);
   AffChXY(0,28,9+i,EntierTexte(Info^.VOffset_Actuel[i],5),3);
   AffChXY(0,36,9+i,EntierTexte(Info^.VPart_entiere[i],2),3);
   AffChXY(0,39,9+i,EntierTexte(Info^.VPart_decimale[i],4),3);
   AffChXY(0,44,9+i,EntierTexte(Info^.VPanning[i],4),3);
   AffChXY(0,50,9+i,EntierTexte(Info^.VControle[i],4),3);
  End;
End;


PROCEDURE Init640x480; Assembler;
ASM
 MOV AX,gr640x480_16c
 INT 10h
End;


PROCEDURE Point(x,y: Word; couleur: Byte); Assembler;
{640x480 16c}
ASM
 MOV AX,0A000h
 MOV ES,AX

 MOV AX,y
 MOV DX,80
 MUL DX
 MOV BX,x
 MOV CL,BL
 SHR BX,3
 ADD BX,AX

 AND CL,00000111b
 XOR CL,00000111b
 MOV AH,1
 SHL AH,CL

 MOV DX,GraphControl
 MOV AL,BitMask
 OUT DX,AX
 MOV AX,(00000010b SHL 8)+GraphicsMode
 OUT DX,AX

 MOV AL,ES:[BX]
 MOV AL,couleur
 MOV ES:[BX],AL

{ MOV AX,(11111111b SHL 8)+BitMask
 OUT DX,AX
 MOV AX,(00000000b SHL 8)+GraphicsMode
 OUT DX,AX}
End;


PROCEDURE Afficher_Oscillo;

Var i: Word;
    c: Byte;

Begin
 If Afficher or (Info^.Pos_Note Mod Info^.Tempo=0) Then
  Begin
   Afficher:=False;
   Init640x480;
  End;

 With Variables^ do
  For i:=0 to MinEntier(639,Info^.Taille_Tampon-1) do
   Begin
    Point(i,120+oscillo.gauche[i],8);
    Point(i,360+oscillo.droite[i],8);
    Point(i,120,7);
    Point(i,360,7);

    oscillo.gauche[i]:=Mem[Seg_Table_Volume:Offset_Tampon1+2*i  ]-128;
    oscillo.droite[i]:=Mem[Seg_Table_Volume:Offset_Tampon1+2*i+1]-128;

    Case Abs(oscillo.gauche[i]) of
      0.. 49: c:=10;
     50.. 79: c:=14;
     80..128: c:=12;
    End;
    Point(i,120+oscillo.gauche[i],c);

    Case Abs(oscillo.droite[i]) of
      0.. 49: c:=10;
     50.. 79: c:=14;
     80..128: c:=12;
    End;
    Point(i,360+oscillo.droite[i],c);
   End;
End;


PROCEDURE Afficher_SpectreTexte;

Const hauteur_barre_max=24;
      valeur_max=64;

Var temps,position: Word;
    fenetre: String[8];
    i,FFT_par_sec: Byte;


Procedure AffSpectre(x,y: Byte; spectre: T_FFT_module); Assembler;
ASM
 PUSH DS

 MOV DX,0B800h
 MOV ES,DX

 XOR DH,DH
 MOV DL,largeur_ecran_txt

 XOR AH,AH
 MOV AL,x
 MOV DI,AX
 DEC DI
 MOV AL,y
 DEC AL
 MUL DL
 ADD DI,AX
 SHL DI,1            {ES:DI -> B800:2*((x-1)+largeur_ecran_txt*(y-1))}

 SHL DX,1            {DX=2*largeur_ecran_txt}

 LDS SI,spectre

 {$IFDEF COL132}
 MOV CH,taille_tampon_FFT/2
 {$ELSE}
 MOV CH,80
 {$ENDIF}
@boucle_barres:
  PUSH DI

  MOV AL,''

  MOV CL,[SI]
  OR  CL,CL
  JZ  @barre_gris
  XOR BX,BX
 @boucle_barre_couleur:
   MOV AH,Byte(CS:[@couleurs+BX])
   MOV Word(ES:[DI]),AX
   SUB DI,DX
   INC BL
   DEC CL
  JNZ @boucle_barre_couleur

 @barre_gris:
  MOV CL,hauteur_barre_max
  SUB CL,[SI]
  OR  CL,CL
  JZ  @fin_barre
  MOV AH,8
 @boucle_barre_gris:
   MOV Word(ES:[DI]),AX
   SUB DI,DX
   DEC CL
  JNZ @boucle_barre_gris

 @fin_barre:
  ADD SI,2
  POP DI
  ADD DI,2
  DEC CH
 JNZ @boucle_barres

 JMP @fin

@couleurs:
 DB 10,10,10,10,10,10
 DB 10,10,10,10,10,10
 DB 14,14,14,14,14,14
 DB 12,12,12,12,12,12

@fin:
 POP DS
End;


Begin
 If Afficher Then
  Begin
   Afficher:=False;
   {$IFDEF COL132}
   InitTexte132(50);
   {$ELSE}
   InitTexte(50);
   {$ENDIF}
   cpt_FFT:=0;
   top_FFT:=Chrono_50+50*(Chrono_sec+60*WORD(Chrono_min));
   min_FFT:=255;
   max_FFT:=0;
  End;

 If (Timer AND $3F)=0 Then
  Begin
   cpt_FFT:=0;
   top_FFT:=Chrono_50+50*(Chrono_sec+60*WORD(Chrono_min));
   min_FFT:=255;
   max_FFT:=0;
  End;

 With Variables^,tampon_FFT do
  Begin
   AffChXY(0,1,1,'Tampons DMA: taille='+EntierTexte2(Info^.Taille_Tampon,4)+
                 ' actif='+EntierTexte2(Info^.Tampon_Actif,1)+
                 ' @0='+EntierHexa(Seg_Table_Volume,4)+
                    ':'+EntierHexa(Offset_Tampon1,4)+
                 ' @1='+EntierHexa(Seg_Table_Volume,4)+
                    ':'+EntierHexa(Offset_Tampon2,4),7);

   AffChXY(0,62,1,EntierTexte2(Chrono_min,et_zeros+2)+':'+
                  EntierTexte2(Chrono_sec,et_zeros+2),11);

   Case mode_FFT AND (FFT_rect+FFT_trapeze+FFT_hanning) of
    FFT_rect   : fenetre:='rectang';
    FFT_trapeze: fenetre:='trapze';
    FFT_hanning: fenetre:='hanning';
   End;
   AffChXY(0,70,1,'fentre='+fenetre+
                 ' amplitude='+EntierTexte2(ampl_FFT,2),15);

   temps:=Chrono_50+50*(Chrono_sec+60*WORD(Chrono_min))-top_FFT;
   If temps<>0 Then
    Begin
     FFT_par_sec:=(50*cpt_FFT) Div temps;
     If FFT_par_sec<min_FFT Then min_FFT:=FFT_par_sec;
     If FFT_par_sec>max_FFT Then max_FFT:=FFT_par_sec;
     AffChXY(0,100,1,EntierTexte2(FFT_par_sec,3)+' FFT/sec.'+
                     ' min='+EntierTexte2(min_FFT,3)+
                     ' max='+EntierTexte2(max_FFT,3),15);
    End;

   {chantillonne le tampon DMA  taille_tampon_FFT points}
   For i:=0 to taille_tampon_FFT-1 do
    Begin
     position:=2*((i*Info^.Taille_Tampon) Div taille_tampon_FFT);
     gauche.points[i]:=ampl_FFT*(Mem[Seg_Table_Volume:Offset_Tampon1+position  ]-128);
     droite.points[i]:=ampl_FFT*(Mem[Seg_Table_Volume:Offset_Tampon1+position+1]-128);
    End;
   { ^^  refaire en ASM avec des ADD/ADC... }

   {calcule les FFT gauche & droite}
   FFT(mode_FFT,gauche,log2_taille_tampon_FFT);
   Inc(cpt_FFT);
   FFT(mode_FFT,droite,log2_taille_tampon_FFT);
   Inc(cpt_FFT);

   {normalise et crte les modules}
   For i:=0 to (taille_tampon_FFT Div 2)-1 do
    Begin
     gauche.module[i]:=MinEntier((gauche.module[i]*hauteur_barre_max) Div valeur_max,hauteur_barre_max);
     droite.module[i]:=MinEntier((droite.module[i]*hauteur_barre_max) Div valeur_max,hauteur_barre_max);
    End;

   {affiche les barres de spectre}
   AffSpectre(1,25,gauche.module);
   AffSpectre(1,50,droite.module);
  End;
End;


PROCEDURE Afficher_SpectreGraphique;

Const hauteur_barre_max=48;
      valeur_max=64;

      pal_FFT: Palette16=(palette:(
             (R: 0; V: 0; B: 0),
             (R: 0; V:10; B:40),
             (R: 0; V:15; B:50),
             (R: 0; V:20; B:60),
             (R: 0; V:30; B:60),
             (R: 0; V:35; B:50),
             (R: 0; V:35; B:40),
             (R: 0; V:45; B:40),
             (R: 0; V:50; B:30),
             (R: 0; V:60; B:20),
             (R:35; V:60; B: 0),
             (R:50; V:60; B: 0),
             (R:60; V:60; B: 0),
             (R:60; V:50; B: 0),
             (R:60; V:35; B: 0),
             (R:60; V:10; B: 0)
            ));

Var i,j: Byte;
    position: Word;

Begin
 If Afficher Then
  Begin
   Afficher:=False;
   Init640x480;

   {initialise la palette 16 couleurs}
   For i:=0 to 15 do FixeDAC(i,pal_FFT.palette[i]);
  End;

 With Variables^,tampon_FFT do
  Begin
   {chantillonne le tampon DMA  taille_tampon_FFT points}
   For i:=0 to taille_tampon_FFT-1 do
    Begin
     position:=2*((i*Info^.Taille_Tampon) Div taille_tampon_FFT);
     gauche.points[i]:=ampl_FFT*(Mem[Seg_Table_Volume:Offset_Tampon1+position  ]-128);
     droite.points[i]:=ampl_FFT*(Mem[Seg_Table_Volume:Offset_Tampon1+position+1]-128);
    End;

   {calcule les FFT gauche & droite}
   FFT(mode_FFT,gauche,log2_taille_tampon_FFT);
   FFT(mode_FFT,droite,log2_taille_tampon_FFT);

   {normalise et crte les modules}
   For i:=0 to (taille_tampon_FFT Div 2)-1 do
    Begin
     gauche.module[i]:=MinEntier((gauche.module[i]*hauteur_barre_max) Div valeur_max,hauteur_barre_max);
     droite.module[i]:=MinEntier((droite.module[i]*hauteur_barre_max) Div valeur_max,hauteur_barre_max);
    End;

   {affiche le spectre graphique}
   For i:=0 to (taille_tampon_FFT Div 2)-1 do
    Begin
     For j:=1 to gauche.module[i] do Point(256+i,239-j,MinEntier((Word(j)*15) Div hauteur_barre_max,15));
     For j:=1+gauche.module[i] to hauteur_barre_max do Point(256+i,239-j,0);

     For j:=1 to droite.module[i] do Point(256+i,240+j,MinEntier((Word(j)*15) Div hauteur_barre_max,15));
     For j:=1+droite.module[i] to hauteur_barre_max do Point(256+i,240+j,0);
    End;
   { ^^ c'est TRES lent !! -> optimiser un peu tout a... }

  End;
End;


PROCEDURE Afficher_SpectreProgressif;

Const valeur_max=64;

Var i: Byte;
    comp: RVB;
    position: Word;

Begin
 If Afficher Then
  Begin
   Afficher:=False;
   Init640x480;

   x_FFT:=0;

   {initialise la palette 16 couleurs}
   For i:=1 to 15 do With comp do
    Begin
     R:=3+4*i;
     V:=18+3*i;
     B:=20;
     FixeDAC(i,comp);
    End;
  End;

 With Variables^,tampon_FFT do
  Begin
   {chantillonne le tampon DMA  taille_tampon_FFT points}
   For i:=0 to taille_tampon_FFT-1 do
    Begin
     position:=2*((i*Info^.Taille_Tampon) Div taille_tampon_FFT);
     gauche.points[i]:=ampl_FFT*(Mem[Seg_Table_Volume:Offset_Tampon1+position  ]-128);
     droite.points[i]:=ampl_FFT*(Mem[Seg_Table_Volume:Offset_Tampon1+position+1]-128);
    End;

   {calcule les FFT gauche & droite}
   FFT(mode_FFT,gauche,log2_taille_tampon_FFT);
   FFT(mode_FFT,droite,log2_taille_tampon_FFT);

   {normalise et crte les modules}
   For i:=0 to (taille_tampon_FFT Div 2)-1 do
    Begin
     gauche.module[i]:=MinEntier((gauche.module[i]*15) Div valeur_max,15);
     droite.module[i]:=MinEntier((droite.module[i]*15) Div valeur_max,15);
    End;

   {affiche le spectre graphique progressif}
   For i:=0 to (taille_tampon_FFT Div 2)-1 do
    Begin
     Point(x_FFT,239-i,gauche.module[i]);
     Point(x_FFT,240+i,droite.module[i]);
    End;

   x_FFT:=(x_FFT+1) Mod 640;
  End;
End;


PROCEDURE Afficher_Spectre3D;

Const hauteur_barre_max=32;
      valeur_max=64;

      proj_x=0.35;
      proj_y=1-proj_x;

      pal_FFT: Palette16=(palette:(
             (R: 0; V: 0; B: 0),
             (R: 0; V:10; B:40),
             (R: 0; V:15; B:50),
             (R: 0; V:20; B:60),
             (R: 0; V:30; B:60),
             (R: 0; V:35; B:50),
             (R: 0; V:35; B:40),
             (R: 0; V:45; B:40),
             (R: 0; V:50; B:30),
             (R: 0; V:60; B:20),
             (R:35; V:60; B: 0),
             (R:50; V:60; B: 0),
             (R:60; V:60; B: 0),
             (R:60; V:50; B: 0),
             (R:60; V:35; B: 0),
             (R:60; V:10; B: 0)
            ));

Var i,j: Byte;
    comp: RVB;
    position: Word;

    xe,ye: Word;

Procedure ConvCoord(x,y,z: Word; Var xe,ye: Word);
Begin
 xe:=Round(y-proj_x*x);
 ye:=Round(z-proj_y*x);
End;

Begin
 If Afficher Then
  Begin
   Afficher:=False;
   Init640x480;

   x_FFT:=0;

   {initialise la palette 16 couleurs}
   For i:=0 to 15 do FixeDAC(i,pal_FFT.palette[i]);
  End;

 With Variables^,tampon_FFT do
  Begin
   {chantillonne le tampon DMA  taille_tampon_FFT points}
   For i:=0 to taille_tampon_FFT-1 do
    Begin
     position:=2*((i*Info^.Taille_Tampon) Div taille_tampon_FFT);
     gauche.points[i]:=ampl_FFT*(Mem[Seg_Table_Volume:Offset_Tampon1+position  ]-128);
     droite.points[i]:=ampl_FFT*(Mem[Seg_Table_Volume:Offset_Tampon1+position+1]-128);
    End;

   {calcule les FFT gauche & droite}
   FFT(mode_FFT,gauche,log2_taille_tampon_FFT);
   FFT(mode_FFT,droite,log2_taille_tampon_FFT);

   {normalise et crte les modules}
   For i:=0 to (taille_tampon_FFT Div 2)-1 do
    Begin
     gauche.module[i]:=MinEntier((gauche.module[i]*hauteur_barre_max) Div valeur_max,hauteur_barre_max);
     droite.module[i]:=MinEntier((droite.module[i]*hauteur_barre_max) Div valeur_max,hauteur_barre_max);
    End;

   {affiche le spectre graphique 3D}
   For i:=0 to (taille_tampon_FFT Div 2)-1 do
    Begin
     ConvCoord(x_FFT,i,2*gauche.module[i],xe,ye);
     xe:=180+xe;
     ye:=100-ye;
     For j:=1 to gauche.module[i] do Point(xe,ye-j+1,i Div 8);

     ConvCoord(x_FFT,i,2*droite.module[i],xe,ye);
     xe:=400+xe;
     ye:=100-ye;
     For j:=1 to droite.module[i] do Point(xe,ye-j+1,i Div 8);
    End;

   Inc(x_FFT,2);
   If x_FFT>=500 Then Afficher:=True;
  End;
End;


BEGIN
 TailleDMAMax:=0;
 TailleDMAMin:=$FFFF;
 PositionDMAMax:=0;
 PositionDMAMin:=$FFFF;
 Type_Affichage:=1;
 Afficher:=True;
 Nb_Octaves_MOD:=Nb_Oct_MOD;

 {Charge_mod('C:\TEMP\TESTFFT.MOD',Erreur);}
 {Charge_mod(repert_mod+'AMBPOWER.MOD',Erreur);}
 {Charge_mod(repert_mod+'AUTOWASC.MOD',Erreur);}
 {Charge_mod(repert_mod+'DESERT.MOD'  ,Erreur);}
 {Charge_mod(repert_mod+'ELYSIUM.MOD' ,Erreur);}
 Charge_mod(repert_mod+'LONGSTAB.MOD',Erreur);
 {Charge_mod(repert_mod+'STARDUST.MOD',Erreur);}
 {Charge_S3M(repert_mod+'ADLIB.S3M'   ,Erreur);}
 {Charge_S3M(repert_mod+'OMNIPHIL.S3M',Erreur);}
 {Charge_s3m(repert_mod+'SERENTIN.S3M',Erreur);}
 {Charge_S3M(repert_mod+'WATER.S3M'   ,Erreur);}
 {Charge_dtm(repert_mod+'VELOMATR.DTM',Erreur);}
 {Charge_mtm(repert_mod+'ABYSS.MTM'   ,Erreur);}
 {Charge_mtm(repert_mod+'HARMNICS.MTM',Erreur);}
 {Charge_ult(repert_mod+'CYBOCULT.ULT',Erreur);}
 {Charge_PTm(repert_mod+'RIGHT.PTM'   ,Erreur);}
 {Charge_669(repert_mod+'ELEMENT.669' ,Erreur);}

{ For i:=1 to MUS.H^.Nb_Total_Samples do
   With MUS.T^.PtrSamples[i]^ do
    Begin
     Writeln('Sample N',i,': ',Nom);
     Write('Info: ',Info,' ');
     If (Info And M_Charge)<>0 Then Write('Charge ');
     If (Info And M_Bidi)  <>0 Then Write('Bidi ');
     If (Info And M_Boucle)<>0 Then Write('Boucle ');
     If (Info And M_16Bit) <>0 Then Write('16bit ');
     Writeln;
     Writeln('Longueur: ',Len);
     Writeln('Rep: ',Rep);
     Writeln('Rep_Len: ',Rep_Len);
     Writeln('Volume: ',Volume);
     Writeln('Fine: ',Fine_Tune1);
     Writeln(': ',C4Spd);
     Writeln('Handle EMS: ',Mem.Handle_EMS);
     Writeln('Nb de pages EMS: ',Mem.Nb_Pages_EMS);
     Repeat Until Readkey=Enter;
    End;}

 Erreur_Modm(Erreur);

 Variables^.Frequence:=Freq;
 Variables^.Utilise_DC:=LectCont;
 Variables^.Utilise_Stereo:=Stereo;
 Variables^.Utiliser_Interpolation:=True;

 Volume_Principal:=Vol;

 Play(Erreur);   { ~ Lancer_Musique et Lancer_Sortie }

 Nb_Voies_Aff:=MUS.H^.Nb_de_Voies;
 If Nb_Voies_Aff>12 Then Nb_Voies_Aff:=12;

 Repeat
  TailleDMA:=Lire_Taille_DMA(1);
  If TailleDMA>TailleDMAMax Then TailleDMAMax:=TailleDMA;

  PositionDMA:=Lire_Position_DMA(1)-(Variables^.Seg_Table_Volume SHL 4);
  If PositionDMA<=PositionDMAMin Then
   Begin
    TPMin:=Lire_Taille_DMA(1);
    PositionDMAMin:=PositionDMA;
   End
  Else
   If PositionDMA>=PositionDMAMax Then
    Begin
     TPMax:=Lire_Taille_DMA(1);
     PositionDMAMax:=PositionDMA;
    End;

  Case Type_Affichage of
   1: Afficher_Infos;
   2: Afficher_Voies;
   3: Afficher_Oscillo;
   4: Afficher_SpectreTexte;
   5: Afficher_SpectreGraphique;
   6: Afficher_SpectreProgressif;
   7: Afficher_Spectre3D;
  End;

  If Keypressed Then
   Case UpCase(ReadKey) of
    Esc     : Break;

    Del     : Begin
               TailleDMAMax:=0;
               TailleDMAMin:=$FFFF;
               PositionDMAMax:=0;
               PositionDMAMin:=$FFFF;
              End;

{    Left    : Position_Precedente;
    Right   : Position_Suivante;    <- a foire... }

    Up      : If ampl_FFT<10 Then Inc(ampl_FFT);
    Down    : If ampl_FFT>1  Then Dec(ampl_FFT);

    Key('R'): mode_FFT:=(mode_FFT AND NOT(FFT_rect+FFT_trapeze+FFT_hanning)) OR FFT_rect;
    Key('T'): mode_FFT:=(mode_FFT AND NOT(FFT_rect+FFT_trapeze+FFT_hanning)) OR FFT_trapeze;
    Key('H'): mode_FFT:=(mode_FFT AND NOT(FFT_rect+FFT_trapeze+FFT_hanning)) OR FFT_hanning;

    Key('1'): Begin Type_Affichage:=1; Afficher:=True End;
    Key('2'): Begin Type_Affichage:=2; Afficher:=True End;
    Key('3'): Begin Type_Affichage:=3; Afficher:=True End;
    Key('4'): Begin Type_Affichage:=4; Afficher:=True End;
    Key('5'): Begin Type_Affichage:=5; Afficher:=True End;
    Key('6'): Begin Type_Affichage:=6; Afficher:=True End;
    Key('7'): Begin Type_Affichage:=7; Afficher:=True End;

    Key('+'): If Info^.Volume_General<64 Then Inc(Info^.Volume_General);
    Key('-'): If Info^.Volume_General>0  Then Dec(Info^.Volume_General);

    Key('I'): Variables^.Utiliser_Interpolation:=Not Variables^.Utiliser_Interpolation;
   End;

 Until Variables^.Sortie_Stoppee;

 Writeln('Lancement de Stop_modm');
 Stop_Sortie;            { Stopper la sortie sonore }
 Stop_Musique;           { Stopper la musique       }
 TextMode(LastMode);
 Writeln('Fin de TESTMMD');
END.