{$A+,G+,Q-,R-,S-}

USES Crt,Texte,Util,VGA{,Timers};

CONST noir : RVB=(R: 0;V: 0;B: 0);
      blanc: RVB=(R:63;V:63;B:63);

      rouge: byte=0;
      pas_rouge: shortint=+1;

      decalage: shortint=0;
      pas_decalage: shortint=+1;

      quitte: boolean=FALSE;

      BOLD16: array['a'..'z'] of Binaire16=(
       ($00,$00,$00,$00,$00,$7C,$06,$7E,$E6,$E6,$E6,$7E,$00,$00,$00,$00),  {a}
       ($00,$00,$E0,$E0,$E0,$FC,$E6,$E6,$E6,$E6,$E6,$FC,$00,$00,$00,$00),  {b}
       ($00,$00,$00,$00,$00,$7C,$E6,$E0,$E0,$E0,$E6,$7C,$00,$00,$00,$00),  {c}
       ($00,$00,$0E,$0E,$0E,$7E,$CE,$CE,$CE,$CE,$CE,$7E,$00,$00,$00,$00),  {d}
       ($00,$00,$00,$00,$00,$7C,$E6,$E6,$FE,$E0,$E6,$7C,$00,$00,$00,$00),  {e}
       ($00,$00,$3C,$76,$70,$70,$F8,$70,$70,$70,$70,$70,$00,$00,$00,$00),  {f}
       ($00,$00,$00,$00,$00,$7C,$E6,$E6,$E6,$E6,$E6,$7E,$06,$C6,$7C,$00),  {g}
       ($00,$00,$E0,$E0,$E0,$FC,$E6,$E6,$E6,$E6,$E6,$E6,$00,$00,$00,$00),  {h}
       ($00,$00,$38,$38,$00,$38,$38,$38,$38,$38,$38,$38,$00,$00,$00,$00),  {i}
       ($00,$00,$0E,$0E,$00,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$CE,$7C,$00),  {j}
       ($00,$00,$E0,$E0,$E0,$E2,$E6,$EC,$F8,$EC,$E6,$E6,$00,$00,$00,$00),  {k}
       ($00,$00,$18,$38,$38,$38,$38,$38,$38,$38,$38,$38,$00,$00,$00,$00),  {l}
       ($00,$00,$00,$00,$00,$EC,$FE,$D6,$D6,$D6,$D6,$D6,$00,$00,$00,$00),  {m}
       ($00,$00,$00,$00,$00,$FC,$E6,$E6,$E6,$E6,$E6,$E6,$00,$00,$00,$00),  {n}
       ($00,$00,$00,$00,$00,$7C,$E6,$E6,$E6,$E6,$E6,$7C,$00,$00,$00,$00),  {o}
       ($00,$00,$00,$00,$00,$FC,$E6,$E6,$E6,$E6,$E6,$FC,$E0,$E0,$E0,$00),  {p}
       ($00,$00,$00,$00,$00,$7E,$CE,$CE,$CE,$CE,$CE,$7E,$0E,$0E,$0E,$00),  {q}
       ($00,$00,$00,$00,$00,$FC,$E6,$E0,$E0,$E0,$E0,$E0,$00,$00,$00,$00),  {r}
       ($00,$00,$00,$00,$00,$7C,$E6,$F0,$7C,$1E,$CE,$7C,$00,$00,$00,$00),  {s}
       ($00,$00,$10,$30,$70,$FC,$70,$70,$70,$70,$76,$3C,$00,$00,$00,$00),  {t}
       ($00,$00,$00,$00,$00,$E6,$E6,$E6,$E6,$E6,$E6,$7E,$00,$00,$00,$00),  {u}
       ($00,$00,$00,$00,$00,$E6,$E6,$E6,$E6,$6C,$38,$10,$00,$00,$00,$00),  {v}
       ($00,$00,$00,$00,$00,$C6,$C6,$D6,$D6,$FE,$7C,$6C,$00,$00,$00,$00),  {w}
       ($00,$00,$00,$00,$00,$C6,$EE,$7C,$38,$7C,$EE,$C6,$00,$00,$00,$00),  {x}
       ($00,$00,$00,$00,$00,$E6,$E6,$E6,$E6,$E6,$E6,$7E,$06,$C6,$7C,$00),  {y}
       ($00,$00,$00,$00,$00,$FE,$0E,$1C,$38,$70,$E0,$FE,$00,$00,$00,$00)   {z}
      );


VAR {t: Timer;}

    Sinus: array[0..63] of shortint;

    couleur0,couleur15: RVB;

    cpt: longint;
    i,j: word;

    ancint09: pointer;

(*
procedure Raster; far;
begin
 FixeDAC(0,couleur0);
 inc(couleur0.R);
end; {Raster}
*)


procedure Int09; interrupt;
begin
 asm
  pushf
  call ancint09
 end;
 quitte:=TRUE;
end;


procedure Wobbler(y,hauteur,position: word); assembler;
asm
 cli

 mov rouge,0
 mov pas_rouge,+1

 xor CX,CX             {n ligne cran}
@boucle_ligne:
 inc CX                {incrmente n ligne cran}
 call AttendHBL2
 cmp CX,y              {premire ligne wobbler atteinte ?}
 jb @boucle_ligne

 mov BX,CX
 sub BX,y              {BX=n ligne wobbler}
 mov SI,BX
 add BX,position
 and BX,63

 mov DX,CRTControl
 mov AX,StartHRetrace+((80+5) shl 8)
 add AH,BYTE(Sinus[BX])
 out DX,AX             {dcale bord gauche d'cran}

 xor AL,AL
 mov DX,DACWrite
 out DX,AL
 mov DX,DACData
 mov AL,rouge
 out DX,AL
 mov AL,16
 out DX,AL
 mov AL,32
 out DX,AL

 mov AL,pas_rouge
 add rouge,AL

 cmp rouge,0
 jz @inverse_rouge
 cmp rouge,63
 jne @pas_inverse_rouge
@inverse_rouge:
 neg pas_rouge
@pas_inverse_rouge:

 cmp SI,hauteur        {dernire ligne wobbler atteinte ?}
 jb @boucle_ligne

 xor AL,AL
 mov DX,DACWrite
 out DX,AL
 mov DX,DACData
 out DX,AL
 out DX,AL
 out DX,AL

 mov DX,CRTControl
 mov AX,StartHRetrace+((80+5) shl 8)
 out DX,AX             {bord gauche d'cran normal}

 sti
end; {Wobbler}


BEGIN
 InitTexte(25);
 LargeurCar(8);
 Curseur(off);
 InitTexteVirtuel(160);
 RedefCar(0,'a',26,BOLD16,binaire);

{ t.Set_(70*225,Raster);
 repeat until Readkey=' ';}

 couleur0:=noir;

 cpt:=0;
 AttendVBL2;
 repeat
  FixeDAC(0,couleur0);
  inc(couleur0.R);
  AttendHBL;
  inc(cpt);
 until cpt>=30000;

{ t.Start(TRUE);
 repeat until t.Ticks>=30000;
 t.Stop;}

 SwapIntVec($09,ancint09,@Int09);

(* Port[$21]:=$FF; {interdit toutes les IRQ}
 Port[$A1]:=$FF;*)

 for i:=1 to 13 do AffChXY(0,15,i,'ceci est un wobbler-raster-sinus-scroller en mode texte...',15);
 for i:=0 to 63 do Sinus[i]:=Round(3*Sin(2*Pi*i/64));

 UnLockCRT;
 i:=0;
 repeat
  SmoothHorizontal(Round(4*(1+Sin(2*Pi*i/80))));
  SmoothVertical(Round(7.5*(1+Sin(2*Pi*i/140))));

  AttendVBL2;
  FixeDAC(15,blanc);

  Wobbler(16*0,16*12,i);
  inc(i);

  couleur0 :=noir;
  couleur15:=noir; FixeDAC(15,couleur15);

  for j:=1 to Round(25*(1+Sin(2*Pi*i/180))) do begin
   AttendHBL2;
   if (j and $01)=0 then
    with couleur0 do begin FixeDAC(0,couleur0); inc(R); inc(V) end;
  end;

  for j:=1 to 63 do begin
   AttendHBL2;
   if (j and $01)=0 then
    with couleur0 do begin FixeDAC(0,couleur0); inc(R); inc(V) end;
   FixeDAC(15,couleur15);
   with couleur15 do begin inc(R); inc(V); inc(B) end;
  end;
  for j:=1 to 63 do begin
   AttendHBL2;
   FixeDAC( 0,couleur0);
   if (j and $01)=0 then
    with couleur0 do begin FixeDAC(0,couleur0); dec(R); dec(V) end;
   FixeDAC(15,couleur15);
   with couleur15 do begin dec(R); dec(V); dec(B) end;
  end;

  couleur0:=noir; FixeDAC(0,couleur0);

  SetStartAddr(160+decalage);
  inc(decalage,pas_decalage);
  if Abs(decalage)=30 then pas_decalage:=-pas_decalage;

  SetLineCompare(Round(300+100*Sin(2*Pi*i/220)));
 until {i=400}quitte;

(* Port[$21]:=$00; {autorise toutes les IRQ}
 Port[$A1]:=$00;*)

 SwapIntVec($09,ancint09,ancint09);

 InitTexte(25);
END.
