{$A+,G+,Q-,R-,S-}

USES Crt,Graph,VESA,Souris,SourisB,Util;

VAR i,n: BYTE;
    x,y: WORD;

CONST forme_curseur: BYTE=fleche;

BEGIN
 ClrScr;

 if not(VESAOk) then begin
  Writeln('Cette carte graphique ne supporte pas les modes vido VESA.');
  halt;
 end;

 Writeln(info_vesa.signature,' version ',
         CHAR(48+info_vesa.version.maj)+'.'+CHAR(48+info_vesa.version.min));
 Writeln('Fabricant: ',Fabricant);

 ReadKey;

 for n:=0 to 5 do begin
  InitVESA(VESA_800x600_16+n,'C:\BP7\BGI','VESA16');

  Randomize;
  for i:=1 to 200 do begin
   SetColor(Random(16));
   OutTextXY(Random(GetMaxX-50),Random(GetMaxY),'Salut!');
  end;
  for i:=1 to 20 do begin
   SetFillStyle(SOLIDFILL,(Random(16)));
   x:=Random(GetMaxX-100);
   y:=Random(GetMaxY-100);
   Bar(x,y,x+Random(100),y+Random(50));
  end;

  InitSouris;

  DefCursSouris(forme_curseur);
  AffCursSouris;

  {limite l'excursion du curseur  une zone o il sera toujours entirement visible}
  ZoneSouris(0,0,GetMaxX-7,GetMaxY-15);

  SetColor(LIGHTGRAY);
  Rectangle(10,10,GetMaxX div 2,GetMaxY div 2);

  repeat
   if SourisBouge then begin
    SetFillStyle(SOLIDFILL,BLACK);
    Bar(0,100,12*8,100+8);
    OutTextXY(0,100,'X='+EntierTexte(Xsouris,3)+' Y='+EntierTexte(Ysouris,3));
   end;
   SourisBouge:=FALSE;

   if BoutonSouris=gauche then begin
    case forme_curseur of
     fleche : forme_curseur:=sablier;
     sablier: forme_curseur:=fleche;
	end;
	DefCursSouris(forme_curseur);
	repeat until BoutonSouris=aucun;
   end;

   AnimeCursSouris;
  until BoutonSouris=droite;

  repeat until BoutonSouris=aucun;

  FinSouris;
 end;

 CloseGraph;
 TextMode(LastMode);
END.
