{$A+,G+,N+,Q-,R-,S-}

USES Crt,Graph256,BMP256,Util;

VAR image1,image2: BMP;
    erreur: word;


procedure Pause;
begin
 repeat until ReadKey=' ';
end;


procedure AfficheImage(image: BMP);
begin
 EffaceZone($A000,0,0,319,199,0);
 palette_noire.Fixe(0,256);
 image.Affiche($A000,0,0);
 image.palette.Fondu(0,256,32);
end;



procedure MiroirImage(image: BMP);
{inverse l'image verticalement - ne marche que si resY est paire !}
begin
 asm
  mov DX,image.ResX

  les DI,image.image
  mov SI,DI          {ES:SI -> image[1]}
  add DI,DX
  dec DI             {ES:DI -> image[ResX]}

  mov CX,DX
  shr CX,1           {CL=ResX/2}
  mov BH,image.ResY
  shr BH,1           {BH=ResY/2}

 @boucle:
   mov BL,CL
  @echange1:
   mov AL,ES:[SI]
   xchg ES:[DI],AL
   mov ES:[SI],AL    {change deux points}
   inc SI
   dec DI
   dec BL
   jnz @echange1

   dec SI
   inc DI
   add SI,DX
   add DI,DX

   mov BL,CL
  @echange2:
   mov AL,ES:[SI]
   xchg ES:[DI],AL
   mov ES:[SI],AL    {change deux points}
   dec SI
   inc DI
   dec BL
   jnz @echange2

   inc SI
   dec DI
   add SI,DX
   add DI,DX

  dec BH
  jnz @boucle
 end;
end; {MiroirImage}



procedure AfficheLigneZoom(var source,destination; long_source,long_dest: word); assembler;
asm
 push DS
 push BP

 lds SI,source
 les DI,destination
 mov AX,long_source
 mov CX,long_dest

 xor DH,DH
 mov DL,AH
 mov AH,AL
 xor AL,AL      {(DX,AX)=256*long_source}
 div CX
 shl DX,1       {DX=2*reste}
 cmp DX,CX      {2*reste>=long_dest ?}
 jnae @suite    {non}
 inc AX         {incrmente quotient (arrondit  l'entier suprieur)}
@suite:
 mov BP,AX      {BP=incrment (partie entire,partie dcimale)}
 xor DX,DX
 xor AX,AX      {(DX,AX)=cumul des incrments (17 bits ncessaires)}

@affiche:
 mov BH,DL
 mov BL,AH         {BX=partie haute du cumul (partie entre)=dcalage source}
 mov BL,DS:[SI+BX] {BL=couleur du point source  afficher}
 mov ES:[DI],BL    {affiche un point dans destination}
 inc DI
 add AX,BP
 adc DX,0       {(DX,AX)=(DX,AX)+BP}
 loop @affiche

 pop BP
 pop DS
end; {AfficheLigneZoom}



procedure Test1;
const x0=55;
var y: byte;
    f: word;
begin
 with image1 do begin
  f:=175;
  repeat
   for y:=20 to 199 do
    AfficheLigneZoom(image^[1+x0+y*ResX],Ptr($A000,x0+y*320)^,175,f);
   LigneVerticale($A000,f-1+x0,20,199,0);
   dec(f);
  until f<5;
  repeat
   for y:=20 to 199 do
    AfficheLigneZoom(image^[1+x0+y*ResX],Ptr($A000,x0+y*320)^,175,f);
   inc(f);
  until f>175;
 end;
end; {Test1}



procedure Test2;
const x0=55;
var x,f: word;
    y: byte;
begin
 with image1 do begin
  x:=x0;
  f:=175;
  repeat
   for y:=20 to 199 do
    AfficheLigneZoom(image^[1+x0+y*ResX],Ptr($A000,((x+x0) div 2)+y*320)^,175,f);
   inc(x);
   dec(f);
  until f<5;
 end;
end; {Test2}



procedure Test3;
const x0=55;
var y: byte;
    f: word;
begin
 with image1 do begin
  f:=210;
  repeat
   for y:=20 to 199 do
    AfficheLigneZoom(image^[1+x0+y*ResX],
                     Ptr($A000,((x0+Round(20*Sin(2*Pi*(y+f)/80))) div 2)+y*320)^,
                     210,f);
   dec(f,3);
  until f<20;
  repeat
   for y:=20 to 199 do
    AfficheLigneZoom(image^[1+x0+y*ResX],
                     Ptr($A000,((x0+Round(y/8*Sin(2*Pi*(y+2*f)/80))) div 2)+y*320)^,
                     210,f);
   inc(f,3);
  until f>210;
 end;
end; {Test3}



procedure Test4;
const x0=55;
var f: word;
    y: byte;
begin
 with image1 do begin
  f:=175;
  repeat
   for y:=20 to 199 do
    AfficheLigneZoom(image^[1+x0+y*ResX],Ptr($A000,x0+y*320)^,175,f);
   inc(f);
  until f>265;
 end;
end; {Test4}



procedure Test5;
const x0=55;
var y,i: byte;
    K: integer;
begin
 with image1 do begin
  i:=0;
  repeat
   for y:=20 to 199 do
    begin
     K:=Round(20*Sin(2*Pi*(y+i)/150));
     AfficheLigneZoom(image^[1+x0+y*ResX],Ptr($A000,x0-K+y*320)^,175,175+2*K)
    end;
   inc(i,5);
  until i>145;
 end;
end; {Test5}



procedure Test6;
var x,f: word;
    y: byte;
begin
 with image2 do begin
  x:=0;
  f:=ResX;
  repeat
   for y:=0 to ResY-1 do
    AfficheLigneZoom(image^[1+y*ResX],Ptr($A000,(x div 2)+y*320)^,ResX,f);
   LigneVerticale($A000,(ResX+f) div 2,0,ResY-1,0);
   inc(x,2);
   dec(f,2);
  until f<5;
  MiroirImage(image2);
  repeat
   for y:=0 to ResY-1 do
    AfficheLigneZoom(image^[1+y*ResX],Ptr($A000,(x div 2)+y*320)^,ResX,f);
   dec(x,2);
   inc(f,2);
  until f>ResX;
 end;
end; {Test6}



procedure Test7;
var x0,f: word;
    y0,y,i: byte;
    cosinus,sinus: array[byte] of word;
begin
 with image2 do begin
  for i:=0 to ResX-4 do cosinus[i]:=Round(ResX*Cos(Pi/2*i/ResX));
  for i:=0 to ResX-4 do sinus[i]:=Round(10*Sin(Pi/2*i/ResX));
  x0:=320-ResX;
  i:=0;
  repeat
   f:=cosinus[i];
   y0:=10-sinus[i];
   for y:=0 to ResY-1 do
    AfficheLigneZoom(image^[1+y*ResX],Ptr($A000,x0+(y+y0)*320)^,ResX,f);
   EffaceZone($A000,x0+f-1,0,319,ResY-1,0);
   EffaceZone($A000,x0,ResY+y0,319,199,0);
   inc(i,2);
  until i>ResX-4;
  MiroirImage(image2);
  repeat
   dec(i,2);
   f:=cosinus[i];
   y0:=10-sinus[i];
   for y:=0 to ResY-1 do
    AfficheLigneZoom(image^[1+y*ResX],Ptr($A000,(320-x0)-f+(y+y0)*320)^,ResX,f);
  until i<1;
  repeat
   f:=cosinus[i];
   y0:=10+sinus[i];
   for y:=0 to ResY-1 do
    AfficheLigneZoom(image^[1+y*ResX],Ptr($A000,(320-x0)-f+(y+y0)*320)^,ResX,f);
   EffaceZone($A000,0,0,(320-x0)-f,ResY-1,0);
   inc(i,2);
  until i>ResX-4;
  MiroirImage(image2);
  repeat
   dec(i,2);
   f:=cosinus[i];
   y0:=10+sinus[i];
   for y:=0 to ResY-1 do
    AfficheLigneZoom(image^[1+y*ResX],Ptr($A000,x0+(y+y0)*320)^,ResX,f);
   EffaceZone($A000,x0,ResY+y0,319,199,0);
  until i<1;
 end;
end; {Test7}




BEGIN
{ sq4.bmp -> (55,20,230,199) }
 image1.Charge('C:\Projets\tests\sq4.bmp',erreur);
 if erreur<>0 then WriteLn('Erreur BMP: ',erreur);
 image2.Charge('C:\Projets\tests\sq4_.bmp',erreur);
 if erreur<>0 then begin WriteLn('Erreur BMP: ',erreur); halt end;

 Init320x200;

 AfficheImage(image1);
 repeat Test1 until KeyPressed;
 Pause;
 AfficheImage(image1);
 repeat Test2 until KeyPressed;
 Pause;
 AfficheImage(image1);
 repeat Test3 until KeyPressed;
 Pause;
 AfficheImage(image1);
 repeat Test4 until KeyPressed;
 Pause;
 AfficheImage(image1);
 repeat Test5 until KeyPressed;
 Pause;
 AfficheImage(image2);
 repeat Test6 until KeyPressed;
 Pause;
 MiroirImage(image2);
 AfficheImage(image2);
 EffaceZone($A000,0,0,319,199,0);
 repeat Test7 until KeyPressed;
 Pause;

 image1.Supprime;
 image2.Supprime;

 TextMode(LastMode);
END.
