{$A+,G+,Q-,R-,S-}

USES Crt,Fichiers,Util;

CONST CRLF=#13#10;

      un_kilo=1024;
      un_mega=un_kilo*un_kilo;

      taille_tampon=32*un_kilo;
      nbr_tampons=un_mega div taille_tampon;

      num: word=0;

VAR touche: char;
    f: Fichier;
    nf: String80;
    tampon: array[1..taille_tampon] of char;
    t,c: word;


function MemCmp(var tampon; motif: char): boolean; assembler;
asm
 mov AL,motif
 mov AH,AL

 les DI,tampon
 mov CX,taille_tampon
 shr CX,1

@boucle:
 cmp ES:[DI],AX
 jne @erreur
 add DI,2
 dec CX
 jnz @boucle

 mov AL,TRUE
 jmp @fin

@erreur:
 mov AL,FALSE

@fin:
end; {MemCmp}


procedure AffErreur;
begin
 Write('ERREUR: ');

 case f_erreur of
  f_err_fich_intr : Write('fichier introuvable');
  f_err_ch_intr   : Write('chemin introuvable');
  f_err_trop_fich : Write('trop de fichiers ouverts');
  f_err_acces_ref : Write('accs au fichier refus');
  f_err_handle    : Write('handle de fichier incorrect');
  f_err_lecteur   : Write('lecteur incorrect');
  f_err_plus_fich : Write('plus de handle de fichier disponible');
  f_err_existe    : Write('fichier existe dj');
  f_err_protect   : Write('disque protg en criture');
  f_err_pas_pret  : Write('lecteur pas prt');
  f_err_disq_plein: Write('disque plein');
  f_err_CRC       : Write('CRC incorrect');
  f_err_donnees   : Write('donnes errones');
  f_err_media     : Write('media inconnu');
  f_err_secteur   : Write('secteur introuvable');
  f_err_ecriture  : Write('impossible d''crire');
  f_err_lecture   : Write('impossible de lire');
  f_err_disq_inut : Write('disque inutilisable');
 end;
end; {AffErreur}


BEGIN
 ClrScr;
 Writeln('ATTENTION !',CRLF,
         'TEST_HD va crire sur ce disque des fichiers de 1 Mo, jusqu'' ce qu''il soit',CRLF,
         'plein, afin d''valuer la capacit rellement accessible au systme.',CRLF,
         'Il est recommand d''effectuer ce test sur un disque dur vide (ou presque).',CRLF,
         'NE PAS EXECUTER CE PROGRAMME DEPUIS LA RACINE ! (limitation  512 entres)');
 Write('CONTINUER (Oui/Non) ?');
 repeat
  touche:=UpCase(ReadKey);
 until touche in ['O','N'];
 if touche='N' then begin
  Writeln('Abandon.');
  halt;
 end;

 while TRUE do with f do begin
  inc(num);
  FillChar(tampon,sizeof(tampon),CHAR(num));

  nf:=EntierTexte2(num,4+et_zeros)+'.THD';
  Write(CRLF,nf,':');

  Cree(ecrase,nf);
  if f_erreur<>f_ok then begin
   AffErreur;
  end;

  Write(' Ecriture...');
  for t:=1 to nbr_tampons do begin
   Ecrit(tampon,sizeof(tampon));
   if f_erreur<>f_ok then begin
    AffErreur;
    case ReadKey of
     #13: continue;
     ' ': break;
     #27: exit;
    end;
   end;
  end;
  Ferme;

  Write(' Vrification...');
  Ouvre(lecture,nf);
  for t:=1 to nbr_tampons do begin
   Lit(tampon,sizeof(tampon));
   if f_erreur=f_ok then begin
    if not(MemCmp(tampon,CHAR(num))) then begin
     Write('ERREUR: incohrence des donnes');
     case ReadKey of
      #13: continue;
      ' ': break;
      #27: exit;
     end;
    end;
   end
   else begin
    AffErreur;
    case ReadKey of
     #13: continue;
     ' ': break;
     #27: exit;
    end;
   end;
  end;
  Ferme;
 end;

 Writeln(CRLF,'Fin de TEST_HD.');
END.