{$A+,G+,Q-,R-,S-}

USES Fichiers,Clavier,Texte,Util,UtilT,MemLin;

{$M 20480,0,8000}

CONST max_lignes=9000;  {nombre maximal de lignes}

      separateurs=[' '..'/',':'..'?','@','['..']','^','{'..'}'];

      CtrlZ=26;
      CtrlW=23;

VAR quitte: boolean;
    touche: Key;

    taille_fichier: longint;  {taille du fichier (modifie en cours d'dition)}
    lignes_fichier: word;     {nombre de lignes du fichier ( " )}
    lig_haut      : word;     {n ligne en haut de l'cran}
    col_gauche    : word;     {n colonne  gauche de l'cran}
    lig,col       : word;     {coordonnes du curseur dans le fichier}

    Ligne: array[1..max_lignes] of
            record adr: longint; long: word end;  {adresse dbut et longueur d'une ligne}



procedure ChargeFichier;
var f: Fichier;
    nom_fichier: String80;
    taille_a_lire,i: word;
    taille_lue,adr,adr_debut_ligne,taille_calculee: longint;
    tampon: array[1..16384] of char;
begin
 InitRepert;
 nom_fichier:=SelectionneFichier('Charge un fichier','*',hauteur_ecran_txt-11);

 if nom_fichier='' then halt;

 with f do begin
  Ouvre(lecture,nom_fichier);
  if f_erreur<>f_ok then
   begin WriteLn('Erreur ',f_erreur); halt end;

  taille_fichier:=Taille;

  WriteLn('Mmoire DOS libre: ',MemDOSLibre,' octets  (',NbrPagesDisp,' pages)');
  WriteLn(nom_fichier,' : ',taille_fichier,' octets  (',
          NbrPagesNec(taille_fichier),' pages estimes)');
  if NbrPagesNec(taille_fichier)>NbrPagesDisp then
   begin WriteLn('Fichier trop grand !'); halt(1) end;

  Write('Lecture...');

  taille_lue:=0;
  taille_a_lire:=sizeof(tampon);

  lignes_fichier:=0; adr_debut_ligne:=0;

  repeat
   if taille_lue+taille_a_lire>taille_fichier then taille_a_lire:=taille_fichier-taille_lue;
   Lit(tampon,taille_a_lire);
   EcritBloc(taille_lue,taille_a_lire,tampon);

   i:=1;
   repeat
    while (i<=taille_a_lire) and (tampon[i]<>#13) do inc(i);
    if (i<=taille_a_lire) or (taille_lue+i=taille_fichier+1) then begin
     inc(lignes_fichier);
     with Ligne[lignes_fichier] do begin
      adr:=adr_debut_ligne;
      long:=taille_lue+i-1-adr_debut_ligne;
     end;
     adr_debut_ligne:=taille_lue+i+1;
    end;
    inc(i);
   until i>taille_a_lire;

   inc(taille_lue,taille_a_lire);
  until taille_lue=taille_fichier;

  Ferme;
 end;

 WriteLn;
 Write(lignes_fichier,' lignes, vrification: ');
 taille_calculee:=0;
 for i:=1 to lignes_fichier do inc(taille_calculee,Ligne[i].long+2);
 Write(taille_calculee,' octets');

 WriteLn;
 Write('Mmoire DOS libre: ',MemDOSLibre,' octets  (',NbrPagesDisp,' pages)');
 repeat until ReadKey=Space;
end;


procedure AffichePage;
var i: byte;
    chaine: String80;
begin
 if col<col_gauche then col_gauche:=col;
 if col>col_gauche+79 then col_gauche:=col-79;

 for i:=1 to MaxEntier(25,MinEntier(25,lignes_fichier)) do
  with Ligne[lig_haut+i-1] do begin
   chaine:=RepeteCar(' ',80);
   if col_gauche<=long then
    LitBloc(adr+col_gauche-1,MinEntier(80,long-col_gauche+1),chaine[1]);
   AffChXY(0,1,i,chaine,7);
  end;
end;


procedure DeplaceHaut;
begin
 if lig>1 then begin
  dec(lig);
  if lig<lig_haut then dec(lig_haut);
 end;
end;


procedure DeplaceBas;
begin
 if lig<lignes_fichier then begin
  inc(lig);
  if lig>lig_haut+25-1 then inc(lig_haut);
 end;
end;


procedure MotPrecedent;
var car_gauche,car_droite: char;
    ok: boolean;
    p: word;
begin
 p:=MinEntier(col,Ligne[lig].long+1);
 ok:=FALSE;
 if p>2 then begin
  dec(p);
  car_droite:=Chr(LitOctet(Ligne[lig].adr+p-1));
  repeat
   dec(p);
   car_gauche:=Chr(LitOctet(Ligne[lig].adr+p-1));
   ok:=(car_gauche in separateurs) and not(car_droite in separateurs);
   car_droite:=car_gauche;
  until ok or (p=1);
 end;
 if ok then col:=p+1
 else
  if not(Chr(LitOctet(Ligne[lig].adr)) in separateurs) and (col>1) then col:=1
  else begin DeplaceHaut; col:=Ligne[lig].long+1 end;
end;


procedure MotSuivant;
var car_gauche,car_droite: char;
    ok: boolean;
    p: word;
begin
 p:=MinEntier(col,Ligne[lig].long+1);
 ok:=FALSE;
 if p+1<Ligne[lig].long then begin
  inc(p);
  car_gauche:=Chr(LitOctet(Ligne[lig].adr+p-1));
  repeat
   inc(p);
   car_droite:=Chr(LitOctet(Ligne[lig].adr+p-1));
   ok:=(car_gauche in separateurs) and not(car_droite in separateurs);
   car_gauche:=car_droite;
  until ok or (p=Ligne[lig].long);
 end;
 if ok then col:=p
 else
  if col<>Ligne[lig].long+1 then col:=Ligne[lig].long+1
  else begin
   DeplaceBas; col:=1;
   while (Chr(LitOctet(Ligne[lig].adr+col-1)) in separateurs) and (col<Ligne[lig].long) do inc(col);
  end;
end;



BEGIN
 InitTexte(25);

 ChargeFichier;

 VitesseClavier(0,0);

 quitte:=FALSE;
 lig_haut:=1; col_gauche:=1;
 lig:=1; col:=1;
 repeat
  AffichePage;
  CursXY(0,col-col_gauche+1,lig-lig_haut+1);
  Curseur(plat);
  touche:=ReadKey;
  case touche of
   Left : if col>1 then dec(col);
   Right: inc(col);
   Up   : DeplaceHaut;
   Down : DeplaceBas;
   Home : col:=1;
   End_ : col:=Ligne[lig].long+1;
   PgUp : if lig_haut>25 then
           begin dec(lig_haut,25); dec(lig,25) end
          else begin lig_haut:=1; lig:=1 end;
   PgDn : if lignes_fichier>25 then begin
           inc(lig_haut,25); inc(lig,25);
           if lig>lignes_fichier then lig:=lignes_fichier;
           if lig_haut>lignes_fichier-25+1 then lig_haut:=lignes_fichier-25+1;
          end
          else lig:=lignes_fichier;
   CtrlLeft : MotPrecedent;
   CtrlRight: MotSuivant;
   CtrlHome : lig:=lig_haut;
   CtrlEnd  : if lignes_fichier>=25 then lig:=lig_haut+25-1 else lig:=lignes_fichier;
   CtrlPgUp : begin col:=1; lig:=1; lig_haut:=1 end;
   CtrlPgDn : begin
               lig:=lignes_fichier;
               if lignes_fichier>25 then lig_haut:=lignes_fichier-25+1;
               col:=Ligne[lig].long+1;
               if col>80 then col_gauche:=col-79 else col_gauche:=1;
              end;
   CtrlW: begin
           if lig_haut>1 then dec(lig_haut);
           if lig>lig_haut+25-1 then dec(lig);
          end;
   CtrlZ: if lignes_fichier>25 then
           if lig_haut<lignes_fichier-25+1 then
            begin inc(lig_haut); if lig<lig_haut then inc(lig) end;
   Esc: quitte:=TRUE;
  end;
 until quitte;

 VitesseClavier(1,3);

 InitTexte(25);
END.
