{ͻ}
{                      --== HARDWARE.PAS ==--                      }
{                                                                      }
{ Unit pour la gestion matrielle (LPT).                              }
{                                                                      }
{ AUTEUR: Freddy Vtel.                                               }
{Ķ}
{ Compatibilit: 286           Dbut d'criture 05/11/95 }
{                              Dernires modifications 26/07/98 }
{ͼ}

UNIT Hardware;

{$A+,G+,Q-,R-,S-}

INTERFACE

USES VarUnit,Util,BiosEqu;

CONST Hardware_Init:BOOLEAN=FALSE;

      Port_LPT:array[1..4] of WORD=(0,0,0,0);
      Port_COM:array[1..4] of WORD=(0,0,0,0);

procedure Detecte_Hardware(affiche: BOOLEAN);


IMPLEMENTATION


procedure Detecte_COM(affiche: BOOLEAN);
var COM_detecte:BOOLEAN;
    i:BYTE;
begin
 COM_Detecte:=FALSE;
 for i:=1 to 4 do begin
   Port_COM[i]:=BiosSeg.ComBase[i];
   if (Port_COM[i]<>0) then begin
     COM_Present[i]:=TRUE;
     COM_Detecte:=TRUE;
   end;
 end;

 if affiche and COM_Detecte then begin
   Write('Serial port(s): ');
   for i:=1 to 4 do
    if COM_Present[i] then Write('COM',i,' at ',EntierHexa(Port_COM[i],4)+'h. ');
   Writeln;
 end;
end;


procedure Detecte_LPT(affiche: BOOLEAN);
var LPT_detecte:BOOLEAN;
    i:BYTE;
begin
 LPT_Detecte:=FALSE;
 for i:=1 to 4 do begin
   Port_LPT[i]:=BiosSeg.LptBase[i];
   if (Port_LPT[i]<>0) then begin
     LPT_Present[i]:=TRUE;
     LPT_Detecte:=TRUE;
   end;
 end;

 if affiche and LPT_Detecte then begin
   Write('Parallel port(s): ');
   for i:=1 to 4 do
    if LPT_Present[i] then Write('LPT',i,' at ',EntierHexa(Port_LPT[i],4)+'h. ');
   Writeln;
 end;
end;

procedure Detecte_Hardware(affiche: BOOLEAN);
begin
 if not Hardware_Init then begin
   Hardware_Init:=TRUE;
   Detecte_COM(affiche);
   Detecte_LPT(affiche);
 end;
end; {Detecte_Hardware}

END.
