{************************************************************************}
{                               VARUNIT.PAS                              }
{                                                                        }
{  Ensemble de variables, constantes, et types 'd'utilits publique'     }
{                                                                        }
{                                                                        }
{  AUTEUR: Freddy Vtel.                                                }
{                                                                        }
{                                                                        }
{                               Dbut d'criture le 22/08/95             }
{                               Dernires modifications le 26/07/98      }
{************************************************************************}
UNIT VarUnit;


INTERFACE

CONST
   { 'Constantes' initialises par DSSUnit }
   DSS_Presente   : BOOLEAN = FALSE;   { Prsence de la Disney Sound Source }

   { 'Constantes' initialises par SBUnit }
   Mixer_SBPro_Present: BOOLEAN=FALSE; { Mixer Sound Blaster Pro ?       }
   Mixer_SGPro_Present: BOOLEAN=FALSE; { Mixer Sound Galaxy NX Pro ?     }
   Mixer_SB16_Present : BOOLEAN=FALSE; { Mixer Sound Blaster 16 ?        }

   OPL2_Presente  : BOOLEAN = FALSE;   { Prsence de la puce OPL2           }
   Sb_Presente    : BOOLEAN = FALSE;   { Prsence de la Sound Blaster       }
   SbPro_Presente : BOOLEAN = FALSE;   { Prsence de la Sound Blaster Pro   }
   SGPro_Presente : BOOLEAN = FALSE;   { Prsence de la Sound Galaxy NX Pro }
   Sb16_Presente  : BOOLEAN = FALSE;   { Prsence de la Sound Blaster 16    }

   { 'Constantes' initialises par GUSUnit }
   GUS_Presente   : BOOLEAN = FALSE;   { Prsence de la Gravis Ultrasound   }

   { 'Constantes' initialises par Memoire }
   EMS_Presente : BOOLEAN = FALSE;
   UMB_Presente : BOOLEAN = FALSE;

   { 'Constantes' initialises par Hardware }
   LPT_Present : array[1..4] of BOOLEAN = (FALSE,FALSE,FALSE,FALSE);
   COM_Present : array[1..4] of BOOLEAN = (FALSE,FALSE,FALSE,FALSE);


TYPE T_OPL2Instr=record            { Instrument OPL2 (Adlib) }
                  AM1,AP1  : BYTE;
                  AM2,AP2  : BYTE;
                  AM3,AP3  : BYTE;
                  AM4,AP4  : BYTE;
                  AM5,AP5  : BYTE;
                  AFeedBack: BYTE;
                 end;

     T_BlocMem = record
                  Segment     : WORD;
                  Handle_EMS  : WORD;  { = $FFFF, si pas en EMS }
                  Nb_Pages_EMS: BYTE;
                 end;

IMPLEMENTATION

{==========================================================}

END.
