{************************************************************************}
{								MM_INIT.PAS								 }
{																		 }
{  Initialisation de Mod Master (mmoire, sortie sonore, ...)			 }
{																		 }
{  AUTEURS: Freddy Vtel et Fabrice Couteau.							 }
{																		 }
{								Dbut d'criture le 27/03/95             }
{								Dernires modifications le 26/07/98		 }
{************************************************************************}

UNIT MM_Init;

{$A+,G+,Q-,R-,S-}

INTERFACE

IMPLEMENTATION

USES Memoire,SBUnit,GUSUnit,Util,Souris;

CONST MemoireMinimale=56000;

(*
function IPlay: BOOLEAN; assembler;
{renvoie TRUE si Inertia Player est actif (shell...)}
asm
 mov AX,60FFh
 xor DL,DL
 mov BX,5344h	{ SD }
 mov CX,4D50h	{ MP }
 int 2Fh		{ Multiplex }
 cmp AX,4F4Bh	{ OK }
 mov AL,TRUE
 je @fin
 mov AL,FALSE
@fin:
end; {IPlay}
*)

(*
function Modm: BOOLEAN; assembler;
{renvoie TRUE si Mod Master est actif (shell...)}
asm
 mov AX,60FFh
 mov DL,2
 mov BX,5344h	{ SD }
 mov CX,4D50h	{ MP }
 int 2Fh		{ Multiplex }
 cmp AX,1234h
 mov AL,TRUE
 je @fin
 mov AL,FALSE
@fin:
end; {Modm}
*)


CONST CPU_Name: array[_386..PentPro] of STRING[11]=('386','486','Pentium','Pentium Pro');

VAR CPU: BYTE;

begin
{ if Win3X then begin
   WriteLn('This program doesn''t require Microsoft Windows.'); Pause(18); halt(1)
 end;}

{ if IPLay then begin
   WriteLn('Inertia Player is under DOS shell! Stop it and use Mod Master instead ;)'); halt(1)
 end;}

{ if Modm then begin
   WriteLn('Mod Master is already running'); halt(1)
  end;}

 if MaxAvail<MemoireMinimale then begin
   WriteLn('Not enough memory to run Mod Master.'); halt(1)
 end;

 CPU:=Processeur;
 if CPU<_386 then begin
   WriteLn('Mod Master requires a 386 or better CPU.'); halt(1)
 end;

 if not(CarteVGA) then begin
   WriteLn('Mod Master requires a color VGA card.'); halt(1)
 end;

 {*******}

 Writeln(#13#10+'Initializing Mod Master v2.3 ...'+#13#10);

 if CPU in [_386..PentPro] then Write(CPU_Name[CPU]) else Write('unknown');
 Write(' CPU');
 if (CPU<Pentium) and Coprocesseur then Write(' with math-coprocessor');
	{ partir du Pentium, il y a toujours un coprocesseur !!}
 Writeln(' found.');

 if InitSouris then Writeln('Mouse driver initialized.');

 if LettreCDRom<>#0 then Writeln('CD-Rom driver detected.');

END.
