.MODEL SMALL,PASCAL
.386

.CODE

INCLUDE Loupe96.inc
               
Tampon DB diametre*diametre DUP (0)       ; tampon pour le calcul de la loupe
; diametre doit tre multiple de 4 !!!

;PROCEDURE AfficheLoupe(segment,x: Word; y: Byte);

PUBLIC AfficheLoupe
AfficheLoupe PROC NEAR segment: WORD, x: WORD, y: BYTE

   PUSH DS BP                   ; sauvegarde registres vitaux de TP
   CLD

   PUSH CS
   POP ES
   LEA DI,Tampon                ; ES:DI -> Tampon

   XOR AL,AL
   MOV AH,y
   MOV SI,AX
   SHR AX,2
   ADD SI,AX
   ADD SI,x                     ; SI=x+320*y

   MOV DX,320
   SUB DX,diametre              ; incrment SI et DI: DX=320-diametre

   MOV DS,segment

   LEA BP,Loupe                 ; CS:BP -> Loupe

   PUSH DS SI                   ; sauvegarde segment:x+320*y

   MOV CH,diametre/4
boucle_y:
   REPT 4
    Local boucle_x
    MOV CL,diametre/4
   boucle_x:
     REPT 4
      MOV BX,CS:[BP]            ; BX=dcalage relatif point cran<->point loupe
      MOV AL,DS:[SI+BX]         ; AL=couleur du point  projeter
      INC SI
      STOSB                     ; stocke le point projet dans le tampon
      INC BP
      INC BP                    ; incrmente l'offset de la loupe
     ENDM
     DEC CL
     JNZ boucle_x
    ADD SI,DX                   ; ligne suivante
   ENDM
   DEC CH
   JNZ boucle_y

   POP DI ES                    ; ES:DI -> segment:x+320*y

   PUSH CS
   POP DS
   LEA SI,Tampon                ; DS:SI -> Tampon

   MOV BL,diametre/4
   XOR CH,CH
aff_tampon:
   REPT 4
    MOV CL,diametre/4           ; CX=diametre/4
    REP MOVSD
    ADD DI,DX                   ; ligne suivante
   ENDM
   DEC BL
   JNZ aff_tampon               ; affiche le tampon  l'cran

   POP BP DS                    ; rcupre registres vitaux
   RET

AfficheLoupe ENDP

END
