{$A+,G+,Q-,R-,S-}

USES Crt,Graph256,Fich_Grp,FNT16_g;

CONST fichier_fontes='C:\Fontes\gr\fontes.dat';

      message='                appuyez sur une touche pour arreter cette mini-demo          ';
      pas_scrolling=2;

      nbr_remarques=5;
      remarques: array[1..nbr_remarques] of string[11]
                  =('ALORS?','RAPIDE,NON?','ARF ARF!',
                    '...','');

      nbr_rem_aff=8;
      rem_aff: array[1..nbr_rem_aff] of string[15]
                =('AFFICHAGE','AFFICHAGE','100% ASSEMBLEUR','',
                  '100% ASSEMBLEUR','','100% ASSEMBLEUR','');

      nbr_rem_fin=7;
      rem_fin: array[1..nbr_rem_fin] of string[22]
                =('BON, MAINTENANT','IL FAUDRAIT PEUT-ETRE','PENSER A APPUYER',
                  'SUR UNE TOUCHE','POUR METTRE FIN','A TOUT CA...','');

      vitesse_demo=3;
      vitesse_16coul=5;
      vitesse_message=1;
      delai_remarques=1500;
      vitesse_remarques=400;
      delai_rem_aff=4000;
      vitesse_rem_aff=150;
      delai_rem_fin=6000;
      vitesse_rem_fin=300;
      delai_c_fini=8500;


VAR demo,_16coul,mini,chiffres,script,digits,rapide,aff100,gris,cfini: FNT;
    erreur,nbr: word;
    nbr_str: string[5];
    i,y,index: byte;
    couleur: RVB;
    sens_y,sens: shortint;
    vitesse_y,num_remarque,num_rem_aff,num_rem_fin: byte;


procedure affchcentre(fonte: FNT; y: byte; chaine: string; fond: boolean; couleur_fond: byte);
begin
 if fond then effacezone($A000,0,y,319,y+fonte.hauteur,couleur_fond);
 fonte.affchxy($A000,160-((length(chaine)*(fonte.largeur+1)) shr 1),y,chaine,fond,couleur_fond);
end;


BEGIN
 definitfichiergroupe(fichier_fontes);
 if f_erreur<>f_ok then begin writeln(fichier_fontes,': erreur ',f_erreur); halt end;

 demo.charge('demo.fnt',erreur);
 _16coul.charge('16coul.fnt',erreur);
 mini.charge('mini.fnt',erreur);
 chiffres.charge('chiffres.fnt',erreur);
 script.charge('script.fnt',erreur);
 digits.charge('digits.fnt',erreur);
 rapide.charge('rapide.fnt',erreur);
 aff100.charge('aff100.fnt',erreur);
 gris.charge('gris.fnt',erreur);
 cfini.charge('cfini.fnt',erreur);

 if erreur<>0 then begin writeln('Erreur FNT: ',erreur); halt end;

 init320x200;
 randomize;

 demo.fixepalette;
 mini.fixepalette;
 chiffres.fixepalette;
 script.fixepalette;
 aff100.fixepalette;

 for i:=0 to 44 do lignehorizontale($A000,i,0,319,17+(i div 3));

 affchcentre(demo,0,'DEMO FONTES',false,0);
 affchcentre(_16coul,20,'16 COULEURS',false,0);
 affchcentre(mini,50,'(c) Fab 1995',false,0);

 nbr:=0; index:=1; sens:=+1;
 y:=90; sens_y:=-1;
 num_remarque:=1; num_rem_fin:=1; num_rem_aff:=1;

 repeat
  vitesse_y:=3+Trunc(sin(nbr));

  if (nbr mod vitesse_16coul)=0 then begin
   with _16coul do begin
    couleur:=palette[15];
    move(palette[0],palette[1],3*15);
    palette[0]:=couleur;
   end;
   _16coul.fixepalette;
  end;

  if (nbr mod vitesse_demo)=0 then
  case random(7) of
   0: for i:=0 to 5 do begin
       chargedac(demo.premiere_couleur+i,couleur);
       with couleur do begin
        if (R=63) and (sens=+1) then sens:=-1;
        if (R= 0) and (sens=-1) then sens:=+1;
        inc(R,sens);
       end;
       fixedac(demo.premiere_couleur+i,couleur);
      end;
   1: for i:=0 to 5 do begin
       chargedac(demo.premiere_couleur+i,couleur);
       with couleur do begin
        if (V=63) and (sens=+1) then sens:=-1;
        if (V= 0) and (sens=-1) then sens:=+1;
        inc(V,sens);
       end;
       fixedac(demo.premiere_couleur+i,couleur);
      end;
   2: for i:=0 to 5 do begin
       chargedac(demo.premiere_couleur+i,couleur);
       with couleur do begin
        if (B=63) and (sens=+1) then sens:=-1;
        if (B= 0) and (sens=-1) then sens:=+1;
        inc(B,sens);
       end;
       fixedac(demo.premiere_couleur+i,couleur);
      end;
   3: for i:=0 to 5 do begin
       chargedac(demo.premiere_couleur+i,couleur);
       with couleur do begin
        if (R=63) and (sens=+1) then sens:=-1;
        if (R= 0) and (sens=-1) then sens:=+1;
        if (V=63) and (sens=+1) then sens:=-1;
        if (V= 0) and (sens=-1) then sens:=+1;
        inc(R,sens);
        inc(V,sens);
       end;
       fixedac(demo.premiere_couleur+i,couleur);
      end;
   4: for i:=0 to 5 do begin
       chargedac(demo.premiere_couleur+i,couleur);
       with couleur do begin
        if (R=63) and (sens=+1) then sens:=-1;
        if (R= 0) and (sens=-1) then sens:=+1;
        if (B=63) and (sens=+1) then sens:=-1;
        if (B= 0) and (sens=-1) then sens:=+1;
        inc(R,sens);
        inc(B,sens);
       end;
       fixedac(demo.premiere_couleur+i,couleur);
      end;
   5: for i:=0 to 5 do begin
       chargedac(demo.premiere_couleur+i,couleur);
       with couleur do begin
        if (V=63) and (sens=+1) then sens:=-1;
        if (V= 0) and (sens=-1) then sens:=+1;
        if (B=63) and (sens=+1) then sens:=-1;
        if (B= 0) and (sens=-1) then sens:=+1;
        inc(V,sens);
        inc(B,sens);
       end;
       fixedac(demo.premiere_couleur+i,couleur);
      end;
   6: for i:=0 to 5 do begin
       chargedac(demo.premiere_couleur+i,couleur);
       with couleur do begin
        if (R=63) and (sens=+1) then sens:=-1;
        if (R= 0) and (sens=-1) then sens:=+1;
        if (V=63) and (sens=+1) then sens:=-1;
        if (V= 0) and (sens=-1) then sens:=+1;
        if (B=63) and (sens=+1) then sens:=-1;
        if (B= 0) and (sens=-1) then sens:=+1;
        inc(R,sens);
        inc(R,sens);
        inc(B,sens);
       end;
       fixedac(demo.premiere_couleur+i,couleur);
      end
  end;

  if (nbr mod (vitesse_message*(script.largeur+1) div pas_scrolling))=0 then begin
   script.affchxy($A000,0,178,Copy(message,index,16),true,0);
   inc(index);
   if index>Length(message) then index:=1;
  end;

  if (nbr mod vitesse_message)=0 then
   scrollezonegauche($A000,0,178,319,199,0,pas_scrolling);

  str(nbr:5,nbr_str);
  digits.affchxy($A000,0,y,nbr_str,true,0);
  str(nbr shr 1:5,nbr_str);
  chiffres.affchxy($A000,250,160-y,nbr_str,true,0);
  lignehorizontale($A000,y-1,0,+5*(1+digits.largeur),0);
  lignehorizontale($A000,y+digits.hauteur,0,0+5*(1+digits.largeur),0);
  lignehorizontale($A000,160-y-1,250,250+5*(1+chiffres.largeur),0);
  lignehorizontale($A000,160-y+chiffres.hauteur,250,250+5*(1+chiffres.largeur),0);
  inc(nbr);
  case sens of
   -1: if y=50 then sens:=+1
       else if (nbr mod vitesse_y)=0 then dec(y);
   +1: if y=110 then sens:=-1
       else if (nbr mod vitesse_y)=0 then inc(y);
  end;

  if (nbr=delai_remarques+num_remarque*vitesse_remarques) and (num_remarque<=nbr_remarques) then begin
   affchcentre(rapide,140,remarques[num_remarque],true,0);
   inc(num_remarque);
  end;

  if (nbr=delai_rem_aff+num_rem_aff*vitesse_rem_aff) and (num_rem_aff<=nbr_rem_aff) then begin
   affchcentre(aff100,140,rem_aff[num_rem_aff],true,0);
   inc(num_rem_aff);
  end;

  if (nbr=delai_rem_fin+num_rem_fin*vitesse_rem_fin) and (num_rem_fin<=nbr_rem_fin) then begin
   affchcentre(gris,140,rem_fin[num_rem_fin],true,0);
   inc(num_rem_fin);
  end;

  if nbr=delai_c_fini then begin
   affchcentre(cfini, 75,'C''est',false,0);
   affchcentre(cfini,105,'fini,',false,0);
   affchcentre(cfini,135,'y''a plus rien',false,0);
   affchcentre(cfini,160,'a voir...',false,0);
  end;
 until keypressed;

 for i:=1 to 160 do begin
  ligneverticale($A000,2*(i-1),0,199,0);
  ligneverticale($A000,319-2*(i-1),0,199,0);
  delay(5);
 end;

 affchcentre(script,80,'salut',false,0);
 delay(800);
 fermefichiergroupe;
 textmode(lastmode);
END.