{$A+,G+,Q-,R-,S-}

USES Util,Texte;

VAR  param: string[80];
     ext  : string[1+3];

     erreur: word;
     z: Zone;
     p: Palette16;

BEGIN
  if (ParamCount<1) then begin
    Writeln('syntaxe: IMAGETXT ecran[.SCR] [palette.[PAL]]');
    Halt(1);
  end;

  param:=Maj(ParamStr(1));
  ext:='.SCR';
  if (Pos(ext,param)=0) then param:=param+ext;

  z.Charge_(param,erreur);
  if (erreur<>0) then begin
    Writeln(param,': erreur ',erreur);
    Halt(2);
  end;

  {initialise le nombre de lignes de texte car mise  jour
   seulement sur appel  InitTexte}
  hauteur_ecran_txt:=Mem[$40:$84]+1;

  z.Restaure(0,0,0,0);
  z.Supprime;

  if (ParamCount>=2) then begin
    param:=Maj(ParamStr(2));
    ext:='.PAL';
    if (Pos(ext,param)=0) then param:=param+ext;

    p.Charge_(param,erreur);
    if (erreur<>0) then begin
      Writeln(param,': erreur ',erreur);
      Halt(3);
    end;

    p.Fixe;
  end;

  LargeurCar(8);

END.