{$A+,G+,Q-,R-,S-}

USES Crt,Graph256,GraphX;

CONST ResX=360; ResY=480;

      nbr_lignes=5;
      longueur_ligne=80;

TYPE T_ligne=record
              points: array[1..2] of
                       record
                        x,y: array[1..longueur_ligne] of word;
                        dx,dy: shortint;
                       end;
              couleur: byte;
              index_queue,index_tete: byte;
             end;

VAR lignes: array[1..nbr_lignes] of T_ligne;
    anc_points: array[1..2] of
                 record
                  x,y: word;
                  dx,dy: shortint;
                 end;
    i,j: byte;
    nouveau,fin: boolean;


procedure CalculePalette;
var i: byte;
    comp: RVB;
    dR,dV,dB: shortint;
begin
 with comp do begin R:=1+Random(63); V:=1+Random(63); B:=1+Random(63) end;
 dR:=+1;
 dV:=+1;
 dB:=+1;
 for i:=1 to 255 do with comp do begin
  FixeDAC(i,comp);
  if (Random(100)=0) or (R in [0,63]) then dR:=-dR;
  if (Random(100)=0) or (V in [0,63]) then dV:=-dV;
  if (Random(100)=0) or (B in [0,63]) then dB:=-dB;
  inc(R,dR);
  inc(V,dV);
  inc(B,dB);
 end;
end;


procedure CyclePalette;
var p: palette256;
    couleur: RVB;
begin
 p.Charge(0,256);
 couleur:=p.palette[255];
 Move(p.palette[1],p.palette[2],3*254);
 p.palette[1]:=couleur;
 p.Fixe(0,256);
end;



BEGIN
{ Init320x200;}
 InitModeX(_360x480);
 Randomize;

 fin:=FALSE;

 repeat
  nouveau:=FALSE;
  for i:=1 to nbr_lignes do with lignes[i] do begin
   for j:=1 to 2 do with points[j] do begin
    x[1]:=10+Random(ResX-20); y[1]:=10+Random(ResY-20);
    dx:=1-2*Random(2); dy:=1-2*Random(2);
   end;
   couleur:=Random(256);
   index_queue:=1; index_tete:=1;
  end;
  CalculePalette;
{  EffaceZone($A000,0,0,ResX-1,ResY-1,0);}
  EffacerEcranX(Segment_actif_x);
  repeat
   repeat
    CyclePalette;
    for i:=1 to nbr_lignes do with lignes[i] do begin
     LigneX(Segment_actif_x,points[1].x[index_tete],points[1].y[index_tete],
                 points[2].x[index_tete],points[2].y[index_tete],couleur);
     dec(couleur);
{     if ((index_queue=1) and (index_tete=longueur_ligne)) or
        (index_queue=index_tete+1) then
      begin
       LigneX($A000,points[1].x[index_queue],points[1].y[index_queue],
                   points[2].x[index_queue],points[2].y[index_queue],0);
       index_queue:=1+(index_queue mod longueur_ligne);
      end;
     for j:=1 to 2 do with anc_points[j] do begin
      x:=points[j].x[index_tete]; y:=points[j].y[index_tete];
      dx:=points[j].dx; dy:=points[j].dy;
     end;
     index_tete:=1+(index_tete mod longueur_ligne);}
     for j:=1 to 2 do with points[j] do begin
{      x[index_tete]:=anc_points[j].x; y[index_tete]:=anc_points[j].y;
      dx:=anc_points[j].dx; dy:=anc_points[j].dy;}
      if (x[index_tete]=0) or (x[index_tete]=ResX-1) then dx:=-dx;
      if (y[index_tete]=0) or (y[index_tete]=ResY-1) then dy:=-dy;
      inc(x[index_tete],dx); inc(y[index_tete],dy);
     end;
    end;
   until Keypressed;
   case UpCase(ReadKey) of
    #27: fin:=TRUE;
    #13: nouveau:=TRUE;
   end;
  until fin or nouveau;
 until fin;

 TextMode(LastMode);
END.
