{$A+,G+,Q-,R-,S-}

USES Util,Texte;

CONST freq_osc=1193180;  {frquence de l'oscillateur interne}

      freq_18_2=freq_osc/65535;  {timer  18.2 Hz}

      freq_horiz=15750;  {frquence de balayage horizontal de l'cran}

      IRQ_Timer  =$01;
      IRQ_Clavier=$02;
      masqueIRQ=BYTE(not(IRQ_Timer or IRQ_Clavier));

      n=60;


VAR ancINT08: pointer;
    couleur: RVB;
    cpt: word;


procedure SetTimer(freq: real);
begin
 Port[$43]:=182;
 Port[$40]:=Lo(Round(freq_osc/freq));
 Port[$40]:=Hi(Round(freq_osc/freq));
end; {SetTimer}


procedure INT08; interrupt;
begin
 FixeDAC(0,couleur);
 if (cpt mod 4)=0 then inc(couleur.B);
 cpt:=(cpt+1) mod 64;

 Port[$20]:=$20; {fin d'IRQ}
end; {INT08}


BEGIN
 InitTexte(50);

 AffChXY(0,1,1,'Appuyez sur Espace...',3);

 SwapIntVec($08,ancINT08,@INT08);

 SetTimer(freq_horiz);
 Port[$21]:=masqueIRQ;
 Port[$A1]:=$FF;

 cpt:=0;
 repeat
  if cpt=0 then begin
   AttendVBL;
   with couleur do begin R:=0; V:=0; B:=0 end;
  end;
 until Port[$60]=57; {KeyPressed}

 SwapIntVec($08,ancINT08,ancINT08);

 SetTimer(freq_18_2);
 Port[$21]:=$00; {autorise toutes les IRQ}
 Port[$A1]:=$00;

 InitTexte(25);
END.
