{$A+,G+,Q-,R-,S-}

USES Crt,Util,Clavier,Graph256,BMP256,Souris,SourisG;

CONST distance: word=200;
      vitesse_distance: shortint=-4;

      angle: integer=0;
      vitesse_angle: shortint=+1;
      accel_angle: shortint=0;

VAR sinus,cosinus,sinus2,cosinus2: array[byte] of integer;

    image: BMP;
    erreur: word;

    y: word;
    image256: ^byte;

TYPE T_Byte=array[0..0] of byte; {pour accder  image256^ par image256[]}


procedure CalculeCosSin;
const ratio=(320/200)/(4/3);
var direction: byte;
    angle: real;
begin
 for direction:=0 to 255 do begin
  angle:=direction*Pi/128;
  sinus   [direction]:=Round(+sin(angle)*256);
  cosinus [direction]:=Round(+cos(angle)*256);
  sinus2  [direction]:=Round(+cos(angle)*256*ratio);
  cosinus2[direction]:=Round(-sin(angle)*256*ratio);
 end;
end; {CalculeCosSin}

procedure AfficheRotations(segment_image,x: word; y: byte; distance: word; angle: byte); external;
{$L RotBMP}

BEGIN
 Randomize;
 CalculeCosSin;

 with image do begin
  Charge('C:\Projets\tests\sq4_poil.bmp',erreur);
  if erreur<>0 then begin WriteLn('Erreur BMP: ',erreur); halt end;

  Init320x200;
  FixePalette;

  {tend l'image  une rsolution de 256x256 pixels}
  GetMem(image256,256*256-1);
  FillChar(image256^,256*256-1,0);
  for y:=0 to MinEntier(256,ResY)-1 do
   Move(image^[ResX*y],T_Byte(image256^)[256*y],MinEntier(256,ResX));

  BougeCursSourisXY(ResX div 2,ResY div 2);

  AfficheRotations(Seg(image256^),Xsouris,Ysouris,distance,angle);
  AffCh5x6($A000,50,50,'Are you ready?',150,FALSE,0);
  Pause(18);

  repeat
   AttendVBL2;
   AfficheRotations(Seg(image256^),Xsouris,Ysouris,distance,angle);

   inc(distance,vitesse_distance);
   if (distance>=2000) or (distance<=4) then vitesse_distance:=-vitesse_distance;

   if vitesse_angle<>0 then
    if Random(100)=0 then accel_angle:=-Sgn(vitesse_angle);
   if accel_angle<>0 then
    if (Timer mod 10)=0 then begin
     inc(vitesse_angle,accel_angle);
     if Abs(vitesse_angle)>=8 then accel_angle:=-Sgn(accel_angle);
    end;
   inc(angle,vitesse_angle);

   if KeyPressed then
    case UpCase(ReadKey) of
     Key('+'): vitesse_distance:=+Abs(vitesse_distance);
     Key('-'): vitesse_distance:=-Abs(vitesse_distance);
     Enter: if vitesse_distance<>0 then vitesse_distance:=0 else vitesse_distance:=-4;
     Space: if vitesse_angle<>0 then begin accel_angle:=0; vitesse_angle:=0 end
                                else accel_angle:=+1;
     Esc  : break;
    end;
  until FALSE;

  palette_blanche.Fondu(0,256,32);

  FreeMem(image256,256*ResY);
  Supprime;

  TextMode(LastMode);
 end;
END.