{Petit programme qui scanne rcursivement un rpertoire pour vrifier la
 fracheur du fichier PSPBRWSE.JBF du browser de PaintShop Pro par rapport
  la date des fichiers images correspondants}

{$A+,G+,Q-,R-,S-}

USES Dos,Crt;

TYPE Char3=array[1..3] of CHAR;

CONST FICHIER_PSP='PSPBRWSE.JBF';
      CRLF=#13#10;

      repertoires: WORD=0;

      N_EXTENSIONS=44;
      extensions: array[1..N_EXTENSIONS] of Char3=(
                   'AI',
                   'BMP',
                   'CDR',
                   'CGM',
                   'CLM',
                   'CMX',
                   'CT',
                   'CUT',
                   'DCX',
                   'DIB',
                   'DRW',
                   'DXF',
                   'EMF',
                   'EPS',
                   'FPX',
                   'GEM',
                   'GIF',
                   'HGL',
                   'IFF',
                   'IMG',
                   'JIF',
                   'JPG',
                   'KDC',
                   'LBM',
                   'MAC',
                   'MSP',
                   'PBM',
                   'PCD',
                   'PCT',
                   'PCX',
                   'PIC',
                   'PGM',
                   'PNG',
                   'PS',
                   'PSD',
                   'PSP',
                   'RAS',
                   'RAW',
                   'RLE',
                   'SCT',
                   'TGA',
                   'TIF',
                   'WPG',
                   'WMF'
                  );


function CompareDateTime(dt1,dt2: DateTime): SHORTINT;
{renvoie -1 si dt1<dt2
          0 si dt1=dt2
         +1 si dt1>dt2}
begin
 if dt1.Year <dt2.Year  then begin CompareDateTime:=-1; exit end;
 if dt1.Year >dt2.Year  then begin CompareDateTime:=+1; exit end;

 if dt1.Month<dt2.Month then begin CompareDateTime:=-1; exit end;
 if dt1.Month>dt2.Month then begin CompareDateTime:=+1; exit end;

 if dt1.Day  <dt2.Day   then begin CompareDateTime:=-1; exit end;
 if dt1.Day  >dt2.Day   then begin CompareDateTime:=+1; exit end;

 if dt1.Hour <dt2.Hour  then begin CompareDateTime:=-1; exit end;
 if dt1.Hour >dt2.Hour  then begin CompareDateTime:=+1; exit end;

 if dt1.Min  <dt2.Min   then begin CompareDateTime:=-1; exit end;
 if dt1.Min  >dt2.Min   then begin CompareDateTime:=+1; exit end;

 if dt1.Sec  <dt2.Sec   then begin CompareDateTime:=-1; exit end;
 if dt1.Sec  >dt2.Sec   then begin CompareDateTime:=+1; exit end;

 CompareDateTime:=0;
end; {CompareDateTime}


procedure Scan(chemin: string);

var f: SearchRec;
    nombre,nouveaux: WORD;
    presence_PSP,ext_trouvee: BOOLEAN;
    dt_PSP,dt: DateTime;
    ext: BYTE;

begin
 nombre:=0;
 nouveaux:=0;

 FindFirst(chemin+FICHIER_PSP,Archive,f);
 presence_PSP:=(DosError=0);
 if presence_PSP then UnPackTime(f.Time,dt_PSP);

 FindFirst(chemin+'*.*',AnyFile,f);
 while DosError=0 do begin
  if f.Attr=Directory then begin
   if f.Name[1]<>'.' then Scan(chemin+f.Name+'\');
  end
  else begin
   if f.Name<>FICHIER_PSP then begin
    ext_trouvee:=FALSE;
    for ext:=1 to N_EXTENSIONS do
     if Pos('.'+extensions[ext],f.Name)<>0 then begin ext_trouvee:=TRUE; break; end;

    if ext_trouvee then begin
     inc(nombre);
     if presence_PSP then begin
      UnPackTime(f.Time,dt);
      if CompareDateTime(dt,dt_PSP)>0 then inc(nouveaux);
     end
     else inc(nouveaux);
    end;
   end;
  end;
  FindNext(f);
 end;

 gotoxy(1,wherey); clreol;
 write(chemin);
 if nouveaux<>0 then begin
  writeln(CRLF,'  ',nouveaux,' nouveau(x) fichier(s) sur ',nombre,CRLF);
  inc(repertoires);
 end;

 case DosError of
  3  : writeln('Chemin introuvable');
  100: writeln('Erreur de lecture');
  152: writeln('Lecteur pas prt');
  154,156,157,158: writeln('Erreur de donnes')
 end;
 if DosError<>18 then halt(1);
end; {Scan}


VAR chemin: string;

BEGIN
 writeln(CRLF,'Analyseur de mise  jour pour PaintShop Pro browser - (c) 1999 Fab');
 if ParamCount>1 then begin
  writeln('syntaxe: SCANPSP [rpertoire]');
  halt(1);
 end;

 if ParamCount=1 then chemin:=ParamStr(1) else GetDir(0,chemin);
 if chemin[Length(chemin)]<>'\' then chemin:=chemin+'\';
 writeln(chemin,CRLF);
 Scan(chemin);

 gotoxy(1,wherey); clreol;
 if repertoires<>0 then writeln('--> ',repertoires,' rpertoire(s)  mettre  jour.')
                   else writeln('Pas de mise  jour ncessaire.');
END.
