PROGRAM Screener; {diteur d'crans en mode texte}
{$A+,G+,Q-,R-,S-}

USES Crt,Dos,Fichiers,Clavier,Texte,Souris,SourisT,Util,UtilT;

CONST {types de fichiers}
      SCR=1; PAL=2; FNT=3; PRJ=4;

TYPE type_fichier=SCR..PRJ;
     type_couleur=(fond,ecriture);
     type_anc_nouv=(anc,nouv);

     Char3=array[1..3] of char;
     Char10=array[0..9] of char;
     Char18=array[1..18] of char;

CONST version: array[1..3] of char='1.1';

      m_Fichier   =1;
      m_Projet    =2;
      m_Edition   =3;
      m_Couleurs  =4;
      m_Caracteres=5;
      m_Options   =6;
      m_Aide      =7;

      nbr_menus=7; nbr_opt_max=10;

      Menu: array[1..nbr_menus] of
             record
              titre: String12;
              xtitre,xcadre,nbr_opt: byte;
              opt_precedente: byte;
              opt: array[1..nbr_opt_max] of
                    record
                     titre: string[28];
                     aide: String64;
                     VGA: boolean;
                    end;
             end

      =((titre:'^F^ichier'; xtitre:3; xcadre:3; nbr_opt:7; opt_precedente:1;
        opt:((titre:'^N^ouveau         F4'; aide:'Efface l''cran et dite un cran vierge'; VGA:FALSE),
             (titre:'^C^harger...      F3'; aide:'Charge un cran depuis le disque'; VGA:FALSE),
             (titre:'^S^auver...       F2'; aide:'Sauve l''cran courant sur disque'; VGA:FALSE),
             (titre:'^I^nsrer zone...   '; aide:'Insre un fichier sur l''cran courant'; VGA:FALSE),
             (titre:'Sauver ^z^one...    '; aide:'Sauve une zone de l''cran sur disque'; VGA:FALSE),
             (titre:'Sauver ^l^imites... '; aide:'Sauve le contenu de la zone d''dition sur disque'; VGA:FALSE),
             (titre:'^Q^uitter        F10'; aide:'Quitte Screener'; VGA:FALSE),
             (),
             (),
             ())),

        (titre:'^P^rojet'; xtitre:13; xcadre:13; nbr_opt:3; opt_precedente:1;
        opt:((titre:'^N^ouveau      F4'; aide:'Initialise l''cran, la palette et la fonte'; VGA:FALSE),
             (titre:'^C^harger...   F3'; aide:'Charge cran, palette, fonte, mmoires et options'; VGA:FALSE),
             (titre:'^S^auver...    F2'; aide:'Sauve cran, palette, fonte, mmoires et options sur disque'; VGA:FALSE),
             (),
             (),
             (),
             (),
             (),
             (),
             ())),

        (titre:'^E^dition'; xtitre:23; xcadre:23; nbr_opt:10; opt_precedente:1;
        opt:((titre:'^A^nnuler              '; aide:'Annule la dernire commande d''dition/couleurs/caractres'; VGA:FALSE),
             (titre:'Copier ^z^one        F5'; aide:'Copie une zone rectangulaire de l''cran  un autre endroit'; VGA:FALSE),
             (titre:'^R^ectangle          F6'; aide:'Remplit un rectangle avec la couleur de fond courante'; VGA:FALSE),
             (titre:'^C^adre simple     '; aide:'Trace un cadre simple paisseur avec les couleurs courantes'; VGA:FALSE),
             (titre:'Ca^d^re double     '; aide:'Trace un cadre double paisseur avec les couleurs courantes'; VGA:FALSE),
             (titre:'^L^igne simple     '; aide:'Trace une ligne simple paisseur avec les couleurs courantes'; VGA:FALSE),
             (titre:'Li^g^ne double     '; aide:'Trace une ligne double paisseur avec les couleurs courantes'; VGA:FALSE),
             (titre:'D^f^inir limites   F7'; aide:'Dfinit les limites de la zone d''dition'; VGA:FALSE),
             (titre:'^V^oir limites       F7'; aide:'Visualise momentanment la zone d''dition en inverse vido'; VGA:FALSE),
             (titre:'Ann^u^ler limites      '; aide:'Autorise l''dition sur tout l''cran'; VGA:FALSE))),

        (titre:'^C^ouleurs'; xtitre:33; xcadre:33; nbr_opt:10; opt_precedente:1;
        opt:((titre:'^A^ttribut            F8'; aide:'Change les couleurs de fond et d''criture courantes'; VGA:FALSE),
             (titre:'Remplacer ^f^ond        '; aide:'Remplace une couleur de fond par une autre'; VGA:FALSE),
             (titre:'Echan^g^er fond         '; aide:'Echange deux couleurs de fond'; VGA:FALSE),
             (titre:'^R^emplacer criture    '; aide:'Remplace une couleur d''criture par une autre'; VGA:FALSE),
             (titre:'^E^changer criture     '; aide:'Echange deux couleurs d''criture'; VGA:FALSE),
             (titre:'Remplacer a^t^tribut    '; aide:'Remplace un attribut (couleurs fond+criture) par un autre'; VGA:FALSE),
             (titre:'Echanger attri^b^ut     '; aide:'Echange deux attributs (couleurs fond+criture)'; VGA:FALSE),
             (titre:'Remplir ^z^one fond     '; aide:'Remplit une zone contige de fond avec la couleur courante'; VGA:FALSE),
             (titre:'Remp^l^ir zone criture '; aide:'Remplit une zone contige d''criture avec la couleur courante';
              VGA:FALSE),
             (titre:'Redfinir ^p^alette  F8'; aide:'Modifie/Charge/Sauve une palette de 16 couleurs (VGA)'; VGA:TRUE))),

        (titre:'Ca^r^actres'; xtitre:44; xcadre:44; nbr_opt:5; opt_precedente:1;
        opt:((titre:'^M^moriser caractre    F9'; aide:'Mmorise un caractre dans une des mmoires Alt+0Alt+9';
              VGA:FALSE),
             (titre:'^R^emplacer caractre      '; aide:'Remplace un caractre par un autre'; VGA:FALSE),
             (titre:'^E^changer caractre       '; aide:'Echange deux caractres'; VGA:FALSE),
             (titre:'Caractres 8/9 ^p^ixels    '; aide:'Change la largeur des caractres en pixels (VGA)'; VGA:TRUE),
             (titre:'Redfinir ^c^aractres  F9'; aide:'Modifie/Charge/Sauve une fonte de caractres (VGA)'; VGA:TRUE),
             (),
             (),
             (),
             (),
             ())),

        (titre:'^O^ptions'; xtitre:57; xcadre:52; nbr_opt:5; opt_precedente:1;
        opt:((titre:'Curseur ^s^uiveur        '; aide:'Autorise le dplacement du curseur en dition de texte'; VGA:FALSE),
             (titre:'Conserver ^c^ouleurs     '; aide:'Conserve les couleurs sous le curseur en dition de texte'; VGA:FALSE),
             (titre:'Cli^g^notement           '; aide:'Slectionne les couleurs clignotantes ou les fonds intenses';
              VGA:FALSE),
             (titre:'^I^ntersections          '; aide:'Valide les intersections de caractres semi-graphiques'; VGA:FALSE),
             (titre:'25/28/50 ^l^ignes        '; aide:'Fixe le nombre de lignes de texte visibles (VGA)'; VGA:TRUE),
             (),
             (),
             (),
             (),
             ())),

        (titre:'^A^ide'; xtitre:73; xcadre:57; nbr_opt:2; opt_precedente:1;
        opt:((titre:'^A^ propos de...    ' ; aide:'Affiche des informations sur le programme'; VGA:FALSE),
             (titre:'^P^age d''aide     F1'; aide:'Dtaille les commandes  la souris et l''diteur plein cran'; VGA:FALSE),
             (),
             (),
             (),
             (),
             (),
             (),
             (),
             ())));

      {aides en ligne}
      select_fichier: string[38]='Slectionnez un fichier avec  et ';
      select_couleur: string[41]='Slectionnez une couleur avec '#27#26' et ';
      select_caractere: string[61]='Slectionnez un caractre avec '#27#26' ou la touche correspondante';

      {flags pour l'extension SCR}
      zone_ecran  =$10;
      zone_edition=$20;

      nom_fichier: array[type_fichier] of String80=('','','','');
      extension: array[type_fichier] of Char3=('SCR','PAL','FNT','PRJ');

      id_PRJ: Char18='Screener v1.0 PRJ ';

      titre: array[boolean] of string[9]=('Remplacer','Echanger');
      prep : array[boolean] of string[4]=('par','avec');

      {rsultats de Confirmation}
      sauve=1; ne_sauve_pas=2; annule=3;

      {rsultats de LigneSouris}
      verticale=1; horizontale=2;

      {boolens pour diverses procdures...}
      efface=FALSE; conserve=TRUE;          {CadreSouris}
      sans_menu=FALSE; avec_menu=TRUE;      {InitNouveauEcran}
      tout=FALSE; ajoute_car=TRUE;          {SauveEcranActuel}
      nouveau_SCR=TRUE; partiel=FALSE;      {SauveFichierSCR}
      demande=TRUE;                         {SauveFichierPAL/FNT}
      modif_projet=TRUE;                    {Init}
      remplacer=FALSE; echanger=TRUE;       {RemplacerEchangerCouleur/Attribut/Caractere}
      aff_nom_coul=TRUE;                    {AfficheBarreCouleurs}
      normal=FALSE; capture=TRUE;           {ChangerAttribut}

      couleur_pal  : byte=0; {couleur pour RedefPalette}
      couleur_copie: byte=0; {couleur copie pour RedefPalette}
      couleur : array[type_couleur] of byte=(0,7); {attribut courant}
      ancienne: array[type_couleur] of byte=(0,0); {attribut recherche}
      nouvelle: array[type_couleur] of byte=(0,0); {attribut remplacement}

      car_defaut=BYTE('A');
      car_fnt  : byte=car_defaut; {caractre pour RedefCaracteres}
      car_copie: byte=car_defaut; {caractre copie pour RedefCaracteres}
      car_memo : byte=car_defaut; {caractre pour MemoriseCaractere}
      car_rech: array[type_anc_nouv] of byte=(car_defaut,car_defaut); {caractres recherche/remplacement}
      MemoireCar: Char10='          '; {mmoire de 10 caractres}

      projet_actif: boolean=FALSE;
      modif: array[type_fichier] of boolean=(FALSE,FALSE,FALSE,FALSE);
      quitte: boolean=FALSE;

      gere_menu   : boolean=TRUE;
      menu_deroule: boolean=FALSE;
      n_menu      : byte=m_Fichier;

      {options oui/non}
      nbr_options_oui_non=4;
      curseur_suiveur  =1;
      conserve_couleurs=2;
      clignote         =3;
      intersections    =4;

      options_oui_non: array[1..nbr_options_oui_non] of boolean=(TRUE,FALSE,TRUE,TRUE);


VAR n_option,
    x_curseur,y_curseur,
    x_origine,y_origine,
    xg_lim,yh_lim,xd_lim,yb_lim: byte;

    direction_curseur: (droite_,bas_);

    zone_barre_menu,zone_menu,zone_aide_en_ligne: Zone;

    zone_limite_max,lettre,anc_modif_SCR: boolean;

    Fonte8x16: Fonte16;
    Fonte8x14: Fonte14;
    Fonte8x8 : Fonte8;


CONST fonte_courante: pointer=@Fonte8x16;


TYPE format_PRJ=record
                 id: Char18;
                 opt: byte;
                 zone_ed: record xg,yh,xd,yb: byte end;
                 pos_curs: record x,y: byte end;
                 pos_orig: record x,y: byte end;
                 coul: record cour,rech,rempl,pal_copie: byte end;
                 car: record
                       memo,rech,rempl,fnt,copie: byte;
                       memoires10: Char10;
                      end;
                 fich: record nom_SCR,nom_PAL,nom_FNT: String80 end;
                end;

{==========================================================}

procedure TesteIntersection(x,y,masque_segments_a_enlever: byte);
{                                ----
  7 6 5 4 3 2 1 0                |  B  |
 Ŀ      forme:   |    |
 00VHDCBA  (4 segments) CA
 Ĵ               |    |
        \forme/                |  D  |
                               ----
        paisseur horizontale (0: simple, 1: double)
       paisseur verticale                           }

const CarGraph: array[0..3] of array[1..11] of char
                =(('','','','','','','','','','',''),
                  ('','','','','','','','','','',''),
                  ('','','','','','','','','','',''),
                  ('','','','','','','','','','',''));

      MasqueForme: array[1..11] of byte=($3,$5,$6,$7,$9,$A,$B,$C,$D,$E,$F);
      NumCarGraph: array[$00..$0F] of byte=(0,2,6,1,2,2,3,4,6,5,6,7,8,9,10,11);

var epaisseur,n_car: byte;
    masque_1,masque_2: byte;
    ptr_car: CharPtr;
    car: char;

begin
 masque_1:=$00;
 ptr_car:=CharPtr(PtrVRAM(0,x,y)); car:=ptr_car^;
 epaisseur:=0;
 repeat
  for n_car:=1 to 11 do
   if car=CarGraph[epaisseur][n_car] then
    begin masque_1:=(epaisseur shl 4)+MasqueForme[n_car]; break end;
  inc(epaisseur);
 until (epaisseur>3) or (masque_1<>$00);

 masque_2:=$00;
 car:=CharPtr(PtrVRAM(1,x,y))^;
 if car in [''..''] then begin
  epaisseur:=0;
  repeat
   for n_car:=1 to 11 do
    if car=CarGraph[epaisseur][n_car] then
     begin masque_2:=(epaisseur shl 4)+MasqueForme[n_car]; break end;
   inc(epaisseur);
  until (epaisseur>3) or (masque_2<>$00);
 end;

 masque_1:=(masque_1 or masque_2) and not(masque_segments_a_enlever);
 ptr_car^:=CarGraph[masque_1 shr 4][NumCarGraph[masque_1 and $0F]];
end; {TesteIntersection}

{----------------------------------------------------------}

procedure LigneSouris(epaisseur,attribut: byte; conserve_aff: boolean);
const car: array[1..2,1..2] of char=(('',''),('',''));
var x1,y1,x2,y2,xg,yh,xd,yb,anc_x,anc_y,x,y,boutons: byte;
    z,z_dim: Zone;
    timer_debut: longint;
begin
 Curseur(off);
 DefCursSouris(inverse_attribut,0,0,car[epaisseur,1]);
 repeat until BoutonSouris=gauche;

 CacheCursSouris;
 EtatSouris(x1,y1,boutons); anc_x:=x1; anc_y:=y1;
 z.Sauve(0,x1,y1,x1,y1);
 z_dim.Sauve(0,38,hauteur_ecran_txt div 2,41,hauteur_ecran_txt div 2);
 AffCursSouris;


 timer_debut:=Timer;
 repeat
  EtatSouris(x2,y2,boutons);
  if Timer>=timer_debut+18 then z_dim.Restaure(0,0,0,0);
  if (x2<>anc_x) or (y2<>anc_y) then begin
   CacheCursSouris;
   if x1<=x2 then begin xg:=x1; xd:=x2 end else begin xg:=x2; xd:=x1 end;
   if y1<=y2 then begin yh:=y1; yb:=y2 end else begin yh:=y2; yb:=y1 end;
   AttendVBL;
   with z_dim do begin Restaure(0,0,0,0); Supprime end;
   with z do begin Restaure(0,0,0,0); Supprime end;
   if hauteur_car*(yb-yh)>=6*(xd-xg) then begin  {ratio=(4/3)*(hauteur_car/8)}
    DefCursSouris(inverse_attribut,0,0,car[epaisseur,2]);
    z.Sauve(0,x1,yh,x1,yb);
    LigneVerticale(0,epaisseur,x1,yh,yb,attribut);
    if options_oui_non[intersections] and conserve_aff then begin
     TesteIntersection(x1,yh,$2);
     for y:=yh+1 to yb-1 do TesteIntersection(x1,y,$0);
     TesteIntersection(x1,yb,$8);
    end;
    x:=yb-yh+1;
   end
   else begin
    DefCursSouris(inverse_attribut,0,0,car[epaisseur,1]);
    z.Sauve(0,xg,y1,xd,y1);
    LigneHorizontale(0,epaisseur,y1,xg,xd,attribut);
    if options_oui_non[intersections] and conserve_aff then begin
     TesteIntersection(xg,y1,$4);
     for x:=xg+1 to xd-1 do TesteIntersection(x,y1,$0);
     TesteIntersection(xd,y1,$1);
    end;
    x:=xd-xg+1;
   end;
   z_dim.Sauve(0,38,hauteur_ecran_txt div 2,41,hauteur_ecran_txt div 2);
   AffChXY(0,38,hauteur_ecran_txt div 2,''+EntierTexte2(x,2)+'',112);
   timer_debut:=Timer;
   AffCursSouris;
   anc_x:=x2; anc_y:=y2;
  end;
 until boutons=aucun;

 CacheCursSouris;
 with z_dim do begin Restaure(0,0,0,0); Supprime end;
 with z do begin if not(conserve_aff) then Restaure(0,0,0,0); Supprime end;
 AffCursSouris;
 DefCursSouris(standard,0,0,#0);
 VideBufferClavier;
end; {LigneSouris}

{----------------------------------------------------------}

procedure CadreSouris(epaisseur: byte; var xg_c,yh_c,xd_c,yb_c: byte; attr: byte; conserve_aff: boolean);
const car: array[1..2,1..4] of char=(('','','',''),('','','',''));
var x1,y1,x2,y2,xg,yh,xd,yb,anc_x,anc_y,x,y,boutons,n: byte;
    z,z_dim: Zone;
    timer_debut: longint;
begin
 Curseur(off);
 DefCursSouris(inverse_attribut,0,0,car[epaisseur,1]);
 repeat until BoutonSouris=gauche;
 DefCursSouris(inverse_attribut,0,0,car[epaisseur,4]);

 CacheCursSouris;
 EtatSouris(x1,y1,boutons); anc_x:=x1; anc_y:=y1;
 xg_c:=x1; yh_c:=y1; xd_c:=x1; yb_c:=y1;
 z.Sauve(0,x1,y1,x1,y1);
 z_dim.Sauve(0,37,hauteur_ecran_txt div 2,43,hauteur_ecran_txt div 2);
 AffCursSouris;

 timer_debut:=Timer;
 repeat
  EtatSouris(x2,y2,boutons);
  if Timer>=timer_debut+18 then z_dim.Restaure(0,0,0,0);
  if (x2<>anc_x) or (y2<>anc_y) then begin
   n:=1;
   if x1<=x2 then begin inc(n);   xg:=x1; xd:=x2 end else begin xg:=x2; xd:=x1 end;
   if y1<=y2 then begin inc(n,2); yh:=y1; yb:=y2 end else begin yh:=y2; yb:=y1 end;
   DefCursSouris(inverse_attribut,0,0,car[epaisseur,n]);
   CacheCursSouris;
   AttendVBL;
   with z_dim do begin Restaure(0,0,0,0); Supprime end;
   with z do begin Restaure(0,0,0,0); Supprime; Sauve(0,xg,yh,xd,yb) end;
   Cadre(0,epaisseur,xg,yh,xd,yb,attr,'',0,'');
   if options_oui_non[intersections] and conserve_aff then begin
    for x:=xg to xd do begin TesteIntersection(x,yh,$0); TesteIntersection(x,yb,$0) end;
    for y:=yh to yb do begin TesteIntersection(xg,y,$0); TesteIntersection(xd,y,$0) end;
   end;
   z_dim.Sauve(0,37,hauteur_ecran_txt div 2,43,hauteur_ecran_txt div 2);
   AffChXY(0,37,hauteur_ecran_txt div 2,''+EntierTexte2(xd-xg+1,2)+'x'+EntierTexte2(yb-yh+1,2)+'',112);
   timer_debut:=Timer;
   AffCursSouris;
   xg_c:=xg; yh_c:=yh; xd_c:=xd; yb_c:=yb;
   anc_x:=x2; anc_y:=y2;
  end;
 until boutons=aucun;

 CacheCursSouris;
 with z_dim do begin Restaure(0,0,0,0); Supprime end;
 with z do begin if not(conserve_aff) then Restaure(0,0,0,0); Supprime end;
 AffCursSouris;
 DefCursSouris(standard,0,0,#0);
 VideBufferClavier;
end; {CadreSouris}

{----------------------------------------------------------}

function SansnomSiVide(nf: String80): String80;
begin
 if nf='' then SansnomSiVide:='<sans nom>' else SansnomSiVide:=NomFichierSeul(nf);
end; {SansnomSiVide}

{----------------------------------------------------------}

procedure AideEnLigne(aide: String64);
const car: array[boolean] of char=(' ','*');
begin
 CacheCursSouris;
 AffChXY2(0,1,hauteur_ecran_txt,' '+XString(aide,' ',64)+'^'+car[modif[SCR]]+'^'+
              XString(SansnomSiVide(nom_fichier[SCR]),' ',13),48,48+14);
 AffCursSouris;
end; {AideEnLigne}

{----------------------------------------------------------}

procedure AfficheOuiNon(o: byte; b: boolean; attr: byte);
const ouinon: array[boolean] of string[3]=('non','oui');
begin
 with Menu[m_Options] do
  AffChXY(0,xcadre+Length(opt[1].titre)-3,o+2,ouinon[b],attr);
end; {AfficheOuiNon}

{----------------------------------------------------------}

procedure AfficheOption(numero,coul_texte,coul_lettre,coul_opt_vga: byte);
begin
 with Menu[n_menu] do
  AffChXY2(0,xcadre+1,numero+2,' '+opt[numero].titre+' ',coul_texte,coul_lettre);
 if (n_menu=m_Options) and
    (numero in [1..nbr_options_oui_non]) then
  AfficheOuiNon(numero,options_oui_non[numero],coul_texte);
 with Menu[n_menu] do
  if opt[numero].VGA and not(CarteVGA) then
   AffChXY2(0,xcadre+1,numero+2,' '+opt[numero].titre+' ',coul_opt_vga,coul_opt_vga);
end; {AfficheOption}

{----------------------------------------------------------}

procedure DerouleMenu;
var o: byte;
begin
 CacheCursSouris;
 with Menu[n_menu] do begin
  n_option:=opt_precedente;
  zone_menu.Ombre(0,xcadre,2,xcadre+Length(opt[1].titre)+1,nbr_opt+3,48);
  Cadre(0,1,xcadre,2,xcadre+Length(opt[1].titre)+1,nbr_opt+3,48,'',0,'');
  for o:=1 to nbr_opt do AfficheOption(o,48,48+14,48+8);
 end;
 menu_deroule:=TRUE;
 AffCursSouris;
end; {DerouleMenu}

{----------------------------------------------------------}

procedure EnrouleMenu;
begin
 Menu[n_menu].opt_precedente:=n_option;
 RestaureZoneSuppr(0,zone_menu);
end; {EnrouleMenu}

{----------------------------------------------------------}

procedure DerouleMenuDirect(m: byte);
begin
 if (m<>n_menu) or not(menu_deroule) then begin
  if menu_deroule then EnrouleMenu;
  n_menu:=m; DerouleMenu;
 end;
 gere_menu:=TRUE;
end; {DerouleMenuDirect}

{----------------------------------------------------------}

procedure QuitteMenu;
begin
 if gere_menu then begin
  if menu_deroule then EnrouleMenu;
  RestaureZoneSuppr(0,zone_barre_menu);
  RestaureZoneSuppr(0,zone_aide_en_ligne);
  gere_menu:=FALSE;
 end;
end; {QuitteMenu}

{----------------------------------------------------------}

procedure Init(type_f: byte; nf: String80; modif_PRJ: boolean);
begin
 nom_fichier[type_f]:=nf; modif[type_f]:=FALSE;
 if type_f=SCR then anc_modif_SCR:=FALSE;
 if projet_actif and modif_PRJ then modif[PRJ]:=TRUE;
end; {Init}

{----------------------------------------------------------}

procedure SauveEcranActuel(nouv_lettre: boolean);
begin
 if not(lettre and nouv_lettre) then
  begin CacheCursSouris; CopiePage(0,1); AffCursSouris end;
 lettre:=nouv_lettre;
end; {SauveEcranActuel}

{----------------------------------------------------------}

function LitNomFichier(type_f: byte; var abandon: boolean): String80;

const largeur=40; hauteur=5; x_milieu=39; y_milieu=12;
      xg=x_milieu-(largeur div 2); xd=xg+largeur-1;
      yh=y_milieu-(hauteur div 2); yb=yh+hauteur-1;

      titre_txt: array[type_fichier] of string[10]=('l''cran','la palette','la fonte','le projet');

var z: Zone;
    nf: String80;
    titre: String25;

begin
 if gere_menu then AideEnLigne('Entrez un nom pour '+titre_txt[type_f and $07]);
 CacheCursSouris;
 z.Ombre(0,xg,yh,xd,yb,48);

 case type_f and (zone_ecran or zone_edition) of
  zone_ecran  : begin titre:='une zone de l''cran'; nf:='' end;
  zone_edition: begin titre:='la zone d''dition'; nf:='' end;
  else begin titre:=titre_txt[type_f]; nf:=nom_fichier[type_f] end;
 end;
 Cadre(0,1,xg,yh,xd,yb,48+1,' Sauver '+titre+' ',112,'');
 AffCursSouris;

 repeat
  nf:=LitChaine(nf,xg+5,yh+2,30,80,TRUE,alpha+symboles_fichiers,TRUE,112+1,16+7,abandon);
 until (nf<>'') or abandon;

 if abandon then LitNomFichier:=''
 else begin
  type_f:=type_f and $07; {enlve les masques ventuels: zone_ecran, zone_edition}
  if PosF('.'+extension[type_f],nf)=0 then nf:=nf+'.'+extension[type_f];
  LitNomFichier:=CorrigeNomFichier(repert,nf);
 end;

 RestaureZoneSuppr(0,z);
end; {LitNomFichier}

{----------------------------------------------------------}

procedure SauveFichierSCR(xg,yh,xd,yb: byte; nf: String80; nouveau: boolean);
var abandon: boolean;
    erreur: word;
    z: Zone;
begin
 if nf='' then begin
  nf:=LitNomFichier(SCR,abandon);
  if abandon then exit;
 end;

 QuitteMenu;
 repeat
  CacheCursSouris;
  with z do begin Sauve(0,xg,yh,xd,yb); Sauve_(nf,erreur); Supprime end;
  AffCursSouris;
  if erreur=f_ok then break;
  if MessageErreur(erreur,nf)=alt_annule then break;
 until FALSE;

 if (erreur=f_ok) and nouveau then Init(SCR,nf,not(modif_projet));
 VideBufferClavier;
end; {SauveFichierSCR}

{----------------------------------------------------------}

function Confirmation(type_f: byte): byte;

const largeur=42; hauteur=7; x_milieu=39; y_milieu=12;
      xg=x_milieu-(largeur div 2); xd=xg+largeur-1;
      yh=y_milieu-(hauteur div 2); yb=yh+hauteur-1;

      type_fichier_txt: array[type_fichier] of string[7]=('Ecran','Palette','Fonte','Projet');
      e: array[type_fichier] of char=(' ','e','e',' '); {pour l'accord au fminin ! :)}

var z: Zone;
    boutonSauve,boutonNeSauvePas,boutonAnnuler: Bouton;
    touche: Key;

begin
 Curseur(off);
 if gere_menu then AideEnLigne('');
 CacheCursSouris;
 z.Ombre(0,xg,yh,xd,yb,112);
 Cadre(0,2,xg+1,yh,xd-1,yb,112+4,' Confirmation ',112+4,'');
 AffChXY(0,xg+7,yh+2,type_fichier_txt[type_f]+' '+
         SansnomSiVide(nom_fichier[type_f])+' modifi'+e[type_f]+' !',112);
 boutonSauve.Definit(0,x_milieu-17,yb-2,' ^S^auve ',48+15,48+8,48+14,0);
 boutonNeSauvePas.Definit(0,x_milieu-8,yb-2,' ^N^e Sauve Pas ',48+15,48+8,48+14,0);
 boutonAnnuler.Definit(0,x_milieu+8,yb-2,' ^A^nnule ',48+15,48+8,48+14,0);
 AffCursSouris;
 boutonSauve.Affiche; boutonNeSauvePas.Affiche; boutonAnnuler.Affiche;

 repeat
  if KeyPressed then begin
   touche:=UpCase(Readkey);
   if boutonSauve.Appuye(CHAR(touche))      then begin Confirmation:=sauve; break end;
   if boutonNeSauvePas.Appuye(CHAR(touche)) then begin Confirmation:=ne_sauve_pas; break end;
   if (boutonAnnuler.Appuye(CHAR(touche))) or (touche=Esc) then begin Confirmation:=annule; break end;
  end
  else begin
   if boutonSauve.Clique      then begin Confirmation:=sauve; break end;
   if boutonNeSauvePas.Clique then begin Confirmation:=ne_sauve_pas; break end;
   if boutonAnnuler.Clique    then begin Confirmation:=annule; break end;
  end;
 until FALSE;

 RestaureZoneSuppr(0,z);
end; {Confirmation}

{----------------------------------------------------------}

procedure ChangeNbrLignes(n: byte);
var anc_hauteur_ecran_txt: byte;
begin
 anc_hauteur_ecran_txt:=hauteur_ecran_txt;
 case n of
  25: ActiveJeuCar(car8x16,0);
  28: ActiveJeuCar(car8x14,0);
  50: ActiveJeuCar(car8x8 ,0);
 end;

 if gere_menu then RestaureZoneSuppr(0,zone_aide_en_ligne);
 if hauteur_ecran_txt>anc_hauteur_ecran_txt then
  EffaceZone(0,1,anc_hauteur_ecran_txt+1,80,hauteur_ecran_txt,7);
 if gere_menu then zone_aide_en_ligne.Sauve(0,1,hauteur_ecran_txt,80,hauteur_ecran_txt);
 if y_curseur>hauteur_ecran_txt then y_curseur:=hauteur_ecran_txt;
 if Ysouris>hauteur_ecran_txt then BougeCursSourisXY(Xsouris,hauteur_ecran_txt);

 case hauteur_ecran_txt of
  25: Fonte8x16.Redef(0);
  28: Fonte8x14.Redef(0);
  50: Fonte8x8 .Redef(0);
 end;

 if (yb_lim>hauteur_ecran_txt) or zone_limite_max then yb_lim:=hauteur_ecran_txt;
 EffacePage(1,7); {plus d'annulation possible!}
 Curseur(off);
end; {ChangeNbrLignes}

{----------------------------------------------------------}

procedure SauveFichierPAL(demande_nom: boolean);
var nf: String80;
    abandon: boolean;
    erreur: word;
    palette: Palette16;
begin
 if demande_nom or (nom_fichier[PAL]='') then begin
  nf:=LitNomFichier(PAL,abandon);
  if abandon then exit;
 end
 else nf:=nom_fichier[PAL];

 palette.Charge;
 repeat
  palette.Sauve_(nf,erreur);
  if erreur=f_ok then break;
  if MessageErreur(erreur,nf)=alt_annule then break;
 until FALSE;

 if erreur=f_ok then Init(PAL,nf,not(modif_projet));
 VideBufferClavier;
end; {SauveFichierPAL}

{----------------------------------------------------------}

procedure ChargeFichierPAL(nf: String80);
var erreur: word;
    palette: Palette16;
begin
 if nf='' then begin
  if gere_menu then AideEnLigne(select_fichier);
  nf:=SelectionneFichier('Charger une palette','PAL',hauteur_ecran_txt-11);
  if nf='' then exit;

  if modif[PAL] then
   case Confirmation(PAL) of
    sauve : SauveFichierPAL(not(demande));
    annule: exit;
   end;
 end;

 repeat
  palette.Charge_(nf,erreur);
  if erreur=f_ok then break;
  if MessageErreur(erreur,nf)=alt_annule then break;
 until FALSE;

 if erreur=f_ok then begin
  palette.Fixe;
  Init(PAL,nf,modif_projet);
 end;
 VideBufferClavier;
end; {ChargeFichierPAL}

{----------------------------------------------------------}

procedure SauveFichierFNT(demande_nom: boolean);
var nf: String80;
    abandon: boolean;
    erreur: word;
begin
 if demande_nom or (nom_fichier[FNT]='') then begin
  nf:=LitNomFichier(FNT,abandon);
  if abandon then exit;
 end
 else nf:=nom_fichier[FNT];

 repeat
  SauveFonte_(nf,hauteur_car,fonte_courante^,erreur);
  if erreur=f_ok then break;
  if MessageErreur(erreur,nf)=alt_annule then break;
 until FALSE;

 if erreur=f_ok then Init(FNT,nf,not(modif_projet));
 VideBufferClavier;
end; {SauveFichierFNT}

{----------------------------------------------------------}

procedure ChargeFichierFNT(nf: String80);
var f: Fichier;
    fonte1: array[1..256*16] of byte; {taille maxi pour une fonte 8x16}
    hauteur: byte;
    ok: boolean;
    boutonContinue,boutonAnnule: Bouton;


function ConfirmeChargeFonte: boolean;

const largeur=45; hauteur=8; x_milieu=39; y_milieu=12;
      xg=x_milieu-(largeur div 2); xd=xg+largeur-1;
      yh=y_milieu-(hauteur div 2); yb=yh+hauteur-1;

var touche: Key;
    z: Zone;

begin
 if gere_menu then AideEnLigne('');
 CacheCursSouris;
 z.Ombre(0,xg,yh,xd,yb,112);
 Cadre(0,2,xg+1,yh,xd-1,yb,112+4,' Confirmation: '+NomFichierSeul(nf)+' ',112+4,'');
 AffChXY(0,xg+3,yh+2,'Cette fonte est plus haute que la fonte',112);
 AffChXY(0,xg+3,yh+3,'courante > l''cran va tre rduit !',112);
 AffCursSouris;
 with boutonContinue do begin Definit(0,x_milieu-14,yb-2,' ^C^ontinue ',48+15,48+8,48+14,0); Affiche end;
 with boutonAnnule do begin Definit(0,x_milieu+3,yb-2,' ^A^nnule ',48+15,48+8,48+14,0); Affiche end;

 repeat
  if KeyPressed then begin
   touche:=UpCase(Readkey);
   if boutonContinue.Appuye(CHAR(touche)) then begin ConfirmeChargeFonte:=TRUE; break end;
   if (boutonAnnule.Appuye(CHAR(touche))) or (touche=Esc) then begin ConfirmeChargeFonte:=FALSE; break end;
  end
  else begin
   if boutonContinue.Clique then begin ConfirmeChargeFonte:=TRUE; break end;
   if boutonAnnule.Clique   then begin ConfirmeChargeFonte:=FALSE; break end;
  end;
 until FALSE;

 RestaureZoneSuppr(0,z);
end; {ConfirmeChargeFonte}


begin  {ChargeFichierFNT}
 if nf='' then begin
  if gere_menu then AideEnLigne(select_fichier);
  nf:=SelectionneFichier('Charger une fonte','FNT',hauteur_ecran_txt-11);
  if nf='' then exit;

  if modif[FNT] then
   case Confirmation(FNT) of
    sauve : SauveFichierFNT(not(demande));
    annule: exit;
   end;
 end;

 repeat
  f.Ouvre(lecture,nf);
  if f_erreur=f_ok then break;
  if MessageErreur(f_erreur,nf)=alt_annule then break;
 until FALSE;

 if f_erreur=f_ok then begin
  case f.Taille of
   256*16: hauteur:=16;
   256*14: hauteur:=14;
   256*8 : hauteur:=8;
   else begin AfficheErreur('Format incorrect',''); f.Ferme; exit end; {hauteur<>16,14,8}
  end;

  f.Lit(fonte1,256*hauteur);
  if hauteur>hauteur_car then ok:=ConfirmeChargeFonte else ok:=TRUE;
  if ok then begin
   case hauteur of
    16: begin
         if hauteur_ecran_txt<>25 then ChangeNbrLignes(25);
         fonte_courante:=@Fonte8x16.fonte;
        end;
    14: begin
         if hauteur_ecran_txt<>28 then ChangeNbrLignes(28);
         fonte_courante:=@Fonte8x14.fonte;
        end;
    8 : begin
         if hauteur_ecran_txt<>50 then ChangeNbrLignes(50);
         fonte_courante:=@Fonte8x8.fonte;
        end;
   end;
   Move(fonte1,fonte_courante^,256*hauteur_car);
   RedefFonte(0,fonte_courante^);
   Init(FNT,nf,modif_projet);
  end;
  f.Ferme;
 end;
 VideBufferClavier;
end; {ChargeFichierFNT}

{----------------------------------------------------------}

procedure ZoneLimite(xg,yh,xd,yb: byte);
begin
 if zone_limite_max then
  begin xg_lim:=1; yh_lim:=1; xd_lim:=80; yb_lim:=hauteur_ecran_txt end
 else begin
  xg_lim:=xg; yh_lim:=yh; xd_lim:=xd; yb_lim:=yb;
  if yb_lim>hauteur_ecran_txt then yb_lim:=hauteur_ecran_txt;
 end;
 if x_curseur<xg_lim then x_curseur:=xg_lim;
 if x_curseur>xd_lim then x_curseur:=xd_lim;
 if y_curseur<yh_lim then y_curseur:=yh_lim;
 if y_curseur>yb_lim then y_curseur:=yb_lim;
end; {ZoneLimite}

{----------------------------------------------------------}

procedure InitNouveauEcran(gere_menu_: boolean);
begin
 x_curseur:=1; y_curseur:=1;
 x_origine:=1; y_origine:=1;
 zone_limite_max:=TRUE; ZoneLimite(1,1,80,hauteur_ecran_txt);
 direction_curseur:=droite_; lettre:=FALSE;
 CacheCursSouris; EffacePage(0,7); CopiePage(0,1); AffCursSouris;
 Init(SCR,'',modif_projet);
 gere_menu:=gere_menu_;
end; {InitNouveauEcran}

{----------------------------------------------------------}

procedure NouveauEcran;
begin
 if modif[SCR] then
  case Confirmation(SCR) of
   sauve : SauveFichierSCR(1,1,80,hauteur_ecran_txt,nom_fichier[SCR],nouveau_SCR);
   annule: exit;
  end;

 QuitteMenu;
 InitNouveauEcran(sans_menu);
end; {NouveauEcran}

{----------------------------------------------------------}

procedure ChargerEcran(nf: String80);
var z: Zone;
    erreur: word;
begin
 if nf='' then begin
  if gere_menu then AideEnLigne(select_fichier);
  nf:=SelectionneFichier('Charger un cran','SCR',hauteur_ecran_txt-11);
  if nf='' then exit;

  if modif[SCR] then
   case Confirmation(SCR) of
    sauve : SauveFichierSCR(1,1,80,hauteur_ecran_txt,nom_fichier[SCR],nouveau_SCR);
    annule: exit;
   end;
 end;

 repeat
  z.Charge_(nf,erreur);
  if erreur=f_ok then break;
  if MessageErreur(erreur,nf)=alt_annule then break;
 until FALSE;

 if erreur=f_ok then begin
  QuitteMenu;
  CacheCursSouris;
  if CarteVGA then
   case z.yb_ of
     1..25: if hauteur_ecran_txt<>25 then ChangeNbrLignes(25);
    26..28: if hauteur_ecran_txt<>28 then ChangeNbrLignes(28);
    29..50: if hauteur_ecran_txt<>50 then ChangeNbrLignes(50);
   end;
  EffacePage(0,7);
  AffCursSouris;
  RestaureZoneSuppr(0,z);
  SauveEcranActuel(tout);
  Init(SCR,nf,modif_projet);
 end;
 VideBufferClavier;
end; {ChargerEcran}

{----------------------------------------------------------}

procedure SauverEcran;
var nf: String80;
    abandon: boolean;
begin
 nf:=LitNomFichier(SCR,abandon);
 if abandon then exit;
 SauveFichierSCR(1,1,80,hauteur_ecran_txt,nf,nouveau_SCR);
end; {SauverEcran}

{----------------------------------------------------------}

procedure CopierZone(xg_c,yh_c,xd_c,yb_c: byte);
{si 0,0,0,0 -> zone dfinie  la souris, sinon utilise les 4 coordonnes}
var zone_copie,zone_grise,zone_cachee: Zone;
    xg,yh,xd,yb,x,y,anc_x,anc_y: byte;
    definit_zone,curs_dans_zone,ok: boolean;

begin
 definit_zone:=(xg_c=0) and (yh_c=0) and (xd_c=0) and (yb_c=0);
 if definit_zone then begin
  CadreSouris(1,xg,yh,xd,yb,7,efface);
  SauveEcranActuel(tout);
 end
 else begin xg:=xg_c; yh:=yh_c; xd:=xd_c; yb:=yb_c end;

 CacheCursSouris;
 if definit_zone then CopiePage(0,2);
 zone_copie.Sauve(0,xg,yh,xd,yb);
 zone_grise.Sauve(0,xg,yh,xd,yb);
 with zone_grise do begin Restaure(0,0,0,8); Supprime end;

 AffCursSouris;
 with zone_copie do
  repeat
   x:=Xsouris; y:=Ysouris;
   curs_dans_zone:=(x in [xg..xd]) and (y in [yh..yb]);
   if curs_dans_zone then DefCursSouris(inverse_fond,0,15,'')
                     else DefCursSouris(change_tout,4,15,'');
   repeat
    x:=Xsouris; y:=Ysouris;
    ok:=(curs_dans_zone and (BoutonSouris=droite)) or KeyPressed;
   until SourisBouge or ok;
  until ok;

 CacheCursSouris;
 DefCursSouris(inverse_attribut,0,0,'');
 AttendVBL;
 CopiePage(2,0);
 zone_cachee.Sauve(0,xg,yh,xd,yb);
 with zone_copie do RestaureLimite(0,xg_,yh_,xg_lim,yh_lim,xd_lim,yb_lim);

 if not(KeyPressed) then begin
  x:=Xsouris; y:=Ysouris; anc_x:=x; anc_y:=y;
  AffCursSouris;
  repeat
   x:=Xsouris; y:=Ysouris;
   if (x<>anc_x) or (y<>anc_y) then begin
    CacheCursSouris;
    AttendVBL;
    zone_copie.DeplaceLimite(0,x-anc_x,y-anc_y,zone_cachee,xg_lim,yh_lim,xd_lim,yb_lim);
    anc_x:=x; anc_y:=y;
    AffCursSouris;
   end;
  until BoutonSouris=aucun;
  anc_modif_SCR:=modif[SCR]; modif[SCR]:=TRUE;
 end
 else
  if Readkey=Esc then zone_cachee.Restaure(0,0,0,0)  {annulation}
                 else begin anc_modif_SCR:=modif[SCR]; modif[SCR]:=TRUE end;

 zone_copie.Supprime; zone_cachee.Supprime;
 DefCursSouris(standard,0,0,#0);
 VideBufferClavier;
end; {CopierZone}

{----------------------------------------------------------}

procedure InsererZone;
var nf: String80;
    z: Zone;
    erreur: word;
begin
 if gere_menu then AideEnLigne(select_fichier);
 nf:=SelectionneFichier('Insrer une zone','SCR',hauteur_ecran_txt-11);
 if nf='' then exit;

 repeat
  z.Charge_(nf,erreur);
  if erreur=f_ok then break;
  if MessageErreur(erreur,nf)=alt_annule then break;
 until FALSE;

 if erreur=f_ok then with z do begin
  QuitteMenu;
  SauveEcranActuel(tout);
  CacheCursSouris; CopiePage(0,2); AffCursSouris;
  if yh_>hauteur_ecran_txt then begin dec(yh_,25); dec(yb_,25) end;
  RestaureZoneSuppr(0,z);
  if (yb_-yh_+1)>hauteur_ecran_txt then yb_:=hauteur_ecran_txt; {tronque si a dpasse...}
  CopierZone(xg_,yh_,xd_,yb_);
 end;
 VideBufferClavier;
end; {InsererZone}

{----------------------------------------------------------}

procedure SauverZone;
var nf: String80;
    xg,yh,xd,yb: byte;
    abandon: boolean;
begin
 QuitteMenu;
 CadreSouris(1,xg,yh,xd,yb,7,efface);
 nf:=LitNomFichier(SCR+zone_ecran,abandon);
 if abandon then exit;
 SauveFichierSCR(xg,yh,xd,yb,nf,partiel);
end; {SauverZone}

{----------------------------------------------------------}

procedure SauverLimites;
var nf: String80;
    abandon: boolean;
begin
 nf:=LitNomFichier(SCR+zone_edition,abandon);
 if abandon then exit;
 SauveFichierSCR(xg_lim,yh_lim,xd_lim,yb_lim,nf,partiel);
end; {SauverLimites}

{----------------------------------------------------------}

procedure SauverProjet;
var nf: String80;
    abandon: boolean;
    buffer: format_PRJ;
    f: Fichier;
begin
 if modif[SCR] then SauveFichierSCR(1,1,80,hauteur_ecran_txt,nom_fichier[SCR],nouveau_SCR);
 if modif[PAL] then SauveFichierPAL(not(demande));
 if modif[FNT] then SauveFichierFNT(not(demande));

 nf:=LitNomFichier(PRJ,abandon);
 if abandon then exit;

 FillChar(buffer,sizeof(buffer),0); {pour enlever les caractres parasites...}

 with buffer do begin
  id:=id_PRJ;

  opt:= BYTE(CarteVGA)+
       ((largeur_car and $01) shl 1)+
       (BYTE(zone_limite_max) shl 2)+
       (BYTE(options_oui_non[curseur_suiveur]) shl 3)+
       (BYTE(options_oui_non[conserve_couleurs]) shl 4)+
       (BYTE(options_oui_non[clignote]) shl 5)+
       (BYTE(options_oui_non[intersections]) shl 6);

  with zone_ed do begin xg:=xg_lim; yh:=yh_lim; xd:=xd_lim; yb:=yb_lim end;
  with pos_curs do begin x:=x_curseur; y:=y_curseur end;
  with pos_orig do begin x:=x_origine; y:=y_origine end;

  with coul do begin
   cour:=(couleur[fond] shl 4)+couleur[ecriture];
   rech:=(ancienne[fond] shl 4)+ancienne[ecriture];
   rempl:=(nouvelle[fond] shl 4)+nouvelle[ecriture];
   pal_copie:=(couleur_pal shl 4)+couleur_copie;
  end;

  with car do begin
   memo:=car_memo;
   rech:=car_rech[anc]; rempl:=car_rech[nouv];
   fnt:=car_fnt; copie:=car_copie;
   memoires10:=MemoireCar;
  end;

  with fich do begin
   nom_SCR:=nom_fichier[SCR];
   nom_PAL:=nom_fichier[PAL];
   nom_FNT:=nom_fichier[FNT];
  end
 end;

 with f do begin
  repeat
   Cree(ecrase,nf);
   if f_erreur=f_ok then break;
   if MessageErreur(f_erreur,nf)=alt_annule then break;
  until FALSE;
  if f_erreur=f_ok then begin Ecrit(buffer,sizeof(buffer)); Ferme end;
 end;

 if f_erreur=f_ok then
  begin Init(PRJ,nf,not(modif_projet)); projet_actif:=TRUE end;
 VideBufferClavier;
end; {SauverProjet}

{----------------------------------------------------------}

procedure ChargerProjet;
var nf: String80;
    buffer: format_PRJ;
{    carte_VGA: boolean;}
    f: Fichier;
begin
 if gere_menu then AideEnLigne(select_fichier);
 nf:=SelectionneFichier('Charger un projet','PRJ',hauteur_ecran_txt-11);
 if nf='' then exit;

 if projet_actif then begin
  if (modif[SCR] or modif[PAL] or modif[FNT] or modif[PRJ]) then
   case Confirmation(PRJ) of
    sauve : SauverProjet;
    annule: exit;
   end
 end
 else begin
  if modif[SCR] then
   case Confirmation(SCR) of
    sauve : SauveFichierSCR(1,1,80,hauteur_ecran_txt,nom_fichier[SCR],nouveau_SCR);
    annule: exit;
   end;

  if modif[PAL] then
   case Confirmation(PAL) of
    sauve : SauveFichierPAL(not(demande));
    annule: exit;
   end;

  if modif[FNT] then
   case Confirmation(FNT) of
    sauve : SauveFichierFNT(not(demande));
    annule: exit;
   end;
 end;

 with f do begin
  repeat
   Ouvre(lecture,nf);
   if f_erreur=f_ok then break;
   if MessageErreur(f_erreur,nf)=alt_annule then break;
  until FALSE;
  if f_erreur=f_ok then begin
   if Taille=sizeof(format_PRJ) then Lit(buffer,sizeof(buffer))
                                else buffer.id[1]:=#0; {pour forcer 'Format incorrect'}
   Ferme;
  end;
 end;

 if f_erreur=f_ok then with buffer do
  if id=id_PRJ then begin
{   carte_VGA:=BOOLEAN(opt and $01);}
   largeur_car:=8+((opt shr 1) and $01);
   if CarteVGA then LargeurCar(largeur_car);
   zone_limite_max:=BOOLEAN((opt shr 2) and $01);
   options_oui_non[curseur_suiveur]:=BOOLEAN((opt shr 3) and $01);
   options_oui_non[conserve_couleurs]:=BOOLEAN((opt shr 4) and $01);
   options_oui_non[clignote]:=BOOLEAN((opt shr 5) and $01);
   Clignotement(options_oui_non[clignote]);
   options_oui_non[intersections]:=BOOLEAN((opt shr 6) and $01);

   with zone_ed do begin
    xg_lim:=LimiteEntier(xg,1,largeur_ecran_txt);;
    yh_lim:=LimiteEntier(yh,1,hauteur_ecran_txt);
    xd_lim:=LimiteEntier(xd,xg_lim,largeur_ecran_txt);
    yb_lim:=LimiteEntier(yb,yh_lim,hauteur_ecran_txt);
   end;

   with pos_curs do begin
    x_curseur:=LimiteEntier(x,1,largeur_ecran_txt);
    y_curseur:=LimiteEntier(y,1,hauteur_ecran_txt);
   end;

   with pos_orig do begin
    x_origine:=LimiteEntier(x,1,largeur_ecran_txt);
    y_origine:=LimiteEntier(y,1,hauteur_ecran_txt);
   end;

   with coul do begin
    couleur[fond]:=cour shr 4; couleur[ecriture]:=cour and $0F;
    ancienne[fond]:=rech shr 4; ancienne[ecriture]:=rech and $0F;
    nouvelle[fond]:=rempl shr 4; nouvelle[ecriture]:=rempl and $0F;
    couleur_pal:=pal_copie shr 4; couleur_copie:=pal_copie and $0F;
   end;

   with car do begin
    car_memo:=memo;
    car_rech[anc]:=rech; car_rech[nouv]:=rempl;
    car_fnt:=fnt; car_copie:=copie;
    MemoireCar:=memoires10;
   end;

   with fich do begin
    ChargerEcran(nom_SCR);
    ChargeFichierPAL(nom_PAL);
    ChargeFichierFNT(nom_FNT);
   end;

   Init(PRJ,nf,not(modif_projet)); projet_actif:=TRUE;
  end
  else AfficheErreur('Format incorrect','');

 VideBufferClavier;
end; {ChargerProjet}

{----------------------------------------------------------}

procedure NouveauProjet;
begin
 if projet_actif then begin
  if (modif[SCR] or modif[PAL] or modif[FNT] or modif[PRJ]) then
   case Confirmation(PRJ) of
    sauve : SauverProjet;
    annule: exit;
   end
 end
 else begin
  if modif[SCR] then
   case Confirmation(SCR) of
    sauve : SauveFichierSCR(1,1,80,hauteur_ecran_txt,nom_fichier[SCR],nouveau_SCR);
    annule: exit;
   end;

  if modif[PAL] then
   case Confirmation(PAL) of
    sauve : SauveFichierPAL(not(demande));
    annule: exit;
   end;

  if modif[FNT] then
   case Confirmation(FNT) of
    sauve : SauveFichierFNT(not(demande));
    annule: exit;
   end;
 end;

 QuitteMenu;
 InitNouveauEcran(sans_menu);

 if CarteVGA then begin
  palette_defaut.Fixe;
  Init(PAL,'',not(modif_projet));

  case hauteur_car of
   16: fonte_courante:=@Fonte8x16.fonte;
   14: fonte_courante:=@Fonte8x14.fonte;
   8 : fonte_courante:=@Fonte8x8 .fonte;
  end;
  Move(PointeurTable(courante)^,fonte_courante^,256*hauteur_car);
  RedefFonte(0,fonte_courante^);
  Init(FNT,'',not(modif_projet));
 end;

 Init(PRJ,'',not(modif_projet)); projet_actif:=TRUE;
end; {NouveauProjet}

{----------------------------------------------------------}

procedure Quitter;
begin
 quitte:=TRUE;

 if projet_actif then begin
  if (modif[SCR] or modif[PAL] or modif[FNT] or modif[PRJ]) then
   case Confirmation(PRJ) of
    sauve : SauverProjet;
    annule: begin quitte:=FALSE; exit end;
   end;
 end
 else begin
  if modif[SCR] then
   case Confirmation(SCR) of
    sauve : SauveFichierSCR(1,1,80,hauteur_ecran_txt,nom_fichier[SCR],nouveau_SCR);
    annule: begin quitte:=FALSE; exit end;
   end;

  if modif[PAL] then
   case Confirmation(PAL) of
    sauve : SauveFichierPAL(not(demande));
    annule: begin quitte:=FALSE; exit end;
   end;

  if modif[FNT] then
   case Confirmation(FNT) of
    sauve : SauveFichierFNT(not(demande));
    annule: begin quitte:=FALSE; exit end;
   end;
 end;

 if gere_menu then gere_menu:=not(quitte);
end; {Quitter}

{----------------------------------------------------------}

procedure Annuler;
var aux: boolean;
begin
 CacheCursSouris;
 CopiePage(0,2); AttendVBL; CopiePage(1,0); CopiePage(2,1);
 aux:=anc_modif_SCR; anc_modif_SCR:=modif[SCR]; modif[SCR]:=aux;
end; {Annuler}

{----------------------------------------------------------}

procedure Rectangle;
var xg,yh,xd,yb: byte;
begin
 SauveEcranActuel(tout);
 ZoneSouris(xg_lim,yh_lim,xd_lim,yb_lim);
 CadreSouris(1,xg,yh,xd,yb,(couleur[fond] shl 4)+couleur[fond],efface);
 ZoneSouris(1,1,80,hauteur_ecran_txt);
 CacheCursSouris;
 EffaceZone(0,xg,yh,xd,yb,(couleur[fond] shl 4)+couleur[ecriture]);
 anc_modif_SCR:=modif[SCR]; modif[SCR]:=TRUE;
end; {Rectangle}

{----------------------------------------------------------}

procedure CadreSimpleDouble(epaisseur: byte);
var xg,yh,xd,yb: byte;
begin
 SauveEcranActuel(tout);
 ZoneSouris(xg_lim,yh_lim,xd_lim,yb_lim);
 CadreSouris(epaisseur,xg,yh,xd,yb,(couleur[fond] shl 4)+couleur[ecriture],conserve);
 ZoneSouris(1,1,80,hauteur_ecran_txt);
 CacheCursSouris;
 anc_modif_SCR:=modif[SCR]; modif[SCR]:=TRUE;
end; {CadreSimpleDouble}

{----------------------------------------------------------}

procedure LigneSimpleDouble(epaisseur: byte);
begin
 SauveEcranActuel(tout);
 ZoneSouris(xg_lim,yh_lim,xd_lim,yb_lim);
 LigneSouris(epaisseur,(couleur[fond] shl 4)+couleur[ecriture],conserve);
 ZoneSouris(1,1,80,hauteur_ecran_txt);
 anc_modif_SCR:=modif[SCR]; modif[SCR]:=TRUE;
end; {LigneSimpleDouble}

{----------------------------------------------------------}

procedure DefinirLimites;
begin
 CadreSouris(1,xg_lim,yh_lim,xd_lim,yb_lim,7,efface);
 zone_limite_max:=FALSE;
end; {DefinirLimites}

{----------------------------------------------------------}

procedure VoirLimites;
var z: Zone;
begin
 Curseur(off);
 CacheCursSouris;
 z.Sauve(0,xg_lim,yh_lim,xd_lim,yb_lim);
 AttendVBL;

 asm
  mov AX,0B800h
  mov ES,AX         {ES=B800}

  mov AH,yh_lim
  dec AH
  shr AX,1          {AX=128*(yh_lim-1)}
  mov BX,AX
  shr BX,2
  add AX,BX
  mov DI,AX         {DI=160*(yh_lim-1)}
  xor AH,AH
  mov AL,xg_lim
  dec AL
  shl AX,1
  add DI,AX
  inc DI            {DI=1+2*(xg_lim-1)+160*(yh_lim-1): coin suprieur gauche}

  mov BH,yb_lim
  sub BH,yh_lim
  inc BH            {BH=yb_lim-yh_lim+1: nombre de lignes}

  mov BL,xd_lim
  sub BL,xg_lim
  inc BL            {BL=xd_lim-xg_lim+1: nombre de colonnes}

  mov DX,160
  sub DL,BL
  sub DL,BL         {incrment DI: DX=160-2*(nombre colonnes)}

  cld
 @inverse_ligne:
  mov CH,BL
  @inverse_couleur:
   mov AL,ES:[DI]
   rol AL,4
   and AL,01111111b {pas de fond>7}
   stosb            {inverse couleurs de fond et d'criture}
   inc DI           {saute code ASCII}
   dec CH
   jnz @inverse_couleur
  add DI,DX         {ligne suivante}
  dec BH
  jnz @inverse_ligne
 end;

 AffCursSouris;
 Pause(6);
 AttendVBL;
 RestaureZoneSuppr(0,z);
end; {VoirLimites}

{----------------------------------------------------------}

procedure AfficheBarreCouleurs(coul: type_couleur; x,y,num_coul: byte; aff_coul,active: boolean);

const nom_couleur: array[type_couleur] of string[8]=('  fond  ','criture');
      attr1: array[boolean] of byte=(48  ,48+15);
      attr2: array[boolean] of byte=(48+3,48+15);

var i,c: byte;

begin
 CacheCursSouris;
 EffaceZone(0,x,y-1,x+2*16-1,y-1,48);
 EffaceZone(0,x,y+1,x+2*16-1,y+1,48);
 if aff_coul then AffChXY(0,x-11,y,nom_couleur[coul],48);
 case coul of
  fond    : AffChXY(0,x+2*num_coul,y-1,'',attr1[active]);
  ecriture: AffChXY(0,x+2*num_coul,y+1,'',attr1[active]);
 end;
 AffCarXY(0,x-2,y,'',attr2[active]);
 for i:=0 to 7 do AffChXY(0,x+2*i,y,'',i);
 if (coul=ecriture) or not(options_oui_non[clignote]) then c:=8 else c:=128;
 for i:=8 to 15 do begin AffChXY(0,x+2*i,y,'',c); inc(c) end;
 AffChXY(0,x+2*16+1,y,EntierTexte2(num_coul,2),48+15);
 AffCursSouris;
end; {AfficheBarreCouleurs}

{----------------------------------------------------------}

procedure ChangerAttribut(capture_: boolean);

const largeur=53; hauteur=9; x_milieu=39; y_milieu=12;
      xg=x_milieu-(largeur div 2); xd=xg+largeur-1;
      yh=y_milieu-(hauteur div 2); yb=yh+hauteur-1;

var z: Zone;
    x,y: byte;
    temp: array[type_couleur] of byte;
    choix_couleur: type_couleur;
    ok: boolean;
    boutonOK,boutonAnnuler: Bouton;

begin
 Curseur(off);
 if gere_menu then AideEnLigne(select_couleur);
 CacheCursSouris;
 z.Ombre(0,xg,yh,xd,yb,48);
 Cadre(0,1,xg,yh,xd,yb,48+1,' Changer attribut ',112,'');
 temp[fond]:=couleur[fond]; temp[ecriture]:=couleur[ecriture];
 choix_couleur:=fond;
 AfficheBoutonsOKAnnuler(x_milieu-9,yb-2,boutonOK,boutonAnnuler);

 ok:=FALSE;
 repeat
  AffCursSouris;
  AfficheBarreCouleurs(fond,    xg+14,yh+2,temp[fond],    aff_nom_coul,(choix_couleur=fond));
  AfficheBarreCouleurs(ecriture,xg+14,yh+4,temp[ecriture],aff_nom_coul,(choix_couleur=ecriture));
  CacheCursSouris;
  AffChXY(0,xd-5,yh+3,' X ',(temp[fond] shl 4)+temp[ecriture]);

  if capture_ then begin AffCursSouris; Pause(9); break end;

  AttendClavierSouris(TRUE,FALSE,x,y);
  if KeyPressed then
   case ReadKey of
    Left : temp[choix_couleur]:=(temp[choix_couleur]+15) mod 16;
    Right: temp[choix_couleur]:=(temp[choix_couleur]+ 1) mod 16;
    Up   : choix_couleur:=fond;
    Down : choix_couleur:=ecriture;
    Enter: ok:=TRUE;
    Esc: break;
   end
  else begin
   if (x in [xg+14..xg+45]) then
    case y of
     yh+2: begin choix_couleur:=fond;     temp[fond]    :=((x-xg-14) shr 1) end;
     yh+4: begin choix_couleur:=ecriture; temp[ecriture]:=((x-xg-14) shr 1) end;
    end;
   ok:=boutonOK.Clique;
   if boutonAnnuler.Clique then break;
  end;
 until ok;
 RestaureZoneSuppr(0,z);

 if ok then begin
  couleur[fond]:=temp[fond]; couleur[ecriture]:=temp[ecriture];
  QuitteMenu;
 end;
end; {ChangerAttribut}

{----------------------------------------------------------}

procedure RemplacerEchangerCouleur(echange: boolean; coul: type_couleur);

const largeur=44; hauteur=11; x_milieu=39; y_milieu=12;
      xg=x_milieu-(largeur div 2); xd=xg+largeur-1;
      yh=y_milieu-(hauteur div 2); yb=yh+hauteur-1;

      nom_couleur: array[type_couleur] of string[10]=('de fond','d''criture');

var z: Zone;
    x,y,anc_coul,nouv_coul: byte;
    temp: array[type_anc_nouv] of byte;
    choix: type_anc_nouv;
    ok,changement: boolean;
    boutonOK,boutonAnnuler: Bouton;

begin
 AideEnLigne(select_couleur);
 CacheCursSouris;
 z.Ombre(0,xg,yh,xd,yb,48);
 Cadre(0,1,xg,yh,xd,yb,48+1,' '+titre[echange]+' couleur '+nom_couleur[coul]+' ',112,'');
 AffChXY(0,xg+3,yh+4,titre[echange]+' '+prep[echange],48+15);
 temp[anc]:=ancienne[coul]; temp[nouv]:=nouvelle[coul];
 choix:=anc;
 AfficheBoutonsOKAnnuler(x_milieu-9,yb-2,boutonOK,boutonAnnuler);

 ok:=FALSE;
 repeat
  AffCursSouris;
  AfficheBarreCouleurs(coul,xg+6,yh+2,temp[anc ],not(aff_nom_coul),(choix=anc ));
  AfficheBarreCouleurs(coul,xg+6,yh+6,temp[nouv],not(aff_nom_coul),(choix=nouv));

  AttendClavierSouris(TRUE,FALSE,x,y);
  if KeyPressed then
   case ReadKey of
    Left : temp[choix]:=(temp[choix]+15) mod 16;
    Right: temp[choix]:=(temp[choix]+ 1) mod 16;
    Up   : choix:=anc;
    Down : choix:=nouv;
    Enter: ok:=TRUE;
    Esc: break;
   end
  else begin
   if (x in [xg+6..xg+37]) then
    case y of
     yh+2: begin choix:= anc; temp[anc ]:=((x-xg-6) shr 1) end;
     yh+6: begin choix:=nouv; temp[nouv]:=((x-xg-6) shr 1) end;
    end;
   ok:=boutonOK.Clique;
   if boutonAnnuler.Clique then break;
  end;
 until ok;
 RestaureZoneSuppr(0,z);

 if ok then begin
  QuitteMenu;
  SauveEcranActuel(tout);
  CacheCursSouris;
  ancienne[coul]:=temp[anc]; nouvelle[coul]:=temp[nouv];
  anc_coul:=ancienne[coul]; nouv_coul:=nouvelle[coul];
  if coul=fond then
   begin anc_coul:=anc_coul shl 4; nouv_coul:=nouv_coul shl 4 end;

  changement:=FALSE;
  asm
   mov AX,0B800h
   mov ES,AX         {ES=B800}

   mov AH,yh_lim
   dec AH
   shr AX,1          {AX=128*(yh_lim-1)}
   mov BX,AX
   shr BX,2
   add AX,BX
   mov DI,AX         {DI=160*(yh_lim-1)}
   xor AH,AH
   mov AL,xg_lim
   dec AL
   shl AX,1
   add DI,AX
   inc DI            {DI=1+2*(xg_lim-1)+160*(yh_lim-1): coin suprieur gauche}

   mov BH,yb_lim
   sub BH,yh_lim
   inc BH            {BH=yb_lim-yh_lim+1: nombre de lignes}

   mov BL,xd_lim
   sub BL,xg_lim
   inc BL            {BL=xd_lim-xg_lim+1: nombre de colonnes}

   mov DX,160
   sub DL,BL
   sub DL,BL         {incrment DI: DX=160-2*(nombre colonnes)}

   mov CL,11110000b  {masque pour la couleur de fond}

   cmp coul,fond
   je @boucle_ligne
   not CL            {inverse le masque pour la couleur d'criture}

  @boucle_ligne:
   mov CH,BL
   @boucle_colonne:
    mov AL,ES:[DI]
    mov AH,AL
    and AH,CL        {conserve fond ou criture}
    cmp AH,anc_coul
    jne @pas_anc_coul
    mov AH,nouv_coul
    jmp @ecrit_couleur
   @pas_anc_coul:
    cmp echange,TRUE
    jne @suite
    cmp AH,nouv_coul
    jne @suite
    mov AH,anc_coul
   @ecrit_couleur:
    not CL
    and AL,CL        {conserve criture ou fond}
    not CL
    or  AL,AH        {ajoute fond ou criture}
    mov ES:[DI],AL
    mov changement,TRUE
   @suite:
    inc DI
    inc DI           {saute code ASCII}
    dec CH
    jnz @boucle_colonne
   add DI,DX         {ligne suivante}
   dec BH
   jnz @boucle_ligne
  end;
  if changement then
   begin anc_modif_SCR:=modif[SCR]; modif[SCR]:=TRUE end;
 end;
end; {RemplacerEchangerCouleur}

{----------------------------------------------------------}

procedure RemplacerEchangerAttribut(echange: boolean);

const largeur=53; hauteur=15; x_milieu=39; y_milieu=12;
      xg=x_milieu-(largeur div 2); xd=xg+largeur-1;
      yh=y_milieu-(hauteur div 2); yb=yh+hauteur-1;

var z: Zone;
    x,y,anc_attr,nouv_attr: byte;
    temp: array[type_anc_nouv,type_couleur] of byte;
    choix_couleur: type_couleur;
    choix: type_anc_nouv;
    ok,changement: boolean;
    boutonOK,boutonAnnuler: Bouton;

begin
 AideEnLigne(select_couleur);
 CacheCursSouris;
 z.Ombre(0,xg,yh,xd,yb,48);
 Cadre(0,1,xg,yh,xd,yb,48+1,' '+titre[echange]+' attribut ',112,'');
 AffChXY(0,xg+5,yh+6,titre[echange]+' '+prep[echange],48+15);
 temp[anc, fond]:=ancienne[fond]; temp[anc, ecriture]:=ancienne[ecriture];
 temp[nouv,fond]:=nouvelle[fond]; temp[nouv,ecriture]:=nouvelle[ecriture];
 choix_couleur:=fond;
 choix:=anc;
 AfficheBoutonsOKAnnuler(x_milieu-9,yb-2,boutonOK,boutonAnnuler);

 ok:=FALSE;
 repeat
  AffCursSouris;
  AfficheBarreCouleurs(fond,    xg+14,yh+2 ,temp[anc, fond],    aff_nom_coul,(choix= anc) and (choix_couleur=fond));
  AfficheBarreCouleurs(ecriture,xg+14,yh+4 ,temp[anc, ecriture],aff_nom_coul,(choix= anc) and (choix_couleur=ecriture));
  AfficheBarreCouleurs(fond,    xg+14,yh+8 ,temp[nouv,fond],    aff_nom_coul,(choix=nouv) and (choix_couleur=fond));
  AfficheBarreCouleurs(ecriture,xg+14,yh+10,temp[nouv,ecriture],aff_nom_coul,(choix=nouv) and (choix_couleur=ecriture));
  CacheCursSouris;
  AffChXY(0,xd-5,yh+3,' X ',(temp[anc ,fond] shl 4)+temp[anc ,ecriture]);
  AffChXY(0,xd-5,yh+9,' X ',(temp[nouv,fond] shl 4)+temp[nouv,ecriture]);

  AttendClavierSouris(TRUE,FALSE,x,y);
  if KeyPressed then
   case ReadKey of
    Left : temp[choix,choix_couleur]:=(temp[choix,choix_couleur]+15) mod 16;
    Right: temp[choix,choix_couleur]:=(temp[choix,choix_couleur]+ 1) mod 16;
    Up   : case choix of
            anc : choix_couleur:=fond;
            nouv: if choix_couleur=ecriture then choix_couleur:=fond
                  else begin choix:=anc; choix_couleur:=ecriture end;
           end;
    Down : case choix of
            anc : if choix_couleur=fond then choix_couleur:=ecriture
                  else begin choix:=nouv; choix_couleur:=fond end;
            nouv: choix_couleur:=ecriture;
           end;
    Enter: ok:=TRUE;
    Esc: break;
   end
  else begin
   if (x in [xg+14..xg+45]) then
    case y of
     yh+2 : begin choix:= anc; choix_couleur:=fond;     temp[anc, fond]    :=((x-xg-14) shr 1) end;
     yh+4 : begin choix:= anc; choix_couleur:=ecriture; temp[anc, ecriture]:=((x-xg-14) shr 1) end;
     yh+8 : begin choix:=nouv; choix_couleur:=fond;     temp[nouv,fond]    :=((x-xg-14) shr 1) end;
     yh+10: begin choix:=nouv; choix_couleur:=ecriture; temp[nouv,ecriture]:=((x-xg-14) shr 1) end;
    end;
   ok:=boutonOK.Clique;
   if boutonAnnuler.Clique then break;
  end;
 until ok;
 RestaureZoneSuppr(0,z);

 if ok then begin
  QuitteMenu;
  SauveEcranActuel(tout);
  CacheCursSouris;
  ancienne[fond]:=temp[anc, fond]; ancienne[ecriture]:=temp[anc, ecriture];
  nouvelle[fond]:=temp[nouv,fond]; nouvelle[ecriture]:=temp[nouv,ecriture];
  anc_attr :=(ancienne[fond] shl 4)+ancienne[ecriture];
  nouv_attr:=(nouvelle[fond] shl 4)+nouvelle[ecriture];

  changement:=FALSE;
  asm
   mov AX,0B800h
   mov ES,AX         {ES=B800}

   mov AH,yh_lim
   dec AH
   shr AX,1          {AX=128*(yh_lim-1)}
   mov BX,AX
   shr BX,2
   add AX,BX
   mov DI,AX         {DI=160*(yh_lim-1)}
   xor AH,AH
   mov AL,xg_lim
   dec AL
   shl AX,1
   add DI,AX
   inc DI            {DI=1+2*(xg_lim-1)+160*(yh_lim-1): coin suprieur gauche}

   mov BH,yb_lim
   sub BH,yh_lim
   inc BH            {BH=yb_lim-yh_lim+1: nombre de lignes}

   mov BL,xd_lim
   sub BL,xg_lim
   inc BL            {BL=xd_lim-xg_lim+1: nombre de colonnes}

   mov DX,160
   sub DL,BL
   sub DL,BL         {incrment DI: DX=160-2*(nombre colonnes)}

  @boucle_ligne:
   mov CH,BL
   @boucle_colonne:
    mov AL,ES:[DI]
    cmp AL,anc_attr
    jne @pas_anc_attr
    mov AL,nouv_attr
    jmp @ecrit_couleur
   @pas_anc_attr:
    cmp echange,TRUE
    jne @suite
    cmp AL,nouv_attr
    jne @suite
    mov AL,anc_attr
   @ecrit_couleur:
    mov ES:[DI],AL
    mov changement,TRUE
   @suite:
    inc DI
    inc DI           {saute code ASCII}
    dec CH
    jnz @boucle_colonne
   add DI,DX         {ligne suivante}
   dec BH
   jnz @boucle_ligne
  end;
  if changement then
   begin anc_modif_SCR:=modif[SCR]; modif[SCR]:=TRUE end;
 end
end; {RemplacerEchangerAttribut}

{----------------------------------------------------------}

procedure RemplitZone(x,y,couleur: byte; mode: type_couleur; xg,yh,xd,yb: byte); assembler;
{x=1..80, y=1..hauteur_ecran_txt, couleur=0..15, mode=fond ou criture}
var couleur_a_remplir,couleur_remplissage: byte;
asm
 mov AL,couleur
 mov BL,00001111b  {masque couleur d'criture}
 mov BH,11110000b  {masque couleur de fond}
 cmp mode,ecriture
 je  @init_coul
 shl AL,4          {si mode=fond, couleur_remplissage=16*couleur}
 xchg BL,BH
@init_coul:
 mov couleur_remplissage,AL

 mov AX,0B800h
 mov ES,AX

 mov AH,y
 dec AH
 shr AX,1          {AX=128*(y-1)}
 mov DI,AX
 shr DI,2
 add DI,AX         {DI=160*(y-1)}
 xor AH,AH
 mov AL,x
 dec AL
 shl AX,1
 add DI,AX
 inc DI            {DI=1+2*(x-1)+160*(y-1)}

 mov AL,ES:[DI]
 and AL,BL
 mov couleur_a_remplir,AL
 cmp couleur_remplissage,AL
 je  @fin_remplit  {pas de remplissage si couleurs identiques}

 mov AL,xg
 dec AL
 mov BYTE ptr CS:[@test_gauche+2],AL
 mov AL,xd
 dec AL
 mov BYTE ptr CS:[@test_droite+2],AL
 mov AL,yh
 dec AL
 mov BYTE ptr CS:[@test_haut+2],AL
 mov AL,yb
 dec AL
 mov BYTE ptr CS:[@test_bas+2],AL

 mov DH,y
 dec DH
 mov DL,x
 dec DL            {DX=(yx)}
 call @Remplissage

 jmp @fin_remplit

{Remplissage: procdure rcursive appele par RemplitZone
 entre: DX=(yx)
 x=0..79, y=0..hauteur_ecran_txt-1}
@Remplissage:

 xor AL,AL
 mov AH,DH
 shr AX,1          {AX=128*y}
 mov DI,AX
 shr DI,2
 add DI,AX         {DI=160*y}
 xor AH,AH
 mov AL,DL
 shl AX,1
 add DI,AX
 inc DI            {DI=1+2*x+160*y}

 mov AL,ES:[DI]
 and AL,BH         {masque la couleur}
 or AL,couleur_remplissage
 mov ES:[DI],AL    {remplace la couleur}

@test_gauche:
 cmp DL,12h        {x>xg?}
 jna @test_droite
 mov AL,ES:[DI-2*1]
 and AL,BL
 cmp AL,couleur_a_remplir
 jne @test_droite
 push DI; push DX
 dec DL
 call @Remplissage {teste (x-1,y)}
 pop DX; pop DI

@test_droite:
 cmp DL,12h        {x<xd?}
 jnb @test_haut
 mov AL,ES:[DI+2*1]
 and AL,BL
 cmp AL,couleur_a_remplir
 jne @test_haut
 push DI; push DX
 inc DL
 call @Remplissage {teste (x+1,y)}
 pop DX; pop DI

@test_haut:
 cmp DH,12h        {y>yh?}
 jna @test_bas
 mov AL,ES:[DI-2*80]
 and AL,BL
 cmp AL,couleur_a_remplir
 jne @test_bas
 push DI; push DX
 dec DH
 call @Remplissage {teste (x,y-1)}
 pop DX; pop DI

@test_bas:
 cmp DH,12h        {y<yb?}
 jnb @fin_test
 mov AL,ES:[DI+2*80]
 and AL,BL
 cmp AL,couleur_a_remplir
 jne @fin_test
 push DI; push DX
 inc DH
 call @Remplissage {teste (x,y+1)}
 pop DX; pop DI

@fin_test:
 retn

@fin_remplit:
end; {RemplitZone}

{----------------------------------------------------------}

procedure RemplirZone(mode: type_couleur);
begin
 QuitteMenu;
 SauveEcranActuel(tout);
 ZoneSouris(xg_lim,yh_lim,xd_lim,yb_lim);
 DefCursSouris(inverse_attribut,0,0,CHAR(31-BYTE(mode)));
 repeat until (BoutonSouris=gauche) or KeyPressed;
 if not(KeyPressed) then begin
  CacheCursSouris;
  RemplitZone(Xsouris,Ysouris,couleur[mode],mode,xg_lim,yh_lim,xd_lim,yb_lim);
  AffCursSouris;
  DefCursSouris(standard,0,0,#0);
  repeat until BoutonSouris=aucun;
  anc_modif_SCR:=modif[SCR]; modif[SCR]:=TRUE;
 end;
 ZoneSouris(1,1,80,hauteur_ecran_txt);
end; {RemplirZone}

{----------------------------------------------------------}

procedure AfficheLigneCaracteres(x,y,code_car: byte; active: boolean; x_code,y_code,attr_code: byte);

const attr: array[1..2,boolean] of byte=((48,48+14),(48,48+15));
var i: shortint;

begin
 CacheCursSouris;
 AffCarXY(0,x-2 ,y  ,'',attr[1,active]); AffCarXY(0,x+29,y  ,'',attr[1,active]);
 AffCarXY(0,x+14,y-1,'',attr[2,active]); AffCarXY(0,x+14,y+1,'',attr[2,active]);
 for i:=-14 to 13 do AffCarXY(0,x+14+i,y,CHAR(code_car+i),48+1);
 AffCarXY(0,x+14,y,CHAR(code_car),15);
 AffChXY(0,x_code,y_code,EntierTexte2(code_car,3)+' ('+EntierHexa(code_car,2)+'h)',attr_code);
 AffCursSouris;
end; {AfficheLigneCaracteres}

{----------------------------------------------------------}

procedure RemplacerEchangerCaractere(echange: boolean);

const largeur=48; hauteur=11; x_milieu=39; y_milieu=12;
      xg=x_milieu-(largeur div 2); xd=xg+largeur-1;
      yh=y_milieu-(hauteur div 2); yb=yh+hauteur-1;

var z: Zone;
    x,y,anc_car,nouv_car: byte;
    temp: array[type_anc_nouv] of byte;
    touche: Key;
    choix: type_anc_nouv;
    ok,attend_bouge,changement: boolean;
    boutonOK,boutonAnnuler: Bouton;

begin
 AideEnLigne(select_caractere);
 CacheCursSouris;
 z.Ombre(0,xg,yh,xd,yb,48);
 Cadre(0,1,xg,yh,xd,yb,48+1,' '+titre[echange]+' caractre ',112,'');
 AffChXY(0,xg+3,yh+4,titre[echange]+' '+prep[echange],48+15);
 temp[anc]:=Ord(car_rech[anc]); temp[nouv]:=Ord(car_rech[nouv]);
 choix:=anc;
 AfficheBoutonsOKAnnuler(x_milieu-9,yb-2,boutonOK,boutonAnnuler);

 ok:=FALSE; attend_bouge:=TRUE;
 repeat
  AffCursSouris;
  AfficheLigneCaracteres(xg+5,yh+2,temp[anc ],(choix=anc ),xd-11,yh+2,48+11);
  AfficheLigneCaracteres(xg+5,yh+6,temp[nouv],(choix=nouv),xd-11,yh+6,48+11);

  AttendClavierSouris(attend_bouge,FALSE,x,y);
  if KeyPressed then begin
   touche:=ReadKey;
   case touche of
    Left : dec(temp[choix]);
    Right: inc(temp[choix]);
    Up   : choix:=anc;
    Down : choix:=nouv;
    Alt1..Alt0: temp[choix]:=Ord(MemoireCar[ChiffreAlt[touche]]);
    Enter: ok:=TRUE;
    Esc: break;
    else temp[choix]:=BYTE(touche);
   end;
  end
  else begin
   attend_bouge:=TRUE;
   if (x in [xg+3,xg+5..xg+32,xg+34]) and (y in [yh+2,yh+6]) then begin
    case y of
     yh+2: choix:=anc;
     yh+6: choix:=nouv;
    end;
    case x of
     xg+3 : begin dec(temp[choix]); DelaiBoutonSouris(10); attend_bouge:=FALSE end;
     xg+34: begin inc(temp[choix]); DelaiBoutonSouris(10); attend_bouge:=FALSE end;
     xg+5..xg+32: begin inc(temp[choix],x-xg-19); BougeCursSourisXY(xg+19,y) end;
    end;
   end;
   ok:=boutonOK.Clique;
   if boutonAnnuler.Clique then break;
  end;
 until ok;
 RestaureZoneSuppr(0,z);

 if ok then begin
  QuitteMenu;
  SauveEcranActuel(tout);
  CacheCursSouris;
  car_rech[anc]:=temp[anc]; car_rech[nouv]:=temp[nouv];
  anc_car:=car_rech[anc]; nouv_car:=car_rech[nouv];

  changement:=FALSE;
  asm
   mov AX,0B800h
   mov ES,AX         {ES=B800}

   mov AH,yh_lim
   dec AH
   shr AX,1          {AX=128*(yh_lim-1)}
   mov BX,AX
   shr BX,2
   add AX,BX
   mov DI,AX         {DI=160*(yh_lim-1)}
   xor AH,AH
   mov AL,xg_lim
   dec AL
   shl AX,1
   add DI,AX         {DI=2*(xg_lim-1)+160*(yh_lim-1): coin suprieur gauche}

   mov BH,yb_lim
   sub BH,yh_lim
   inc BH            {BH=yb_lim-yh_lim+1: nombre de lignes}

   mov BL,xd_lim
   sub BL,xg_lim
   inc BL            {BL=xd_lim-xg_lim+1: nombre de colonnes}

   mov DX,160
   sub DL,BL
   sub DL,BL         {incrment DI: DX=160-2*(nombre colonnes)}

  @boucle_ligne:
   mov CH,BL
   @boucle_colonne:
    mov AL,ES:[DI]
    cmp AL,anc_car
    jne @pas_anc_car
    mov AL,nouv_car
    jmp @ecrit_caractere
   @pas_anc_car:
    cmp echange,TRUE
    jne @suite
    cmp AL,nouv_car
    jne @suite
    mov AL,anc_car
   @ecrit_caractere:
    mov ES:[DI],AL
    mov changement,TRUE
   @suite:
    inc DI
    inc DI           {saute attribut}
    dec CH
    jnz @boucle_colonne
   add DI,DX         {ligne suivante}
   dec BH
   jnz @boucle_ligne
  end;
  if changement then
   begin anc_modif_SCR:=modif[SCR]; modif[SCR]:=TRUE end;
 end;
end; {RemplacerEchangerCaractere}

{----------------------------------------------------------}

procedure MemoriseCaractere;

const largeur=52; hauteur=18; x_milieu=39; y_milieu=12;
      xg=x_milieu-(largeur div 2); xd=xg+largeur-1;
      yh=y_milieu-(hauteur div 2); yb=yh+hauteur-1;

var z: Zone;
    touche: Key;
    col,lig,anc_col,anc_lig,i,j: byte;
    boutonOK: Bouton;
    ok: boolean;


procedure AfficheMemoires;
var m: byte;
begin
 CacheCursSouris;
 for m:=0 to 9 do
  AffChXY(0,xg+38,m+yh+4,' Alt+'+CHAR(48+m)+': '+MemoireCar[m]+' ',112);
 AffCursSouris;
end; {AfficheMemoires}


begin {MemoriseCaractere}
 Curseur(off);
 if gere_menu then AideEnLigne('Slectionnez le caractre avec '#27#26', 09 pour mmoriser');
 CacheCursSouris;
 z.Ombre(0,xg,yh,xd,yb,48);
 Cadre(0,1,xg,yh,xd,yb,48+1,' Mmoriser un caractre ',112,'');
 for i:=0 to 15 do
  for j:=0 to 15 do AffCarXY(0,2*i+xg+4,j+yh+1,CHAR(16*i+j),48+1);
 boutonOK.Definit(0,xd-10,yb-2,' OK ',112+1,112+3,0,128);
 AffCursSouris; boutonOK.Affiche;
 AfficheMemoires;
 col:=car_memo div 16; lig:=car_memo mod 16;
 anc_col:=col; anc_lig:=lig;

 ok:=FALSE;
 repeat
  CacheCursSouris;
  AffCarXY(0,2*anc_col+xg+4,anc_lig+yh+1,CHAR(16*anc_col+anc_lig),48+1);
  AffCarXY(0,2*col+xg+4,lig+yh+1,CHAR(16*col+lig),48+14);
  AffChXY(0,xd-13,yh+2,EntierTexte2(16*col+lig,3)+'  ('+EntierHexa(16*col+lig,2)+'h)',48+15);
  anc_col:=col; anc_lig:=lig;

  AttendClavierSouris(TRUE,FALSE,i,j);
  if KeyPressed then begin
   touche:=ReadKey;
   case touche of
    Left : col:=(col+15) mod 16;
    Right: col:=(col+1 ) mod 16;
    Up   : lig:=(lig+15) mod 16;
    Down : lig:=(lig+1 ) mod 16;
    Home : col:=0;
    End_ : col:=15;
    PgUp : lig:=0;
    PgDn : lig:=15;
    Key('0')..Key('9'): begin
                         MemoireCar[touche-48]:=CHAR(16*col+lig);
                         AfficheMemoires;
                        end;
    Enter: ok:=TRUE;
    Esc: break;
   end;
  end
  else begin
   if (i in [xg+4..xg+34]) and (j in [yh+1..yh+16]) then begin col:=(i-xg-4) shr 1; lig:=j-yh-1 end;
   if (i in [xg+38..xg+47]) and (j in [yh+4..yh+13]) then begin
    MemoireCar[j-yh-4]:=CHAR(16*col+lig); AfficheMemoires;
   end;
   ok:=boutonOK.Clique;
  end;
 until ok;
 car_memo:=16*col+lig;

 RestaureZoneSuppr(0,z);
 if ok then QuitteMenu;
end; {MemoriseCaractere}

{----------------------------------------------------------}

procedure RedefPalette; {VGA seulement}

const largeur=46; hauteur=19; x_milieu=39; y_milieu=12;
      xg=x_milieu-(largeur div 2); xd=xg+largeur-1;
      yh=y_milieu-(hauteur div 2); yb=yh+hauteur-1;

      car: array[boolean] of char=(' ','*');

var z: Zone;
    boutonOK,boutonDefaut,boutonCharge,boutonSauve: Bouton;
    ok,change_couleur: boolean;
    i,j: byte;
    comp: RVB;

begin
 if not(CarteVGA) then exit;

 Curseur(off);
 CacheCursSouris;
 z.Ombre(0,xg,yh,xd,yb,48);
 Cadre(0,1,xg,yh,xd,yb,48+1,' Redfinir la palette ',112,'');
 EffaceZone(0,xg+4,yh+2,xg+13,yb-1,0);
 AffChXY(0,xg+4,yh+1,'',3);
 for i:=0 to 1 do
  for j:=0 to 7 do begin
   AffChXY(0,xg+5+5*i,yh+2+2*j,'',8*i+j);
   AffChXY(0,xg+5+5*i,yh+3+2*j,'',8*i+j);
  end;
 EffaceZone(0,xg+19,yh+2,xg+38,yh+7,0);
 AffChXY(0,xg+18,yh+12,'Intensit ',48);
 AffChXY(0,xg+33,yh+9 ,' Copier ',112+10);
 AffChXY(0,xg+33,yh+12,' Coller ',112+10);
 Cadre(0,1,xg+16,yh+8,xd-3,yb-5,48,'',48,'');
 LigneVerticale(0,1,xg+31,yh+9,yh+12,48);
 AffCarXY(0,xg+31,yh+8,'',48); AffCarXY(0,xg+31,yh+13,'',48);

 boutonCharge.Definit(0,x_milieu-3,yb-4,' Charge ',112+15,112+14,0,128);
 boutonSauve. Definit(0,x_milieu+9,yb-4,' Sauve ',112+15,112+14,0,128);
 boutonOK.Definit(0,x_milieu-1,yb-2,' OK ',112+1,112+3,0,128);
 boutonDefaut.Definit(0,x_milieu+7,yb-2,' Dfaut ',112,112+8,0,128);
 boutonOK.Affiche; boutonDefaut.Affiche;
 boutonCharge.Affiche; boutonSauve.Affiche;
 AffCursSouris;

 ok:=FALSE; change_couleur:=FALSE;
 repeat
  if gere_menu then AideEnLigne(CopyL(select_couleur,34));
  CacheCursSouris;
  AttendVBL;
  for i:=0 to 3 do AffChXY(0,xg+21,yh+3+i,RepeteCar('',16),couleur_pal);
  EffaceZone(0,xg+8,yh+2,xg+9,yb-2,0);
  AffCarXY(0,xg+8+(couleur_pal div 8),yh+2+2*(couleur_pal mod 8),CHAR(17-(couleur_pal div 8)),15);
  AffChXY(0,xd-5,yh+2,EntierTexte2(couleur_pal,2),48+15);
  ChargeDAC(couleur_pal,comp);
  with comp do begin
   AffChXY2(0,xg+18,yh+9 ,'Rouge   ^'+EntierTexte2(R,2),48,48+8);
   AffChXY2(0,xg+18,yh+10,'Vert    ^'+EntierTexte2(V,2),48,48+8);
   AffChXY2(0,xg+18,yh+11,'Bleu    ^'+EntierTexte2(B,2),48,48+8);
  end;
  AffChXY(0,xg+33,yh+10,'',16*3+couleur_copie);
  AffChXY(0,xg+33,yh+11,'',16*3+couleur_copie);
  AffChXY(0,xg+39,yh+10,EntierTexte2(couleur_copie,2),48);
  AffCarXY(0,xd-5,yb-4,car[modif[PAL]],48+14);

  AttendClavierSouris(not change_couleur,FALSE,i,j);
  if change_couleur then DelaiBoutonSouris(10);
  change_couleur:=FALSE;

  if KeyPressed then
   case ReadKey of
    Left : if couleur_pal>=8 then dec(couleur_pal,8);
    Right: if couleur_pal<=7 then inc(couleur_pal,8);
    Up   : if (couleur_pal mod 8)>0 then dec(couleur_pal);
    Down : if (couleur_pal mod 8)<7 then inc(couleur_pal);
    Enter: ok:=TRUE;
    Esc: break;
   end
  else begin
   ok:=boutonOK.Clique;

   if boutonDefaut.Clique then begin
    palette_defaut.Fixe;
    Init(PAL,'',modif_projet);
   end;

   if boutonCharge.Clique then ChargeFichierPAL('');

   if boutonSauve.Clique then SauveFichierPAL(demande)
   else begin
    if j in [yh+2..yh+17] then
     case i of
      xg+5 ..xg+7 : couleur_pal:=(j-yh-2) div 2;
      xg+10..xg+12: couleur_pal:=8+((j-yh-2) div 2);
     end;

    if (i in [xg+25..xg+26]) and (j in [yh+9..yh+11]) then with comp do begin
     case i of
      xg+25: case j of
              yh+9 : if R>0 then dec(R);
              yh+10: if V>0 then dec(V);
              yh+11: if B>0 then dec(B);
             end;
      xg+26: case j of
              yh+9 : if R<63 then inc(R);
              yh+10: if V<63 then inc(V);
              yh+11: if B<63 then inc(B);
             end;
     end;
     FixeDAC(couleur_pal,comp);
     change_couleur:=TRUE; modif[PAL]:=TRUE;
    end;

    if (i in [xg+28..xg+29]) and (j=yh+12) then with comp do begin
     case i of
      xg+28: begin
              if R>0 then dec(R);
              if V>0 then dec(V);
              if B>0 then dec(B);
             end;
      xg+29: begin
              if R<63 then inc(R);
              if V<63 then inc(V);
              if B<63 then inc(B);
             end;
     end;
     FixeDAC(couleur_pal,comp);
     change_couleur:=TRUE; modif[PAL]:=TRUE;
    end;

    if (i in [xg+33..xg+40]) then
     case j of
      yh+9: couleur_copie:=couleur_pal;
      yh+12: begin
              ChargeDAC(couleur_copie,comp);
              FixeDAC(couleur_pal,comp);
              modif[PAL]:=TRUE;
             end;
     end;
   end;
  end;
 until ok;

 RestaureZoneSuppr(0,z);
 if ok then QuitteMenu;
end; {RedefPalette}

{----------------------------------------------------------}

procedure RedefCaracteres; {VGA seulement}

const largeur=60; hauteur=20; x_milieu=39; y_milieu=13;
      xg=x_milieu-(largeur div 2); xd=xg+largeur-1;
      yh=y_milieu-(hauteur div 2); yb=yh+hauteur-1;

      car: array[boolean] of char=(' ','*');

var z: Zone;
    boutonOK,boutonDefaut,boutonCharge,boutonSauve: Bouton;
    ok,attend_bouge: boolean;
    i,j,k,largeur_point: byte;
    touche: Key;


procedure Echange(var i,j: byte);
var aux: byte;
begin
 aux:=i; i:=j; j:=aux;
end; {Echange}


procedure InverseBits(var i: byte); assembler;
asm
 les DI,i
 mov AL,ES:[DI]
 xor BL,BL
 mov CX,8
@inverse:
 rol AL,1
 mov AH,AL
 and AH,00000001b
 or  BL,AH         {bit 0 de BL=bit 0 de AL}
 ror BL,1
 loop @inverse
 mov ES:[DI],BL
end; {InverseBits}


procedure MiroirBitsGauche(var i: byte); assembler;
asm
 les DI,i
 mov AL,ES:[DI]
 xor BL,BL
 mov CX,4
@miroir:
 rol BL,1
 mov AH,AL
 and AH,00000001b
 or  BL,AH         {bit 0 de BL=bit 0 de AL}
 ror AL,1
 loop @miroir
 shr AL,4          {rcupre les 4 bits faibles de i}
 shl BL,4          {miroir de ces 4 bits}
 or  BL,AL
 mov ES:[DI],BL
end; {MiroirBitsGauche}


procedure MiroirBitsDroite(var i: byte); assembler;
asm
 les DI,i
 mov AL,ES:[DI]
 xor BL,BL
 mov CX,4
@miroir:
 rol AL,1
 mov AH,AL
 and AH,00000001b
 or  BL,AH         {bit 0 de BL=bit 0 de AL}
 ror BL,1
 loop @miroir
 shl AL,4          {rcupre les 4 bits forts de i}
 shr BL,4          {miroir de ces 4 bits}
 or  BL,AL
 mov ES:[DI],BL
end; {MiroirBitsDroite}


procedure AffMatriceCar(pointeur: pointer; x,y,caractere: byte);
const car: array[boolean] of char=(' ','');
      couleur: array[boolean] of byte=(15,7);
var i,j,code,masque: byte;
begin
 for i:=1 to hauteur_car do begin
  code:=BytePtr(AddPtr(pointeur,(i-1)+caractere*hauteur_car))^;
  masque:=$80;
  for j:=1 to 8 do begin
   AffChXY(0,x+largeur_point*(j-1),y+i-1,
             RepeteCar(car[(code and masque)=masque],largeur_point),couleur[Odd(i+j)]);
   masque:=masque shr 1;
  end;
 end;
end; {AffMatriceCar}


procedure RedefCarCourant;
begin
 case hauteur_car of
  16: RedefCar(0,CHAR(car_fnt),1,Fonte8x16.fonte[car_fnt],binaire);
  14: RedefCar(0,CHAR(car_fnt),1,Fonte8x14.fonte[car_fnt],binaire);
  8 : RedefCar(0,CHAR(car_fnt),1,Fonte8x8 .fonte[car_fnt],binaire);
 end;
 modif[FNT]:=TRUE;
end; {RedefCarCourant}


begin  {RedefCaracteres}
 if not(CarteVGA) then exit;

 Curseur(off);
 CacheCursSouris;
 z.Ombre(0,xg,yh,xd,yb,48);
 Cadre(0,1,xg,yh,xd,yb,48+1,' Redfinir les caractres ',112,'');

 Cadre(0,1,xg+4,yh+4,xg+35,yb-5,48,'',0,'');
 LigneHorizontale(0,1,yh+10,xg+5,xg+34,48);
 AffCarXY(0,xg+4,yh+10,'',48); AffCarXY(0,xg+35,yh+10,'',48);
 LigneVerticale(0,1,xg+20,yh+11,yh+13,48);
 AffCarXY(0,xg+20,yh+10,'',48); AffCarXY(0,xg+20,yh+14,'',48);

 AffChXY(0,xg+6 ,yh+5,'Translation',48);
 AffChXY(0,xg+11,yh+7,'Miroir',48);
 AffChXY(0,xg+8 ,yh+9,'Inversion',48);

 for i:=1 to 2 do
  for j:=1 to 4 do
   AffChXY(0,xg+19+4*(j-1),yh+5+2*(i-1),' '+Copy(#27#26'',j,1)+' ',112+10);
 AffChXY(0,xg+19,yh+9,' '#27#26' ',122);
 AffChXY(0,xg+25,yh+9,'  ',122);

 AffChXY(0,xg+7,yh+11,' Copier ',112+10);
 AffChXY(0,xg+7,yh+13,' Coller ',112+10);
 AffChXY(0,xg+24,yh+11,' Effacer ',112+10);
 AffChXY(0,xg+23,yh+13,' Inverser ',112+10);

 boutonCharge.Definit(0,xg+10,yb-4,' Charge ',112+15,112+14,0,128);
 boutonSauve.Definit(0,xg+22,yb-4,' Sauve ',112+15,112+14,0,128);
 boutonOK.Definit(0,xg+12,yb-2,' OK ',112+1,112+3,0,128);
 boutonDefaut.Definit(0,xg+20,yb-2,' Dfaut ',112,112+8,0,128);
 boutonOK.Affiche; boutonDefaut.Affiche;
 boutonCharge.Affiche; boutonSauve.Affiche;

 case hauteur_car of
  16: fonte_courante:=@Fonte8x16.fonte;
  14: fonte_courante:=@Fonte8x14.fonte;
  8 : fonte_courante:=@Fonte8x8 .fonte;
 end;

 ok:=FALSE; attend_bouge:=TRUE;
 repeat
  AffCursSouris;
  if gere_menu then AideEnLigne(select_caractere);
  AfficheLigneCaracteres(xg+6,yh+2,car_fnt,TRUE,xd-14,yh+1,48+15);
  CacheCursSouris;
  if hauteur_ecran_txt=50 then largeur_point:=1 else largeur_point:=2;
  AffMatriceCar(fonte_courante,xg+39,yh+2,car_fnt);
  AffCarXY(0,xg+16,yh+11,CHAR(car_copie),48);
  AffCarXY(0,xg+31,yh+15,car[modif[FNT]],48+14); {*}

  AttendClavierSouris(attend_bouge,FALSE,i,j);
  if KeyPressed then begin
   touche:=ReadKey;
   case touche of
    Left : dec(car_fnt);
    Right: inc(car_fnt);
    Alt1..Alt0: car_fnt:=Ord(MemoireCar[ChiffreAlt[touche]]);
    Enter: ok:=TRUE;
    Esc: break;
    else car_fnt:=BYTE(touche);
   end;
  end
  else begin
   attend_bouge:=TRUE;
   ok:=boutonOK.Clique;

   if boutonDefaut.Clique then begin
    Move(PointeurTable(courante)^,fonte_courante^,256*hauteur_car);
    RedefFonte(0,fonte_courante^);
    Init(FNT,'',modif_projet);
   end;

   if boutonCharge.Clique then begin
    ChargeFichierFNT('');
    EffaceZone(0,xg+39,yh+2,xd-5,yb-2,48); {zone de la matrice}
   end;

   if boutonSauve.Clique then SauveFichierFNT(demande)
   else begin
    if j=yh+2 then
     case i of  {dfilement des caractres}
      xg+4: begin dec(car_fnt); DelaiBoutonSouris(10); attend_bouge:=FALSE end;
      xg+35: begin inc(car_fnt); DelaiBoutonSouris(10); attend_bouge:=FALSE end;
      xg+6..xg+33: begin inc(car_fnt,i-xg-20); BougeCursSourisXY(xg+20,yh+2) end;
     end;

    if (i in [xg+39..xg+38+8*largeur_point]) and (j in [yh+2..yh+hauteur_car+1]) then begin
     k:=1 shl ((xg+38+8*largeur_point-i) div largeur_point); {masque de bits}
     case BoutonSouris of
      gauche: case hauteur_car of  {allume un point}
               16: Fonte8x16.fonte[car_fnt][j-yh-1]:=Fonte8x16.fonte[car_fnt][j-yh-1] or k;
               14: Fonte8x14.fonte[car_fnt][j-yh-1]:=Fonte8x14.fonte[car_fnt][j-yh-1] or k;
               8 : Fonte8x8 .fonte[car_fnt][j-yh-1]:=Fonte8x8 .fonte[car_fnt][j-yh-1] or k;
              end;
      droite: case hauteur_car of  {teint un point}
               16: Fonte8x16.fonte[car_fnt][j-yh-1]:=Fonte8x16.fonte[car_fnt][j-yh-1] and not(k);
               14: Fonte8x14.fonte[car_fnt][j-yh-1]:=Fonte8x14.fonte[car_fnt][j-yh-1] and not(k);
               8 : Fonte8x8 .fonte[car_fnt][j-yh-1]:=Fonte8x8 .fonte[car_fnt][j-yh-1] and not(k);
              end;
     end;
     RedefCarCourant;
    end;

    if j=yh+5 then begin  {Translation}
     case i of
      xg+19..xg+21: for k:=1 to hauteur_car do  {translation  gauche}
                     case hauteur_car of
                      16: Fonte8x16.fonte[car_fnt][k]:=Fonte8x16.fonte[car_fnt][k] shl 1;
                      14: Fonte8x14.fonte[car_fnt][k]:=Fonte8x14.fonte[car_fnt][k] shl 1;
                      8 : Fonte8x8 .fonte[car_fnt][k]:=Fonte8x8 .fonte[car_fnt][k] shl 1;
                     end;
      xg+23..xg+25: for k:=1 to hauteur_car do  {translation  droite}
                     case hauteur_car of
                      16: Fonte8x16.fonte[car_fnt][k]:=Fonte8x16.fonte[car_fnt][k] shr 1;
                      14: Fonte8x14.fonte[car_fnt][k]:=Fonte8x14.fonte[car_fnt][k] shr 1;
                      8 : Fonte8x8 .fonte[car_fnt][k]:=Fonte8x8 .fonte[car_fnt][k] shr 1;
                     end;
      xg+27..xg+29: case hauteur_car of  {translation en haut}
                     16: begin
                          Move(Fonte8x16.fonte[car_fnt][2],Fonte8x16.fonte[car_fnt][1],16-1);
                          Fonte8x16.fonte[car_fnt][16]:=0;
                         end;
                     14: begin
                          Move(Fonte8x14.fonte[car_fnt][2],Fonte8x14.fonte[car_fnt][1],14-1);
                          Fonte8x14.fonte[car_fnt][14]:=0;
                         end;
                     8 : begin
                          Move(Fonte8x8 .fonte[car_fnt][2],Fonte8x8 .fonte[car_fnt][1], 8-1);
                          Fonte8x8 .fonte[car_fnt][8 ]:=0;
                         end;
                    end;
      xg+31..xg+33: case hauteur_car of  {translation en bas}
                     16: begin
                          Move(Fonte8x16.fonte[car_fnt][1],Fonte8x16.fonte[car_fnt][2],16-1);
                          Fonte8x16.fonte[car_fnt][1]:=0;
                         end;
                     14: begin
                          Move(Fonte8x14.fonte[car_fnt][1],Fonte8x14.fonte[car_fnt][2],14-1);
                          Fonte8x14.fonte[car_fnt][1]:=0;
                         end;
                     8 : begin
                          Move(Fonte8x8 .fonte[car_fnt][1],Fonte8x8 .fonte[car_fnt][2], 8-1);
                          Fonte8x8 .fonte[car_fnt][1]:=0;
                         end;
                    end;
     end;
     RedefCarCourant;
    end;

    if j=yh+7 then begin  {Miroir}
     case i of
      xg+19..xg+21: for k:=1 to hauteur_car do  {miroir  gauche}
                     case hauteur_car of
                      16: MiroirBitsGauche(Fonte8x16.fonte[car_fnt][k]);
                      14: MiroirBitsGauche(Fonte8x14.fonte[car_fnt][k]);
                      8 : MiroirBitsGauche(Fonte8x8 .fonte[car_fnt][k]);
                     end;
      xg+23..xg+25: for k:=1 to hauteur_car do  {miroir  droite}
                     case hauteur_car of
                      16: MiroirBitsDroite(Fonte8x16.fonte[car_fnt][k]);
                      14: MiroirBitsDroite(Fonte8x14.fonte[car_fnt][k]);
                      8 : MiroirBitsDroite(Fonte8x8 .fonte[car_fnt][k]);
                     end;
      xg+27..xg+29: for k:=1 to (hauteur_car div 2) do  {miroir en haut}
                     case hauteur_car of
                      16: Fonte8x16.fonte[car_fnt][k]:=Fonte8x16.fonte[car_fnt][hauteur_car-k+1];
                      14: Fonte8x14.fonte[car_fnt][k]:=Fonte8x14.fonte[car_fnt][hauteur_car-k+1];
                      8 : Fonte8x8 .fonte[car_fnt][k]:=Fonte8x8 .fonte[car_fnt][hauteur_car-k+1];
                     end;
      xg+31..xg+33: for k:=1 to (hauteur_car div 2) do  {miroir en bas}
                     case hauteur_car of
                      16: Fonte8x16.fonte[car_fnt][hauteur_car-k+1]:=Fonte8x16.fonte[car_fnt][k];
                      14: Fonte8x14.fonte[car_fnt][hauteur_car-k+1]:=Fonte8x14.fonte[car_fnt][k];
                      8 : Fonte8x8 .fonte[car_fnt][hauteur_car-k+1]:=Fonte8x8 .fonte[car_fnt][k];
                     end;
     end;
     RedefCarCourant;
    end;

    if j=yh+9 then begin  {Inversion}
     case i of
      xg+19..xg+22: for k:=1 to hauteur_car do  {inversion horizontale}
                     case hauteur_car of
                      16: InverseBits(Fonte8x16.fonte[car_fnt][k]);
                      14: InverseBits(Fonte8x14.fonte[car_fnt][k]);
                      8 : InverseBits(Fonte8x8 .fonte[car_fnt][k]);
                     end;
      xg+25..xg+27: for k:=1 to (hauteur_car div 2) do  {inversion verticale}
                     case hauteur_car of
                      16: Echange(Fonte8x16.fonte[car_fnt][k],Fonte8x16.fonte[car_fnt][hauteur_car-k+1]);
                      14: Echange(Fonte8x14.fonte[car_fnt][k],Fonte8x14.fonte[car_fnt][hauteur_car-k+1]);
                      8 : Echange(Fonte8x8 .fonte[car_fnt][k],Fonte8x8 .fonte[car_fnt][hauteur_car-k+1]);
                     end;
     end;
     RedefCarCourant;
    end;

    if (i in [xg+7..xg+14]) then
     case j of
      yh+11: car_copie:=car_fnt; {Copier}
      yh+13: begin  {Coller}
              case hauteur_car of
               16: Move(Fonte8x16.fonte[car_copie],Fonte8x16.fonte[car_fnt],16);
               14: Move(Fonte8x14.fonte[car_copie],Fonte8x14.fonte[car_fnt],14);
               8 : Move(Fonte8x8 .fonte[car_copie],Fonte8x8 .fonte[car_fnt],8 );
              end;
              RedefCarCourant;
             end;
     end;

    if (j=yh+11) and (i in [xg+24..xg+32]) then begin  {Effacer}
     case hauteur_car of
      16: FillChar(Fonte8x16.fonte[car_fnt],16,0);
      14: FillChar(Fonte8x14.fonte[car_fnt],14,0);
      8 : FillChar(Fonte8x8 .fonte[car_fnt],8 ,0);
     end;
     RedefCarCourant;
    end;

    if (j=yh+13) and (i in [xg+23..xg+32]) then begin  {Inverser}
     for k:=1 to hauteur_car do
      case hauteur_car of
       16: Fonte8x16.fonte[car_fnt][k]:=not(Fonte8x16.fonte[car_fnt][k]);
       14: Fonte8x14.fonte[car_fnt][k]:=not(Fonte8x14.fonte[car_fnt][k]);
       8 : Fonte8x8 .fonte[car_fnt][k]:=not(Fonte8x8 .fonte[car_fnt][k]);
      end;
     RedefCarCourant;
    end;
   end;
  end;
 until ok;

 RestaureZoneSuppr(0,z);
 if ok then QuitteMenu;
end; {RedefCaracteres}

{----------------------------------------------------------}

procedure AProposDe;

const largeur=40; hauteur=9; x_milieu=39; y_milieu=12;
      xg=x_milieu-(largeur div 2); xd=xg+largeur-1;
      yh=y_milieu-(hauteur div 2); yb=yh+hauteur-1;

var z: Zone;
    boutonOK: Bouton;

begin
 AideEnLigne('');
 CacheCursSouris;
 z.Ombre(0,xg,yh,xd,yb,48);
 Cadre(0,2,xg+1,yh,xd-1,yb,48+1,' A propos de Screener... ',112,'');
 AffChXY(0,xg+10,yh+2,'SCREENER version '+version,48+14);
 AffChXY(0,xg+5,yh+3,'Editeur d''crans en mode texte',48+15);
 AffChXY(0,xg+8,yh+4,'(c) 1998 Fabrice Couteau',48+1);
 boutonOK.Definit(0,x_milieu-3,yb-2,' OK ',112+1,112+3,0,128);
 AffCursSouris; boutonOK.Affiche;
 repeat
  if KeyPressed then begin if (ReadKey in [Enter,Esc]) then break end
                else if boutonOK.Clique then break;
 until FALSE;
 RestaureZoneSuppr(0,z);
end; {AProposDe}

{----------------------------------------------------------}

procedure Aide;

const nbr_lignes_aide=88;
      Aide_txt: array[1..nbr_lignes_aide] of String80
       =(' Edition de texte',
         'Le texte entr au clavier (touches alphanumriques ou ^Alt^+^0^^Alt^+^9^)',
         's''affiche sous le curseur clignotant, qui se dplace vers la position',
         'suivante ('#26' ou ) si l''option ^Curseur suiveur^ est active.',
         'Le texte est affich avec les couleurs courantes, sauf si l''option',
         '^Conserver couleurs^ est active (seul le caractre est alors modifi).',
         'Les derniers caractres entrs peuvent tre effacs avec ^'#27'Suppr^, ce',
         'qui restitue les anciens caractres recouverts  cette position.',
         'Le texte peut tre effac/dcal avec ^Suppr^ et insr avec ^Ins^.',
         'Vous pouvez dplacer le curseur avec ^'#27#26'^ (modifie le sens du dpla-',
         'cement automatique) ou ^Ctrl^+^'#27#26'^ (mot prcdent/suivant) ou en cliquant',
         'le bouton gauche de la souris.',
         '',
         ' Fentre d''informations',
         'En cliquant le bouton droit, vous affichez les coordonnes du curseur',
         'souris, ses distances (X,Y) par rapport  une origine variable',
         ' (voir Raccourcis clavier et captures),',
         'des informations sur le caractre situ juste en dessous du curseur:',
         'code Ascii dcimal et (hexa), attribut couleur (criture/fond).',
         '',
         ' Barre de menus',
         'Pour activer la barre de menus, appuyez sur ^Esc^ (ou cliquez les deux',
         'boutons simultanment puis relchez un des deux boutons de la souris)',
         'Vous pouvez galement ouvrir directement un menu avec ^Alt^+<initiale>.',
         '',
         ' Slection d''une zone  la souris',
         ' (Sauver zone, Copier zone, Rectangle, Dfinir limites)',
         'Placez le curseur de la souris sur un coin de la zone puis cliquez et',
         'maintenez le bouton gauche. Dplacez le curseur vers le coin oppos',
         'et relchez le bouton gauche.',
         '',
         ' Dplacement d''une zone  la souris',
         ' (Insrer zone, Copier zone)',
         'Placez le curseur de la souris  l''intrieur de la zone slectionne',
         '(affiche en gris), puis cliquez et maintenez le bouton droit.',
         'Dplacez la zone  l''endroit voulu et relchez le bouton droit.',
         '',
         ' Trac d''une ligne  la souris',
         ' (Ligne simple, Ligne double)',
         'Placez le curseur de la souris sur une extrmit de la ligne, puis',
         'cliquez et maintenez le bouton gauche. Dplacez le curseur vers',
         'l''autre extrmit et relchez le bouton gauche. La ligne sera trace',
         'horizontalement ou verticalement, selon la position du curseur.',
         '',
         ' Zone d''dition',
         ' (Dfinir limites)',
         'Vous pouvez dfinir une zone rectangulaire de l''cran,  l''extrieur',
         'de laquelle toute modification est interdite, et  l''intrieur de',
         'laquelle les commandes suivantes agissent:',
         ' Edition de texte, Insrer zone, Copier zone, Rectangle, Cadres,',
         ' Lignes, Remplacer/Echanger fond/criture/attribut/caractre et',
         ' Remplir zone fond/criture.',
         'Le curseur clignotant peut tre dplac dans cette zone avec les',
         'touches ^Dbut^ (colonne de gauche), ^Fin^ (colonne de droite), ^Page^',
         '(ligne du haut), ^Page^ (ligne du bas) et ^^ (ligne suivante).',
         '',
         ' Largeur des caractres et redfinition',
         ' (Caractres 8/9 pixels, Redfinir caractres)',
         'Sur une carte VGA, la largeur des caractres en mode texte est soit',
         'de 8 pixels, soit de 9 pixels. Dans ce dernier cas, les caractres',
         'dont le code Ascii est compris entre 192 (C0h) et 223 (DFh) ont leur',
         '8me colonne automatiquement copie dans la 9me, alors que pour les',
         'autres, cette 9me colonne est vide et non modifiable.',
         'Si vous souhaitez que deux caractres adjacents se raccordent bien',
         'horizontalement (lignes, cadres, logos...), optez pour des caractres',
         'de 8 pixels de large, sauf si leurs codes sont entre 192 et 223.',
         '',
         ' Notion de projet',
         'Un projet Screener permet de conserver la configuration courante:',
         '-nom de fichier des lments dits (cran, palette et fonte)',
         '-options et paramtres des menus (Couleurs, Caractres, Options)',
         '-coordonnes de la zone d''dition, position du curseur et origine',
         '-contenu des mmoires-caractres.',
         '',
         ' Raccourcis clavier et captures',
         'En combinant un clic  la souris et une (ou deux) touches du clavier,',
         'vous accdez directement aux fonctionnalits suivantes:',
         ' bouton souris   touche clavier              fonction',
         ' -------------   --------------  ------------------------------------',
         '    gauche         Ctrl           capture la couleur de fond',
         '    gauche         Alt            capture la couleur d''criture',
         '    gauche         Ctrl+Alt       capture l''attribut',
         '    gauche         Shift+Ctrl     dite la couleur de fond (VGA)',
         '    gauche         Shift+Alt      dite la couleur d''criture (VGA)',
         '    gauche         Shift          dfinit la position de l''origine',
         '    droit          Ctrl           capture le caractre',
         '    droit          Shift          dite le caractre (VGA)',
         '    droit          Alt            affiche le curseur d''alignement'
        );

      Attr: array[boolean] of byte=(48+11,48);

      largeur=75; x_milieu=40;
      x_asc=x_milieu+36; y_asc=4;  {coordonnes de la flche vers le haut}

var z: Zone;
    boutonOK: Bouton;
    defile_fenetre,bouge_ascenseur: boolean;
    i,x,y,hauteur_fenetre,premiere: byte;


procedure DefileHaut;
begin
 if premiere>1 then dec(premiere);
end; {DefileHaut}


procedure DefileBas;
begin
 if premiere<nbr_lignes_aide-hauteur_fenetre+1 then inc(premiere);
end; {DefileBas}


begin {Aide}
 Curseur(off);
 if gere_menu then AideEnLigne('Utilisez , Page pour faire dfiler le texte');
 CacheCursSouris;
 hauteur_fenetre:=hauteur_ecran_txt-9;
 z.Ombre(0,x_asc+1-largeur+1,y_asc-1,x_asc+1,y_asc+hauteur_fenetre+3,48);
 Cadre(0,1,x_asc+1-largeur+2,y_asc-1,x_asc,y_asc+hauteur_fenetre+3,48+1,' Aide ',112,'');
 LigneHorizontale(0,1,y_asc+hauteur_fenetre,x_asc+1-largeur+3,x_asc-1,48+1);
 boutonOK.Definit(0,x_milieu-2,y_asc+hauteur_fenetre+1,' OK ',113,115,0,128);
 AffCursSouris; boutonOK.Affiche;

 premiere:=1;
 defile_fenetre:=FALSE; bouge_ascenseur:=FALSE;
 repeat
  if (BoutonSouris=aucun) or not(defile_fenetre) then CacheCursSouris;

  AfficheAscenseur(x_asc,y_asc,hauteur_fenetre,nbr_lignes_aide,premiere,11);

  AttendVBL;
  EffaceZone(0,x_asc+1-largeur+4,y_asc,x_asc-2,hauteur_fenetre-1+y_asc,48);
  for i:=premiere to premiere+hauteur_fenetre-1 do
   case Aide_txt[i][1] of
    '': AffChXY(0,x_asc+1-largeur+4,i-premiere+y_asc,Aide_txt[i],48+15);
    ' ': AffChXY(0,x_asc+1-largeur+4,i-premiere+y_asc,Aide_txt[i],48);
    else AffChXY2(0,x_asc+1-largeur+4,i-premiere+y_asc,Aide_txt[i],48+1,Attr[i in [4,6]]);
   end;

  if BoutonSouris=aucun then begin
   DefCursSouris(standard,0,0,#0);
   defile_fenetre:=FALSE; bouge_ascenseur:=FALSE;
  end;

  if defile_fenetre or bouge_ascenseur then ZoneSouris(x_asc,y_asc,x_asc,y_asc+hauteur_fenetre-1)
                                       else ZoneSouris(1,1,80,hauteur_ecran_txt);

  AttendClavierSouris(not(defile_fenetre or bouge_ascenseur),FALSE,x,y);
  if bouge_ascenseur then
   repeat until KeyPressed or SourisBouge or (BoutonSouris=aucun);

  if KeyPressed then
   case ReadKey of
    Up  : DefileHaut;
    Down: DefileBas;
    PgUp: if premiere>hauteur_fenetre then dec(premiere,hauteur_fenetre)
                                      else premiere:=1;
    PgDn: begin
           inc(premiere,hauteur_fenetre);
           if premiere>nbr_lignes_aide-hauteur_fenetre+1 then
            premiere:=nbr_lignes_aide-hauteur_fenetre+1;
          end;
    Home: premiere:=1;
    End_: premiere:=nbr_lignes_aide-hauteur_fenetre+1;
    Enter,Esc: break;
   end
  else begin
   if x=x_asc then
    if y=y_asc then begin
     DefCursSouris(standard,0,0,#0);
     defile_fenetre:=TRUE; DefileHaut; DelaiBoutonSouris(10);
    end
    else
     if y=y_asc+hauteur_fenetre-1 then begin
      DefCursSouris(standard,0,0,#0);
      defile_fenetre:=TRUE; DefileBas; DelaiBoutonSouris(10);
     end
     else
      if (y in [y_asc+1..y_asc+hauteur_fenetre-2]) then begin
       DefCursSouris(change_tout,4,11,'');
       defile_fenetre:=FALSE; bouge_ascenseur:=TRUE;
       premiere:=1+Round((y-y_asc-1)*(nbr_lignes_aide-hauteur_fenetre)/(hauteur_fenetre-3));
      end;
   if boutonOK.Clique then break;
  end;
 until FALSE;

 RestaureZoneSuppr(0,z);
end; {Aide}

{----------------------------------------------------------}

procedure TesteToucheAlt(touche: Key);
var m: byte;
begin
 case touche of
  AltQ..AltM: for m:=1 to nbr_menus do with Menu[m] do
               if LettreAlt[touche]=System.UpCase(titre[Pos('^',titre)+1]) then
                begin DerouleMenuDirect(m); break end;
 end;
end; {TesteToucheAlt}

{----------------------------------------------------------}

procedure GestionMenu;
var touche: Key;
    m,o,x,y: byte;
    option_cliquee: boolean;


procedure AfficheBarreMenu(inverse: byte);
var m: byte;
begin
 CacheCursSouris;
 AttendVBL;
 EffaceZone(0,1,1,80,1,48);
 for m:=1 to nbr_menus do if m<>inverse then
  with Menu[m] do AffChXY2(0,xtitre,1,' '+titre+' ',48,48+14);
 with Menu[inverse] do AffChXY2(0,xtitre,1,' '+titre+' ',15,15);
 AffCursSouris;
end; {AfficheBarreMenu}


procedure InverseOption;
begin
 CacheCursSouris; AfficheOption(n_option,15,15,8); AffCursSouris;
end; {InverseOption}


procedure NormalOption;
begin
 CacheCursSouris; AfficheOption(n_option,48,48+14,48+8); AffCursSouris;
end; {NormalOption}


procedure Choix;
begin
 DefCursSouris(standard,0,0,#0);
 case n_menu of
  m_Fichier: case n_option of
              1: NouveauEcran;
              2: ChargerEcran('');
              3: SauverEcran;
              4: InsererZone;
              5: SauverZone;
              6: SauverLimites;
              7: Quitter;
             end;
  m_Projet : case n_option of
              1: NouveauProjet;
              2: ChargerProjet;
              3: SauverProjet;
             end;
  m_Edition: begin
              QuitteMenu;
              case n_option of
               1: Annuler;
               2: CopierZone(0,0,0,0);  {Copier zone}
               3: Rectangle;
               4: CadreSimpleDouble(1); {Cadre simple}
               5: CadreSimpleDouble(2); {Cadre double}
               6: LigneSimpleDouble(1); {Ligne simple}
               7: LigneSimpleDouble(2); {Ligne double}
               8: DefinirLimites;
               9: VoirLimites;
               10:zone_limite_max:=TRUE; {Annuler limites}
              end;
             end;
  m_Couleurs: case n_option of
               1: ChangerAttribut(normal);
               2: RemplacerEchangerCouleur(remplacer,fond); {Remplacer fond}
               3: RemplacerEchangerCouleur(echanger,fond);  {Echanger fond}
               4: RemplacerEchangerCouleur(remplacer,ecriture); {Remplacer criture}
               5: RemplacerEchangerCouleur(echanger,ecriture);  {Echanger criture}
               6: RemplacerEchangerAttribut(remplacer); {Remplacer attribut}
               7: RemplacerEchangerAttribut(echanger);  {Echanger attribut}
               8: RemplirZone(fond);     {Remplir zone fond}
               9: RemplirZone(ecriture); {Remplir zone criture}
               10:RedefPalette;
              end;
  m_Caracteres: case n_option of
                 1: MemoriseCaractere;
                 2: RemplacerEchangerCaractere(remplacer); {Remplacer caractre}
                 3: RemplacerEchangerCaractere(echanger);  {Echanger caractre}
                 4: if CarteVGA then LargeurCar(17-largeur_car); {Caractres 8/9 pixels}
                 5: RedefCaracteres;
                end;
  m_Options: case n_option of
              1..nbr_options_oui_non: begin
                                       options_oui_non[n_option]:=not(options_oui_non[n_option]);
                                       if n_option=clignote then Clignotement(options_oui_non[clignote]);
                                      end;
              5: if CarteVGA then  {25/28/50 lignes}
                  case hauteur_ecran_txt of
                   25: ChangeNbrLignes(28);
                   28: ChangeNbrLignes(50);
                   50: ChangeNbrLignes(25);
                  end;
             end;
  m_Aide: case n_option of
           1: AProposDe;
           2: Aide;
          end;
 end;
end; {Choix}


begin  {GestionMenu}
 CacheCursSouris; Curseur(off);
 zone_barre_menu.Sauve(0,1,1,80,1);
 zone_aide_en_ligne.Sauve(0,1,hauteur_ecran_txt,80,hauteur_ecran_txt);
 option_cliquee:=FALSE;

 repeat
  AfficheBarreMenu(n_menu);
   if menu_deroule then begin
    InverseOption; AideEnLigne(Menu[n_menu].opt[n_option].aide);
   end
   else AideEnLigne('Appuyez sur <Esc> pour revenir  l''diteur plein cran');

  if option_cliquee then DefCursSouris(inverse_attribut,0,0,'')
                    else DefCursSouris(standard,0,0,#0);

  AttendClavierSouris(TRUE,option_cliquee,x,y);

  if option_cliquee and (BoutonSouris=aucun) then
   begin option_cliquee:=FALSE; Choix end
  else
   if KeyPressed then begin
    option_cliquee:=FALSE;
    touche:=UpCase(ReadKey);

    if menu_deroule then
     with Menu[n_menu] do begin  {teste lettre option}
      for o:=1 to nbr_opt do with opt[o] do
       if touche=UpCase(Key(titre[Pos('^',titre)+1])) then
        begin NormalOption; n_option:=o; InverseOption; Choix; break end;
     end
    else begin  {teste lettre menu}
     for m:=1 to nbr_menus do with Menu[m] do
      if touche=UpCase(Key(titre[Pos('^',titre)+1])) then
       begin n_menu:=m; DerouleMenu; break end;
    end;

    TesteToucheAlt(touche);

    case touche of
     Left : begin
             if menu_deroule then EnrouleMenu;
             if n_menu>1 then dec(n_menu) else n_menu:=nbr_menus;
             if menu_deroule then DerouleMenu;
            end;
     Right: begin
             if menu_deroule then EnrouleMenu;
             if n_menu<nbr_menus then inc(n_menu) else n_menu:=1;
             if menu_deroule then DerouleMenu;
            end;
     Up   : if menu_deroule then
             if n_option>1 then begin NormalOption; dec(n_option) end;
     Down : if menu_deroule then begin
             if n_option<Menu[n_menu].nbr_opt then
              begin NormalOption; inc(n_option) end;
            end
            else DerouleMenu;
     Home,PgUp: if menu_deroule then
                 if n_option>1 then begin NormalOption; n_option:=1 end;
     End_,PgDn: if menu_deroule then with Menu[n_menu] do
                 if n_option<nbr_opt then
                  begin NormalOption; n_option:=nbr_opt end;
     Enter: if menu_deroule then Choix else DerouleMenu;
     Esc  : QuitteMenu;
    end;
   end
   else begin  {souris}
    if y=1 then
     for m:=1 to nbr_menus do with Menu[m] do
      if x in [xtitre..xtitre+Length(titre)-1] then
       begin DerouleMenuDirect(m); break end;
    if menu_deroule then begin
     with Menu[n_menu] do
      option_cliquee:=(y in [3..nbr_opt+2]) and
                      (x in [xcadre+1..xcadre+Length(opt[1].titre)]);
     if option_cliquee then
      if n_option<>y-2 then begin NormalOption; n_option:=y-2 end;
    end;
    if y>1 then with Menu[n_menu] do
     if not((y in [2..nbr_opt+3]) and
            (x in [xcadre..xcadre+Length(opt[1].titre)+1]))
        or not(menu_deroule) then QuitteMenu;
   end;
 until not(gere_menu);

 DefCursSouris(standard,0,0,#0);
 menu_deroule:=FALSE;
end; {GestionMenu}

{----------------------------------------------------------}

procedure GestionClavierSouris;

const {pour ChercheCaractere}
      a_gauche=1;
      a_droite=2;
      separateurs=[' '..'/',':'..'?','@','['..']','^','{'..'}'];

var touche: Key;
    x,y,temp: byte;


procedure AffichePositionSouris;

const largeur=18; hauteur=4; {dimensions de la fentre d'infos}

var xs,ys,anc_xs,anc_ys,boutons,i,x,y: byte;
    z: Zone;

function CaractereSigne(entier: integer): char; assembler;
{renvoie '-', '+' ou ' ' selon le signe de l'entier}
asm
 mov AX,entier
 or  AX,AX
 mov AL,' '
 jz  @fin
 mov AL,'-'
 js  @fin
 mov AL,'+'
@fin:
end; {CaractereSigne}

begin  {AffichePositionSouris}
 repeat
  CacheCursSouris;
  EtatSouris(xs,ys,boutons);
  if xs<80-largeur-1 then x:=xs+3 else x:=xs-largeur-2;
  if ys<hauteur_ecran_txt-hauteur+2 then y:=ys else y:=ys-hauteur+1;
  z.Sauve(0,x,y,x+largeur-1,y+hauteur-1);
  AffChXY(0,x,y,'X='+EntierTexte2(xs,2)+'    Y='+EntierTexte2(ys,2)+'    ',112);
  AffChXY(0,x,y+1,'X='+CaractereSigne(xs-x_origine)+EntierTexte2(Abs(xs-x_origine),2+et_j_gauche)+
                 '  Y='+CaractereSigne(ys-y_origine)+EntierTexte2(Abs(ys-y_origine),2+et_j_gauche)+'  ',112);
  i:=CodeXY(0,xs,ys);
  AffChXY(0,x,y+2,'ASCII='+EntierTexte2(i,3)+'  ('+EntierHexa(i,2)+'h)',112);
  i:=AttrXY(0,xs,ys);
  AffChXY(0,x,y+3,'ATTR='+EntierTexte2(i,3)+' ('+EntierTexte2(i and $0F,2)+'/'+EntierTexte2(i shr 4,2)+')',112);
  AffCursSouris;
  anc_xs:=xs; anc_ys:=ys;
  repeat
   EtatSouris(xs,ys,boutons);
  until (xs<>anc_xs) or (ys<>anc_ys) or (boutons<>droite);
  AttendVBL;
  RestaureZoneSuppr(0,z);
 until boutons<>droite;
end; {AffichePositionSouris}


procedure AfficheCurseurLignes;
var xs,ys,anc_xs,anc_ys,boutons: byte;

 procedure AfficheLignes(x,y: byte); assembler;
 asm
  mov DX,0B800h
  mov ES,DX
  xor AH,AH
  mov AL,x
  dec AL
  shl AX,1
  mov DI,AX
  xor CH,CH
  mov CL,hauteur_ecran_txt
 @ligne_verticale:
  mov AX,ES:[DI]
  xor AH,01010000b
  mov ES:[DI],AX
  add DI,2*80
  loop @ligne_verticale
  mov AL,y
  dec AL
  mov BL,2*80
  mul BL
  mov DI,AX
  mov CL,80
 @ligne_horizontale:
  mov AX,ES:[DI]
  xor AH,01010000b
  mov ES:[DI],AX
  add DI,2
  loop @ligne_horizontale
 end; {AfficheLignes}

begin  {AfficheCurseurLignes}
 CacheCursSouris;
 repeat
  EtatSouris(xs,ys,boutons);
  AfficheLignes(xs,ys);
  anc_xs:=xs; anc_ys:=ys;
  repeat
   EtatSouris(xs,ys,boutons);
  until (xs<>anc_xs) or (ys<>anc_ys) or (boutons=aucun);
  AttendVBL;
  AfficheLignes(anc_xs,anc_ys);
 until boutons=aucun;
 AffCursSouris;
end; {AfficheCurseurLignes}


procedure AfficheCar(c: char);
begin
 CacheCursSouris;
 if (EtatClavier and InsMode)=InsMode then
  case direction_curseur of
   droite_: if x_curseur<xd_lim then ScrolleZoneDroite(0,x_curseur,y_curseur,xd_lim,y_curseur);
   bas_   : if y_curseur<yb_lim then ScrolleZoneBas(0,x_curseur,y_curseur,x_curseur,yb_lim);
  end;
 if options_oui_non[conserve_couleurs] then CharPtr(PtrVRAM(0,x_curseur,y_curseur))^:=c
                                       else AffCarXY(0,x_curseur,y_curseur,c,(couleur[fond] shl 4)+couleur[ecriture]);
 AffCursSouris;
 if options_oui_non[curseur_suiveur] then
  case direction_curseur of
   droite_: if x_curseur<xd_lim then inc(x_curseur);
   bas_   : if y_curseur<yb_lim then inc(y_curseur);
  end;
 anc_modif_SCR:=modif[SCR]; modif[SCR]:=TRUE;
end; {AfficheCar}


procedure ChercheCaractere(direction: byte);
var x,y: byte;
    test_init,test: boolean;
begin
 x:=x_curseur; y:=y_curseur;
 test_init:=(direction=a_gauche); test:=test_init;
 if test_init then
  if x-1>=xg_lim then
   if (CHAR(CodeXY(0,x-1,y)) in separateurs) and not(CHAR(CodeXY(0,x,y)) in separateurs) then dec(x);
 repeat
  while (CHAR(CodeXY(0,x,y)) in separateurs)=test do
   case direction of
    a_gauche: begin
               dec(x);
               if x<xg_lim then begin x:=xd_lim; dec(y); if y<yh_lim then exit end;
              end;
    a_droite: begin
               inc(x);
               if x>xd_lim then begin x:=xg_lim; inc(y); if y>yb_lim then exit end;
              end;
   end;
  test:=not(test);
 until test=test_init;
 x_curseur:=x+BYTE(test_init); y_curseur:=y;
end; {ChercheCaractere}


begin  {GestionClavierSouris}
 if gere_menu then GestionMenu;

 ZoneLimite(xg_lim,yh_lim,xd_lim,yb_lim);
 if (EtatClavier and InsMode)=0 then Curseur(plat) else Curseur(rect);
 CursXY(0,x_curseur,y_curseur);

 AttendClavierSouris(FALSE,quitte,x,y);

 if KeyPressed then begin
  touche:=ReadKey;
  TesteToucheAlt(touche);
  case touche of
   Space..255: begin SauveEcranActuel(ajoute_car); AfficheCar(CHAR(touche)) end;
   Enter: begin
           x_curseur:=xg_lim;
           if y_curseur<yb_lim then inc(y_curseur);
          end;
   Bdel: begin
          case direction_curseur of
           droite_: if x_curseur>xg_lim then dec(x_curseur);
           bas_   : if y_curseur>yh_lim then dec(y_curseur);
          end;
          SauveEcranActuel(ajoute_car);
          CacheCursSouris;
          WordPtr(PtrVRAM(0,x_curseur,y_curseur))^:=WordPtr(PtrVRAM(1,x_curseur,y_curseur))^;
          AffCursSouris;
          anc_modif_SCR:=modif[SCR]; modif[SCR]:=TRUE;
         end;
   Del : begin
          SauveEcranActuel(ajoute_car);
          CacheCursSouris;
          case direction_curseur of
           droite_: if x_curseur<xd_lim then ScrolleZoneGauche(0,x_curseur,y_curseur,xd_lim,y_curseur)
                                        else CharPtr(PtrVRAM(0,x_curseur,y_curseur))^:=' ';
           bas_   : if y_curseur<yb_lim then ScrolleZoneHaut(0,x_curseur,y_curseur,x_curseur,yb_lim)
                                        else CharPtr(PtrVRAM(0,x_curseur,y_curseur))^:=' ';
          end;
          AffCursSouris;
          anc_modif_SCR:=modif[SCR]; modif[SCR]:=TRUE;
         end;
   Left : begin
           direction_curseur:=droite_;
           if x_curseur>xg_lim then dec(x_curseur);
          end;
   Right: begin
           direction_curseur:=droite_;
           if x_curseur<xd_lim then inc(x_curseur);
          end;
   Up   : begin
           direction_curseur:=bas_;
           if y_curseur>yh_lim then dec(y_curseur);
          end;
   Down : begin
           direction_curseur:=bas_;
           if y_curseur<yb_lim then inc(y_curseur);
          end;
   Home : x_curseur:=xg_lim;
   End_ : x_curseur:=xd_lim;
   PgUp : y_curseur:=yh_lim;
   PgDn : y_curseur:=yb_lim;
   CtrlLeft : ChercheCaractere(a_gauche);
   CtrlRight: ChercheCaractere(a_droite);
   Alt1..Alt0: begin
                SauveEcranActuel(ajoute_car);
                AfficheCar(MemoireCar[ChiffreAlt[touche]]);
               end;
   Esc: gere_menu:=TRUE;
   F1: Aide;
   F2: SauverEcran;
   F3: ChargerEcran('');
   F4: NouveauEcran;
   ShiftF2,CtrlF2: SauverProjet;
   ShiftF3,CtrlF3: ChargerProjet;
   ShiftF4,CtrlF4: NouveauProjet;
   F5: CopierZone(0,0,0,0);
   F6: Rectangle;
   ShiftF7,CtrlF7: DefinirLimites;
   F7: VoirLimites;
   F8: ChangerAttribut(normal);
   ShiftF8,CtrlF8: RedefPalette;
   F9: MemoriseCaractere;
   ShiftF9,CtrlF9: RedefCaracteres;
   F10,AltX: Quitter;
  end;
 end
 else  {souris}
  case BoutonSouris of
   gauche: if EtatClavier and (ShiftG or ShiftD or Ctrl or Alt)=0 then
            begin x_curseur:=x; y_curseur:=y end
           else begin
            CacheCursSouris; temp:=AttrXY(0,x,y); AffCursSouris;
            case EtatClavier and (ShiftG or ShiftD or Ctrl or Alt) of
             ShiftG,
             ShiftD: begin x_origine:=x; y_origine:=y end;
             ShiftG+Ctrl,
             ShiftD+Ctrl: begin
                           BougeCursSourisXY(45,8);
                           couleur_pal:=temp shr 4; RedefPalette;
                          end;
             ShiftG+Alt ,
             ShiftD+Alt : begin
                           BougeCursSourisXY(45,8);
                           couleur_pal:=temp and $0F; RedefPalette;
                          end;
             Ctrl: begin couleur[fond]    :=temp shr 4; ChangerAttribut(capture) end;
             Alt : begin couleur[ecriture]:=temp and $0F; ChangerAttribut(capture) end;
             Ctrl+Alt: begin
                        couleur[fond]:=temp shr 4;
                        couleur[ecriture]:=temp and $0F; ChangerAttribut(capture);
                       end;
            end;
            Pause(2);
           end;
   droite: if EtatClavier and (ShiftG or ShiftD or Ctrl or Alt)=0 then AffichePositionSouris
           else begin
            temp:=CodeXY(0,x,y);
            case EtatClavier and (ShiftG or ShiftD or Ctrl or Alt) of
             ShiftG,
             ShiftD: begin
                      BougeCursSourisXY(29,5);
                      car_fnt:=temp; RedefCaracteres;
                     end;
             Ctrl: begin
                    car_memo:=temp;
                    for temp:=0 to 9 do if MemoireCar[temp]=' ' then break;
                    BougeCursSourisXY(60-1,temp+3+4);
                    MemoriseCaractere;
                   end;
             Alt : AfficheCurseurLignes;
            end;
           end;
   gauche+droite,milieu: begin
                          n_menu:=1+((x-1)*nbr_menus div 80);
                          BougeCursSourisXY(Menu[n_menu].xtitre+1,1);
                          gere_menu:=TRUE; DerouleMenu;
                         end;
  end;
end; {GestionClavierSouris}

{==========================================================}

VAR anc_nbr_lignes: byte;

BEGIN
 if not(InitSouris) then begin WriteLn('Pilote souris non trouv.'); halt(1) end;

 CheckBreak:=FALSE;

 anc_nbr_lignes:=NombreLignes+1;
 InitTexte(anc_nbr_lignes);

 AffCursSouris;
 InitNouveauEcran(avec_menu);
 InitRepert;
 DesactiveMode(InsMode);
 Clignotement(options_oui_non[clignote]);
 if CarteVGA then begin
  Move(PointeurTable(table8x16)^,Fonte8x16.fonte,256*16);
  Move(PointeurTable(table8x14)^,Fonte8x14.fonte,256*14);
  Move(PointeurTable(table8x8 )^,Fonte8x8 .fonte,256*8 );
 end;
 VideBufferClavier;

 repeat GestionClavierSouris until quitte;

 CacheCursSouris;
 InitTexte(anc_nbr_lignes);
END.