{$A+,G+,Q-,R-,S-}

USES Crt,Graph256;

CONST hauteur=22;
      largeur=22;
      Forme: array[1..hauteur,1..largeur] of byte
              =((0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0),
                (0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0),
                (0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0),
                (0,0,1,1,1,1,2,2,2,2,2,2,2,2,2,2,1,1,1,1,0,0),
                (0,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,0),
                (0,1,1,1,2,2,2,3,3,3,3,3,3,3,3,2,2,2,1,1,1,0),
                (0,1,1,1,2,2,3,3,3,3,3,3,3,3,3,3,2,2,1,1,1,0),
                (1,1,1,2,2,2,3,3,3,4,4,4,4,3,3,3,2,2,2,1,1,1),
                (1,1,1,2,2,3,3,3,4,4,4,4,4,4,3,3,3,2,2,1,1,1),
                (1,1,1,2,2,3,3,4,4,4,5,5,4,4,4,3,3,2,2,1,1,1),
                (1,1,1,2,2,3,3,4,4,5,6,6,5,4,4,3,3,2,2,1,1,1),
                (1,1,1,2,2,3,3,4,4,5,6,6,5,4,4,3,3,2,2,1,1,1),
                (1,1,1,2,2,3,3,4,4,4,5,5,4,4,4,3,3,2,2,1,1,1),
                (1,1,1,2,2,3,3,3,4,4,4,4,4,4,3,3,3,2,2,1,1,1),
                (1,1,1,2,2,2,3,3,3,4,4,4,4,3,3,3,2,2,2,1,1,1),
                (0,1,1,1,2,2,3,3,3,3,3,3,3,3,3,3,2,2,1,1,1,0),
                (0,1,1,1,2,2,2,3,3,3,3,3,3,3,3,2,2,2,1,1,1,0),
                (0,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,0),
                (0,0,1,1,1,1,2,2,2,2,2,2,2,2,2,2,1,1,1,1,0,0),
                (0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0),
                (0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0),
                (0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0));

      x0=160-(largeur shr 1);
      y0=100-(hauteur shr 1);

      longueur_shadebob=100;

      nbr_shadebobs=3;


TYPE shadebob=record
               x: array[1..longueur_shadebob] of word;
               y: array[1..longueur_shadebob] of byte;
               facteur_x,facteur_y: byte;
               index_queue,index_tete: byte;
              end;

VAR shadebobs: array[1..nbr_shadebobs] of shadebob;
    t,dt: array[1..nbr_shadebobs] of real;
    i: byte;
    nouveau,fin: boolean;



procedure CalculePalette;
var i: byte;
    comp: RVB;
    dR,dV,dB: shortint;
begin
 with comp do
  begin R:=1+Random(63); V:=1+Random(63); B:=1+Random(63) end;
 dR:=+1;
 dV:=+1;
 dB:=+1;
 for i:=0 to 255 do with comp do begin
  FixeDAC(i,comp);
  if (Random(100)=0) or (R in [0,63]) then dR:=-dR;
  if (Random(100)=0) or (V in [0,63]) then dV:=-dV;
  if (Random(100)=0) or (B in [0,63]) then dB:=-dB;
  inc(R,dR);
  inc(V,dV);
  inc(B,dB);
 end;
end;


procedure AfficheForme(x,y: integer);
begin
 AfficheFormeLimite(Forme,$A000,x,y,largeur,hauteur,TRUE,FALSE,ADD_,0,0,319,199);
end;


procedure EffaceForme(x,y: integer);
begin
 AfficheFormeLimite(Forme,$A000,x,y,largeur,hauteur,TRUE,FALSE,SUB_,0,0,319,199);
end;



BEGIN
 Init320x200;
 Randomize;

 fin:=FALSE;

 repeat
  nouveau:=FALSE;
  for i:=1 to nbr_shadebobs do begin
   with shadebobs[i] do begin
    index_queue:=1; index_tete:=1;
    facteur_x:=2+Random(8); facteur_y:=2+Random(8);
   end;
   t[i]:=4*Random;
   dt[i]:=2*Pi/(50+Random(100));
  end;
  CalculePalette;
  EffaceZone($A000,0,0,319,199,0);
  repeat
   repeat
    for i:=1 to nbr_shadebobs do begin
     with shadebobs[i] do begin
      x[index_tete]:=x0+Round(x0*Cos(t[i])*Sin(t[i]/facteur_x));
      y[index_tete]:=y0+Round(y0*Sin(t[i])*Sin(t[i]/facteur_y));
      AfficheForme(x[index_tete],y[index_tete]);
      if ((index_queue=1) and (index_tete=longueur_shadebob)) or
         (index_queue=index_tete+1) then begin
       EffaceForme(x[index_queue],y[index_queue]);
       index_queue:=1+(index_queue mod longueur_shadebob);
      end;
      index_tete:=1+(index_tete mod longueur_shadebob);
     end;
     t[i]:=t[i]+dt[i];
    end;
   until KeyPressed;
   case UpCase(ReadKey) of
    #27: fin:=TRUE;
    #13: nouveau:=TRUE;
   end;
  until fin or nouveau;
 until fin;

 TextMode(LastMode);
END.
