PROGRAM Taquin_;
{$A+,G+,Q-,R-,S-}

USES Graph256,Util,Souris,SourisG;

CONST NL=4; NC=8;
      cote=16;

VAR Taquin: array[1..NL,1..NC] of byte;
    lig_trou,col_trou: byte;


procedure GenereTaquin;
var lig,col,n: byte;
    hasard: array[1..NL*NC] of boolean;
    trouve: boolean;
begin
 Randomize;
 FillChar(hasard,sizeof(hasard),FALSE);
 for lig:=1 to NL do
  for col:=1 to NC do begin
   trouve:=FALSE;
   repeat
    n:=1+Random(NL*NC);
    if not(hasard[n]) then begin
     hasard[n]:=TRUE; Taquin[lig,col]:=n;
     if n=NL*NC then begin lig_trou:=lig; col_trou:=col end;
     trouve:=TRUE;
    end;
   until trouve;
  end;
end; {GenereTaquin}


procedure AfficheCaseTaquin(lig,col: byte; select: boolean);
begin
 if (lig=lig_trou) and (col=col_trou) then
  EffaceZone($A000,cote*(col-1),cote*(lig-1),cote*col-1,cote*lig-1,20)
 else begin
  EffaceZoneCadreOmbre($A000,cote*(col-1),cote*(lig-1),cote*col-1,cote*lig-1,3,select);
  AffCh5x6($A000,cote*(col-1)+3,cote*(lig-1)+4+BYTE(select),
                 EntierTexte2(Taquin[lig,col],1),0+14*BYTE(select),TRUE,3);
 end;
end; {AfficheCaseTaquin}


procedure AfficheTaquin;
var lig,col,n: byte;
begin
 CacheCursSouris;
 AttendVBL;
 for lig:=1 to NL do
  for col:=1 to NC do AfficheCaseTaquin(lig,col,FALSE);
 AffCursSouris;
end; {AfficheTaquin}


function Gagne: boolean;
var lig,col: byte;
begin
 Gagne:=TRUE;
 for lig:=1 to NL do
  for col:=1 to NC do
   if Taquin[lig,col]<>col+NC*(lig-1) then begin Gagne:=FALSE; exit end;
end; {Gagne}


CONST anc_lig: byte=0;
      anc_col: byte=0;

VAR x: word;
    y,bt,lig,col: byte;
    d_lig,d_col: shortint;
    ok_clique: boolean;
    mouvements: word;

BEGIN
 Init320x200;
 ZoneSouris(0,0,cote*NC-1,cote*NL-1);

 repeat
  GenereTaquin;
  BougeCursSourisXY(cote*col_trou-(cote div 2),cote*lig_trou-(cote div 2));
  AffCursSouris;
  AfficheTaquin;

  mouvements:=0;
  repeat
   EtatSouris(x,y,bt);
   lig:=1+(y div cote); col:=1+(x div cote);
   d_lig:=lig_trou-lig; d_col:=col_trou-col;
   ok_clique:=(Abs(d_lig)+Abs(d_col)=1);

   if (lig<>anc_lig) or (col<>anc_col) then begin
    CacheCursSouris;
    if (anc_lig<>0) then AfficheCaseTaquin(anc_lig,anc_col,FALSE);
    if ok_clique then AfficheCaseTaquin(lig,col,TRUE);
    AffCursSouris;
    anc_lig:=lig; anc_col:=col;
   end;

   AffCh4x5($A000,cote*NC+8,0,EntierTexte2(mouvements,3),15,TRUE,0);

   if (bt=gauche) and ok_clique then begin
    inc(mouvements);
    x:=Taquin[lig_trou,col_trou];
    Taquin[lig_trou,col_trou]:=Taquin[lig,col];
    Taquin[lig,col]:=x;
    lig_trou:=lig; col_trou:=col;
    AfficheTaquin;
    repeat until BoutonSouris=aucun;
   end;
  until Gagne or (bt=droite);

  CacheCursSouris;
  repeat until BoutonSouris=aucun;
 until mouvements=0;

 asm
  mov AX,03h
  int 10h
 end;
END.
