{$A+,G+,N+,Q-,R-,S-}

USES Crt,Util,Graph;

TYPE Key=word;

{ 15 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
  Ŀ
  ACGD00xxxxxxxxxx
  
          code touche
      
       Shift droit  )
      Shift gauche )
     Ctrl
    Alt   }


CONST msq_Key = $1FF; {masque 9 bits pour accder au code touche de Key}
      code_etendu: boolean=FALSE;

      longueur_buffer_clavier=32;

      {codes touches}
      Space=32;
      Esc  =27;
      Enter=13;
      Bdel =8;
      Del  =339;
      Ins  =338;
      Tab  =9;

      F1=315; F2=316; F3=317; F4 =318; F5 =319; F6 =320;
      F7=321; F8=322; F9=323; F10=324; F11=325; F12=326;

      Left=331; Right=333;
      Up  =328; Down =336;
      PgUp=329; PgDn =337;
      Home=327; End_ =335;

      {constantes pour combinaisons de touches Shift,Ctrl,Alt}
      ShiftD =$01;
      ShiftG =$02; Shift=ShiftG or ShiftD;
      Ctrl   =$04;
      Alt    =$08;
      Combi  =Shift or Ctrl or Alt;

      {scan-codes}

      {touches spciales}
      scan_ShiftG=$2A;
      scan_ShiftD=$36;
      scan_Ctrl  =$1D;
      scan_Alt   =$38;

      scan_Caps  =$3A;
      scan_Num   =$45;
      scan_Scroll=$46;

      scan_etendu=$60;
      scan_etendu2=$2A;

      {A..Z}
      scan_A=$10;
      scan_B=$30;
      scan_C=$2E;
      scan_D=$20;
      scan_E=$12;
      scan_F=$21;
      scan_G=$22;
      scan_H=$23;
      scan_I=$17;
      scan_J=$24;
      scan_K=$25;
      scan_L=$26;
      scan_M=$27;
      scan_N=$31;
      scan_O=$18;
      scan_P=$19;
      scan_Q=$1E;
      scan_R=$13;
      scan_S=$1F;
      scan_T=$14;
      scan_U=$16;
      scan_V=$2F;
      scan_W=$2C;
      scan_X=$2D;
      scan_Y=$15;
      scan_Z=$11;

      scan_AZ: array['A'..'Z'] of byte=(
                scan_A,scan_B,scan_C,scan_D,scan_E,scan_F,scan_G,scan_H,
                scan_I,scan_J,scan_K,scan_L,scan_M,scan_N,scan_O,scan_P,
                scan_Q,scan_R,scan_S,scan_T,scan_U,scan_V,scan_W,scan_X,
                scan_Y,scan_Z);

      {0..9}
      scan_0=$0B;
      scan_1=$02;
      scan_2=$03;
      scan_3=$04;
      scan_4=$05;
      scan_5=$06;
      scan_6=$07;
      scan_7=$08;
      scan_8=$09;
      scan_9=$0A;

      scan_09: array[0..9] of byte=(
                scan_0,scan_1,scan_2,scan_3,scan_4,
                scan_5,scan_6,scan_7,scan_8,scan_9);

      {}
      scan_carre=$29;

      {)}
      scan_parf=$0C;

      {=}
      scan_egal=$0D;

      {^}
      scan_circ=$1A;

      { $}
      scan_doll=$1B;

      {%}
      scan_pour=$28;

      {*}
      scan_etoile=$2B;

      {<}
      scan_inf=$56;

      {?}
      scan_inter=$32;

      {.}
      scan_point=$33;

      {:}
      scan_2points=$34;

      {!}
      scan_exclam=$35;

      {F1..F12}
      scan_F1 =$3B;
      scan_F2 =$3C;
      scan_F3 =$3D;
      scan_F4 =$3E;
      scan_F5 =$3F;
      scan_F6 =$40;
      scan_F7 =$41;
      scan_F8 =$42;
      scan_F9 =$43;
      scan_F10=$44;
      scan_F11=$57;
      scan_F12=$58;

      scan_FF: array[1..12] of byte=(
                scan_F1 ,scan_F2 ,scan_F3 ,scan_F4 ,scan_F5 ,scan_F6 ,
                scan_F7 ,scan_F8 ,scan_F9 ,scan_F10,scan_F11,scan_F12);

      {curseur}
      scan_Left =$4B;
      scan_Right=$4D;
      scan_Up   =$48;
      scan_Down =$50;
      scan_PgUp =$49;
      scan_PgDn =$51;
      scan_Home =$47;
      scan_End  =$4F;

      {divers}
      scan_Space=$39;
      scan_Esc  =$01;
      scan_Enter=$1C;
      scan_Bdel =$0E;
      scan_Del  =$53;
      scan_Ins  =$52;
      scan_Tab  =$0F;

      {pav numrique}
      scan_PV_Plus  =$4E;
      scan_PV_Moins =$4A;
      scan_PV_Slash =$35;
      scan_PV_Etoile=$37;

      {0..9}
      scan_PV_0=$52;
      scan_PV_1=$4F;
      scan_PV_2=$50;
      scan_PV_3=$51;
      scan_PV_4=$4B;
      scan_PV_5=$4C;
      scan_PV_6=$4D;
      scan_PV_7=$47;
      scan_PV_8=$48;
      scan_PV_9=$49;

      scan_PV_09: array[0..9] of byte=(
                   scan_PV_0,scan_PV_1,scan_PV_2,scan_PV_3,scan_PV_4,
                   scan_PV_5,scan_PV_6,scan_PV_7,scan_PV_8,scan_PV_9);

      {tableau de conversion scan-code (8 bits) -> code touche (9 bits)}
      scan2code: array[$01..$7F] of Key
                 =(Esc     , { $01 }
                   Key('1'), { $02 }
                   Key('2'), { $03 }
                   Key('3'), { $04 }
                   Key('4'), { $05 }
                   Key('5'), { $06 }
                   Key('6'), { $07 }
                   Key('7'), { $08 }
                   Key('8'), { $09 }
                   Key('9'), { $0A }
                   Key('0'), { $0B }
                   Key(')'), { $0C }
                   Key('='), { $0D }
                   Bdel    , { $0E }
                   Tab     , { $0F }
                   Key('A'), { $10 }
                   Key('Z'), { $11 }
                   Key('E'), { $12 }
                   Key('R'), { $13 }
                   Key('T'), { $14 }
                   Key('Y'), { $15 }
                   Key('U'), { $16 }
                   Key('I'), { $17 }
                   Key('O'), { $18 }
                   Key('P'), { $19 }
                   Key('^'), { $1A }
                   Key('$'), { $1B }
                   Enter   , { $1C }
                   Ctrl    , { $1D }
                   Key('Q'), { $1E }
                   Key('S'), { $1F }
                   Key('D'), { $20 }
                   Key('F'), { $21 }
                   Key('G'), { $22 }
                   Key('H'), { $23 }
                   Key('J'), { $24 }
                   Key('K'), { $25 }
                   Key('L'), { $26 }
                   Key('M'), { $27 }
                   Key('%'), { $28 }
                   Key(''), { $29 }
                   ShiftG  , { $2A }
                   Key('*'), { $2B }
                   Key('W'), { $2C }
                   Key('X'), { $2D }
                   Key('C'), { $2E }
                   Key('V'), { $2F }
                   Key('B'), { $30 }
                   Key('N'), { $31 }
                   Key('?'), { $32 }
                   Key('.'), { $33 }
                   Key(':'), { $34 }
                   Key('!'), { $35 }
                   ShiftD  , { $36 }
                   Key('*'), { $37 }
                   Alt     , { $38 }
                   Space   , { $39 }
                   0       , { $3A }
                   F1      , { $3B }
                   F2      , { $3C }
                   F3      , { $3D }
                   F4      , { $3E }
                   F5      , { $3F }
                   F6      , { $40 }
                   F7      , { $41 }
                   F8      , { $42 }
                   F9      , { $43 }
                   F10     , { $44 }
                   0       , { $45 }
                   0       , { $46 }
                   Key('7'), { $47 }
                   Key('8'), { $48 }
                   Key('9'), { $49 }
                   Key('-'), { $4A }
                   Key('4'), { $4B }
                   Key('5'), { $4C }
                   Key('6'), { $4D }
                   Key('+'), { $4E }
                   Key('1'), { $4F }
                   Key('2'), { $50 }
                   Key('3'), { $51 }
                   Key('0'), { $52 }
                   Del     , { $53 }
                   0       , { $54 }
                   0       , { $55 }
                   Key('<'), { $56 }
                   F11     , { $57 }
                   F12     , { $58 }
                   0       , { $59 }
                   0       , { $5A }
                   0       , { $5B }
                   0       , { $5C }
                   0       , { $5D }
                   0       , { $5E }
                   0       , { $5F }
                   0       , { $60 }
                   0       , { $61 }
                   0       , { $62 }
                   0       , { $63 }
                   0       , { $64 }
                   0       , { $65 }
                   0       , { $66 }
                   0       , { $67 }
                   0       , { $68 }
                   0       , { $69 }
                   0       , { $6A }
                   0       , { $6B }
                   0       , { $6C }
                   0       , { $6D }
                   0       , { $6E }
                   0       , { $6F }
                   0       , { $70 }
                   0       , { $71 }
                   0       , { $72 }
                   0       , { $73 }
                   0       , { $74 }
                   0       , { $75 }
                   0       , { $76 }
                   0       , { $77 }
                   0       , { $78 }
                   0       , { $79 }
                   0       , { $7A }
                   0       , { $7B }
                   0       , { $7C }
                   0       , { $7D }
                   0       , { $7E }
                   0         { $7F }
                  );

      {codage des notes (en demi-tons)}
      bemol=-1;
      diese=+1;

      {n note       masque binaire (pour clavier)}
      Do_=0;         m_Do =1 shl Do_;
      Dod=Do_+diese; m_Dod=1 shl Dod;
      Re =Dod+1;     m_Re =1 shl Re ;
      Reb=Re +bemol; m_Reb=1 shl Reb;
      Red=Re +diese; m_Red=1 shl Red;
      Mi =Red+1;     m_Mi =1 shl Mi ;
      Mib=Mi +bemol; m_Mib=1 shl Mib;
      Fa =Mi +1;     m_Fa =1 shl Fa ;
      Fad=Fa +diese; m_Fad=1 shl Fad;
      Sol=Fad+1;     m_Sol=1 shl Sol;
      Sob=Sol+bemol; m_Sob=1 shl Sob;
      Sod=Sol+diese; m_Sod=1 shl Sod;
      La =Sod+1;     m_La =1 shl La ;
      Lab=La +bemol; m_Lab=1 shl Lab;
      Lad=La +diese; m_Lad=1 shl Lad;
      Si =Lad+1;     m_Si =1 shl Si ;
      Sib=Si +bemol; m_Sib=1 shl Sib;

      blanches: array[0..6] of byte=(Do_,Re,Mi,Fa,Sol,La,Si);
      noires  : array[0..4] of byte=(Dod,Mib,Fad,Sod,Sib);

      {noms des notes}
      NomNote: array[Do_..Si] of string[3]=
                ('Do ','Do#','R ','Mib','Mi ','Fa ','Fa#','Sol','So#','La ','Sib','Si ');

      {  _____________
               
         S D  G H J 
        WXCVBN?
        ;
        DoRMiFaSoLaSi  }

      {tableau de conversion scan-code -> octave+note}
      scan2note: array[$02..$35] of record octave,note: byte; end
                 =((                  ), { '1' $02 }
                   (octave:2; note:Dod), { '2' $03 }
                   (octave:2; note:Mib), { '3' $04 }
                   (                  ), { '4' $05 }
                   (octave:2; note:Fad), { '5' $06 }
                   (octave:2; note:Sod), { '6' $07 }
                   (octave:2; note:Sib), { '7' $08 }
                   (                  ), { '8' $09 }
                   (octave:3; note:Dod), { '9' $0A }
                   (octave:3; note:Mib), { '0' $0B }
                   (                  ), { ')' $0C }
                   (octave:3; note:Fad), { '=' $0D }
                   (),                   {     $0E }
                   (),                   {     $0F }
                   (octave:2; note:Do_), { 'A' $10 }
                   (octave:2; note:Re ), { 'Z' $11 }
                   (octave:2; note:Mi ), { 'E' $12 }
                   (octave:2; note:Fa ), { 'R' $13 }
                   (octave:2; note:Sol), { 'T' $14 }
                   (octave:2; note:La ), { 'Y' $15 }
                   (octave:2; note:Si ), { 'U' $16 }
                   (octave:3; note:Do_), { 'I' $17 }
                   (octave:3; note:Re ), { 'O' $18 }
                   (octave:3; note:Mi ), { 'P' $19 }
                   (octave:3; note:Fa ), { '^' $1A }
                   (octave:3; note:Sol), { '$' $1B }
                   (                  ), {     $1C }
                   (                  ), {     $1D }
                   (                  ), { 'Q' $1E }
                   (octave:1; note:Dod), { 'S' $1F }
                   (octave:1; note:Mib), { 'D' $20 }
                   (                  ), { 'F' $21 }
                   (octave:1; note:Fad), { 'G' $22 }
                   (octave:1; note:Sod), { 'H' $23 }
                   (octave:1; note:Sib), { 'J' $24 }
                   (                  ), { 'K' $25 }
                   (octave:2; note:Dod), { 'L' $26 }
                   (octave:2; note:Mib), { 'M' $27 }
                   (                  ), { '%' $28 }
                   (                  ), {     $29 }
                   (                  ), {     $2A }
                   (                  ), {     $2B }
                   (octave:1; note:Do_), { 'W' $2C }
                   (octave:1; note:Re ), { 'X' $2D }
                   (octave:1; note:Mi ), { 'C' $2E }
                   (octave:1; note:Fa ), { 'V' $2F }
                   (octave:1; note:Sol), { 'B' $30 }
                   (octave:1; note:La ), { 'N' $31 }
                   (octave:1; note:Si ), { '?' $32 }
                   (octave:2; note:Do_), { '.' $33 }
                   (octave:2; note:Re ), { ':' $34 }
                   (octave:2; note:Mi )  { '!' $35 }
                  );

      {accords (dans la gamme de Do) classs par longueur croissante}
      nbr_accords=34;
      Accord: array[1..nbr_accords] of
               record
                nom: string[5];
                masque: word;
               end

              =((nom:'maj'  ; masque:m_Do or m_Mi  or m_Sol                           ),
                (nom:'aug'  ; masque:m_Do or m_Mi  or m_Sod                           ),
                (nom:'dim'  ; masque:m_Do or m_Mib or m_Fad                           ),
                (nom:'sus'  ; masque:m_Do or m_Fa  or m_Sol                           ),
                (nom:'min'  ; masque:m_Do or m_Mib or m_Sol                           ),
                (nom:'min+5'; masque:m_Do or m_Mib or m_Sod                           ),
                (nom:'2'    ; masque:m_Do or m_Re  or m_Mi  or m_Sol                  ),
                (nom:'6'    ; masque:m_Do or m_Mi  or m_Sol or m_La                   ),
                (nom:'7'    ; masque:m_Do or m_Mi  or m_Sol or m_Sib                  ),
                (nom:'maj7' ; masque:m_Do or m_Mi  or m_Sol or m_Si                   ),
                (nom:'7-5'  ; masque:m_Do or m_Mi  or m_Fad or m_Sib                  ),
                (nom:'7+5'  ; masque:m_Do or m_Mi  or m_Sod or m_Sib                  ),
                (nom:'dim6' ; masque:m_Do or m_Mib or m_Fad or m_La                   ),
                (nom:'sus7' ; masque:m_Do or m_Fa  or m_Sol or m_Sib                  ),
                (nom:'min2' ; masque:m_Do or m_Re  or m_Mib or m_Sol                  ),
                (nom:'min6' ; masque:m_Do or m_Mib or m_Sol or m_La                   ),
                (nom:'min7' ; masque:m_Do or m_Mib or m_Sol or m_Sib                  ),
                (nom:'min+7'; masque:m_Do or m_Mib or m_Sol or m_Si                   ),
                (nom:'mi7-5'; masque:m_Do or m_Mib or m_Fad or m_Sib                  ),
                (nom:'9'    ; masque:m_Do or m_Mi  or m_Sol or m_Sib or m_Re          ),
                (nom:'maj9' ; masque:m_Do or m_Mi  or m_Sol or m_Si  or m_Re          ),
                (nom:'7-9'  ; masque:m_Do or m_Mi  or m_Sol or m_Sib or m_Dod         ),
                (nom:'7-10' ; masque:m_Do or m_Mi  or m_Sol or m_Sib or m_Red         ),
                (nom:'7+5-9'; masque:m_Do or m_Mi  or m_Sod or m_Sib or m_Dod         ),
                (nom:'9+5'  ; masque:m_Do or m_Mi  or m_Sod or m_Sib or m_Red         ),
                (nom:'6.9'  ; masque:m_Do or m_Mi  or m_Sol or m_La  or m_Re          ),
                (nom:'min9' ; masque:m_Do or m_Mib or m_Sol or m_Sib or m_Re          ),
                (nom:'mi7-9'; masque:m_Do or m_Mib or m_Sol or m_Sib or m_Dod         ),
                (nom:'mi9+7'; masque:m_Do or m_Mib or m_Sol or m_Si  or m_Re          ),
                (nom:'mi6.9'; masque:m_Do or m_Mib or m_Sol or m_La  or m_Re          ),
                (nom:'11'   ; masque:m_Do or m_Mi  or m_Sol or m_Sib or m_Re  or m_Fa ),
                (nom:'11+'  ; masque:m_Do or m_Mi  or m_Sol or m_Sib or m_Re  or m_Fad),
                (nom:'maj11'; masque:m_Do or m_Mi  or m_Sol or m_Si  or m_Re  or m_Fad),
                (nom:'min11'; masque:m_Do or m_Mib or m_Sol or m_Sib or m_Re  or m_Fa )
               );


VAR {buffer circulaire}
    buffer_clavier: record
                     touche: array[0..longueur_buffer_clavier-1] of Key;
                     debut,fin: byte;
                    end;

    anc_INT09: pointer;

    key_pressed: array[$01..$7F] of boolean;

    EtatClavier: byte absolute $0040:$0017;


CONST x: byte=1;
      y: byte=5;


procedure INT09; interrupt;

var scan: byte;
    make: boolean;
    code: Key;

begin
 scan:=Port[$60];
 make:=(scan<$80);
 scan:=scan and not($80);

 asm
  pushf
  call anc_INT09

  cli
  mov DX,0040h
  mov ES,DX
  mov AL,ES:[001Ch]
  mov ES:[001Ah],AL   {vide le buffer interne du clavier (BIOS)}
  sti
 end;

{ GotoXY(x,y);
 if make then Write('') else Write('');
 Write(EntierHexa(scan,2),',');
 inc(x,4);
 if x>80 then begin
  x:=1; inc(y);
  if y>=25 then begin ClrScr; y:=5 end;
 end;}

 key_pressed[scan]:=make;

 case scan of
  {teste la prsence d'un code tendu}
  scan_etendu : if not code_etendu then begin code_etendu:=TRUE; exit end;
  scan_etendu2,

  {ignore les touches de combinaisons et commutes}
  scan_ShiftG,scan_ShiftD,
  scan_Ctrl,scan_Alt,
  scan_Caps,scan_Num,scan_Scroll: begin code_etendu:=FALSE; exit end;
 end;

 {teste si une touche est appuye}
 if make then with buffer_clavier do
  {vrifie que le buffer clavier n'est pas plein}
  if not(((debut>=1) and (fin=debut-1)) or
         ((debut =0) and (fin=longueur_buffer_clavier-1))) then begin

   if code_etendu then
    case scan of
     $4B: code:=Left;
     $4D: code:=Right;
     $48: code:=Up;
     $50: code:=Down;
     $52: code:=Ins;
     $53: code:=Del;
     $47: code:=Home;
     $4F: code:=End_;
     $49: code:=PgUp;
     $51: code:=PgDn;
     $35: code:=Key('/');
     $1C: code:=Enter;
     else code:=$00;
    end
   else
    code:=scan2code[scan];

   touche[fin]:=((EtatClavier and Combi) shl 12) or code;

   if fin<longueur_buffer_clavier-1 then inc(fin) else fin:=0;
  end;

 code_etendu:=FALSE;
end; {INT09}


function KeyPressed: boolean;
begin
 with buffer_clavier do KeyPressed:=(debut<>fin);
end; {KeyPressed}


function ReadKey: Key;
begin
 repeat until KeyPressed;

 with buffer_clavier do begin
  ReadKey:=touche[debut];
  touche[debut]:=$00;
  if debut<longueur_buffer_clavier-1 then inc(debut) else debut:=0;
 end;
end; {ReadKey}


procedure VideBufferClavier;
begin
 with buffer_clavier do debut:=fin;
end; {VideBufferClavier}


procedure AffBuffClav;
var i: byte;
begin
 GotoXY(1,1);
 with buffer_clavier do
  for i:=0 to longueur_buffer_clavier-1 do begin
   if touche[i]=$00 then TextColor(DARKGRAY) else TextColor(LIGHTGRAY);
   if i=fin then TextColor(WHITE);
   Write(EntierHexa(touche[i],3),' ');
  end;
end;


procedure AffClav;
var c: char;
    t: byte;
begin
 GotoXY(1,4);
 for c:='A' to 'Z' do begin
  if key_pressed[scan_AZ[c]] then TextColor(LIGHTGRAY) else TextColor(DARKGRAY);
  Write(c,' ');
 end;
 GotoXY(1,5);
 for t:=0 to 9 do begin
  if key_pressed[scan_09[t]] then TextColor(LIGHTGRAY) else TextColor(DARKGRAY);
  Write(t,' ');
 end;
 GotoXY(40,5);
 for t:=1 to 12 do begin
  if key_pressed[scan_FF[t]] then TextColor(LIGHTGRAY) else TextColor(DARKGRAY);
  Write('F',t,' ');
 end;

 GotoXY(1,6);
 for t:=$01 to $7F do
  if key_pressed[t] then begin TextColor(LIGHTGRAY); Write('') end
                    else begin TextColor(DARKGRAY ); Write('') end;
end;


procedure AffClavier(octave_: byte);

const larg_b=12; {largeur touche blanche}
      haut_b=50; {hauteur touche blanche}
      larg_n= 8; {largeur touche noire  }
      haut_n=30; {hauteur touche noire  }

      x_bn=larg_b-(larg_n div 2); {distance x entre une blanche et une noire}

      tn: array[0..5] of byte=(0,1,0,2,3,4);

var t,x,y: byte;
    masque_note: word;

begin
 masque_note:=$000;
 for t:=$02 to $35 do with scan2note[t] do
  if key_pressed[t] and (octave=octave_) then
   masque_note:=masque_note or (1 shl note);

 x:=10+7*(larg_b+1)*(octave_-1);
 y:=50;

 {touches blanches}
 for t:=0 to 6 do begin
  if (masque_note and (1 shl blanches[t]))=0 then begin
   SetFillStyle(SolidFill,WHITE);
   SetColor(LIGHTGRAY);
  end
  else begin
   SetFillStyle(SolidFill,LIGHTGRAY);
   SetColor(DARKGRAY);
  end;
  Bar      (x+t*(larg_b+1),y,x+t*(larg_b+1)+larg_b-1,y+haut_b-1);
  Rectangle(x+t*(larg_b+1),y,x+t*(larg_b+1)+larg_b-1,y+haut_b-1);
  PutPixel (x+t*(larg_b+1)         ,y+haut_b-1,DARKGRAY);
  PutPixel (x+t*(larg_b+1)+larg_b-1,y+haut_b-1,DARKGRAY);
 end;

 {touches noires}
 for t:=0 to 5 do if t<>2 then begin
  if (masque_note and (1 shl noires[tn[t]]))=0 then begin
   SetFillStyle(SolidFill,DARKGRAY);
   SetColor(BLACK);
  end
  else begin
   SetFillStyle(SolidFill,LIGHTGRAY);
   SetColor(DARKGRAY);
  end;
  Bar      (x+t*(larg_b+1)+x_bn,y,x+t*(larg_b+1)+x_bn+larg_n-1,y+haut_n-1);
  Rectangle(x+t*(larg_b+1)+x_bn,y,x+t*(larg_b+1)+x_bn+larg_n-1,y+haut_n-1);
  PutPixel (x+t*(larg_b+1)+x_bn         ,y+haut_n-1,WHITE);
  PutPixel (x+t*(larg_b+1)+x_bn+larg_n-1,y+haut_n-1,WHITE);
 end;
end;


CONST n_octaves=3;
      longueur_onde=640;
      YC=300;

VAR touche: Key;
    combi_t: byte;

    gd,gm: integer;
    c: char;
    t: word;
    note_change: boolean;

    o,octave_accord,base_accord,note_basse,nombre_notes_accord,
	note,nombre_notes,numero_accord,a,b: byte;
    masque_notes,anc_masque_notes: array[1..n_octaves] of word;
    masque_accord,masque_base,msq: word;
    accord_trouve: boolean;
    nom_accord: string[3+1+5+1+3];

    amplitude: byte;
    freq,K: real;
    onde: array[0..longueur_onde-1] of integer;

begin
 {initialise le buffer clavier}
 with buffer_clavier do begin debut:=0; fin:=0; end;

 ClrScr;

 SwapIntVec($09,anc_INT09,@INT09);

 repeat
  AffBuffClav;
  AffClav;
  GotoXY(1,3); ClrEol;

  if KeyPressed then touche:=ReadKey else touche:=$00;
  combi_t:=touche shr 12;

  AffBuffClav;
  AffClav;
  TextColor(WHITE);
  GotoXY(1,3); Write(EntierHexa(touche,4),': ');

  if (combi_t and Shift)<>0 then Write('Shift+');
  if (combi_t and Ctrl )<>0 then Write('Ctrl+');
  if (combi_t and Alt  )<>0 then Write('Alt+');

  touche:=touche and msq_Key;

  case touche of
   Key('A')..Key('Z'),
   Key('0')..Key('9'),
   Key(''),Key(')'),Key('='),
   Key('^'),Key('$'),
   Key('%'),Key('*'),
   Key('<'),Key('?'),Key('.'),Key(':'),Key('!'): Write(char(touche));

   F1..F12: Write('F',touche-F1+1);

   Left : Write(#27);
   Right: Write(#26);
   Up   : Write('');
   Down : Write('');
   PgUp : Write('Page');
   PgDn : Write('Page');
   Home : Write('Home');
   End_ : Write('end');

   Space: Write('espace');
   Esc  : Write('Esc');
   Enter: Write('');
   Bdel : Write('Del');
   Del  : Write('Del');
   Ins  : Write('Ins');
   Tab  : Write('Tab');

   Key('+'): Write('+');
   Key('-'): Write('-');
   Key('/'): Write('/');
   Key('*'): Write('*');
  else Write('<?>');
  end;

  Pause(2);
 until touche=Esc;

 gd:=VGA;
 gm:=VGAHi;
 InitGraph(gd,gm,'C:\BP7\BGI');

 for o:=1 to n_octaves do AffClavier(o);
 Pause(6);

 repeat
  AttendVBL;

  MoveTo(0,10);
  for c:='A' to 'Z' do begin
   if key_pressed[scan_AZ[c]] then SetColor(LIGHTGRAY) else SetColor(DARKGRAY);
   OutText(c+' ');
  end;

  {affiche les notes joues}
  SetFillStyle(SolidFill,BLACK);
  Bar(0,25,GetMaxX,25+8);
  MoveTo(0,25);
  SetColor(WHITE);
  for t:=$02 to $35 do with scan2note[t] do
   if key_pressed[t] and (octave<>0) then
    OutText(NomNote[note]+char(byte('0')+octave)+' ');

  {recherche les notes joues}
  for o:=1 to n_octaves do masque_notes[o]:=$000;

  for t:=$02 to $35 do with scan2note[t] do
   if key_pressed[t] and (octave<>0) then
    masque_notes[octave]:=masque_notes[octave] or (1 shl note);

  {affiche les octaves du clavier}
  note_change:=FALSE;
  for o:=1 to n_octaves do
   if masque_notes[o]<>anc_masque_notes[o] then begin
    note_change:=TRUE;
    AffClavier(o);
    anc_masque_notes[o]:=masque_notes[o];
   end;

  if note_change then begin
   {compose l'accord en ramenant toutes les notes dans une seule octave}
   masque_accord:=$000;
   for o:=n_octaves downto 1 do begin
    masque_accord:=masque_accord or masque_notes[o];
    if masque_notes[o]<>$000 then begin  {recherche la note la plus basse de l'octave}
     msq:=masque_notes[o];
     asm
      mov AX,msq
      xor BL,BL
      mov CL,12

     @cherche_premier_bit_1:
      shr AX,1
      jc  @trouve
      inc BL
      dec CL
      jnz @cherche_premier_bit_1

     @trouve:
      mov note_basse,BL
     end;
    end;
   end;

   {compte le nombre de notes dans l'accord}
   asm
    mov AX,masque_accord
    xor BL,BL
    mov CL,12

   @compte_bits:
    shr AX,1
    adc BL,0
    dec CL
    jnz @compte_bits

    mov nombre_notes_accord,BL
   end;

   accord_trouve:=FALSE;
   base_accord:=0;

   {vrifie qu'un accord peut exister (au moins 3 notes)}
   if nombre_notes_accord>=3 then
    {recherche l'accord avec la note relative la plus basse comme note de base}
    for b:=1 to 12 do begin
     {ajuste le masque accord avec la note de base (par rotation  droite sur 12 bits)
      -> compare avec un accord en Do}
     asm
      mov AX,masque_accord
      mov CH,base_accord
      or  CH,CH
      jz  @fin

     @rotation_masque:
      mov BL,AL
      and BL,00000001b
      ror AX,1
      and AX,0000011111111111b
      shl BL,3
      or  AH,BL
      dec CH
      jnz @rotation_masque

     @fin:
      mov masque_base,AX
     end;

     {commence par rechercher les accords les plus longs}
     if (masque_base and Do_)=Do_ then
      for a:=nbr_accords downto 1 do with Accord[a] do
       if (masque_base and masque)=masque then begin
        {compte le nombre de notes dans l'accord a}
        msq:=masque;
        asm
         mov AX,msq
         xor BL,BL
         mov CL,12

        @compte_bits:
         shr AX,1
         adc BL,0
         dec CL
         jnz @compte_bits

         mov nombre_notes,BL
        end;

        accord_trouve:=(nombre_notes>=nombre_notes_accord);
        numero_accord:=a;
        break;
       end;

     if accord_trouve then break;

     inc(base_accord); {recherche l'accord avec la note de base augmente d'un demi-ton}
     if base_accord>Si then begin inc(octave_accord); base_accord:=Do_; end;
    end;

   {affiche le nom de l'accord}
   SetFillStyle(SolidFill,BLACK);
   Bar(0,35,GetMaxX,35+8);
   SetColor(LIGHTCYAN);
   if accord_trouve then begin
    nom_accord:=NomNote[base_accord];
    if nom_accord[Length(nom_accord)]=' ' then dec(nom_accord[0]);
    nom_accord:=nom_accord+' '+Accord[numero_accord].nom;
    if note_basse<>base_accord then nom_accord:=nom_accord+'/'+NomNote[note_basse];
   end else nom_accord:='             ';
   OutTextXY(0,35,nom_accord);

   {compte le nombre de notes simultanes}
   nombre_notes:=0;
   for o:=1 to n_octaves do begin
    msq:=masque_notes[o];
    asm
     mov AX,msq
     xor BL,BL
     mov CL,12

    @compte_bits:
     shr AX,1
     adc BL,0
     dec CL
     jnz @compte_bits

     add nombre_notes,BL
    end;
   end;

   {calcule l'amplitude}
   if nombre_notes<>0 then amplitude:=128 div nombre_notes else amplitude:=0;

   AttendVBL;

   {efface l'ancienne onde}
   SetColor(BLACK);
   MoveTo(0,YC-onde[0]);
   for t:=1 to longueur_onde-1 do LineTo(t,YC-onde[t]);

   {calcule l'onde}
   FillChar(onde,sizeof(onde),0);
   for o:=1 to n_octaves do for note:=Do_ to Si do
    if (masque_notes[o] and (1 shl note))<>0 then begin
     freq:=440*exp(ln(2)*((note-La)/12+(o-1)));
     K:=2*PI*freq/64/longueur_onde;
     for t:=0 to longueur_onde-1 do inc(onde[t],Round(amplitude*sin(K*t)));
    end;

   {affiche ligne horizontale niveau 0}
   SetColor(LIGHTGRAY);
   Line(0,YC,GetMaxX,YC);

   {affiche l'onde}
   SetColor(LIGHTGREEN);
   MoveTo(0,YC-onde[0]);
   for t:=1 to longueur_onde-1 do LineTo(t,YC-onde[t]);
  end;
 until key_pressed[scan_Esc];

 CloseGraph;

 repeat until not key_pressed[scan_Esc];

 SwapIntVec($09,anc_INT09,anc_INT09);
END.
