USES Crt,Clavier,Util;

TYPE lettre='A'..'Z';

CONST sc_up   =72;
      sc_down =80;
      sc_left =75;
      sc_right=77;

      sc_esc  = 1;
      sc_space=57;

      sc_bip=127;

      sc_AZ: array[lettre] of byte=
              (16,48,46,32,18,33,34,35,23,36,37,38,39,49,24,25,30,19,31,20,22,47,44,45,21,17);

      press: array[boolean] of string[8]=('relche','appuye ');
      app: array[boolean] of string[2]=('  ',' ');


VAR oldINT09: pointer;

    quitte,
    up_pressed,down_pressed,left_pressed,right_pressed: boolean;
    status_AZ: array[lettre] of boolean;


procedure INT09; interrupt;
var scan,dir: byte;
    make: boolean;
    i: lettre;
begin
 scan:=Port[$60];
 make:=(scan<$80);

 if not(make) then dec(scan,$80);
 case scan of
  sc_esc  : quitte:=not(make);
  sc_up   : up_pressed   :=make;
  sc_down : down_pressed :=make;
  sc_left : left_pressed :=make;
  sc_right: right_pressed:=make;
 end;
 for i:='A' to 'Z' do if scan=sc_AZ[i] then status_AZ[i]:=make;

 asm
  pushf
  call oldINT09
 end;
 VideBufferClavier;

 GotoXY(1,3); ClrEol; GotoXY(1,3);

 case scan of
  sc_esc: Write('Relchez Esc pour quitter!');
  sc_bip: Write('Trop de touches appuyes!');
 end;

 GotoXY(1,5); Write('touche '#24' : ',press[up_pressed]);
 GotoXY(1,6); Write('touche '#25' : ',press[down_pressed]);
 GotoXY(1,7); Write('touche '#27' : ',press[left_pressed]);
 GotoXY(1,8); Write('touche '#26' : ',press[right_pressed]);

 TextAttr:=8;
 GotoXY(30,5); Write('\  /');
 GotoXY(30,6); Write(' + ');
 GotoXY(30,7); Write('/  \');

 if up_pressed then
  if left_pressed then dir:=1 else if right_pressed then dir:=3 else dir:=2
 else
  if down_pressed then
   if left_pressed then dir:=7 else if right_pressed then dir:=9 else dir:=8
  else
   if left_pressed then dir:=4 else if right_pressed then dir:=6 else dir:=5;

 Mem[$B800:1+2*((30+2*((dir-1) mod 3))-1)+160*((5+(dir-1) div 3)-1)]:=15;

 TextAttr:=7;
 GotoXY(1,10); Write('scan-code Make: ',scan:3,' break: ',scan+$80:3);

 GotoXY(1,12); Write('A B C D E F G H I J K L M N O P Q R S T U V W X Y Z');
 GotoXY(1,13);
 for i:='A' to 'Z' do Write(app[status_AZ[i]]);
end;



BEGIN
 ClrScr;
 SwapIntVec($09,oldINT09,@INT09);

 WriteLn('Appuyez sur une touche... Esc pour quitter');

 repeat until quitte;

 SwapIntVec($09,oldINT09,oldINT09);
END.
