{$A+,G+,Q-,R-,S-}

USES Crt,Graph256,BMP256,Util;

VAR b: BMP;
	erreur: word;



procedure AfficheImage;
begin
 palette_noire.Fixe(0,256);
 b.Affiche($A000,0,0);
 b.palette.Fondu(0,256,32);
end;



procedure AfficheLigneZoom(var source,destination; long_source,long_dest: word); assembler;
asm
 push DS
 push BP

 lds SI,source
 les DI,destination
 mov AX,long_source
 mov CX,long_dest

 xor DH,DH
 mov DL,AH
 mov AH,AL
 xor AL,AL		{(DX,AX)=256*long_source}
 div CX
 shl DX,1		{DX=2*reste}
 cmp DX,CX		{2*reste>=long_dest ?}
 jnae @suite	{non}
 inc AX			{incrmente quotient (arrondit  l'entier suprieur)}
@suite:
 mov BP,AX		{BP=incrment (partie entire,partie dcimale)}
 xor DX,DX
 xor AX,AX		{(DX,AX)=cumul des incrments (17 bits ncessaires)}

@affiche:
 mov BH,DL
 mov BL,AH		   {BX=partie haute du cumul (partie entre)=dcalage source}
 mov BL,DS:[SI+BX] {BL=couleur du point source  afficher}
 mov ES:[DI],BL	   {affiche un point dans destination}
 inc DI
 add AX,BP
 adc DX,0		{(DX,AX)=(DX,AX)+BP}
 loop @affiche

 pop BP
 pop DS
end; {AfficheLigneZoom}



procedure Transition1;
var i,j: byte;
	p: Palette256;
	couleur: RVB;
begin
 palette_blanche.Fondu(0,256,auto);

 for i:=1 to 8 do
  for j:=1 to 40 do
   LigneVerticale($A000,40*(i-1)+(j-1),0,199,1+3*(i-1)+(j-1));

 with p do begin
  for i:=1 to 61 do with palette[i] do
   begin R:=63; V:=63; B:=63 end;
  for i:=1 to 61 do with palette[i+61] do
   begin R:=64-i; V:=64-i; B:=64-i end;
  for i:=1 to 61 do with palette[i+2*61] do
   begin R:=0; V:=0; B:=0 end;

  for i:=1 to 2*61 do begin
   Fixe(1,61);
   couleur:=palette[1];
   Move(palette[2],palette[1],3*254);
   palette[255]:=couleur;
   AttendVBL2;
  end;
 end;

 palette_noire.Fondu(0,1,auto);
end; {Transition1}



procedure Transition2;
var i: byte;
	p: Palette256;
begin
 for i:=1 to 64 do begin
  with p do begin
   Charge(0,256);
   Intensite(0,256,+1,rouge+vert+bleu);
   Fixe(0,256);
  end;
  EffaceZone($A000,2*(i-1),0,2*(i-1)+1,199,0);
  EffaceZone($A000,320-2*(i-1)-1,0,320-2*(i-1),199,0);
  AttendVBL2;
 end;
 palette_noire.Fondu(0,256,auto);
end; {Transition2}



procedure Transition3;
var i: byte;
	p: Palette256;
begin
 for i:=1 to 50 do begin
  with p do begin
   Charge(0,256);
   Intensite(0,256,-1,rouge+vert+bleu);
   Fixe(0,256);
  end;
  EffaceZone($A000,0,2*(i-1),319,2*(i-1)+1,0);
  EffaceZone($A000,0,200-2*(i-1)-1,319,200-2*(i-1),0);
 end;
end; {Transition3}



procedure Transition4;
begin
 palette_blanche.Fondu(0,256,16);
 b.palette.Fondu(0,256,8);
 palette_noire.Fondu(0,256,auto);
end; {Transition4}



procedure Transition5;
const vitesse=5;
var y: byte;
	f: word;
	p: Palette256;
begin
 with b do begin
  f:=ResX-vitesse+1;
  repeat
   with p do begin
	Charge(0,256);
	Intensite(0,256,-1,rouge+vert);
	Fixe(0,256);
   end;
   for y:=0 to resY-1 do
	AfficheLigneZoom(image^[1+y*ResX],Ptr($A000,y*320)^,ResX,f);
   EffaceZone($A000,f-1,0,f-1+vitesse-1,199,0);
   dec(f,vitesse);
   AttendVBL2;
  until f<ResX div 3;
  repeat
   with p do begin
	Charge(0,256);
	Intensite(0,256,+1,bleu);
	Fixe(0,256);
   end;
   for y:=0 to resY-1 do
	AfficheLigneZoom(image^[1+y*ResX],Ptr($A000,y*320)^,ResX,f);
   inc(f,vitesse);
   AttendVBL2;
  until f>ResX;
 end;
 palette_blanche.Fondu(0,256,16);
 palette_noire.Fondu(0,256,auto);
end; {Transition5}



procedure Transition6; assembler;
asm
 mov DX,0A000h
 mov ES,DX
 mov DI,0+320*198
 mov DX,320
 mov CH,1

@boucle:
 mov CL,320/2
 @lignes_verticales:
  mov BL,CH
  mov AX,ES:[DI]
  @ligne_verticale_vers_bas:
   add DI,DX
   mov ES:[DI],AL
   dec BL
  jnz @ligne_verticale_vers_bas

  inc DI
  mov BL,CH
  @ligne_verticale_vers_haut:
   mov ES:[DI],AH
   sub DI,DX
   dec BL
  jnz @ligne_verticale_vers_haut

  inc DI
  dec CL
 jnz @lignes_verticales

 sub DI,320+320
 inc CH
 cmp CH,190
 jbe @boucle
end; {Transition6}



BEGIN
 b.Charge('C:\Projets\tests\sq4.bmp',erreur);
 if erreur<>0 then begin WriteLn('Erreur BMP: ',erreur); halt end;

 Init320x200;

 AfficheImage;
 Transition1;
 AfficheImage;
 Transition2;
 AfficheImage;
 Transition3;
 AfficheImage;
 Transition4;
 AfficheImage;
 Transition5;
 AfficheImage;
 Transition6;

 b.Supprime;

 TextMode(LastMode);
END.
