{$A+,G+,Q-,R-,S-}

USES Crt,Dos,Texte,Util,Souris,SourisSm;

{$M 16384,0,65536}

CONST repert='C:\Musique\MODM\modm23\design\';

      corr_R_min=-20; corr_R_max=+15;
      corr_V_min=-20; corr_V_max=+15;
      corr_B_min=-10; corr_B_max=+35;

      pas_corr_RVB=1;

      couleurs_base: array[3..6] of RVB=
                      ((R:20;V:20;B:14),
                       (R:32;V:32;B:20),
                       (R:36;V:36;B:22),
                       (R:44;V:44;B:26));

      sensib_souris_min=10;
      sensib_souris_max=100;

      {aspects pour CadreOmbre}
      concave=$00;
      convexe=$01;
      plein  =$02;

      {aspects pour FenetreOmbre}
      normale=$00;
      encadre=$01;


VAR erreur: word;
    z: Zone;
    f: Fonte8;
    p: Palette16;

    touche: char;
    couleur: byte;

    comp: RVB;
    corr_R,corr_V,corr_B: shortint;

    sensib_souris: byte;

const {couleurs}
      coul_fond   =4;
      coul_claire =6;
      coul_moyenne=5;
      coul_sombre =3;

      coul_blanc  =15;



procedure CadreOmbre(xg,yh,xd,yb,aspect: byte);

const car_coin_sup_g='';
      car_coin_sup_d=#246;
      car_coin_inf_g=#247;
      car_coin_inf_d='';

var coul_haut_gauche,coul_bas_droite: byte;
    ptr_VRAM: pointer;

begin
 if (xd<xg+2) or (yb<yh+2) then exit;

 case (aspect and (concave or convexe)) of
  concave: begin coul_haut_gauche:=coul_claire; coul_bas_droite:=coul_sombre end;
  convexe: begin coul_haut_gauche:=coul_sombre; coul_bas_droite:=coul_claire end;
 end;

 if (aspect and plein)=plein then EffaceZone(0,xg+1,yh+1,xd-1,yb-1,16*coul_fond+coul_blanc);

 ptr_VRAM:=PtrVRAM(0,xg,yh);
 asm
  les DI,ptr_VRAM

  mov CH,yb
  sub CH,yh
  dec CH
  mov CL,xd
  sub CL,xg
  dec CL

  xor DH,DH
  mov DL,largeur_ecran_txt
  shl DX,1

  mov AX,256*(16*coul_fond)+car_coin_sup_g
  or  AH,coul_haut_gauche
  mov ES:[DI],AX
  add DI,2

  push CX
 @bord_haut:
  mov AX,256*(16*coul_fond)+''
  or  AH,coul_haut_gauche
  mov ES:[DI],AX
  add DI,2
  dec CL
  jnz @bord_haut
  pop CX

  mov AX,256*(16*coul_fond)+car_coin_sup_d
  or  AH,coul_moyenne
  mov ES:[DI],AX
  add DI,DX

  push CX
 @bord_droit:
  mov AX,256*(16*coul_fond)+''
  or  AH,coul_bas_droite
  mov ES:[DI],AX
  add DI,DX
  dec CH
  jnz @bord_droit
  pop CX

  mov AX,256*(16*coul_fond)+car_coin_inf_d
  or  AH,coul_bas_droite
  mov ES:[DI],AX
  sub DI,2

  push CX
 @bord_bas:
  mov AX,256*(16*coul_fond)+''
  or  AH,coul_bas_droite
  mov ES:[DI],AX
  sub DI,2
  dec CL
  jnz @bord_bas
  pop CX

  mov AX,256*(16*coul_fond)+car_coin_inf_g
  or  AH,coul_moyenne
  mov ES:[DI],AX
  sub DI,DX

  push CX
 @bord_gauche:
  mov AX,256*(16*coul_fond)+''
  or  AH,coul_haut_gauche
  mov ES:[DI],AX
  sub DI,DX
  dec CH
  jnz @bord_gauche
  pop CX
 end
end; {CadreOmbre}



procedure FenetreOmbre(xg,yh,xd,yb,aspect: byte);

const car_coin_sup_g=#6;
      car_coin_sup_d=#5;
      car_coin_inf_g=#4;
      car_coin_inf_d=#3;

var ptr_VRAM: pointer;

begin
 if (xd<xg+2) or (yb<yh+2) then exit;

 EffaceZone(0,xg+1,yh+1,xd-1,yb-1,16*coul_fond+coul_blanc);
 if (aspect and encadre)=encadre then CadreOmbre(xg+1,yh+1,xd-1,yb-1,convexe);

 ptr_VRAM:=PtrVRAM(0,xg,yh);
 asm
  les DI,ptr_VRAM

  mov CH,yb
  sub CH,yh
  dec CH
  mov CL,xd
  sub CL,xg
  dec CL

  xor DH,DH
  mov DL,largeur_ecran_txt
  shl DX,1

  mov AX,ES:[DI]
  and AH,11110000b
  or  AH,coul_claire
  mov AL,car_coin_sup_g
  mov ES:[DI],AX
  add DI,2

  push CX
 @bord_haut:
  mov AX,ES:[DI]
  and AH,11110000b
  or  AH,coul_claire
  mov AL,''
  mov ES:[DI],AX
  add DI,2
  dec CL
  jnz @bord_haut
  pop CX

  mov AX,ES:[DI]
  and AH,11110000b
  or  AH,coul_moyenne
  mov AL,car_coin_sup_d
  mov ES:[DI],AX
  add DI,DX

  push CX
 @bord_droit:
  mov AH,coul_sombre
  mov AL,''
  mov ES:[DI],AX
  add DI,DX
  dec CH
  jnz @bord_droit
  pop CX

  mov AH,coul_sombre
  mov AL,car_coin_inf_d
  mov ES:[DI],AX
  sub DI,2

  push CX
 @bord_bas:
  mov AH,coul_sombre
  mov AL,''
  mov ES:[DI],AX
  sub DI,2
  dec CL
  jnz @bord_bas
  pop CX

  mov AX,ES:[DI]
  and AH,11110000b
  or  AH,coul_moyenne
  mov AL,car_coin_inf_g
  mov ES:[DI],AX
  sub DI,DX

  push CX
 @bord_gauche:
  mov AX,ES:[DI]
  and AH,11110000b
  or  AH,coul_claire
  mov AL,''
  mov ES:[DI],AX
  sub DI,DX
  dec CH
  jnz @bord_gauche
  pop CX
 end;
end; {FenetreOmbre}


procedure ZoomFenetreOmbre(xg,yh,xd,yb,aspect: byte);

const facteur=10;

var xc,yc,i: byte;
    xgr,yhr,xdr,ybr, dxgr,dyhr,dxdr,dybr: real;

begin
 xc:=(xg+xd) div 2; yc:=(yh+yb) div 2;
 xgr:=xc-(xc-xg)/facteur; xdr:=xgr+(xd-xg+1)/facteur-1;
 yhr:=yc-(yc-yh)/facteur; ybr:=yhr+(yb-yh+1)/facteur-1;
 dxgr:=(xg-xgr)/(facteur-1); dxdr:=(xd-xdr)/(facteur-1);
 dyhr:=(yh-yhr)/(facteur-1); dybr:=(yb-ybr)/(facteur-1);
 for i:=1 to facteur do begin
  AttendVBL;
  FenetreOmbre(Round(xgr),Round(yhr),Round(xdr),Round(ybr),aspect);
  xgr:=xgr+dxgr; xdr:=xdr+dxdr;
  yhr:=yhr+dyhr; ybr:=ybr+dybr;
 end;
end; {ZoomFenetreOmbre}


VAR ProgName,CmdLine: string;


BEGIN
 z.Charge_(repert+'80x50\modm_int.scr',erreur);
 if erreur<>0 then begin Writeln('erreur SCR=',erreur); halt end;

 f.Charge_(repert+'modm8.fnt',erreur);
 if erreur<>0 then begin Writeln('erreur FNT=',erreur); halt end;

 p.Charge_(repert+'pal_modm.pal',erreur);
 if erreur<>0 then begin Writeln('erreur PAL=',erreur); halt end;

 InitTexte(50);
 InitTexteVirtuel(132);
 LargeurCar(8);
 Clignotement(FALSE);

 InitSourisSmooth(#166,#167,#169,#170);

 with z do begin Restaure(0,0,0,0); Supprime end;
 f.Redef(0);
 p.Fixe;

 asm
  mov AX,0B800h
  mov ES,AX
  mov AL,largeur_ecran_txt
  mul hauteur_ecran_txt
  mov DI,AX
  dec DI
  shl DI,1
 @boucle:
  cmp CHAR(ES:[DI]),' '
  je  @met_blanc
  cmp CHAR(ES:[DI]),0
  je  @met_blanc
  jmp @suite
 @met_blanc:
  or  BYTE(ES:[DI+1]),15
 @suite:
  sub DI,2
  jnz @boucle
 end;

 corr_R:=0; corr_V:=0; corr_B:=0;
 sensib_souris:=32;

 AffCursSouris;

 repeat
  AffChXY(0,1,1,' R='+EntierTexte2(corr_R,3)+
                ' V='+EntierTexte2(corr_V,3)+
                ' B='+EntierTexte2(corr_B,3)+
                ' sensib_souris='+EntierTexte2(sensib_souris,3),7);

  touche:=Readkey;
  case touche of
   '7': corr_R:=LimiteEntier(corr_R-pas_corr_RVB,corr_R_min,corr_R_max);
   '9': corr_R:=LimiteEntier(corr_R+pas_corr_RVB,corr_R_min,corr_R_max);
   '4': corr_V:=LimiteEntier(corr_V-pas_corr_RVB,corr_V_min,corr_V_max);
   '6': corr_V:=LimiteEntier(corr_V+pas_corr_RVB,corr_V_min,corr_V_max);
   '1': corr_B:=LimiteEntier(corr_B-pas_corr_RVB,corr_B_min,corr_B_max);
   '3': corr_B:=LimiteEntier(corr_B+pas_corr_RVB,corr_B_min,corr_B_max);
   '-': if sensib_souris>sensib_souris_min then dec(sensib_souris);
   '+': if sensib_souris<sensib_souris_max then inc(sensib_souris);
  end;

  for couleur:=3 to 6 do begin
   ChargeDAC(couleur,comp);
   with comp do begin
    R:=couleurs_base[couleur].R+corr_R;
    V:=couleurs_base[couleur].V+corr_V;
    B:=couleurs_base[couleur].B+corr_B;
   end;
   FixeDAC(couleur,comp);
  end;

  SensibiliteSouris(sensib_souris,sensib_souris,10);
 until touche=#27;

 FinSourisSmooth;

{ EffacePage(0,coul_blanc);

 CadreOmbre(10,5,50,30,plein+concave);
 FenetreOmbre(25,10,70,40,encadre);
 ZoomFenetreOmbre(20,10,75,40,encadre);

 repeat until ReadKey=' ';}

{ InitTexte(25);
 Write('Program to Exec (full path): ');
 ReadLn(ProgName);
 if ProgName='' then ProgName:='C:\Util\unzip.exe';
 Write('Command line to pass to ',ProgName, ': ');
 ReadLn(CmdLine);
 if CmdLine='' then CmdLine:='C:\Temp\bidon';
 WriteLn('About to Exec...');
 SwapVectors;
 Exec(ProgName, CmdLine);
 SwapVectors;
 WriteLn('...back from Exec');
 if DosError <> 0 then WriteLn('Dos error #', DosError)
 else WriteLn('Exec successful. ','Child process exit code = ',DosExitCode);

 repeat until ReadKey=' ';}

 InitTexte(25);
END.
